#!/usr/bin/perl -w

# Ergaenzt den file MakeLib um ein programm (ohne extension angeben!)

if ($#ARGV < 0) {
  print "usage: MLu.pl name (ohne extension!)\n";
  exit 1;
}

open IN,"MakeLib";
@arr=<IN>;
close IN;
chomp @arr;

$name=shift @ARGV;

for ($i=0;$#arr;$i++) {
  if ($arr[$i] =~ m/OBJECTS\s+=/) {
    $arr[$i-1] .= " \\";
    $line=sprintf("%16s%s%s"," ",$name,".f");
    splice @arr,$i,0,$line;
    $i+=2;
  }
  if ($arr[$i] =~ m/SRCMOC\s+=/) {
    $arr[$i-1] .= " \\";
    $line=sprintf("%16s%s%s"," ",$name,".o");
    splice @arr,$i,0,$line;
    last;
  }
}
push @arr,sprintf ("%s.o: %s.f",$name,$name);

open OUT,">MakeLib";
foreach (@arr) {
  print OUT "$_\n";
}
close OUT;
