C     ----------------------------------------------------------
       SUBROUTINE FCNV (AIN,NZBUF,LFRM,KARTE,KARPOI,KAREND,IRC)
C     ----------------------------------------------------------
C
C                  geschrieben: 18.10.79    (Hundt)
C                  geaendert: 291621 APR 99 (Hundt)
C
C               Bedeutung des Returncodes IRC
C               -----------------------------
C               -4 Gleichheitszeichen gefunden
C               -3 Pufferende in Apostroph-Struktur
C               -2 Pufferende in Klammerstruktur
C               -1 Pufferende bei A-Konversion in Apostrophen
C
C               1  Fehler im Pseudo-Format.
C               2  Unerwartete Info im String.
C               3  String laenger als angegebenes Feld.
C               4  Ill. Char. bei I-Konversion.
C               5  Ill. Char. bei F-Konversion.
C               6  Zahl ist nicht darstellbar.
C               7  Illegale Adresse auf Karte.
C
C     ----------------------------------------------------------
C
      IMPLICIT NONE
C
      character *1 LFRM(*)
      INTEGER *1 KARTE(*),I1WORT(4)
      INTEGER *4 NZBUF(*),IBUZFF(16),IZRET
      INTEGER *4 IBFLEN,IBUA,IBUAPO,IBUARZ,IBUB,IBUBLK,IBUC,IBUE
      INTEGER *4 IBUF,IBUG,IBUGLZ,IBUI,IBUJ,IBUKAE,IBUKLA,IBUKLZ
      INTEGER *4 IBUKOM,IBUR,IBUS,IBUSLA,IBUSMI,IBUSTN,IBUZ
      INTEGER *4 IENDFL,IERZVD,IEXLIM,IFRAC,IFRGO,IFRPOI,IFXBAS
      INTEGER *4 IFXMAX,ILZCH,INCOU,INFOFL,INPOI,INPOIS,IRC
      INTEGER *4 IVBFLG,IZRETS,KAREND,KARPOI,KLACOU,KOCOU,NZPOI
      INTEGER *4 I,IAPFLG,IBUCHE,IBUMNS,IBUPKT,IBUPLS,IEXAC,IEXSV
      INTEGER *4 IFXAC,IFXSV,IMNSFL,IMXFL,INKOU,INUM,IPKTFL,IPOI
      INTEGER *4 ISLFLG,J,IWORT
      REAL    *4 AIN(1),ZPOT1(10),ZPOT2(7)
      REAL    *4 BLK,EX,FACSAV,FXAC,WORT
C
      SAVE
C
      EQUIVALENCE (IWORT,WORT,I1WORT),(IFXAC,FXAC)
C
      DATA IFXMAX/16777215/,ILZCH/0/,BLK/4H    /,IERZVD/0/
      DATA ZPOT1/1.,10.,100.,1.E3,1.E4,1.E5,1.E6,1.E7,1.E8,1.E9/
      DATA ZPOT2/1.E10,1.E20,1.E30,1.E30,1.E30,1.E30,1.E30/
      DATA IEXLIM/38/
      DATA IBUBLK,IBUPKT,IBUKLA,IBUPLS,IBUSTN/32,46,40,43,42/
      DATA IBUKLZ,IBUMNS,IBUSLA,IBUKOM,IBUAPO/41,45,47,44,39/
      DATA IBUA,IBUB,IBUC,IBUE,IBUF,IBUG,IBUI/65,66,67,69,70,71,73/
      DATA IBUR,IBUS,IBUKAE/82,83,255/,IBUGLZ/61/,IBUARZ/33/
      DATA IBUSMI/59/,IBUJ/74/,IBUZ/90/
      DATA IBUZFF/48,49,50,51,52,53,54,55,
     1            56,57,65,66,67,68,69,70/
C
      IVBFLG=0
      IENDFL=0
      IF (IRC .GT. -1) GO TO 10
      IRC=0
      GO TO 430
C
   10 IF (IRC .NE. 3) GO TO 20
      IRC=0
      GO TO 50
C                            Initialisierung Formatentschluesselung
   20 IRC=0
      INFOFL=0
      INPOI=0
      INPOIS=0
      NZPOI=0
      IFRPOI=0
      GO TO 50
C                            Naechstes Segment
   30 INCOU=-1
   40 INPOI=INPOIS+IFRAC
      INPOIS=INPOI
      NZBUF(NZPOI)=INCOU
      IF (IRC .NE. 0) GO TO 1200
C
C                            Entschluessele Format
   50 IFRAC=0
      INCOU=0
C                            Naechstes Zeichen
   60 IFRPOI=IFRPOI+1
      ILZCH=ichar(LFRM(IFRPOI))
C
C                            ZIFFER
C
      IF (ILZCH .LT. IBUZFF(1)) GO TO 70
      IF (ILZCH .GT. IBUZFF(10)) GO TO 70
      IFRAC=IFRAC*10+ILZCH-IBUZFF(1)
      GO TO 60
C                            Setze AC=1 wenn keine Ziffern da waren.
C
   70 IF (IFRAC .LE. 0) IFRAC=1
C
C                            Erhoehe Anzahl-Pointer und loesche
C                            Mengenangabe.
      NZPOI=NZPOI+1
C                            Teste, ob Ende entdeckt wurde.
C
      IF (IENDFL .EQ. 0) GO TO 190
C
C                            Ja.  Return, wenn Buchstabe E, R oder S.
C
      IF (ILZCH-IBUR) 80,1200,90
   80 IF (ILZCH-IBUE) 40,1200,40
   90 IF (ILZCH-IBUS) 100,1200,100
C
C                            Fehler im Format.
C
  100 IRC=1
      GO TO 1200
C                            Entschluessele Formatanweisungstyp
C
  110 IF (ILZCH-IBUA) 100,220,100
  120 IF (ILZCH-IBUB) 110,230,130
  130 IF (ILZCH-IBUC) 100,240,140
  140 IF (ILZCH-IBUE) 100,320,100
  150 IF (ILZCH-IBUF) 120,250,170
  160 IF (ILZCH-IBUG) 100,260,100
  170 IF (ILZCH-IBUI) 160,270,180
  180 IF (ILZCH-IBUJ) 100,280,100
  190 IF (ILZCH-IBUR) 150,1200,200
  200 IF (ILZCH-IBUS) 100,310,210
  210 IF (ILZCH-IBUZ) 100,300,100
C
C                            Buchstabe A
  220 IFRGO=-1
      IBFLEN=4
      GO TO 520
C                            Buchstabe B
  230 IFRGO=-1
      IBFLEN=1
      GO TO 520
C                            Buchstabe C
  240 IFRGO=5
      GO TO 520
C                            Buchstabe F
  250 IFRGO=0
      GO TO 520
C                            Buchstabe G
  260 IFRGO=4
      GO TO 520
C                            Buchstabe I
  270 IFRGO=1
      GO TO 290
C                            Buchstabe J
  280 IFRGO=2
  290 IFXBAS=10
      GO TO 520
C                            Buchstabe Z
  300 IFRGO=3
      IFXBAS=16
      GO TO 520
C                            Skip bis zum Trennzeichen.
  310 IERZVD=1
  320 IZRET=1
      GO TO 430
C                            Teste auf Blank.
C
  330 IF (ILZCH .EQ. IBUKOM) GO TO 430
      IF (ILZCH-IBUBLK) 420,430,340
C
C                            Teste auf (
C
  340 IF (ILZCH .NE. IBUKLA) GO TO 400
C
C                            Ueberspringe Klammerstruktur.
  350 KLACOU=1
      IZRETS=IZRET
      IZRET=2
      GO TO 430
C                            Teste auf )
C
  360 IF (ILZCH-IBUKLZ) 380,370,390
  370 KLACOU=KLACOU-1
      IF (KLACOU .GT. 0) GO TO 430
      IZRET=IZRETS
      GO TO 430
C
  380 IF (ILZCH .NE. IBUKLA) GO TO 430
      KLACOU=KLACOU+1
      GO TO 430
C
  390 IF (ILZCH .LT. IBUKAE) GO TO 430
      IRC=-2
      GO TO 1200
C                            Teste auf /
C
  400 IF (ILZCH .EQ. IBUSLA) GO TO 1200
      IF (ILZCH .EQ. IBUSMI) GO TO 1200
C
C                            Teste auf Kartenende.
C
      IF (ILZCH .GE. IBUKAE) GO TO 1200
C
C                            Teste auf Trennzeichen (=)
C
      IF (ILZCH .NE. IBUGLZ) GO TO 420
  410 IRC=-4
      GO TO 1200
C                            Schreibe Fehlermeldung.
C
  420 IF (IERZVD .NE. 0) GO TO 430
      IRC=2
      GO TO 40
C                            Hole Zeichen.
C
  430 IF (IVBFLG .EQ. 0) GO TO 460
      IVBFLG=0
      IF (KARPOI) 440,470,450
  440 IRC=7
      GO TO 1200
C
  450 IF (KARPOI-KAREND) 480,480,490
  460 IF (KARPOI-KAREND) 470,510,440
  470 KARPOI=KARPOI+1
  480 ILZCH=KARTE(KARPOI)
      IF (ILZCH .NE. IBUARZ) GO TO 500
      IF (IZRET .EQ. 2) GO TO 360
      IF (IZRET .EQ. 4) GO TO 710
      KARPOI=KAREND+1
  490 ILZCH=IBUKAE
  500 GO TO (330,360,530,710,770,900,940,1070,980),IZRET
  510 KARPOI=KARPOI+1
      GO TO 490
C
C*************************** KONVERSIONSTEIL; ALLGEMEINER TEIL
C
  520 KOCOU=0
      IZRET=3
      GO TO 430
C                            Teste auf Blank.
C
  530 IF (ILZCH-IBUBLK) 630,430,540
C
C                            Teste auf Komma.
C
  540 IF (ILZCH .NE. IBUKOM) GO TO 550
      IF (KOCOU .GT. 0) GO TO 560
      KOCOU=1
      GO TO 430
C                            Teste auf Stern (Default).
C
  550 IF (ILZCH-IBUSTN) 590,570,590
  560 IVBFLG=1
  570 INFOFL=1
      IF (IFRGO .GE. 0) GO TO 580
      INCOU=IFRAC
      GO TO 40
  580 INCOU=INCOU+1
      INPOI=INPOI+1
      IF (INCOU-IFRAC) 520,40,40
C
C                            Klammer auf.
C
  590 IF (ILZCH .EQ. IBUKLA) GO TO 350
C
C                            Simuliertes Kartenende.
C
      IF (ILZCH .EQ. IBUGLZ) GO TO 410
      IF (ILZCH .EQ. IBUSLA) GO TO 600
      IF (ILZCH .NE. IBUSMI) GO TO 610
  600 INFOFL=1
      GO TO 620
C                            Echtes Kartenende.
C
  610 IF (ILZCH .LT. IBUKAE) GO TO 630
C
C                            Info gefunden?
  620 IENDFL=1
      GO TO 40
C                            Teste, ob verwendbares Zeichen.
C
  630 IF (IFRGO) 650,970,640
  640 IF (IFRGO-4) 840,970,830
C
C*************************** A-Konversion.  Teste auf Apostroph.
C
  650 IF (ILZCH .NE. IBUAPO) GO TO 730
C
C                            Text in Apostrophen konvertieren.
      IZRET=4
      WORT=BLK
      IPOI=0
      IAPFLG=0
      INFOFL=1
      GO TO 430
C
  660 IAPFLG=0
  670 IF (ILZCH .LT. IBUKAE) GO TO 680
      IRC=-1
      IF (INCOU .LT. IFRAC) GO TO 1200
      IRC=-3
      GO TO 1200
C
  680 IF (IPOI .LT. IBFLEN) GO TO 700
      IF (INCOU .GE. IFRAC) GO TO 690
      INCOU=INCOU+1
      INPOI=INPOI+1
      AIN(INPOI)=WORT
  690 WORT=BLK
      IPOI=0
  700 IPOI=IPOI+1
      I1WORT(IPOI)=ILZCH
      GO TO 430
C
  710 IF (ILZCH .NE. IBUAPO) GO TO 720
      IF (IAPFLG .NE. 0) GO TO 660
      IAPFLG=1
      GO TO 430
C
  720 IF (IAPFLG) 780,670,780
C
C                            Text ohne Apostrophe konvertieren.
  730 IZRET=5
      INFOFL=1
      GO TO 750
C                            Hilfspuffer auf Hauptpuffer.
  740 INCOU=INCOU+1
      INPOI=INPOI+1
      AIN(INPOI)=WORT
C                            Loesche Hilfspuffer.
  750 WORT=BLK
      IPOI=0
C                            Zeichen auf Hilfspuffer.
  760 IPOI=IPOI+1
      I1WORT(IPOI)=ILZCH
C
C                            Hole Zeichen.
      GO TO 430
C                            Teste auf Delimiter , BL / * KE
C
  770 IF (ILZCH .EQ. IBUBLK) GO TO 780
      IF (ILZCH .EQ. IBUKOM) GO TO 780
C     IF (ILZCH .EQ. IBUSLA) GO TO 750
      IF (ILZCH .EQ. IBUSMI) GO TO 780
      IF (ILZCH .EQ. IBUSTN) GO TO 780
      IF (ILZCH .LT. IBUKAE) GO TO 790
  780 IVBFLG=1
      INKOU=INCOU
      GO TO 810
C                            Noch Platz auf Hilfspuffer?
C
  790 IF (IPOI .LT. IBFLEN) GO TO 760
C
C                            Noch Platz auf Hauptpuffer?
C
      IF (INCOU-IFRAC) 740,750,750
C
C                            Loesche evtl verbliebenen Rest.
  800 INPOI=INPOI+1
      AIN(INPOI)=WORT
      INKOU=INKOU+1
C                            Loesche Hilfspuffer.
      WORT=BLK
      IPOI=0
C                            Noch Platz auf Hauptpuffer?
C
  810 IF (INKOU .LT. IFRAC) GO TO 800
C
C                            Ist Hilfspuffer geloescht?
C
      IF (IPOI .LE. 0) GO TO 820
      IRC=3
      GO TO 40
  820 INCOU=INCOU+1
      GO TO 40
C
C*************************** C-Konversion ******************************
  830 CONTINUE
      CALL KPSTCD (KARTE,KARPOI,IFXAC,IRC)
      IF (IRC .NE. 0) GO TO 30
      GO TO 960
C*************************** I-Konversion ******************************
C
  840 IMNSFL=1
C                            Teste -, + und Ziffer.
C
      IF (ILZCH .EQ. IBUMNS) GO TO 880
      IF (ILZCH .EQ. IBUPLS) GO TO 890
      DO 850 INUM=1,IFXBAS
      IF (ILZCH .EQ. IBUZFF(INUM)) GO TO 920
  850 CONTINUE
  860 IF (IFRGO .NE. 2) GO TO 870
C
C                            NICHT NUMERISCH
      IVBFLG=1
      GO TO 40
C
  870 IRC=4
      GO TO 30
C
  880 IMNSFL=-1
  890 IZRET=6
      GO TO 430
C
  900 DO 910 INUM=1,IFXBAS
      IF (ILZCH .EQ. IBUZFF(INUM)) GO TO 920
  910 CONTINUE
      GO TO 860
C
  920 IFXAC=INUM-1
      IZRET=7
      GO TO 430
C
  930 IFXAC=IFXAC*IFXBAS+INUM-1
      GO TO 430
C
  940 DO 950 INUM=1,IFXBAS
      IF (ILZCH .EQ. IBUZFF(INUM)) GO TO 930
  950 CONTINUE
C
      IFXAC=IFXAC*IMNSFL
  960 INCOU=INCOU+1
      INPOI=INPOI+1
      AIN(INPOI)=FXAC
      IVBFLG=1
      INFOFL=1
      IF (INCOU-IFRAC) 520,40,40
C
C*************************** Floating-Konversion ***********************
C
  970 IPKTFL=0
      IBUCHE=0
      ISLFLG=0
  980 IFXAC=0
      IMNSFL=1
      IEXAC=0
      IMXFL=0
      IZRET=8
C                            Teste auf - + . und Ziffer.
C
      IF (ILZCH .NE. IBUMNS) GO TO 990
      IMNSFL=-1
      GO TO 430
C
  990 IF (ILZCH .EQ. IBUPLS) GO TO 430
      IF (ILZCH .NE. IBUPKT) GO TO 1010
 1000 IF (IPKTFL .GT. 0) GO TO 1020
      IPKTFL=1
      GO TO 430
C
 1010 IF (ILZCH .LT. IBUZFF(1)) GO TO 1020
      IF (ILZCH .LE. IBUZFF(10)) GO TO 1050
 1020 IF (IFRGO .NE. 4) GO TO 1030
      IVBFLG=1
      GO TO 40
C
 1030 IRC=5
      GO TO 30
C
 1040 IF (IMXFL .GT. 0) GO TO 1060
      IF (IFXAC .LT. IFXMAX) GO TO 1050
      IMXFL=1
      GO TO 1060
 1050 IFXAC=IFXAC*10-IBUZFF(1)+ILZCH
 1060 IEXAC=IEXAC+IMXFL-IPKTFL
      GO TO 430
C                            Teste auf Ziffer, Punkt und E.
C
 1070 IF (ILZCH .LT. IBUZFF(1)) GO TO 1080
      IF (ILZCH .LE. IBUZFF(10)) GO TO 1040
 1080 IF (ILZCH .EQ. IBUPKT) GO TO 1000
      IF (ILZCH .EQ. IBUSLA) THEN
        ISLFLG=ISLFLG+1
        GO TO 1090
      ENDIF
      IF (ILZCH .NE. IBUE) GO TO 1090
      IF (IBUCHE .NE. 0) GO TO 1090
      IBUCHE=1
      IPKTFL=1
      IFXSV=IFXAC*IMNSFL
      IEXSV=IEXAC
      IZRET=9
      GO TO 430
C                            Ende der Konversion.
C
 1090 IF (IBUCHE .NE. 0) GO TO 1100
      IFXAC=IFXAC*IMNSFL
      GO TO 1110
C
 1100 IEXAC=IEXSV+IFXAC*IMNSFL
      IFXAC=IFXSV
 1110 FXAC=FLOAT(IFXAC)
C                            Berechne Exponent.
      I=IABS(IEXAC)
      IF (I .LE. IEXLIM) GO TO 1130
 1120 IRC=6
      GO TO 30
C
 1130 IF (I .LE. 0) GO TO 1170
      J=I/10
      I=I-10*J
      EX=ZPOT1(I+1)
      IF (J .LE. 0) GO TO 1140
      EX=EX*ZPOT2(J)
 1140 IF (IEXAC) 1160,1170,1150
 1150 FXAC=FXAC*EX
      GO TO 1170
C
 1160 FXAC=FXAC/EX
C
 1170 ISLFLG=ISLFLG+1
      IF (ISLFLG-2) 960,1180,1190
 1180 FACSAV=FXAC
      IPKTFL=0
      IBUCHE=0
      IZRET=9
      GO TO 430
 1190 IF (ISLFLG .NE. 3) GO TO 1030
      IF (FXAC .EQ. 0.) GO TO 1120
      FXAC=FACSAV/FXAC
      GO TO 960
C
 1200 IERZVD=0
C                            Reset KARPOI, wenn Zch pending.
      KARPOI=KARPOI-IVBFLG
C
      RETURN
      END
