C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c              -----------------------------------------
                SUBROUTINE addapo (strv,lenv,strn,lenn)
c              -----------------------------------------
c
c Der string strv wird in apostrophe eingeschlossen und darin
c enthaltene apostrophe verdoppelt. Ist lenv negativ, werden
c trailing blanks abgeschnitten.
c
c                 geschrieben: 291503 mar 1996 (Hundt)
c              -----------------------------------------
c
      IMPLICIT NONE
      INTEGER *4 lenv,lenn
      INTEGER *1 strv(*),strn(*)
c
      INTEGER *4 len,i,j
      len=lenv
      if (len .lt. 0) then
        len=-len
   10   if (strv(len) .ne. 32) go to 20
        len=len-1
        if (len .ge. 1) go to 10
        go to 20
      endif
c
   20 i=0
      j=1
      go to 40
c
   30 strn(j)=strv(i)
      j=j+1
      if (strv(i) .ne. 39) go to 50
   40 strn(j)=39
      j=j+1
   50 i=i+1
      if (i .le. len) go to 30
      strn(j)=39
      lenn=j
      return
      END
