C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                        ---------------------
                          FUNCTION ARCCOS (X)
C  CY-ENG-               ---------------------
C
C     ARCCOS(X) IN DEGREES
C
      IMPLICIT NONE
      REAL *4 A,X,ARCCOS
      IF (X .EQ. 0.) THEN
        A=90.0
      ELSE IF (X .LE. -1.) THEN
        A=180.0
      ELSE IF (X .GE. +1.) THEN
        A=0.0
      ELSE
        A=ATAN(SQRT(1.0-X*X)/X)*57.29578
        IF (X .LT. 0.) A=A+180.
      ENDIF
      ARCCOS=A
      RETURN
      END
