C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                     -------------------------
                       SUBROUTINE ATOM (IQA,Z)
C  CY-ENG-            -------------------------
C
C                   BEARBEITET: 170905 JAN 90 (HUNDT)
C
      IMPLICIT NONE
      INTEGER *4 IQA
      REAL    *4 Z(3)
      INCLUDE 'ZVCOM.INC'
C
C---- ES WERDEN DIE TRIKLINEN KOORDINATEN Z FUER DEN ATOMBEZEICHNERCODE
C     IQA  BERECHNET.
C
      INTEGER *4 J
C
      ICDS(7)=IQA
      NC=7
      NTRY=24
      CALL ZVDEK
      IF (IERR .EQ. 0) THEN
        DO  J=1,3
          Z(J)=X(J,7)
        ENDDO
      ELSE
        DO  J=1,3
          Z(J)=0.
        ENDDO
      ENDIF
      RETURN
      END
