C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CCNVTLO        ---------------------------------------
                SUBROUTINE CNVTLO (STRING,ISTART,LEN)
C              ---------------------------------------
C
C  Das Programm konvertiert Grossbuchstaben in Kleinbuchstaben.
C
C                 geschrieben: 301544 JUN 86 (Hundt)
C                 geaendert:   010744 JUL 89 (Hundt)
C
C CY-ENG-      ---------------------------------------
C
      IMPLICIT NONE
      INTEGER *4 I,J,N,ISTART,LEN
      INTEGER*1 STRING(*)
C
      I=ISTART
      DO  J=1,LEN
        N=STRING(I)
        IF (N .GE.  65 .AND. N .LT.  91) STRING(I)=N+32
        I=I+1
      ENDDO
      RETURN
      END
