C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                --------------------------------
                  SUBROUTINE DRAW (W,DX,DY,NPEN)
C                --------------------------------
C
C               BEARBEITET:  140752 JAN 92 (HUNDT)
C
C---- PROGRAMM ZUR STEUERUNG DES PLOTTERS
C
      IMPLICIT NONE
      INTEGER *4 NPEN,I
      REAL    *4 W(3),DX,DY,X(3),Y(3),Z(3)
C
      INCLUDE 'KPORC.INC'
C
      Y(1)=W(1)+DX
      Y(2)=W(2)+DY
      IF (ITILT .LT. 0) THEN
C
C---- DREHE BEI PERSPEKTIVISCHEM TITEL.
C
        Y(3)=XO(3)
        DO  I=1,3
          Z(I)=Y(I)-VT(I,4)
        ENDDO
        DO  I=1,3
          X(I)=VT(I,1)*Z(1)+VT(I,2)*Z(2)+VT(I,3)*Z(3)+VT(I,4)
        ENDDO
        CALL PLTXY (X,Y)
      ENDIF
C
C---- TESTE AUF RANDUEBERSCHREITUNG.
C
C     DO  J=1,2
C       IF (Y(J) .GT. XLNG(J)-.1) Y(J)=XLNG(J)-.1
C       IF (Y(J) .LT. .1) Y(J)=.1
C     ENDDO
C                            FUEHRE DAS ZEICHENKOMMANDO AUS.
      CALL UPLINF (Y,NPEN)
      RETURN
      END
