C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                -------------------------------------
                  SUBROUTINE KPCDST (STRNG,ISTRT,NUM)
C                -------------------------------------
C
C  Konvertiert eine zahl NUM (I*4) in einen string (I*1).
C
C                geschrieben: 111331 DEC 1999  (Hundt)
C
C               ----------------------------------------
C
      IMPLICIT NONE
C
      INTEGER *4 ISTRT,NUM,I,J,IP,JE,IFK
      INTEGER *1 STRNG(*),ITAB(0:21)
C
      DATA ITAB/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,
     1          1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1H ,1H-/
      IP=ISTRT
      JE=ISTRT-1
      DO  I=1,10
        JE=JE+1
        STRNG(JE)=ITAB(20)
      ENDDO
      I=ABS(NUM)
      IF (I .GT. 100000) IP=JE-1
   10 IFK=10
      IF (JE .EQ. IP) IFK=20
      J=I/IFK
      STRNG(JE)=ITAB(I-IFK*J)
      JE=JE-1
      I=J
      IF (I .NE. 0) GO TO 10
      IF (NUM .LT. 0) STRNG(JE)=ITAB(21)
C
      RETURN
      END
