C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C            ----------------------------------------------
                SUBROUTINE KPSTCD (STRNG,ISTRT,NUM,IRC)
C            ----------------------------------------------
C
C  Konvertiert einen string (I*1) in einen code (I*4)
C
C                geschrieben: 070919 DEC 1999  (Hundt)
C                  geaendert: 251032 MAR 2000  (Hundt)
C
C               ----------------------------------------
C
      IMPLICIT NONE
C
      INTEGER *4 ISTRT,NUM,IRC,I,IE,J,IP,JE,IFK,IVZ
      INTEGER *1 STRNG(*),ITAB(0:21)
C
      DATA ITAB/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,
     1          1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1H ,1H-/

      IRC=0
      NUM=0
      IVZ=1
C                          Negativ?
C
   10 IF (STRNG(ISTRT) .EQ. ITAB(21)) THEN
        ISTRT=ISTRT+1
        IVZ=-1
      ENDIF
C                          Suche das ende.
      IE=ISTRT
   20 CONTINUE
      IF (STRNG(IE) .GE. 97 .AND. STRNG(IE) .LT. 123)
     +STRNG(IE)=STRNG(IE)-32
      DO  J=0,19
        IF (STRNG(IE) .EQ. ITAB(J)) GO TO 30
      ENDDO
      GO TO 40
   30 IE=IE+1
      GO TO 20
C                        Teste, ob nur nummer.
   40 J=IE-ISTRT
      IF (J .GT. 0 .AND. J .LT. 5) THEN
        IP=-1
        GO TO 50
      ELSE
        IF (J .GT. 5) THEN
          IP=IE-2
          GO TO 50
        ENDIF
      ENDIF
      IRC=4
      GO TO 999
   50 JE=9
      IFK=10
      IF (ISTRT .EQ. IP) THEN
        JE=19
        IFK=20
      ENDIF
      DO  I=0,JE
        IF (STRNG(ISTRT) .EQ. ITAB(I)) GO TO 60
      ENDDO
      IF (ISTRT .NE. IE) THEN
        IRC=4
        ISTRT=IE
      ENDIF
      NUM=NUM*IVZ
      GO TO 999
C
   60 NUM=NUM*IFK+I
      ISTRT=ISTRT+1
      GO TO 50
C
  999 RETURN
      END
