C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                       ------------------------
                         SUBROUTINE KPWRTE (NR)
C                       ------------------------
C
C--- Schreibt den Pufferinhalt auf die einheit mit der nummer NR.
C
C                 geschrieben: 210915 oct 1996 (Hundt)
C                   geaendert: 091653 may 2005 (Hundt)
C
      IMPLICIT NONE
      INTEGER *4 NR,I,NRA,ISPOI,J,STDOUT
      PARAMETER (STDOUT=6)
      CHARACTER*120 SLINE
C
      INCLUDE 'WRBFR.INC'
C
      SAVE SLINE,ISPOI
C
      DATA ISPOI/0/
C
      NRA=IABS(NR)
      DO  I=120,1,-1
        IF (WRLINE(I:I) .NE. ' ') GO TO 10
      ENDDO
      I=1
   10 CONTINUE
CYDOS1
      IF (WRLINE .EQ. 'rdrw') GO TO 999
CYDOS2
      IF (NR .GT. 0) THEN
        IF (NRA .NE. NTOSYS) THEN
	  IF (NRA .EQ. STDOUT) THEN
	    call output(WRLINE)
	  ELSE
	    WRITE (NRA,'(A)') WRLINE(1:I)
	  ENDIF
	ENDIF
        IF (NTOSYS .GT. 0 .AND.
     +    (NRA .EQ. STDOUT .OR. NTOSYS .EQ. NRA)) THEN
          WRITE (NTOSYS,'(A,A)') SLINE(1:ISPOI),WRLINE(1:I)
          ISPOI=0
        ENDIF
      ELSE
        IF (NRA .NE. NTOSYS) THEN
	  CALL OUTPUT(WRLINE)
	ELSE
      	  WRITE (NRA,'($,A)') WRLINE(1:I)
	ENDIF
        IF (NTOSYS .GT. 0) THEN
          DO  J=1,I
            IF (ISPOI .LT. 120) THEN
              ISPOI=ISPOI+1
              SLINE(ISPOI:ISPOI)=WRLINE(J:J)
            ENDIF
          ENDDO
        ENDIF
      ENDIF
  999 RETURN
      END
