C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C             -------------------------------------------
               SUBROUTINE PROJ (D,DP,X,XO,VIEW,I1,I2,I3)
C             -------------------------------------------
C  CY-ENG-
C
C     ***** 3D CARTESIAN TO 2D PLOTTER COORDINATES *****
C
      IMPLICIT NONE
      INTEGER *4 I,I1,I2,I3
      REAL    *4 D(3,1),DP(2,1),X(3),XO(3),T1,T2,T3,T4,VIEW
C
      T3=VIEW-X(3)
      DO  I=I1,I2,I3
        T1=D(1,I)+X(1)
        T2=D(2,I)+X(2)
        IF (VIEW .GT. 0.) THEN
          T4=VIEW/(T3-D(3,I))
          T1=T1*T4
          T2=T2*T4
        ENDIF
        DP(1,I)=T1+XO(1)
        DP(2,I)=T2+XO(2)
      ENDDO
      RETURN
      END
