C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                    ------------------------------
                      SUBROUTINE UPLINF (AR,NSTEU)
C                    ------------------------------
C
C   Das Programm kann als Substitution fuer die Graphiktreiber
C   eingesetzt werden.
C
C                geschrieben: 170949 jul 1994  (Hundt)
C
C                    ------------------------------
C
      IMPLICIT NONE
C
      INTEGER *4 NSTEU
      INTEGER *4 I,NTFILE,nret
      REAL    *4 AR(*),AI
      real*4 aapxlg,aascre
      save nret
      EQUIVALENCE (I,AI)
      DATA NTFILE/6/,aascre/4HSCRE/,aapxlg/4HPXLG/ ,nret/0/
C
      IF (NSTEU) 40,60,10
   10 IF (NSTEU .GT. 37) GO TO 360
      GO TO (80,20,20,15,15,100,20,120,140,160,160,360,991,200,991,
c             1  2  3  4  5   6  7   8   9  10  11  12  13  14  15
     1 991,240,260,15,300,160,20,20,160,160,160,20,160,320,340,160,
c       16  17  18 19  20  21 22 23  24  25  26 27  28  29  30  31
     2 400,400,400,400,400,400),NSTEU
C       32  33  34  35  36  37
c                            4-5,19
   15 call uplinfc(ar,nsteu)
      go to 991
C                            2-5,7,22-23,27
   20 call uplinfc(ar,nsteu)
      if (nsteu .eq. 27) then
C      call schreibbuffer()
      endif
      go to 999
C                            -1
C
   40 if (ar(1) .eq. aapxlg) then
        nret=0
        go to 991
      endif
      GO TO 999
C                            0
   60 call uplinfc(ar,0)
      GO TO 999
C                            1
   80 continue
      if (ar(1) .eq. aapxlg) then
        nret=1
        go to 991
      else
        call uplinfc(ar,nsteu)
        endif
      GO TO 999
C                            6
  100 call uplinfc(ar,nsteu)
      GO TO 999
C                            8
  120 continue
      AR(1)=0.
      AR(2)=0.
      AR(3)=0.
      AR(4)=0.
      call uplinfc(ar,NSTEU)
      GO TO 999
C
  140 continue
      call uplinfc(ar,NSTEU)
      GO TO 999
C                            10-11,16,21,24-26,28,31
  160 AI=AR(1)
      call uplinfc(ar,NSTEU)
      GO TO 999
C                            13
  180 call uplinfc(ar,NSTEU)
      GO TO 999
C                            14
  200 call uplinfc(ar,NSTEU)
      GO TO 999
C                            15
  220 continue
c     WRITE (NTFILE,230)
c 230 FORMAT (' DEFINITION EINES FUELLMUSTERS')
      GO TO 999
C                            17
  240 I=1
      AR(1)=AI
c     WRITE (NTFILE,250)
c 250 FORMAT (' REPORT TREIBERTYP (+1)')
      GO TO 999
C                            18
  260 continue
c     WRITE (NTFILE,270)
c 270 FORMAT (' GIB TEXT AUS')
      GO TO 999
C                            19
  280 continue
c     WRITE (NTFILE,290) AR(1)
c 290 FORMAT (' OPTION:',F10.5)
      GO TO 999
C                            20
  300 continue
c     WRITE (NTFILE,310)
c 310 FORMAT (' GIB PLOTPUFFER AUS')
      GO TO 999
C                            29
  320 continue
c     WRITE (NTFILE,330)
c 330 FORMAT (' SYSTEM-CALL')
      GO TO 999
C                            30
  340 continue
c     WRITE (NTFILE,350)
c 350 FORMAT (' ZAHL DER BILDSCHIRME (1)')
      I=1
      AR(1)=AI
      GO TO 999
C                            UNDEFINIERT
  400 call uplinfc(ar,nsteu)
      GO TO 999

  360 continue
c 360 WRITE (NTFILE,370) NSTEU
c 370 FORMAT (' >>>>> STEUERZAHL',I6,' NICHT DEFINIERT <<<<<')
      go to 9999
C
  999 if (nret .eq. 0) go to 9999
  991 call uplinx (ar,nsteu)
 9999 RETURN
      END
