C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                       -----------------------
                         subroutine zprn (z,n)
c                       -----------------------
c
c  Ausgabe des strings z auf einen file oder den druckerport (n > 0).
c  n=-1: Setze pfad auf druckerport (default).
c  n=0 : Oeffne 20 und setze pfad auf file.
c  n=-2: Schliesse 20
c
c  Author: Rolf Sievers 1994
c  modifiziert: Hundt 250902 FEB 1997
c
      implicit none
c     include 'dos.fi'
      INCLUDE 'WRBFR.INC'
      integer*4 ntbld,flag,i,j,n
      character *80 chfil
      integer*1 z(*),filnam(80)
c
      save ntbld,flag
c
      equivalence (filnam(1),chfil)
c
      data flag/1/,ntbld/20/
c
      if (n) 10,20,30
   10 if (n .eq. -2) then
        close (ntbld)
        go to 999
      endif
c                            Ausgabe auf druckerport
      flag=1
      go to 999
c                            Ausgabe auf file; oeffne.
   20 flag=0
      chfil=' '
      do  i=1,80
        filnam(i)=z(i)
        if (filnam(i) .eq. 32) go to 25
      enddo
   25 open (ntbld,file=chfil,form='formatted',status='unknown')
      go to 999
c
c
   30 if (flag .EQ. 0) then
        do  j=1,n
          write (ntbld,'($,A1)') z(j)
	enddo
      else
c
c       do j=1,n
c         ah = '00'X
c         al = z(j)
c         dx = '0000'x
c         call fintr ('17'X,regs)
c       end do
      ENDIF
c
  999 return
      end
