C                -----------------------------------
                  SUBROUTINE BOND (IZZ1,IZZ2,IPPAR)
C                -----------------------------------
C                    V E K T O R V E R S I O N
C                 Bearbeitet: 170844 JAN 1990 (Hundt)
C                 Bearbeitet: 180853 may 2001 (Hundt)
C
C
C   Benoetigte Unterprogramme: AXES,DIFV,DRAW,ERPNT,MM,MV,NORM,NUMBUR,
C   PAXES,PLTXY,PROJ,RADIAL,SYMBQL,UNIT,VM,VMV,VV
C
      IMPLICIT NONE
      INTEGER *4 IZZ1,IZZ2,IPERIM(3),IW(13,2),IPPAR,ITYP
      INTEGER *4 I,J,K,L,M,N,NB,NG1,II,IBND,KODE,KODEM,NBND,KL
      INTEGER *4 IRLINE(30)
C
      REAL    *4 B(3,3),E(3,3),R(3,3),RT(3,3),SS(3,3),U(3,3),VUE(3)
      REAL    *4 V7(3),W(13,2),DIST,VMV,HGT,VV,T6,T1
      REAL    *4 CONE,T2,T5,RADIUS,T3,T4
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
C
      EQUIVALENCE (W(1,1),IW(1,1)),(WRLINE,IRLINE(1))
C
      DATA IPERIM/0,0,1/
C
      CALL UPLINF (IATF(2,IPPAR),11)
      NB=1
      NG1=0
      DO  I=1,2
        DO  J=1,13
          W(J,I)=0.
        ENDDO
      ENDDO
      IW(1,1)=ICD(IZZ1,NS)
      IW(1,2)=ICD(IZZ2,NS)
C
      DO  I=1,2
        CALL XYZ (IW(1,I),W(4,I),2)
        IF (NG .NE. 0) THEN
          NG1=1
          WRITE (WRLINE,90) AT(5,K,NS),AT(6,K,NS),K,L,(W(J,I),J=2,9)
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 'Atom ausserhalb des Zeichenfeldes.'
          CALL KPWRTE (NTDISP)
        ELSE
          DO  J=1,3
            W(J+6,I)=XT(J)
          ENDDO
          K=IW(1,I)/200000
          L=IW(1,I)-K*200000
          CALL PLTXY (W(4,I),W(2,I))
          IF (ISKP(6) .NE. 0) THEN
            WRITE (WRLINE,90) AT(5,K,NS),AT(6,K,NS),K,L,(W(J,I),J=2,9)
   90       FORMAT (' ',2A4,' (',I4,' ',I5,') ',
     +      2F8.2,5X,3F8.3,13X,3F8.4)
            CALL KPWRTE (NTOUT)
          ENDIF
        ENDIF
      ENDDO
      IF (NG1 .NE. 0) GO TO 999
      CALL DIFV (W(7,1),W(7,2),V7)
      DIST=SQRT(VMV(V7,AA,V7))
      IF (NTYP .EQ. 2) THEN
        CALL UPLINF (IATF(1,IPPAR),10)
        HGT=SCL*.012
C       RADIUS IN     CD(3,1)
        CALL SYMBQL (W(2,1),W(3,1),HGT,MOD(IW(1,1)/200000,10),0,0.,-1)
        CALL SYMBQL (W(2,2),W(3,2),HGT,MOD(IW(1,2)/200000,10),0,0.,-2)
        GO TO 780
      ENDIF
C                            Typ (t)
      KODE=IATF(11,IPPAR)
      KODEM=KODE
      IF (KODE .EQ. 0) THEN
        NBND=0
        GO TO 160
      ELSE IF (KODE .LT. 0) THEN
        KODE=-KODE
      ENDIF
      NBND=128/2**KODE
C
C     Bringe hoechstes atom auf position eins
C
  160 IF (VIEW .EQ. 0.) THEN
        W(12,1)=1.
        W(12,2)=1.
        IF (W(6,1)-W(6,2)) 210,230,230
      ENDIF
C
C     Vektor vom atom zum augpunkt
C
      DO  I=1,2
        DO  J=10,12
          W(J,I)=-W(J-6,I)
        ENDDO
        W(12,I)=W(12,I)+VIEW
C
C     Abstand zum augpunkt zum quadrat
C
        W(13,I)=VV(W(10,I),W(10,I))
      ENDDO
      IF (W(13,2) .GE. W(13,1)) GO TO 230
C
C     Vertausche atome
C
  210 DO  J=1,13
        K=IW(J,1)
        IW(J,1)=IW(J,2)
        IW(J,2)=K
      ENDDO
C
C     Einheitsmatrix
C
  230 DO  K=1,3
        DO  J=1,3
          E(J,K)=0.
        ENDDO
        E(K,K)=1.
      ENDDO
C
C     ***** FORM VECTOR SET RADIAL TO BOND *****
C
      CALL DIFV (W(4,2),W(4,1),DA(1,3))
      CALL UNIT (DA(1,3),V3,1)
      T6=ABS(V3(3))
      IF (.9994 .LT. T6) GO TO 790
      T1=T(3)/CONST(43)
      IF (NTYP .EQ. 3) T1=.001
      IF (ICDS(6) .EQ. 0) T1=T1+T(1)
      CALL AXES (V3,E(1,3),B,1)
      DO  J=1,3
        DA(J,1)=-B(J,2)*T1
        DA(J,2)=-B(J,3)*T1
      ENDDO
      IF (NBND .LE. 0) GO TO 680
      CALL RADIAL (3)
C
C     ***** DERIVE QUADRICS FOR EACH ATOM *****
C
      DO  II=1,2
        CALL PAXES (IW(1,II),2)
        IF (NG .NE. 0) THEN
          WRITE (WRLINE,'(A,I3,I10)') 'RC aus PAXES (NG):',NG,IW(1,II)
          CALL KPWRTE (NTDISP)
          RETURN
        ENDIF
C
C       Geht die bindung zum ellipsoid oder zum rand
C
        T1=3-II*2
        DO  J=1,3
          V3(J)=V3(J)*T1
          VUE(J)=0.
        ENDDO
        IF (KODEM .LE. 0) GO TO 420
        CALL UNIT (W(10,II),R(1,3),1)
        IF (VMV(V3,Q,R(1,3)) .GE. 0.) GO TO 420
C
C       ***** ESTABLISH VIEW COORDINATE SYSTEM *****
C
        IBND=0
        IF (VIEW .LE. 0.) THEN
C
C       ***** DERIVE TANGENT CYLINDER *****
C
          CONE=0.
        ELSE
C
C       ***** DERIVE TANGENT CONE *****
C
          CONE=SCL*SCL/W(13,II)
          CALL NORM (E(1,2),R(1,3),R(1,1),1)
          CALL UNIT (R(1,1),R(1,1),1)
          CALL NORM (R(1,3),R(1,1),R(1,2),1)
          DO  I=1,3
            DO  J=1,3
              RT(I,J)=R(J,I)
            ENDDO
          ENDDO
C
C       ***** BASE ELLIPSOID ON VIEW COORDINATE SYSTEM *****
C
          CALL MM (RT,Q,U)
          CALL MM (U,R,Q)
        ENDIF
        T1=1./(CONE-Q(3,3))
        T2=CONE*T1
        DO  J=1,2
          DO  K=1,2
            SS(K,J)=Q(K,J)+Q(K,3)*Q(J,3)*T1
          ENDDO
          SS(3,J)=Q(3,J)*T2
          SS(J,3)=Q(J,3)*T2
        ENDDO
        SS(3,3)=Q(3,3)*T2
        IF (CONE .EQ. 0.) GO TO 440
        DO  J=1,3
          VUE(J)=-W(J+9,II)/SCL
        ENDDO
C
C       ***** BASE TANGENT CONE ON WORKING SYSTEM *****
C
        CALL MM (R,SS,U)
        CALL MM (U,RT,SS)
        T5=0.
        GO TO 450
C
C       Uebertrage ellipsoid
C
  420   DO  K=1,3
          DO  J=1,3
            SS(J,K)=Q(J,K)
          ENDDO
        ENDDO
        IBND=II
  440   T5=1.
C
C       Pruefe auf bindungsverjuengung
C
  450   IF (II .LT. 2) THEN
          RADIUS=1.+T6*CONST(41)
        ELSE
          RADIUS=1.-T6*CONST(41)
        ENDIF
        CALL MV (SS,V3,V4)
        T2=VV (V3,V4)
C
C       Berechne schnitt mit der bindung
C
        KL=5-II-II
        DO  K=1,65,4
          DO  J=1,3
            V6(J)=D(J,K)*RADIUS
            V5(J)=V6(J)+VUE(J)
          ENDDO
          T3=VV(V5,V4)
          T4=T3*T3-T2*(VMV(V5,SS,V5)-T5)
          IF (T4 .LT. 0.) THEN
            NG=13
            WRITE (WRLINE,'(A)')
CYENG1
     +      'Bindungsstab dicker als Atom:'
CYENG2
CYENGY     +      'Bonding stick bigger than atom:'
            CALL KPCDST (IRLINE,32,IW(1,II))
            CALL KPWRTE (NTDISP)
            GO TO 999
          ENDIF
C
          T4=SQRT(T4)
          T1=(T4-T3)/T2
          T3=(-T4-T3)/T2
          L=K+KL-1
          DO  J=1,3
            D(J,L)=(V6(J)+T1*V3(J))*SCL
            D(J,L+1)=(-V6(J)-T3*V3(J))*SCL
          ENDDO
        ENDDO
        CALL PROJ (D(1,KL),DP(1,II),W(4,II),XO,VIEW,1,65,4)
        IF (IBND .EQ. 1) THEN
          CALL PROJ (D(1,KL+5),DP(1,II+68),W(4,II),XO,VIEW,1,61,4)
        ELSE
C
C       Ziehe obere hlfte noch einmal nach
C
          DO  K=4,64,4
            L=K+II
            M=L+64
            N=66-L
            IF (N .GT. 0) THEN
              DP(1,M)=DP(1,N)
              DP(2,M)=DP(2,N)
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C
C    Pruefe auf ueberlappung oder verdeckte bindung, aber nur,
C    wenn der bdg-typ >= 0
C
      IF (KODEM .GE. 0) THEN
        DO  K=1,65,32
          T1=0.
          T2=0.
          DO  J=1,2
            T1=T1+(DP(J,K)-W(J+1,1))**2
            T2=T2+(DP(J,K+1)-W(J+1,1))**2
          ENDDO
          IF (T2 .LE. T1) GO TO 790
        ENDDO
      ENDIF
C
C
C     Zeichne einzelheiten der bindung
C
      IF (ICDS(6) .EQ. 0) GO TO 680
      CALL UPLINF (IATF(9,IPPAR),10)
      CALL UPLINF (IATF(10,IPPAR),11)
      K=65
  650 K=K-NBND
      IF (K .LE. 1) GO TO 680
      CALL UPLINF (DP(1,K),3)
      CALL UPLINF (DP(1,K+1),2)
      K=K-NBND
      IF (K .LE. 1) GO TO 680
      CALL UPLINF (DP(1,K+1),3)
      CALL UPLINF (DP(1,K),2)
      GO TO 650
C
  680 CONTINUE
C
C     Aussenlinie der bindung
C
      CALL UPLINF (IATF(1,IPPAR),10)
      K=IATF(2,IPPAR)
      CALL UPLINF (K,11)
      ITYP=22
      IF (IATF(4,IPPAR) .LT. 0) THEN
        IF (ICDS(6) .EQ. 0) GO TO 999
        ITYP=2
      ENDIF
      CALL UPLINF (DP(1,1),ITYP+1)
C
      DO  K=5,129,4
        CALL UPLINF (DP(1,K),ITYP)
      ENDDO
      DO  K=2,66,4
        CALL UPLINF (DP(1,K),ITYP)
      ENDDO
      CALL UPLINF (DP(1,65),ITYP)
C                               Teste, ob nur geputzt wird.
      IF (ICDS(6) .EQ. 0) THEN
        CALL UPLINF (IPERIM,24)
        CALL UPLINF (IPERIM(2),21)
        CALL UPLINF (IPERIM(3),24)
        GO TO 999
      ENDIF
C
      CALL UPLINF (IPERIM(3),24)
      IF (ITYP .EQ. 22) CALL UPLINF (IATF(4,IPPAR),21)
  780 ITILT=0
      IF (ISKP(6) .NE. 0) THEN
        WRITE (WRLINE,810) DIST
        CALL KPWRTE (NTOUT)
  810   FORMAT(' ',59X,'ABSTAND = ',F8.3,/,' ')
      ENDIF
      GO TO 999
  790 NG=14
C      BINDUNG VERDECKT
C
  999 CONTINUE
      RETURN
      END
