C                 ------------------------------
                   SUBROUTINE UPLHGL (AR,NSTEU)
C                 ------------------------------
C
C   CY-VAX-Y
C
C   Dieses Programm produziert HPGL-Code direkt auf den
C   Printer-Port PRN: oder einen File.
C
C               geschrieben: 050800 OCT 1991 (Hundt)
C               geaendert:   161722 jan 2002 (Hundt)
C
C                 ------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'WRBFR.INC'
C
      REAL*4 AR(*),XZER,YZER,FAKT,FAKTX,FAKTY,BFX,BFY,ADFPEN,ADFSTD
      REAL*4 PFMT
C
      INTEGER*4 NSTEU,I,J,OPOI,OMAX,INIT,NTDEV,IPFMT
      INTEGER*4 AKSTD,DFSTD,AKPEN,DFPEN,TRTAB(0:15)
      INTEGER*1 OBUF(80),OCHR(12),ILINE(13),LLINE(6)
C
      EQUIVALENCE (DFPEN,ADFPEN),(DFSTD,ADFSTD),(PFMT,IPFMT)
C
      SAVE XZER,YZER,FAKT,INIT,FAKTX,FAKTY,OBUF,OPOI,BFX,BFY
      SAVE AKSTD,DFSTD,AKPEN,DFPEN,IPFMT
C
CYVAX1
c     DATA OCHR/Z'1B','D','U','P',',',';','S','W','0','.','A','B'/
C                  1   2   3   4   5   6   7   8   9  10  11  12
c     DATA ILINE/Z'1B',1HE,Z'1B',1H%,1H0,1HB,1HI,1HN,1H;,1HS,1HP,1H1,
c    1 1H;/
c     DATA LLINE/Z'1B',1H%,1H0,1HA,Z'1B',1HE/
CYVAX2
CYVAXY
      DATA OCHR/Z'1B' ,'D','U','P',',',';','S','W','0','.','A','B'/
      DATA BFX,BFY/400.,400./  ! Basisskalenfaktoren
      DATA FAKT/1./,INIT/0/,NTDEV/20/,OMAX/60/
CYVAXY
      DATA ILINE/Z'1B',1HE,Z'1B',1H%,1H0,1HB,1HI,
CYVAXY
     + 1HN,1H;,1HS,1HP,1H1,1H;/
CYVAXY
      DATA LLINE/Z'1B',1H%,1H0,1HA,Z'1B',1HE/
      DATA AKSTD/-1/,AKPEN/-1/,DFSTD/3/,DFPEN/1/,IPFMT/1/
      DATA TRTAB/1,5,3,7,2,6,4,1, 1,5,3,7,2,6,4,1/
C
C                            Jumper
C     +---------+---------------------------------------------+
C     I  NSTEU  I   Meaning                                   I
C     +---------+---------------------------------------------+
C     I   <0    I   Leave graphic mode                        I
C     I    0    I   Clear internal buffer                     I
C     I    1    I   Initialisation                            I
C     I    2    I   Draw a line                               I
C     I    3    I   Move to the point                         I
C     I    4    I   Define field origin                       I
C     I    5    I   Move field origin                         I
C     I   10    I   Change pen                                I
C     I   11    I   Change penwidth                           I
C     I   13    I   Define factor                             I
C     I   16    I   0: Landscape, 1 High plot                 I
C     +---------+---------------------------------------------+
C
      IF (NSTEU) 160,160,5
    5 IF (NSTEU .GT. 16) GO TO 999
   10 GO TO (20,60,60,120,130,999,999,999,999,140,
C             1  2  3   4   5   6   7   8   9  10
     + 145,999,150,999,999,51),NSTEU
C       11  12  13  14  15 16
C
C                       INIT
C
   20 IF (INIT) 999,30,999
   30 CONTINUE
C      OPEN (NTDEV,FILE='PRN:')
C       open (NTDEV,file='HPGLFL.DAT',carriagecontrol='LIST',
C     1       status='NEW',FORM='FORMATTED')
      INIT=1
      OPOI=0
      WRITE (WRLINE,40) (ILINE(I),I=7,13)
      CALL KPWRTE (NTDEV)
   40 FORMAT (80A1)
      AKPEN=0
      DFPEN=3
C                       FAKTOR
   50 FAKTX=BFX*FAKT
      FAKTY=BFY*FAKT
      GO TO 52
C
   51 PFMT=AR(1)
   52 XZER=0.
      IF (IPFMT .NE. 0) GO TO 55
      YZER=10800.
      GO TO 999
C
   55 YZER=0.
      GO TO 999
C                       POINT und LINE
   60 CONTINUE
      IF (OPOI-OMAX) 90,70,70
   70 IF (INIT) 999,999,80
   80 WRITE (WRLINE,40) (OBUF(I),I=1,OPOI)
      CALL KPWRTE (NTDEV)
      OPOI=0
   90 IF (AKSTD-DFSTD) 100,110,100
C
C                       Setze Strichstaerke
C
  100 OBUF(OPOI+1)=OCHR(4)
      OBUF(OPOI+2)=OCHR(8)
      OBUF(OPOI+3)=OCHR(9)
      OBUF(OPOI+4)=OCHR(10)
      AKSTD=DFSTD
      OPOI=OPOI+4
      CALL KPNTOS (AKSTD,OBUF,OPOI,0)
      OPOI=OPOI+1
      OBUF(OPOI)=OCHR(6)
      GO TO 60
C                       Stift

  110 IF (AKPEN-DFPEN) 111,115,111
  111 OBUF(OPOI+1)=OCHR(7)
      OBUF(OPOI+2)=OCHR(4)
      AKPEN=DFPEN
      OPOI=OPOI+2
      CALL KPNTOS (AKPEN,OBUF,OPOI,0)
      OPOI=OPOI+1
      OBUF(OPOI)=OCHR(6)
      GO TO 60
C                       Pen up / down
C
  115 OBUF(OPOI+1)=OCHR(4)
      OBUF(OPOI+2)=OCHR(NSTEU)
      OPOI=OPOI+2
      IF (IPFMT .NE. 0) GO TO 116
      I=AR(2)*FAKTX+XZER
      J=-AR(1)*FAKTY+YZER
      GO TO 118
C
  116 I=AR(1)*FAKTX+XZER
      J=AR(2)*FAKTY+YZER
  118 CALL KPNTOS (I,OBUF,OPOI,0)
      OPOI=OPOI+1
      OBUF(OPOI)=OCHR(5)
      CALL KPNTOS (J,OBUF,OPOI,0)
      OPOI=OPOI+1
      OBUF(OPOI)=OCHR(6)
      GO TO 999
C                       FELD-URSPRUNG
C
  120 IF (IPFMT .NE. 0) GO TO 122
      XZER=AR(2)*BFX
      YZER=(27.-AR(1))*BFY
      GO TO 999
C
  122 XZER=AR(1)*BFX
      YZER=AR(2)*BFY
      GO TO 999
C
  130 IF (IPFMT .NE. 0) GO TO 132
      XZER=XZER+AR(2)*BFX
      YZER=YZER-AR(1)*BFY
      GO TO 999
C
  132 XZER=XZER+AR(1)*BFX
      YZER=YZER+AR(2)*BFY
      GO TO 999
C                       NEUER PEN
  140 ADFPEN=AR(1)
      IF (DFPEN .LT. 0) DFPEN=0
      IF (DFPEN .GT. 15) DFPEN=0
      DFPEN=TRTAB(DFPEN)
      GO TO 999
C                       Neue Strichstaerke
  145 ADFSTD=AR(1)
      GO TO 999
C                       FAKTOR
  150 FAKT=AR(1)
      GO TO 50
C                       TEMPORAERES / ENDGUELTIGES ENDE
C
  160 IF (INIT) 999,999,170
  170 IF (OPOI) 190,190,180
  180 WRITE (WRLINE,40) (OBUF(I),I=1,OPOI)
      CALL KPWRTE (NTDEV)
      OPOI=0
  190 IF (NSTEU) 200,999,999
  200 CONTINUE
      WRITE (WRLINE,40) LLINE
      CALL KPWRTE (NTDEV)
C      CLOSE (NTDEV)
      INIT=0
C
  999 RETURN
      END
