CKPEXPU   07             -------------------
                          SUBROUTINE ZVEXPU
C                        -------------------
C                          VEKTOR-VERSION
C
C  Das Programm fuehrt die gespeicherten Plotbefehle aus.  Es wird
C  vorausgesetzt, dass die Codeliste sortiert ist in der Weise, dass die
C  z-Koordinaten der gespeicherten Atome steigen.  Beim Plotten werden
C  dann verdeckte Linien beruecksichtigt.
C
C                 geaendert:   161723 jan 2002  (Hundt)
C
C                        -------------------
C
      INTEGER ATMSYM
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
C                            Parameter fuer Kugeln
      INTEGER *4 IDCBDM
      PARAMETER (IDCBDM=6)
      REAL    *4 DCB(9,IDCBDM)
      INTEGER *4 IDCB(9,IDCBDM)
C
      DIMENSION IAT(6,PARDIM,2),IAIN(72),VQ(IPKDIM,2)
      INTEGER *4 IPERIM(3)
      REAL*4    AATF(17,IATFDM)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(IDCB(1,1),DCB(1,1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (X(1,1),XK),(X(2,1),YK),(IATF(1,1),AATF(1,1))
C
      SAVE IDCB
C
      DATA IBLANK/4H    /,IPERIM/0,0,1/
C
C  NTYP:  Kommando:
C   1      EXP/EXPU  Plotbefehle ausfuehren
C   2      LNP       Loesche Nicht-Plot-Liste
C   3      NP        Nicht plotten (Codes)
C   4      NPN       Nicht plotten (Nummern in Codeliste)
C   5      SKG       Schraffiere Kugeln
C   6      OSKG      Schreibe Kontrollbloecke
C   7      QSKG      Schreibe Kontrollbloecke auf File
C   8      NPM       Nicht plotten (Codes aus Mausliste)
C   9      QNP       Nicht plotten (Nummern in Codeliste)
C  10      ATF       Atomfarbe definieren
C  11      OATF      Atomfarbe listen
C  12      QATF      Atomfarbe punchen
C  13      -         Initialisierung
C  14      XC        Farbzahlen tauschen
C
C
      NTYPS=NTYP
      GO TO (10,1280,1290,1290,1425,1490,1520,1580,1550,1590,
C             1    2    3    4    5    6    7    8    9   10
     1 1650,1680,1630,1710), NTYPS
C        11   12   13   14
C                            EXP/EXPU Berechne freie Koordinaten,
C                            soweit noch nicht geschehen.
C
   10 IF (IPKP(NS) .LE. 0) GO TO 9993
      VIEW=HOE*O9
      K8(NS)=0
      NTRY=44
      NC=1
      GO TO 40
   20 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO 30 I=1,3
   30 ATOMS(I,K9(NS),NS)=X2(I)
   40 IF (NCD(NS)-K9(NS)) 50,50,20
C                            Suche nach Polyedercode
   50 IPEFLG=0
      IPKPNT=1
      GO TO 90
C
   60 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF-8) 80,100,70
   70 IF (IPLTBF-11) 100,80,71
   71 IF (IPLTBF-15) 80,100,72
   72 IF (IPLTBF-17) 100,100,80

C
   80 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
   90 IF (IPKPNT-IPKP(NS)) 60,110,110
C
C                            Polyedercode gefunden.  Initialisiere.
  100 CALL ZVPLDR (IPEFLG)
      IF (IERR) 9990,110,9990
C
C                            Uebergib die akt. Feldgroesse.
C
  110 CALL UPLINF (CONST(8),27)
      IF (ISKP(7)) 150,120,150
  120 ISKP(25)=0
C                            Setze Konstanten fuer die Abschattung.
C
  150 IF (NCDA(NS)-NCD(NS)) 160,160,9990
  160 TEMX=ATOMS(3,NCDA(NS),NS)
      TEMP=ATOMS(3,NCD(NS),NS)-TEMX
      IF (TEMP) 180,170,180
  170 CONST(26)=0.
      CONST(25)=(CONST(23)+CONST(24))*.5
      GO TO 190
  180 CONST(26)=(CONST(24)-CONST(23))/TEMP
      CONST(25)=CONST(23)-CONST(26)*TEMX
C
C                            Initialisiere mit Default-Pen
C
      CALL UPLINF (ISKP(41),10)
C
C                            Starte Lauf.
  190 IC1=NCD(NS)+1
C                            Setze Atom 1 um eins weiter
C
  220 IC1=IC1-1
      IF (IC1 .LT. NCDA(NS)) GO TO 1000
C
C                            Zeichne ggf. Polyeder
      IF (IPEFLG) 250,260,250
  250 CALL ZVPLDR (IC1)
      IF (IERR) 9990,260,9990
C
  260 IC1CD=ICD(IC1,NS)
      IZ1=IC1CD/200000
      NCOLPO=ICLRP(IZ1,NS)
      IF ((NCOLPO .LT. 1) .OR. (NCOLPO .GT. IATFDM)) NCOLPO=1
      NCOLOR=IATF(1,NCOLPO)
      ISTRK=IATF(2,NCOLPO)
      NCOLFL=IATF(3,NCOLPO)
      IPOLS=IATF(4,NCOLPO)
      NCOLSR=IATF(5,NCOLPO)
      ISTRS=IATF(6,NCOLPO)
      IF (KEYIN(0) .NE. ISKP(20)) GO TO 300
      IERR=-1
      GO TO 9990
C                            Setzte Modus auf Sperren und Phase=1
C
  270 IF ((ISKP(25) .EQ. 0) .OR. (IPOLS .LT. 0)) GO TO 220
  280 IF (IPKFLG) 290,220,290
  290 IPEN=22
      TEMP=X(1,2)
      IF (ISKP(27) .GE. 0) GO TO 440
      TEMP=X(1,2)+T(1)
      GO TO 440
C                            Atom2 = Atom1;  Auftrag: Plotte Kreis
  300 IC=IC1
C                            Berechne Plotkoordinaten. hinterlege dabei
C                            die Parameter fuer Verbindungen.
      ICDS(6)=1
      X(3,1)=ATOMS(3,IC1,NS)
      TEMPFK=HOE/(HOE-X(3,1))
      X(3,2)=TEMPFK
      XK=ATOMS(1,IC1,NS)*TEMPFK
      YK=ATOMS(2,IC1,NS)*TEMPFK
      TEMP=AT(4,IZ1,NS)*TEMPFK*FKGL
      ATMSYM=IAT(5,IZ1,NS)
C
C--- ISKP(10) > 0 hat folgende Bedeutung:
C    1: Beschriften mit Atomsymbol, 2. Buchstabe klein
C    2: Beschriften mit Unterscheider
C    3: Beschriften mit Atomsymbol, unveraendert
C    4: Beschriften mit Platznummer; wenn > 100, dann geht es mit
C       Buchstaben weiter, A0 = 100,...,Z9 = 359.
C    5: Wie 4, aber nur Codes xx55501
C    6: Wie 5, aber nur Codes xx555yy
C
      IF (ISKP(10) .EQ. 2) ATMSYM=IAT(6,IZ1,NS)
      IF (ISKP(10) .EQ. 4 .OR. ISKP(10) .EQ. 5
     1  .OR. ISKP(10) .EQ. 6) THEN
        ATMSYM=IBLANK
        IF (ISKP(10) .EQ. 4 .OR.
     +    (ISKP(10) .EQ. 5 .AND. IZ1*200000+111001 .EQ. IC1CD) .OR.
     +    (ISKP(10) .EQ. 6 .AND. IZ1*2000+1110 .EQ. IC1CD/200)) THEN
          IF (IZ1 .LT. 360) THEN
            J=0
            CALL KPNTOS (IZ1,ATMSYM,J,0)
            IF (IZ1 .GE. 100) THEN
              CALL COPYCH (ATMSYM,2,2, ATMSYM,1)
              I=IZ1/10+55
              CALL COPYCH (I,1,1, ATMSYM,1)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      T(2)=CONST(26)*ATOMS(3,IC1,NS)+CONST(25)
      T(1)=T(2)/O9
      X(1,2)=TEMP
C                            Setze Modus auf Plotten und Phase=0
      IPKFLG=0
      IPKPNT=1
      IPEN=2
      GO TO 550
C
  310 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF-1) 540,320,540
C
C                            Plotbefehl: Plotte Kreis.
C
  320 IF (IZ1-IPK(IPKPNT+2,NS)) 540,340,330
  330 IF (IZ1-IPK(IPKPNT+3,NS)) 340,340,540
C
C                            Teste, ob Atom in Verbotsliste steht.
  340 IF (NPPOI(NS)) 380,380,350
  350 DO 370 I=1,NPPOI(NS),2
      IF (IC1CD-NPLST(I,NS)) 370,360,370
  360 IF (NPLST(I+1,NS)) 370,540,370
  370 CONTINUE
C                            Baue cos-sin-Tabelle auf (falls veraendert)
  380 NSTPKT=IPK(IPKPNT+4,NS)
      NST=IABS(NSTPKT)
C                            Erzeuge optional Output.
C
  410 IF (ISKP(6)) 420,440,420
  420 AIN(61)=XK*O9+CONST(11)
      AIN(62)=YK*O9+CONST(12)
      WRITE (WRLINE,430)
     + IAT(5,IZ1,NS),IAT(6,IZ1,NS),IC1CD,AIN(61),AIN(62),TEMP
  430 FORMAT (' Atom ',2A4,' (',I8,')  xp=',F8.3,' yp=',F8.3,
     1 ' r=',F7.2)
      CALL KPWRTE (NTOUT)
C                            Hole Radius und plotte Kreis.
C
  440 IF (ISKP(7)) 450,540,450
  450 IF (IPKFLG .NE. 0) GO TO 460
      J=0
      IF (IPK(IPKPNT,NS) .LE. 5) GO TO 365
      J=IPK(IPKPNT+5,NS)
C
  365 IF ((ISKP(25) .EQ. 0) .OR. (IPOLS .LT. 0)) IPEN=2
      IF (IATF(6,NCOLPO) .LE. 0) GO TO 539
      IF (ISKP(10) .LE. 0 .AND. NSTPKT .GT. 0) GO TO 539
      SCHRF=1.0
      IF (NST .LT. 6) SCHRF=0.8
      IF (LCOMPS(ATMSYM,2,1, IBLANK,1)) 510,500,510
  500 AIN(61)=TEMP*0.9*SCHRF
      XORG=AIN(61)*.357143
      GO TO 520
C
  510 AIN(61)=TEMP*0.8*SCHRF
      XORG=AIN(61)*.85
      IF (ISKP(10) .LE. 1) CALL CNVTLO (ATMSYM,2,1)
  520 YORG=AIN(61)*.5
      CALL UPLINF (NCOLSR,10)
      ISKP(42)=NCOLSR
      CALL UPLINF (ISTRS,11)
      CALL SYMBQL ((XK-XORG)*O9+CONST(11),(YK-YORG)*O9+CONST(12),
     1 AIN(61)*O9,ATMSYM,1,0.,ISKP(69))
C
  539 CALL UPLINF (NCOLOR,10)
      ISKP(42)=NCOLOR
      CALL UPLINF (ISTRK,11)
  460 IF (IPEN .EQ. 22) CALL UPLINF (IPERIM,24)
      I=0
      AINCR=CONST(2)/FLOAT(NST)
      ZUSCH=AATF(17,NCOLPO)*CONST(3)
  381 ICNT1=IATF(7,NCOLPO)
      ICNT2=IATF(8,NCOLPO)
      IF (ISKP(60) .NE. 0 .AND. IPFLG(IZ1,NS) .NE. 0) THEN
        ISKP(61)=NCOLPO
        CALL ZVORPA (IC1,IRC)
        GO TO 389
      ENDIF
      IPENT=IPEN+1
      IF (IPEN .LE. 2) GO TO 382
      ICNT1=NST+2
  382 IF (ICNT1 .LE. 0) GO TO 383
      AI=FLOAT(I)*AINCR+ZUSCH
      AIN(61)=(XK+TEMP*COS(AI))*O9+CONST(11)
      AIN(62)=(YK+TEMP*SIN(AI))*O9+CONST(12)
      CALL UPLINF (AIN(61),IPENT)
      IPENT=IPEN
      ICNT1=ICNT1-1
      GO TO 470
C
  383 ICNT2=ICNT2-1
      IF (ICNT2 .LT. 2) GO TO 381
  470 I=I+1
      IF (I .LE. NST) GO TO 382
      IF (IPEN .EQ. 22) THEN
        CALL UPLINF (IPERIM,21)
        CALL UPLINF (IPERIM(3),24)
      ENDIF
C
  389 IF (IPKFLG) 220,480,540
  480 IPKFLG=1
      IF (J .GT. 0 .AND. J .LE. IDCBDM) CALL ZVSHKG (IDCB(1,J))
C                            Skip zum naechsten Plotbefehl
C
  540 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  550 IF (IPKPNT-IPKP(NS)) 310,560,560
C
C                            Setze Atom 2 um eins weiter
  560 IF (IPKFLG) 580,580,570
  570 IPKFLG=-1
  580 IF (IC-NCDA(NS)) 990,990,590
C
C                            Auftrag: Verbinde
  590 IC=IC-1
  591 IC2CD=ICD(IC,NS)
      IZ2=IC2CD/200000
      IPKPNT=1
      GO TO 980
C
  600 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF-2) 970,690,610
  610 IF (IPLTBF-5) 690,970,620
  620 IF (IPLTBF-12) 970,640,630
  630 IF (IPLTBF-14) 640,640,970
C
C                            Verbinde direkt.  Teste, ob Paar
C                            im Befehl vorkommt.
  640 J=IPK(IPKPNT,NS)
      I=5
  650 IF (IPK(IPKPNT+I,NS) .EQ. IC1CD) GO TO 670
  660 I=I+1
      IF (I .LT. J) GO TO 650
      GO TO 970
C
  670 IF (IPK(IPKPNT+I+1,NS) .EQ. IC2CD) GO TO 680
      IF (IPK(IPKPNT+I-1,NS) .NE. IC2CD) GO TO 660
  680 T(3)=VQ(IPKPNT+2,NS)
      TEMP=0.
      GO TO 890
C
C                            Fuehre Plotbefehl aus.  Teste, ob Nummer
C                            in Frage kommt.
C                                        1. Atom = ur?
  690 IF (IZ1-IPK(IPKPNT+2,NS)) 730,710,700
  700 IF (IZ1-IPK(IPKPNT+3,NS)) 710,710,730
C                                        2. Atom = zl?
  710 IF (IZ2-IPK(IPKPNT+4,NS)) 730,770,720
  720 IF (IZ2-IPK(IPKPNT+5,NS)) 770,770,730
C                                        1. Atom = zl?
  730 IF (IZ1-IPK(IPKPNT+4,NS)) 970,750,740
  740 IF (IZ1-IPK(IPKPNT+5,NS)) 750,750,970
C                                        2. Atom = ur?
  750 IF (IZ2-IPK(IPKPNT+2,NS)) 970,770,760
  760 IF (IZ2-IPK(IPKPNT+3,NS)) 770,770,970
C
C                            Teste, ob Bindung verboten.
  770 IF (NPPOI(NS)) 840,840,780
  780 I=1
C
  790 IF (IC1CD-NPLST(I,NS)) 810,800,810
  800 IF (IC2CD-NPLST(I+1,NS)) 810,970,810
C
  810 IF (IC1CD-NPLST(I+1,NS)) 830,820,830
  820 IF (IC2CD-NPLST(I,NS)) 830,970,830
C
  830 I=I+2
      IF (I-NPPOI(NS)) 790,840,840
C
C                            Teste Abstandsintervall.
  840 DMAX=VQ(IPKPNT+7,NS)
      TEMP=0.
      DO 860 I=1,3
      TEMP2=ABS(ATOMS(I,IC1,NS)-ATOMS(I,IC,NS))
      IF (TEMP2-DMAX) 850,850,970
  850 TEMP=TEMP+TEMP2*TEMP2
  860 CONTINUE
C
      IF (TEMP-DMAX*DMAX) 870,870,970
  870 IF (TEMP-VQ(IPKPNT+6,NS)*VQ(IPKPNT+6,NS)) 970,880,880
  880 CONTINUE
C                            Fuehre Verbindung aus.
C
      T(3)=VQ(IPKPNT+8,NS)
  890 X(2,2)=TEMPFK*T(3)
      NTYP=IPLTBF
      IF (ISKP(6)) 900,920,900
  900 TEMP=SQRT(TEMP)
      WRITE (WRLINE,910) IAT(5,IZ2,NS),IAT(6,IZ2,NS),IC2CD,TEMP
      CALL KPWRTE (NTOUT)
  910 FORMAT (' Bindung nach ',2A4,' (',I8,') d=',F8.4)
  920 IF (ISKP(7)) 930,970,930
  930 IF (NTYP .LE. 4) GO TO 940
      NTYP=NTYP-10
      IPOI=IPKPNT+3
      GO TO 960
C
  940 IPOI=IPKPNT+9
  960 I=IPK(IPOI,NS)
      IF (I .LE. 0 .OR. I .GT. IATFDM) I=1
      IF (ISKP(60) .EQ. 0 .OR. IPFLG(IZ1,NS) .EQ. 0 .OR.
     +  IPFLG(IZ2,NS) .EQ. 0 .OR. VQ(IPOI-1,NS) .GT. 20.) THEN
        CALL ZVVBU (I)
      ELSE
        CALL BOND (IC1,IC,I)
      ENDIF
  961 IF (ICDS(6) .NE. 0) GO TO 560
      IF (IC .GE. NCD(NS)) GO TO 990
C
C                            Auftrag: Sperre naechste Bindung
      IC=IC+1
      GO TO 591
C                            Skip zum naechsten Plotbefehl.
C
  970 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  980 IF (IPKPNT-IPKP(NS)) 600,961,961
C
C                            Am Ende eines Zyklus'.
C
  990 IF (ISKP(27) .EQ. 0) GO TO 997
      IF (ICDS(6) .EQ. 0) GO TO 997
      ICDS(6)=0
      IC=IC1
      GO TO 961
C
  997 IF (IPKFLG) 270,220,270
C
 1000 CONTINUE
C                            Zeichne ggf. letzten Polyeder
C
      IF (IPEFLG .NE. 0) CALL ZVPLDR (IC1)
C
C                            Beschriftung ausfuehren.
 1005 AIN(1)=0.
      AIN(2)=0.
      CALL UPLINF (AIN,5)
      IPKPNT=1
      GO TO 1180
C
 1010 NTYP=IPK(IPKPNT+1,NS)
      IF (NTYP-5) 1170,1030,1020
 1020 IF (NTYP-6) 1170,1080,1240
C
C                            Kommando BA - Beschrifte Atom(e).
C
 1030 IF (ISKP(7)) 1040,1170,1040
 1040 ISKP(42)=IPK(IPKPNT+2,NS)
      CALL UPLINF (ISKP(42),10)
      CALL UPLINF (IPK(IPKPNT+3,NS),11)
C
      J=IPKPNT+5
      K=IPKPNT+IPK(IPKPNT,NS)
      NC=1
      NTRY=28
  952 ICDS(1)=IPK(J,NS)
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9980
      TEMP=HOE/(HOE-X2(3))
      AIN(61)=(X2(1)+VQ(J+1,NS))*TEMP*O9+CONST(11)
      AIN(62)=(X2(2)+VQ(J+2,NS))*TEMP*O9+CONST(12)
      AIN(63)=VQ(IPKPNT+4,NS)*O9*TEMP
      IF (ISKP(26)) 1060,1050,1060
 1050 AIN(64)=4.
      AIN(65)=AT(5,IANR,NS)
      CALL UPLINF (AIN(61),18)
      GO TO 1170
 1060 CALL KPCVNM (AT(5,IANR,NS),CONST(36),AIN(66),IAIN(68))
 1070 CALL SYMBQL (AIN(61),AIN(62),AIN(63),IAIN(66),1,0.,IAIN(68))
      J=J+3
      IF (J .LT. K) GO TO 952
      GO TO 1170
C                            BT - Beschrifte mit Text
C
 1080 J=IPK(IPKPNT+7,NS)
      IF (ISKP(7)) 1090,1170,1090
 1090 NTRY=28
      DO 1110 I=1,2
      NC=I
      ICDS(NC)=IPK(IPKPNT+I+1,NS)
      IF (I .NE. 2) GO TO 1085
      IF (ICDS(2) .EQ. 0) ICDS(2)=ICDS(1)
 1085 CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9980
      DO 1100 K=1,3
 1100 X(K,NC)=X2(K)
 1110 CONTINUE
      DO 1120 I=1,3
 1120 X2(I)=(X(I,1)+X(I,2))*.5
      DO 1111 K=1,2
      AIN(61)=HOE/(HOE-X(3,K))
      X(1,K)=X(1,K)*AIN(61)*O9+CONST(11)
      X(2,K)=X(2,K)*AIN(61)*O9+CONST(12)
 1111 CONTINUE
C                       Ermittle Drehwinkel
      ANG=0.
      X1(1)=X(1,2)-X(1,1)
      X1(2)=X(2,2)-X(2,1)
      IF (X1(1) .NE. 0.) GO TO 1114
      IF (X1(2)) 1112,1115,1113
 1112 ANG=-90.
      GO TO 1115
 1113 ANG=90.
      GO TO 1115
 1114 ANG=CONST(4)*ATAN(X1(2)/X1(1))
      IF (X1(1) .LT. 0.) ANG=ANG+180.
C
C                       Rechne Offset um
C
 1115 AIN(63)=COS(ANG*CONST(3))
      AIN(64)=SIN(ANG*CONST(3))
      X1(1)=AIN(63)*VQ(IPKPNT+4,NS)-AIN(64)*VQ(IPKPNT+5,NS)
      X1(2)=AIN(64)*VQ(IPKPNT+4,NS)+AIN(63)*VQ(IPKPNT+5,NS)
      TEMP=HOE/(HOE-X2(3))
      AIN(61)=(X2(1)+X1(1))*TEMP*O9+CONST(11)
      AIN(62)=(X2(2)+X1(2))*TEMP*O9+CONST(12)
      AIN(63)=VQ(IPKPNT+6,NS)*O9*TEMP
      IAIN(64)=4*J
      IF (ISKP(26)) 1150,1130,1150
 1130 JM=MAX0(J,8)
      DO 1140 I=1,JM
 1140 AIN(I+64)=VQ(IPKPNT+I+7,NS)
      AIN(64)=FLOAT(IAIN(64))
      CALL UPLINF (AIN(61),18)
      GO TO 1170
 1150 I=IPK(IPKPNT+7,NS)+8+IPKPNT
      ISKP(42)=IPK(I,NS)
      CALL UPLINF (ISKP(42),10)
      CALL UPLINF (IPK(I+1,NS),11)
 1160 CALL SYMBQL (AIN(61),AIN(62),AIN(63),
     +IPK(IPKPNT+8,NS),1,ANG,IAIN(64))
C
C                            Erhoehe Pointer
 1170 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
 1180 IF (IPKPNT-IPKP(NS)) 1010,1190,1190
C
C                            PR - Plotte Rahmen
C
 1190 IF (ISKP(88) .NE. 0) THEN
        NTYP=6
        CALL ZVPNCD(NS)
      ENDIF
      CALL UPLINF (ISKP(41),10)
      ISKP(42)=ISKP(41)
      CALL UPLINF (ISKP(49),11)
      IF (ISKP(3) .EQ. 0) GO TO 9990
      IF (ISKP(7) .EQ. 0) GO TO 9990
      DO  J=1,10
        AIN(J)=0.
      ENDDO
      IF (ISKP(3) .EQ. 1) THEN
        AIN(3)=CONST(8)
        AIN(5)=CONST(8)
        AIN(6)=CONST(9)
        AIN(8)=CONST(9)
C
        I=3
        DO  J=1,9,2
          CALL UPLINF (AIN(J),I)
          I=2
        ENDDO
        GO TO 9990
      ENDIF
      AIN(2)=CONST(9)
      AIN(3)=CONST(8)
      DO  I=1,3,2
        CALL UPLINF (AIN(I),3)
        CALL UPLINF (AIN(I),2)
      ENDDO
      GO TO 9990
C                            Plotte Pfeil
C
 1240 IF (NTYP-7) 1170,1250,1170
 1250 IF (ISKP(7)) 1260,1170,1260
 1260 DO 1270 I=1,10
 1270 IAIN(I)=IPK(IPKPNT+I+1,NS)
C     CALL KPPPFL
      IF (IERR) 9990,1170,9990
C
C                            LNP
 1280 NPPOI(NS)=0
 1281 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      GO TO 9993
C                            NP  - Addiere Nicht-Plot-Befehl(e)
C
 1290 DO 1300 I=1,72
 1300 IAIN(I)=0
      CALL FLES (IAIN,ISKP(31),4H72CE,11Hc1,c2,...?$)
      J=ISKP(31)
      I=0
      GO TO 1410
 1310 IF (NPPOI(NS)-NPDIM) 1340,1320,1320
 1320 CALL FLES (AIN,AIN,1HK,AIN)
      WRITE (WRLINE,1330)
      CALL KPWRTE (NTOUT)
 1330 FORMAT (' ZVEXPU1250 - Tabelle NPLST voll.')
      GO TO 9993
C
 1340 NPPOI(NS)=NPPOI(NS)+1
      K=IAIN(I)
      IF (K) 1420,1400,1350
 1350 IF (NTYP-4) 1380,1360,1380
 1360 IF (K-NCDDM) 1370,1370,1420
 1370 K=ICD(K,NS)
 1380 IF (K-NATDM) 1390,1390,1400
 1390 K=K*200000+111001
 1400 NPLST(NPPOI(NS),NS)=K
 1410 I=I+1
      IF (I-J) 1310,1310,9993
 1420 IERR=7142016
      NPPOI(NS)=NPPOI(NS)-1
      GO TO 9993
C
C                     Definition der Kugel-Kontroll-Bloecke
C
 1425 CALL FLES (I,ISKP(31),2HIR,4HNr?$)
      IF (I .GT. 0 .AND. I .LE. IDCBDM) GO TO 1430
      IERR=7142016
      GO TO 9994
C
 1430 IF (IDCB(2,I) .LT. 0) GO TO 1450
      DO 1440 J=1,9
 1440 IAIN(J)=IDCB(J,I)
      GO TO 1470
 1450 DO 1460 J=1,9
 1460 IAIN(J)=0
C
 1470 CALL FLES (IAIN,ISKP(31),8H3I3FI2FE,
     1 44HFarbe,Str.-St.,Iflag,D,Wst,Winc,Irep,L1,L2?$)
C
      IF (AIN(4) .LE. 0.) AIN(4)=0.1
      DO 1480 J=1,9
 1480 IDCB(J,I)=IAIN(J)
      GO TO 9994
C                       OSKG
 1490 DO 1510 I=1,IDCBDM
      IF (IDCB(2,I) .LT. -1) GO TO 1510
      WRITE (WRLINE,1500) I,
     1 (IDCB(J,I),J=1,3),(DCB(J,I),J=4,6),IDCB(7,I),(DCB(J,I),J=8,9)
      CALL KPWRTE (NTOUT)
 1500 FORMAT (' (',I1,')',3I3,F5.2,2F7.2,I3,2F5.2)
 1510 CONTINUE
      GO TO 1281
C                       QSKG
 1520 NTYP=NTBILF
      CALL ZVEAEH
      DO 1540 I=1,IDCBDM
      IF (IDCB(1,I) .LT. 0) GO TO 1540
      WRITE (WRLINE,1530) I,
     1 (IDCB(J,I),J=1,3),(DCB(J,I),J=4,6),IDCB(7,I),(DCB(J,I),J=8,9)
      CALL KPWRTE (NTBILF)
 1530 FORMAT ('SKG ',I1,3I3,F5.2,2F7.2,I3,2F5.2)
 1540 CONTINUE
      GO TO 9994
C
C                       QNP
 1550 NTYP=NTBILF
      CALL ZVEAEH
      I=1
 1560 IF (I .GT. NPPOI(NS)) GO TO 9994
      J=I+5
      IF (J .GT. NPPOI(NS)) J=NPPOI(NS)
      WRITE (WRLINE,1570) (NPLST(K,NS),K=I,J)
      CALL KPWRTE (NTBILF)
 1570 FORMAT ('NP ',6I10)
      I=I+6
      GO TO 1560
C                       NPM
 1580 NTYP=7
      I=1
 1585 J=I
      CALL ZVGC01 (J)
      IF (J .EQ. 0) GO TO 1281
      K=I+1
      CALL ZVGC01 (K)
      IF (K .EQ. 0) GO TO 1281
      IF (K .EQ. J) K=0
      IF (NPPOI(NS)+2 .GT. NPDIM) GO TO 1310
      NPPOI(NS)=NPPOI(NS)+2
      NPLST(NPPOI(NS)-1,NS)=J
      NPLST(NPPOI(NS),NS)=K
      I=I+2
      GO TO 1585
C                           Atom-Farben
 1590 I=1
      CALL FLES (I,ISKP(31),2HIR,
     1 61HNr, fr,sr, fm,nm, fs,ss, ns,nl, fi,si, n1,n2,n3,n4, a0,a1,z?$)
      IF (I .LE. 0 .OR. I .GT. IATFDM) THEN
        IERR=7070416
      ELSE
        CALL FLES (IATF(1,I),ISKP(31),6H14I3FE,
     1  57Hfr,sr, fm,nm, fs,ss, ns,nl, fi,si, n1,n2,n3,n4, a0,a1,z?$)
      ENDIF
      GO TO 9993
C                           Initialisierung
 1630 DO  I=1,IDCBDM
        IDCB(1,I)=-2
      ENDDO
      GO TO 9993
C                           Liste Atomfarben
 1650 IAIN(1)=1
      IAIN(2)=IATFDM
      CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
      IF (ISKP(31) .EQ. 1) IAIN(2)=IAIN(1)
      IF (IAIN(2) .LE. 0) IAIN(2)=IAIN(1)
      IF (IAIN(2) .GT. IATFDM) IAIN(2)=IATFDM
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. IAIN(2)) THEN
        IERR=7073216
        GO TO 9993
      ENDIF
      DO  I=IAIN(1),IAIN(2)
        WRITE (WRLINE,1660) I,(IATF(J,I),J=1,14),(AATF(J,I),J=15,17)
 1660   FORMAT ('(',I2,') ',6I3,2I5,6I3,2F7.3,F7.2)
        CALL KPWRTE (NTOUT)
      ENDDO
      GO TO 9993
C                           Punche Atomfarben
 1680 CONTINUE
C                            JETZT IN KPBILF
      GO TO 1281
C                           Tausche Farbzahlen
 1710 DO 1730 I=1,IATFDM
      IF (IATF(1,I) .EQ. IAIN(1)) IATF(1,I)=IAIN(2)
 1730 CONTINUE
C
      DO 1750 I=1,IDCBDM
      IF (IDCB(1,I) .EQ. IAIN(1)) IDCB(1,I)=IAIN(2)
 1750 CONTINUE
      GO TO 9993
C                            Es ist ein Fehler passiert
 9980 WRITE (WRLINE,9981)
      CALL KPWRTE (NTDISP)
 9981 FORMAT (' ZVEXPU9980 - Illegaler Code bei Plotkommandos.')
      IERR=-1
C                            Verlasse Plot-Modus
C
 9990 IF (ISKP(7)) 9991,9993,9991
 9991 IF (ISKP(25)) 9992,9993,9992
 9992 IAIN(1)=1
      CALL UPLINF (AIN,24)
 9993 NTYP=NTYPS
      IF (ISKP(41) .EQ. ISKP(42)) GO TO 9994
      IAIN(61)=ISKP(41)
      CALL UPLINF (AIN(61),10)
      ISKP(42)=ISKP(41)
 9994 RETURN
      END
