C         19           --------------------------
                        SUBROUTINE ZVVBU (IPPAR)
C                      --------------------------
C
C    Das Programm verbindet zwei Atome miteinander.  Die projizierten
C    Koordinaten des ersten Atoms befinden sich auf dem Bereich
C    VAT(*,1) .  Zielatom ist das Atom mit der Nummer IC in der Code-
C    liste.
C                    geschrieben: 291644 FEB 84  (Hundt)
C                    geaendert:   250941 MAR 98  (Hundt)
C
C                         ------------------
C
      DIMENSION VAT(5,3),V(2),VS(2),VSO(2),VSU(2),PO(2),PU(2)
      DIMENSION CTAB( 8),STAB( 8),TBUF(2)
      DIMENSION DSTRCH(3)
      INTEGER *4 IPERIM(2),IPPAR
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      SAVE NSTZP,CTAB,STAB
C
      EQUIVALENCE (X(1,1),VAT(1,1)),(X(1,6),V(1)),(X(3,6),VS(1))
      EQUIVALENCE (X(2,7),VSO(1)),(S(1,1),VSU(1)),(S(3,1),DFLAE)
      EQUIVALENCE (S(1,2),DRAEU),(S(2,2),COSD),(S(3,2),SIND)
      EQUIVALENCE (S(1,3),U1),(S(2,3),U2),(S(3,3),U)
      EQUIVALENCE (ICDS(1),PO(1)),(ICDS(3),PU(1))
C
      DATA NSTZP/0/,IPERIM/0,1/
C
C                            Baue sin/cos-Tabelle auf, soweit noch
C                            nicht geschehen.
C
      IF (NSTZP-ISKP(9)) 10,30,10
   10 NSTZP=ISKP(9)
      TEMP2=CONST(1)/FLOAT(NSTZP-1)
      DO 20 I=1,NSTZP
      TEMP=FLOAT(I-1)*TEMP2
      CTAB(I)=COS(TEMP)
      STAB(I)=SIN(TEMP)
   20 CONTINUE
C                            Stelle die zu verbindenden Atome zu-
C                            sammen, und zwar so, dass VAT(*,2)
C                            hoeher liegt.
C
   30 IF (VAT(3,1)-ATOMS(3,IC,NS)) 50,40,40
   40 I=2
      J=3
      GO TO 60
   50 I=3
      J=2
   60 DO 70 K=1,5
   70 VAT(K,I)=VAT(K,1)
C                            Berechne die Koordinaten des 2. Atoms.
C
      TEMP=HOE/(HOE-ATOMS(3,IC,NS))
      VAT(1,J)=TEMP*ATOMS(1,IC,NS)
      VAT(2,J)=TEMP*ATOMS(2,IC,NS)
      VAT(3,J)=ATOMS(3,IC,NS)
      VAT(4,J)=TEMP*AT(4,IZ2,NS)*FKGL
      VAT(5,J)=TEMP*T(3)
C
      AIN(1)=VAT(1,2)*O9+CONST(11)
      AIN(2)=VAT(2,2)*O9+CONST(12)
      AIN(3)=VAT(1,3)*O9+CONST(11)
      AIN(4)=VAT(2,3)*O9+CONST(12)
      AIN(5)=AIN(3)-AIN(1)
      AIN(6)=AIN(4)-AIN(2)
      TEMP=AIN(5)*AIN(5)+AIN(6)*AIN(6)
      IF (TEMP) 999,999,80
   80 TEMP=T(2)/SQRT(TEMP)
      EXT2=(AIN(5)-AIN(6))*TEMP
      EXT1=(AIN(5)+AIN(6))*TEMP
C
C                            Soll gestrichelt werden?
      NZSTR=0
      IF (ABS(T(3)) .LE. 20.) GO TO 90
      NZSTR=ABS(T(3))/10.
      DSTRCH(1)=ABS(T(3))-FLOAT(10*NZSTR)
      DSTRCH(2)=1./(FLOAT(NZSTR)*(DSTRCH(1)+1.)-1.)
      DSTRCH(3)=DSTRCH(2)*DSTRCH(1)
C
C                            Kommando VB ?
   90 IF (NTYP-2) 999,100,110
  100 IF (NZSTR) 250,250,200
C                            Kommandos VBS und VBR
C
  110 DFLAE=(VAT(1,3)-VAT(1,2))**2+(VAT(2,3)-VAT(2,2))**2
      IF (DFLAE) 120,120,150
  120 IF (ISKP(6)) 130,999,130
  130 WRITE (WRLINE,140)
      CALL KPWRTE (NTOUT)
  140 FORMAT (' ZVVBU0140 - Bindung verdeckt.')
      GO TO 999
C
  150 DRAEU=SQRT(DFLAE+(VAT(3,3)-VAT(3,2))**2)
      DFLAE=SQRT(DFLAE)
      COSD=DFLAE/DRAEU
      U=(DRAEU-VAT(4,3))*COSD
      IF (U-VAT(4,2)) 120,120,160
C
C                            V = Vektor vom hoeheren zum tieferen
C                            Atom normiert auf 1
  160 DO 170 I=1,2
  170 V(I)=(VAT(I,3)-VAT(I,2))/DFLAE
C
C                            Kommando VBS ?
      IF (NTYP-3) 190,180,280
  180 CONTINUE
      AIN(1)=(VAT(1,2)+VAT(4,2)*V(1))*O9+CONST(11)
      AIN(2)=(VAT(2,2)+VAT(4,2)*V(2))*O9+CONST(12)
      AIN(3)=(VAT(1,2)+U*V(1))*O9+CONST(11)
      AIN(4)=(VAT(2,2)+U*V(2))*O9+CONST(12)
C
C                            Farbparameter
C
  190 CALL UPLINF (IATF(1,IPPAR),10)
      ISKP(42)=IATF(1,IPPAR)
      CALL UPLINF (IATF(2,IPPAR),11)
      IF (NZSTR .EQ. 0) GO TO 250
C
C                            Strichele.
  200 AIN(5)=AIN(3)-AIN(1)
      AIN(6)=AIN(4)-AIN(2)
      DSTRCH(1)=0.
      AIN(7)=AIN(1)
      AIN(8)=AIN(2)
      IF (T(3) .GT. 0.) GO TO 210
      I=2
      AIN(7)=DSTRCH(2)
      DSTRCH(2)=DSTRCH(3)
      DSTRCH(3)=AIN(7)
      GO TO 230
C
  210 IF (ICDS(6) .EQ. 0) GO TO 260
      CALL UPLINF (ISKP(42),10)
      I=3
  220 CALL UPLINF (AIN(7),I)
      IF (DSTRCH(1) .GE. 1.) GO TO 260
  230 DSTRCH(1)=DSTRCH(1)+DSTRCH(I)
      IF (DSTRCH(1) .LE. 1.) GO TO 240
      IF (I .EQ. 2) GO TO 260
      DSTRCH(1)=1.
  240 AIN(7)=AIN(1)+DSTRCH(1)*AIN(5)
      AIN(8)=AIN(2)+DSTRCH(1)*AIN(6)
      IF (I .EQ. 2) GO TO 210
      I=2
      GO TO 220
C
  250 CALL UPLINF (IATF(1,IPPAR),10)
      CALL UPLINF (IATF(2,IPPAR),11)
      CALL UPLINF (AIN(1),3)
      CALL UPLINF (AIN(3),2)
  260 IF (NTYP-3) 999,270,999
  270 AIN(7)=AIN(1)
      AIN(8)=AIN(2)
      AIN(5)=AIN(3)
      AIN(6)=AIN(4)
      J=7
      GO TO 360
C                            Kommando VBR
C
  280 SIND=(VAT(3,2)-VAT(3,3))/DRAEU
C
C                            Uebertreibung der Stabverjuengung
C
      VAT(5,2)=VAT(5,2)*(1.+CONST(41)*SIND)
      VAT(5,3)=VAT(5,3)*(1.-CONST(41)*SIND)
C
C                            VS : Vektor senkrecht zu V
C                            VSO : VS * Q1
C                            VSU : VS * Q2
C                            VS : V * Q1 * SIND
      VS(1)=V(2)
      VS(2)=-V(1)
      DO 290 I=1,2
      VSO(I)=VS(I)*VAT(5,2)
      VSU(I)=VS(I)*VAT(5,3)
      VS(I)=SIND*VAT(5,3)*V(I)
  290 CONTINUE
C                            Start- und Endpunkt auf der Verbindugs-
C                            linie.
C
      U1=VAT(4,2)**2-VAT(5,2)**2
      IF (U1) 300,300,310
  300 ISKP(10)=19030013
      GO TO 999
C
  310 U1=SQRT(U1)
      U2=VAT(4,3)**2-VAT(5,3)**2
      IF (U2) 300,300,320
  320 U2=(DRAEU-SQRT(U2))*COSD
      DO 330 I=1,2
      PO(I)=VAT(I,2)+U1*V(I)
  330 PU(I)=VAT(I,2)+U2*V(I)
C                            Plotte Verbindung.
C
      J=1
      AIN(J)=  (PO(1)+VSO(1))*O9+CONST(11)
      AIN(J+1)=(PO(2)+VSO(2))*O9+CONST(12)
      IF (ICDS(6) .EQ. 0) GO TO 335
C
C                             Plotte Bindungsstab ...
C
      CALL UPLINF (IPERIM(2),24)
      CALL UPLINF (IATF(1,IPPAR),10)
      ISKP(42)=IATF(1,IPPAR)
      CALL UPLINF (AIN(J),3)
      CALL UPLINF (IATF(2,IPPAR),11)
C
  335 DO 350 I=1,NSTZP
      J=J+2
      AIN(J)=  (PU(1)+VSU(1)*CTAB(I)+VS(1)*STAB(I))*O9+CONST(11)
      AIN(J+1)=(PU(2)+VSU(2)*CTAB(I)+VS(2)*STAB(I))*O9+CONST(12)
      IF (ICDS(6) .EQ. 0) GO TO 350
      CALL UPLINF (AIN(J),2)
  350 CONTINUE
      J=J+2
      AIN(J)=  (PO(1)-VSO(1))*O9+CONST(11)
      AIN(J+1)=(PO(2)-VSO(2))*O9+CONST(12)
      IF (ICDS(6) .EQ. 0) GO TO 370
      CALL UPLINF (AIN(J),2)
      IF (ISKP(7) .LT. 0) CALL UPLINF (AIN,2)
      IF (ISKP(25) .EQ. 0) GO TO 999
C
C                             ... und sperre den Bereich.
C
      CALL UPLINF (IPERIM(1),24)
      K=23
      DO 355 I=1,J,2
      CALL UPLINF (AIN(I),K)
      K=22
  355 CONTINUE
      CALL UPLINF (AIN(1),K)
      CALL UPLINF (AIN,21)
C
  360 IF (ISKP(25)) 365,999,365
  365 IF (ICDS(6) .NE. 0) GO TO 999
C
  370 IF (ISKP(25) .EQ. 0) GO TO 999
      CALL UPLINF (IPERIM(1),24)
C
      TBUF(1)=AIN(J)-EXT1
      TBUF(2)=AIN(J+1)+EXT2
      CALL UPLINF (TBUF,23)
      TBUF(1)=AIN(1)-EXT2
      TBUF(2)=AIN(2)-EXT1
      CALL UPLINF (TBUF,22)
      TBUF(1)=AIN(3)+EXT1
      TBUF(2)=AIN(4)-EXT2
      CALL UPLINF (TBUF,22)
      TBUF(1)=AIN(J-2)+EXT2
      TBUF(2)=AIN(J-1)+EXT1
      CALL UPLINF (TBUF,22)
      TBUF(1)=AIN(J)-EXT1
      TBUF(2)=AIN(J+1)+EXT2
      CALL UPLINF (TBUF,22)
      CALL UPLINF (TBUF,21)
      CALL UPLINF (IPERIM(2),24)
C
  999 RETURN
      END
