C             --------------------------------------------
               SUBROUTINE KPNTOS (IZAHL, STRING,IPOI,NST)
C             --------------------------------------------
C
C  Konvertiert integerzahl oder pseudo-gleitkommazahl in einen string.
C  IZAHL:  (I*4) zu konvertierende zahl
C  STRING: (I*1) ergebnispuffer
C  IPOI:   (I*4) pointer auf die letzte geschriebene stelle, muss
C          beim aufruf  v o r  der ersten schreibstelle stehen
C  NST:    (I*4) nachkommastellen. Wenn NST=0 wird eine integerzahl
C          konvertiert; NST > 0 (max. 10) wird ein dezimalpunkt
C          eingefuegt und es erscheinen NST stellen dahinter.
C
C                 Geschrieben: 051039 OCT 1991 (Hundt)
C                   Geaendert: 161714 jan 2001 (Hundt)
C
C              ----------------------------------------
C
      IMPLICIT NONE
      INTEGER*4 ISUB(10),IZAHL,IPOI,J,I,K,N,NST,M
      INTEGER*1 STRING(*),IZFFRN(12)
C
      DATA ISUB/1000000000,100000000,10000000,1000000,100000,10000,
     1 1000,100,10,1/
      DATA IZFFRN/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H-,1H./
C
      M=9-NST
      J=1
      I=IZAHL
      IF (I) 10,20,20
   10 I=-I
      IPOI=IPOI+1
      STRING(IPOI)=IZFFRN(11)
C
   20 N=I-ISUB(J)
      IF (N) 30,40,40
   30 J=J+1
      IF (J-M) 20,35,40
   35 IF (J-10) 20,70,70
C
   40 K=1
      GO TO 60
C
   50 K=K+1
      I=N
   60 N=I-ISUB(J)
      IF (N) 80,50,50
   70 K=I+1
   80 IF (J-M-2) 100,90,100
   90 IPOI=IPOI+1
      STRING(IPOI)=IZFFRN(12)
  100 IPOI=IPOI+1
      STRING(IPOI)=IZFFRN(K)
      J=J+1
      IF (J-10) 40,70,999
C
  999 RETURN
      END
