C                       -----------------------
                         SUBROUTINE RADIAL(ND)
C  CY-ENG-              -----------------------
C
C                   BEARBEITET: 171141 JAN 90 (HUNDT)
C
C     ***** GENERATE ELLIPSE FROM TWO CONJUGATE VECTORS *****
C     ***** ORTHONORMAL VECTORS PRODUCE 8-128 SPOKED CIRCLE *****
C     ***** ND DENOTES NUMBER OF SUBDIVISIONS (1 TO 5) *****
C
      IMPLICIT NONE
      INTEGER *4 ND,J,K,KDEL,KDEL1,KDEL2,L,M,N
      REAL    *4 T1,T2
      INCLUDE 'KPORC.INC'
C
      DO  J=1,3
        T1=DA(J,1)
        D(J,1)=T1
        D(J,129)=T1
        D(J,65)=-T1
        T1=DA(J,2)
        D(J,33)=T1
        D(J,97)=-T1
      ENDDO
      DO  K=1,ND
        T1=CONT(K)
        KDEL=2**(6-K)
        KDEL1=KDEL+1
        KDEL2=KDEL/2
        DO  L=KDEL1,65,KDEL
          J=L-KDEL
          M=L-KDEL2
          DO  N=1,3
            T2=(D(N,L)+D(N,J))*T1
            D(N,M)=T2
            D(N,M+64)=-T2
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END
