#!/usr/bin/perl -w

$n=@ARGV;
if ($n < 3) {
  print "Usage: tt mm jj\n";
  exit 1;
}

$tt=shift @ARGV;
$mm=shift @ARGV;
$jj=shift @ARGV;

$zeit=(julday($tt,$mm,$jj)-julday(1,1,1970))*60*60*24;

@arr=`ls *.f`;
chomp @arr;

@orr=();
open OUT,">mkforw";
foreach (@arr) {
  @brr=stat($_);
  $diff=$brr[9]-$zeit;
  if ($diff > 0) {
    @crr = split "[/\.]",$_;
    print OUT "cp -uvp $crr[$#crr-1].f /dose/kpwin9\n";
    push @orr,$crr[$#crr-1];
  }
}
# print OUT "cp mkfor.bat /dosc/kpg77\n";
close OUT;
chmod 0700,"mkforw";

# open OUT,">mkfor.bat";
# for ($i=0;$i<=$#orr;$i++) {
#   print OUT "g77 -c $orr[$i].f\n";
#   print OUT "ar -r libkp.a $orr[$i].o\n";
#   print OUT "del $orr[$i].o\n";
# }
# close OUT;
print "mkforw erzeugt.\n";
exit 0;
$diff=$zeit-$arr[9];
print "Diff: $diff\n";

sub julday {
  my($IGREG,$jy,$jm,$z1,$z2,$julday);
  $IGREG=15+31*(10+12*1582);
  $jy=$_[2];
  if ($jy == 0) {
    print "Es gibt kein Jahr 0.";
    exit 1;
  }
  if ($jy < 0) {$jy++}
  if ($_[1] > 2) {$jm=$_[1]+1}
  else {$jy--;$jm=$_[1]+13}
  $z1=365.25*$jy;
  $z1=~s/(\d*)\.\d*/$1/; # int()
  $z2=30.6001*$jm;
  $z2=~s/(\d*)\.\d*/$1/;
  $julday=$z1+$z2+$_[0]+1720995;
  
  # Wechsel zum gregorianischen kalender?

  if ($_[0]+31*($_[1]+12*$_[2]) >= $IGREG) {
    $z1=0.01*$jy;
    $z1=~s/(\d*)\.\d*/$1/; # int()
    $z2=0.25*$z1;
    $z2=~s/(\d*)\.\d*/$1/;
    $julday += 2-$z1+$z2;
  }
  return $julday;
}
