C         92              -------------------
                           SUBROUTINE ZVCMPC
C                         -------------------
C
C         Das programm vergleicht zwei Zellinhalte miteinander.
C
C                  geschrieben: 211056 FEB 2005  (Hundt)
C                    geaendert: 181748 SEP 2006  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 ITDIM
      PARAMETER (ITDIM=200)
C
      INTEGER *4 IATDIM
      PARAMETER (IATDIM=10)
C
      INTEGER *4 IARDIM
      PARAMETER (IARDIM=22)
      INTEGER *4 IARBER(IARDIM)
C
      INTEGER *4 IATPOI(2),ITEMP,JTEMP,IATNAM(IATDIM,2),IATCNT(IATDIM,2)
      INTEGER *4 IATLST(IATDIM+1),LPOI,NAMERS(IATDIM),NNULL
C
      INTEGER *4 INBFR(5),I,J,K,NSSV,IRLINE(30),NSA,NOPT(8),NRNSE
      INTEGER *4 II,JJ,KK,L,L2,L3,ITLIST(3,ITDIM),ITPOI,ITRF
      INTEGER *4 IAIN(72),NSE,ICT,ICTA,ICTE,ICPOI(2,3),IAT(8,PARDIM,2)
      INTEGER *4 NOPT5,NLSG,IZEN(2),IORGNN,IRC,NOPT6,ITC(3)
C
      REAL    *4 AINBFR(5),A(3,3),QVBL(3),QVBU(3),ZLL(3),ZLU(3),TEMP
      REAL    *4 AIDN(12),TOLG,TOLW,TEMP2,WA(3),ARCCOS,ZSAV(7,2),VLIM(2)
      REAL    *4 URVAL(3,2),EVOL(2),ORGFRE(3),ORGTRI(3),ORGKRT(3)
      REAL    *4 ZTSAV(6),DGSV(3,3)
C
      CHARACTER *4 ACH
C
      SAVE INBFR,NOPT,URVAL
C
      EQUIVALENCE (INBFR(1),AINBFR(1)),(WRLINE,IRLINE(1))
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
C
      DATA AINBFR/0.5,0.1,4.,0.5,0.0/,NOPT/0,1,1,3*0,1,0/,ACH/'abc?'/
      DATA AIDN/2.,1.,0.,0., 2.,0.,1.,0.,2.,0.,0.,1./,NNULL/4H0   /
      DATA ITC/131001,113001,111201/
      DATA (IARBER(I),I=1,22) /2,2,6,15,25,74,83,88,99,142,147,148,
     1 156,167,174,176,183,194,200,206,215,230/
C
      NSSV=NS
      IF (NTYP .EQ. 2) THEN
        I=NOPT(1)
        ISKP(94)=0
CYENG1
        CALL FLES (NOPT,ISKP(31),3H8IE,10HOptionen?$)
CYENG2
CYENGY        CALL FLES (NOPT,ISKP(31),3H8IE,9HOptions?$)
C
C  1: 0/1 Die zellen sollen auf gleiche anzahl pro vol. skaliert w.
C  2: 0-2 Unspezifisch / namensscharf / namensscharf mit permutationen
C  3: 0/1 Nach gefundener uebereinstimmung nachoptimieren
C  4: 0/1 Im suchbereich eines atoms duerfen auch mehr als ein atom
C         gefunden werden.
C  5: 0/1 Nicht-zentrosymmetrische strukturen werden auch invertiert.
C  6: 0/1 Nach dem durchlauf werden die gitterkonstanten restored.
C  7: n   Nummer der gewuenschten loesung.
C  8: n   Nummer der struktur, die transformiert werden darf (1/2)
C         oder selber suchen (0)
C
        IF (ISKP(31) .EQ. 0) THEN
CYENG1
          WRITE (WRLINE,'(A,8I3)') 'Optionen:',(NOPT(I),I=1,8)
CYENG2
CYENGY          WRITE (WRLINE,'(A,8I3)') 'Options:',(NOPT(I),I=1,8)
          CALL KPWRTE (NTOUT)
        ELSE IF (NOPT(1) .LT. 0) THEN
          WRITE (WRLINE,'(A)') 
CYENG1
     +'1: 0-3 Gleicht Zellen auf gleiche Anzahl Atome pro Volumen an.'
CYENG2
CYENGY     +'1: 0-3 Adjust cells to have the same number of atoms per volume.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'2: 0-2 Teste unspezifisch / namensscharf / plus Permutationen.'
CYENG2
CYENGY     +'2: 0-2 Test unspecifically / acc. working names / plus permutatio
CYENGY     +ns.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'3: 0/1 Bei gefundener Uebereinstimmung nachoptimieren.'
CYENG2
CYENGY     +'3: 0/1 After a successful comparison do a post optimization.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'4: 0/1 Mehr als ein Atom in der Suchsphaere erlaubt.'
CYENG2
CYENGY     +'4: 0/1 Allow more than one atom in the search area.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'5: 0/1 Nicht-zentrosymmetrische Strukturen werden auch invertiert
     +.'
CYENG2
CYENGY     +'5: 0/1 Non centrosymmetric structures should also be inverted.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'6: 0/1 Setze Gitterkonstanten nach dem Lauf wieder zurck.'
CYENG2
CYENGY     +'6: 0/1 Restore lattice parameters after a run.'
          CALL KPWRTE (NTDISP)
CYENG1
          WRITE (WRLINE,'(A)') '7: n   Auswahl der n-ten Loesung.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') '7: n   Number of solution to be kept.'
          CALL KPWRTE (NTDISP)
          WRITE (WRLINE,'(A)') 
CYENG1
     +'8: 0-2 Keine / bestimmte Struktur, die transformiert wird.'
CYENG2
CYENGY     +'8: 0-2 No / specific structure to be transformed.'
          CALL KPWRTE (NTDISP)
          NOPT(1)=I
        ENDIF
        GO TO 999
      ELSE IF (NTYP .EQ. 3) THEN
        DO  K=1,2
          DO  I=1,3
            UR(I,K)=URVAL(I,K)
          ENDDO
        ENDDO
        GO TO 999
      ENDIF
C                            Setze efolgsflag zurueck.
      ISKP(94)=0
      ISKP(66)=1
      INBFR(5)=ISKP(24)
      CALL FLES (INBFR,ISKP(31),4H4FAE,25Htols,tolg,tolw,tolv,ref?$)
C
C                            Gibt es ueberhaupt atome?
C
      IF (NAT(1) .LT. ISKP(53) .OR. NAT(2) .LT. ISKP(53)) THEN
        IERR=92 0092 08
        GO TO 990
      ENDIF
      TOLG=AINBFR(2)
      TOLW=AINBFR(3)
      CALL CNVTUP (INBFR(5),1,4)
C
C                            Save zellen.
      DO  I=1,2
        DO  J=1,7
          ZSAV(J,I)=ZELLE(J,I)
        ENDDO
      ENDDO
      NOPT6=NOPT(6)
C                            Sollen die zellen skaliert werden?
C
      IF (NOPT(1) .NE. 0) THEN
        J=0
        IF (NOPT(1) .EQ. 1 .OR. NOPT(1) .EQ. 2) THEN
          NS=NOPT(1)
          J=1
        ENDIF
        DO  K=1,2
          NTYP=3
          IAIN(1)=ISKP(53)
          IAIN(2)=NAT(NS)
          CALL ZVZLIN
          IF (IERR .NE. 0) GO TO 990
          IF (J .NE. 0) THEN
            IF (K .EQ. 1) THEN
              TEMP2=FLOAT(NCD(NS))/ZELLE(7,NS)
              GO TO 10
            ENDIF
          ELSE
            TEMP2=0.045
          ENDIF
C
C    Skaliere eine zelle auf die dichte der vorgegebenen zelle
C    oder beide auf 0.045 atome pro A**3
C
          TEMP=(FLOAT(NCD(NS))/(ZELLE(7,NS)*TEMP2))**0.33333333
          DO  I=1,3
            ZELLE(I,NS)=ZELLE(I,NS)*TEMP
          ENDDO
          ISKP(14)=1
          NTYP=1
          CALL ZVZ
   10     NS=3-NS
        ENDDO
        NS=NSSV
      ENDIF
      NRNSE=0
C                            Sollen permutationen untersucht werden?
C
      IF (NOPT(2) .GT. 1) THEN
C
C                            Stelle fuer beide strukturen ...
        DO  NS=1,2
C                            ... einen zellinhalt zusammen ...
C
          IATPOI(NS)=0
          IAIN(1)=ISKP(53)
          IAIN(2)=NAT(NS)
          NTYP=3
          CALL ZVZLIN
C                            ... und zaehle die vorkommenden elemente.
          DO  IC=1,NCD(NS)
            IANR=ICD(IC,NS)/200000
            ITEMP=IAT(5,IANR,NS)
            CALL CNVTUP(ITEMP,1,4)
            DO  I=1,IATPOI(NS)
              IF (ITEMP .EQ. IATNAM(I,NS)) THEN
                IATCNT(I,NS)=IATCNT(I,NS)+1
                GO TO 20
              ENDIF
            ENDDO
            IF (IATPOI(NS) .GE. IATDIM) THEN
              WRITE (WRLINE,'(A)') 'ZVCMPC0155 - IATPOI Overflow.'
              CALL KPWRTE (NTOUT)
              IERR=-1
              GO TO 280
            ENDIF
            IATPOI(NS)=IATPOI(NS)+1
            IATNAM(IATPOI(NS),NS)=ITEMP
            IATCNT(IATPOI(NS),NS)=1
   20     CONTINUE
          ENDDO
C                            Ermittle jetzt den groessten gemeinsamen ...
          ITEMP=IATCNT(1,NS)
          DO  K=2,IATPOI(NS)
            J=ITEMP
            I=IATCNT(K,NS)
            IF (I .GE. J) GO TO 40
   30       J=I
            I=ITEMP
            ITEMP=J
   40       I=MOD(I,J)
            IF (I .NE. 0) GO TO 30
          ENDDO
C                            ... teiler und dividiere.
          DO  I=1,IATPOI(NS)
            IATCNT(I,NS)=IATCNT(I,NS)/ITEMP
          ENDDO
C                            Sortiere den vektor mit den indices ...
          DO  J=2,IATPOI(NS)
            ITEMP=IATNAM(J,NS)
            JTEMP=IATCNT(J,NS)
            DO  I=J-1,1,-1
              IF (IATCNT(I,NS) .LE. JTEMP) GO TO 50
              IATNAM(I+1,NS)=IATNAM(I,NS)
              IATCNT(I+1,NS)=IATCNT(I,NS)
            ENDDO
            I=0
   50       IATNAM(I+1,NS)=ITEMP
            IATCNT(I+1,NS)=JTEMP
          ENDDO
        ENDDO
C                   ... und teste, ob sich die formeln entsprechen.
C
        IF (IATPOI(1) .NE. IATPOI(2)) GO TO 60
        DO  I=1,IATPOI(1)
          NAMERS(I)=NNULL
          J=1
          IF (I .GT. 9) J=0
          CALL KPNTOS (I,NAMERS(I),J,0)
          IF (IATCNT(I,1) .NE. IATCNT(I,2)) GO TO 60
        ENDDO
C                            Lege eine liste fuer die permutationen an.
        IATLST(1)=1
        LPOI=1
        DO  I=2,IATPOI(1)
          IF (IATCNT(I-1,1) .NE. IATCNT(I,1)) THEN
            LPOI=LPOI+1
            IATLST(LPOI)=I
          ENDIF
        ENDDO
        LPOI=LPOI+1
        IATLST(LPOI)=IATPOI(1)+1
        GO TO 70
   60   WRITE (WRLINE,'(A)')
CYENG1
     1   'Die beiden Summenformeln passen nicht zusammen.'
CYENG2
CYENGY     1   'The sum formulae do not agree.'
        CALL KPWRTE (NTDISP)
        GO TO 280
C                            Aendere die arbeitsnamen
   70   DO  NS=1,2
          DO  K=ISKP(53),NAT(NS)
            ITEMP=IAT(5,K,NS)
            CALL CNVTUP (ITEMP,1,4)
            DO  I=1,IATPOI(NS)
              IF (ITEMP .EQ. IATNAM(I,NS)) IAT(7,K,NS)=NAMERS(I)
            ENDDO
          ENDDO
        ENDDO
        NS=NSSV
      ENDIF
C                            Sollen auch zentrosymmetrische versionen
C                            untersucht werden?
      NOPT5=NOPT(5)
      IF (NOPT5 .EQ. 1) THEN
C
C  Untersuche, ob nicht eine der beiden strukturen zentrosymmetrisch
C  ist oder eine raumgruppe vorliegt, wo das invertieren ueberfluessig
C  ist.
        i=nhmsnr(3,1)
        if (i .gt. 230) i=i/100
        j=nhmsnr(3,1)
        if (j .gt. 230) j=j/100
        DO  K=1,21,2
          IF (((i .GE. IARBER(K) .AND. i .LE. IARBER(K+1))) .OR.
     +         (j .GE. IARBER(K) .AND. j .LE. IARBER(K+1))) THEN
C
C                            Streiche option 5.
            NOPT5=0
            GO TO 90
          ENDIF
        ENDDO
      ENDIF
   90 CONTINUE
C                            Bestimme zelle mit dem groesseren volumen.
      DO  NS=1,2
        EVOL(NS)=ZELLE(7,NS)
        IZEN(NS)=0
C                            Zaehle zentrierungen.
        DO  I=1,NSYM(NS)
          DO  J=1,12
            IF (AIDN(J) .LE. 1.) THEN
              IF (ABS(SYM(J,I,NS)-AIDN(J)) .GT. 0.0001) GO TO 100
            ENDIF
          ENDDO
C                              Zentrierung gefunden
          IZEN(NS)=IZEN(NS)+1
  100     CONTINUE
        ENDDO
        IF (IZEN(NS) .GT. 1) EVOL(NS)=EVOL(NS)/FLOAT(IZEN(NS))
      ENDDO
      NS=1
C                            Vorgaben oder das groessere volumen?
C
      IF (NOPT(8) .GT. 0 .AND. NOPT(8) .LE. 2) THEN
        NS=NOPT(8)
      ELSE
        IF (EVOL(NS) .LT. EVOL(3-NS)) THEN
          NS=3-NS
        ENDIF
      ENDIF
C
      NSA=3-NS
      NSE=NS
      VLIM(1)=(1.-AINBFR(4))*ZELLE(7,NSE)
      VLIM(2)=(1.+AINBFR(4))*ZELLE(7,NSE)
C
C                Save die basis der zu transformierenden struktur.
      DO  K=1,3
        DO  I=1,3
          DGSV(I,K)=DG(I,K,NSE)
        ENDDO
      ENDDO
C                            Loesche die urspruenge.
      DO  K=1,2
        DO  I=1,3
          UR(I,K)=0.
        ENDDO
      ENDDO
C                 Merke die laengen der achesen und der diagonalen.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        ZTSAV(I)=ZELLE(I,NSE)
        ZTSAV(I+3)=SQRT((DG(1,J,NSE)-DG(1,K,NSE))**2+
     +  (DG(2,J,NSE)-DG(2,K,NSE))**2+(DG(3,J,NSE)-DG(3,K,NSE))**2)
      ENDDO
C                            Berechne die erlaubten winkel.
      TEMP2=0.
      DO  II=1,3
        TEMP=ZELLE(II+3,NS)
        QVBL(II)=TEMP-TOLW
        IF (QVBL(II) .LE. 5.) TEMP2=355.
        QVBU(II)=TEMP+TOLW
        IF (QVBU(II) .GE. 175.) TEMP2=355.
        TEMP2=TEMP2+QVBU(II)
        ZLL(II)=ZELLE(II,NS)*(1.-TOLG)
        ZLU(II)=ZELLE(II,NS)*(1.+TOLG)
      ENDDO
      IF (TEMP2 .GE. 355.) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVCMPC0319 - Unzulaessige(r) Winkel / Winkelsumme.'
CYENG2
CYENGY     +  'ZVCMPC0319 - Invalid angle / sum of angles.'
        CALL KPWRTE (NTOUT)
        GO TO 280
      ENDIF
C                            qvbl und qvbu sind die erlauben
C                            winkel (lower, upper)
C
C                            Bestimme die beiden groessten achsen.
      DO  II=1,3
        JJ=ID2(II)
        KK=ID2(JJ)
        IF (ZELLE(II,NS) .LE. ZELLE(JJ,NS) .AND.
     +  ZELLE(II,NS) .LE. ZELLE(KK,NS)) GO TO 110
      ENDDO
  110 II=ID2(KK)
C                            Ausgewaehlt: jj,kk.
C                            Wechsele die struktur ...
      NS=3-NS
C
C  Als referenzatom sollte eines gewaehlt werden, das moeglichst selten
C  in der zelle vorkommt.  Muss "seltenes" atom noch besorgt werden?
C
      IF (INBFR(5) .EQ. ISKP(24)) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NAT(NS)
        NTYP=4
        CALL ZVZLIN
        INBFR(5)=IAIN(1)
      ENDIF
C                            Definiere einen origin.
C
      DO  I=ISKP(53),NAT(NS)
        IF (INBFR(5) .EQ. IAT(7,I,NS)) THEN
          IORGNN=I
          DO  J=1,3
            UR(J,NS)=AT(J,IORGNN,NS)
          ENDDO
          DO  J=1,3
            ORGKRT(J)=DG(J,1,NS)*UR(1,NS)+DG(J,2,NS)*UR(2,NS)+
     +      DG(J,3,NS)*UR(3,NS)
          ENDDO
          GO TO 120
        ENDIF
      ENDDO
      WRITE (WRLINE,'(A,A4,A)')
CYENG1
     1 'Atom ''',INBFR(5),''' nicht gefunden.'
CYENG2
CYENGY     1 'Atom ''',INBFR(5),''' not found.'
      CALL KPWRTE (NTOUT)
      GO TO 990
C                            Bestimme zielkandidaten ...
  120 ICPOI(1,1)=NCDA(NS)
      NCD(NS)=0
      K8(NS)=0
      DO  I=1,3
        DO  J=ISKP(53),NAT(NS)
          IF (IAT(7,J,NS) .NE. INBFR(5)) GO TO 130
C
C                            ... via AKS.
          ICDS(1)=IORGNN
          IZ1=J
          IZ2=J
          DQ=ZELLE(I,3-NS)*(1.+TOLG)
          CONST(20)=(ZELLE(I,3-NS)*(1.-TOLG))**2
          NTYP=3
          ISKP(14)=1
          CALL ZVAVBR
          IF (IERR .NE. 0) GO TO 990
  130     CONTINUE
        ENDDO
        IF (NCD(NS) .LT. NCDA(NS)) GO TO 270
C
C  Damit es brauchbare kandidaten sind, muessen sie in paaren
C  auftreten, die sich einander gegenueber liegen.
C  Berechne kartesische koordinaten ...
C
         NTRY=42
         NC=1
         K8(NS)=0
         DO  IC=ICPOI(1,I),NCD(NS)
           CALL ZVDEK
           DO  K=1,3
             ATOMS(K,IC,NS)=X1(K)
           ENDDO
         ENDDO
C                            ... und suche paerchen.
C
        DO  IC=ICPOI(1,I),NCD(NS)
          DO  J=ICPOI(1,I),NCD(NS)
            IF (IC .NE. J .AND. ICD(J,NS) .NE. 0) THEN
              DO  K=1,3
                IF (ABS((ATOMS(K,IC,NS)+ATOMS(K,J,NS))*0.5-ORGKRT(K))
     +            .GT. AINBFR(1)) GO TO 140
              ENDDO
              GO TO 150
            ENDIF
  140       CONTINUE
          ENDDO
          ICD(IC,NS)=0
  150     CONTINUE
        ENDDO
C                            Komprimiere liste.
        K=ICPOI(1,I)-1
        DO  IC=ICPOI(1,I),NCD(NS)
          IF (ICD(IC,NS) .NE. 0) THEN
            K=K+1
            ICD(K,NS)=ICD(IC,NS)
          ENDIF
        ENDDO
        NCD(NS)=K
C
        ICPOI(2,I)=NCD(NS)
        IF (I .LT. 3) THEN
          NCDA(NS)=NCD(NS)+1
          ICPOI(1,I+1)=NCDA(NS)
        ELSE
          NCDA(NS)=1
        ENDIF
      ENDDO
C
C           Optimiere die reihenfolge der codes, und zwar so,
C           dass die originalzelle moeglichst vorne steht.
C
      DO  I=1,3
        J=IORGNN*200000+ITC(I)
        K=ICPOI(1,I)
        DO  IC=K,ICPOI(2,I)
          IF (ICD(IC,NS) .EQ. J) THEN
            ICD(IC,NS)=ICD(K,NS)
            ICD(K,NS)=J
          ENDIF
        ENDDO
      ENDDO
C                            Jetzt werden handels konstruiert.
      NTRY=28
      ICDS(1)=IORGNN
      NC=1
      CALL ZVDEK
      DO  I=1,3
        ORGFRE(I)=X2(I)
        ORGTRI(I)=X(I,1)
      ENDDO
      ITPOI=0
      DO  J=ICPOI(1,JJ),ICPOI(2,JJ)
        NC=JJ
        ICDS(NC)=ICD(J,NS)
        CALL ZVDEK
        DO  I=1,3
          X(I,NC)=X2(I)-ORGFRE(I)
        ENDDO
        WA(JJ)=X(1,NC)**2+X(2,NC)**2+X(3,NC)**2
        DO  K=ICPOI(1,KK),ICPOI(2,KK)
C
C                            Code darf weder mit einem anderen
C                            noch mit der gegenrichtung uebereinstimmen.
C
          IF (ICD(K,NS) .NE. ICD(J,NS)) THEN
            NC=KK
            ICDS(NC)=ICD(K,NS)
            CALL ZVDEK
            DO  I=1,3
              X(I,NC)=X2(I)-ORGFRE(I)
            ENDDO
            WA(KK)=X(1,NC)**2+X(2,NC)**2+X(3,NC)**2
            TEMP=0.
            DO  I=1,3
              TEMP=X(I,JJ)*X(I,KK)+TEMP
            ENDDO
            TEMP=ARCCOS(TEMP/SQRT(WA(JJ)*WA(KK)))
            IF (TEMP .GE. QVBL(II) .AND. TEMP .LE. QVBU(II)) THEN
C
C                     Handle sind icd(jj) u. icd(kk)
C                     Gehe auf kandidatensuche fuer dritte richtung.
C
              DO  I=ICPOI(1,II),ICPOI(2,II)
                NC=II
                ICDS(II)=ICD(I,NS)
                IF (ICDS(II) .NE. ICDS(JJ) .AND.
     +            ICDS(II) .NE. ICDS(KK)) THEN
                  CALL ZVDEK
                  DO  L=1,3
                    X2(L)=X2(L)-ORGFRE(L)
                  ENDDO
                  WA(II)=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
                  TEMP=0.
                  DO  L=1,3
                    TEMP=X(L,JJ)*X2(L)+TEMP
                  ENDDO
                  TEMP=ARCCOS(TEMP/SQRT(WA(JJ)*WA(II)))
                  IF (TEMP .GE. QVBL(KK) .AND. TEMP .LE. QVBU(KK)) THEN
                    TEMP=0.
                    DO  L=1,3
                      TEMP=X(L,KK)*X2(L)+TEMP
                    ENDDO
                    TEMP=ARCCOS(TEMP/SQRT(WA(II)*WA(KK)))
                    IF (TEMP .GE. QVBL(JJ) .AND. TEMP .LE. QVBU(JJ))
     +                THEN
C                            Teste noch die haendigkeit.
                      TEMP=0.
                      DO  L=1,3
                        L2=ID2(L)
                        L3=ID2(L2)
                        TEMP=TEMP+
     +                  (X(L2,JJ)*X(L3,KK)-X(L3,JJ)*X(L2,KK))*X2(L)
                      ENDDO
                      IF (TEMP .GT. 0.) THEN
                        IF (ITPOI .LT. ITDIM) THEN
                          ITPOI=ITPOI+1
                          ITLIST(II,ITPOI)=ICD(I,NS)
                          ITLIST(JJ,ITPOI)=ICD(J,NS)
                          ITLIST(KK,ITPOI)=ICD(K,NS)
                        ELSE
                          WRITE (WRLINE,'(A)')
CYENG1
     +                    'ZVCMPC0479 - Ueberlauf von ITLIST.'
CYENG2
CYENGY     +                    'ZVCMPC0479 - Overflow of ITLIST.'
                          CALL KPWRTE (NTOUT)
                          NRNSE=NRNSE+1
                          IF (NRNSE .LT. 3) THEN
                            TOLG=TOLG*0.5
                            GO TO 90
                          ENDIF
                          IERR=-1
                          GO TO 990
                        ENDIF
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      IF (ITPOI .LE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVCMPC0503 - Keine moegliche Transformation gefunden.'
CYENG2
CYENGY     +  'ZVCMPC0503 - No suitable transformation found.'
        CALL KPWRTE (NTOUT)
        GO TO 280
      ENDIF
C                            Der bereich itlist enthaelt jetzt die
C                            moeglichen transformationen.
      NLSG=0
C                            Generiere einen zellinhalt.
      IAIN(1)=1
      IAIN(2)=ISKP(53)
      IAIN(3)=NAT(NSE)
      DO  I=4,6
        AIN(I)=.5
      ENDDO
      NCD(NSE)=0
      NTYP=1
      ISKP(14)=1
      NS=NSE
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
      DO  ITRF=1,ITPOI
        NS=NSA
        NTRY=24
        DO  NC=1,3
          ICDS(NC)=ITLIST(NC,ITRF)
          CALL ZVDEK
          DO  I=1,3
            X(I,NC)=X(I,NC)-ORGTRI(I)
          ENDDO
        ENDDO
        CALL MM (DG(1,1,NSA),X,S)
        IF (ISKP(58) .GT. 0) THEN
          WRITE (WRLINE,'(A)')
CYENG1
     +    'Aktuelle Transformation:'
CYENG2
CYENGY     +    'Transformation used:'
          CALL KPCDST (IRLINE,30,ICDS(1))
          CALL KPCDST (IRLINE,40,ICDS(2))
          CALL KPCDST (IRLINE,50,ICDS(3))
          CALL KPWRTE (NTOUT)
        ENDIF
        NS=NSE
C                     Bilde durch internes ZBAS affin ab.
  160   ISKP(14)=1
        NTYP=20
        CALL ZVZ
        IF (IERR .NE. 0) GO TO 990
        IF (ZELLE(7,NS) .GT. 0. .AND. (ZELLE(7,NS) .LT. VLIM(1)
     +    .OR. ZELLE(7,NS) .GT. VLIM(2))) GO TO 260
C
C                            Berechne die transformationsmatrix.
        DO  I=1,3
          DO  J=1,3
            A(I,J)=TRAINV(I,1,NSA)*TRA(1,J,NSE)+
     +      TRAINV(I,2,NSA)*TRA(2,J,NSE)+TRAINV(I,3,NSA)*TRA(3,J,NSE)
          ENDDO
        ENDDO
        CONST(19)=0.
        CONST(20)=0.
C                            Durchlaufe die atome beider strukuren.
  170   CONTINUE
        DO  II=ISKP(53),NAT(NSE)
C
C                            Setze ursprung auf das atom ii ...
          DO  I=1,3
            UR(I,NSE)=AT(I,II,NSE)
          ENDDO
C
C                            Box, in die die suchsphaere passt.
          DO  I=1,3
            X(I,7)=AINBFR(1)*RK(I,NSA)
          ENDDO
          DO  JJ=ISKP(53),NAT(NSA)
C
            IF (NOPT(2) .NE. 0 .AND.
     +      IAT(7,II,NSE) .NE. IAT(7,JJ,NSA)) GO TO 240
C
C                            Setze jetzt den zweiten ursprung ...
            NS=NSA
            DO  I=1,3
              UR(I,NSA)=AT(I,JJ,NSA)
            ENDDO
C                            ... und suche nach partnern via AKS.
            IZ1=ISKP(53)
            IZ2=NAT(NSA)
            DQ=AINBFR(1)*AINBFR(1)
            ICTA=NCDA(NSE)
            ICTE=NCD(NSE)
            DO  ICT=ICTA,ICTE
C
C                            Hole code ...
              NS=NSE
              ICDS(1)=ICD(ICT,NSE)
              NTRY=24
              NC=1
              CALL ZVDEK
              IF (IERR .NE. 0) GO TO 990
              NRNSE=IANR
C
C                    ... und rechne die triklinen koordinaten um.
C
              DO  I=1,3
                T(I)=X(I,1)-UR(I,NSE)
              ENDDO
              DO  I=1,3
                X(I,1)=A(I,1)*T(1)+A(I,2)*T(2)+A(I,3)*T(3)+UR(I,NSA)
              ENDDO
              NS=NSA
              DO  I=1,3
                X2(I)=DG(I,1,NS)*X(1,1)+DG(I,2,NS)*X(2,1)+
     +          DG(I,3,NS)*X(3,1)
              ENDDO
              NTYP=3
              NCD(NS)=0
              CALL ZVADD
              IF (IERR .NE. 0) GO TO 990
C
C                            Etwas gefunden?
C
              IF (NCD(NS)-1) 240,180,190
  180         IF (NOPT(2) .NE. 0 .AND. IAT(7,ICD(1,NSA)/200000,NSA)
     +        .NE. IAT(7,NRNSE,NSE)) GO TO 240
              GO TO 200
  190         IF (NOPT(4) .EQ. 0) GO TO 240
              IF (NOPT(2) .NE. 0) THEN
C
C     Wenn mehr als ein atom im suchbereich zugelassen ist, teste,
C     ob der richtige name wenigstens dabei ist.
C
                DO  I=1,3
                  IF (IAT(7,ICD(I,NSA)/200000,NSA)
     +            .EQ. IAT(7,NRNSE,NSE)) GO TO 200
                ENDDO
                GO TO 240
              ENDIF
  200         CONTINUE
            ENDDO  ! ICT=ICTA,ICTE
C
C      In dieser richtung sind wir schon schon mal erfolgreich.
C      Jetzt kommt die gegenprobe. Stelle die grosse zelle in die
C      standardposition ...
C
              NS=NSE
              NTYP=21
              ISKP(14)=1
              CALL ZVK
              DO  I=1,3
                UR(I,NSA)=AT(I,1,NSA)
              ENDDO
C                            ... und addiere eine kartesische box.
              NS=NSA
              IAIN(1)=ISKP(53)
              IAIN(2)=NAT(NS)
              DO  I=1,3
                AIN(I+2)=ZELLE(I,NSE)*0.5001
              ENDDO
              NCD(NS)=0
              ISKP(14)=1
              NTYP=2
              CALL ZVAVBR
              IF (IERR .NE. 0) GO TO 990
              DO  I=1,3
                UR(I,NSA)=AT(I,JJ,NSA)
                UR(I,NSE)=AT(I,II,NSE)
              ENDDO
C
C                            Jetzt sollte um diese atome wieder die
C                            gleiche anzahl an partnern gefunden werden.
C
              NS=NSE
              IAIN(1)=ISKP(53)
              IAIN(2)=NAT(NSA)
              IAIN(3)=ISKP(53)
              IAIN(4)=NAT(NSE)
              AIN(5)=AINBFR(1)
              NTYP=10
              ISKP(14)=1
              NCD(NS)=0
              CALL ZVAVBR
              IF (IERR .NE. 0) GO TO 990
C
C                            Teste, ob erfolg.
C
              IF (NCD(NSE)-NCD(NSA)) 230,220,210
  210           IF (NOPT(4) .EQ. 0) GO TO 230
  220           CONTINUE
                NLSG=NLSG+1
                WRITE (WRLINE,'(A,I4,A,I1,A,I2,A)')
CYENG1
     +          'Loesung',NLSG,' (',NSA,' ->',NSE,')'
CYENG2
CYENGY     +          'Solution',NLSG,' (',NSA,' ->',NSE,')'
                CALL KPWRTE (NTOUT)
                WRITE (WRLINE,'(6X,A,8X,A)')
CYENG1
     +          'Transformationsmatrix','Verschiebung'
CYENG2
CYENGY     +          'Transformation matrix','displacement'
                CALL KPWRTE (NTOUT)
C
C                            Soll optimiert werden?
C
                IF (NOPT(3) .NE. 0) THEN
                  DO  I=1,2
                    DO  J=1,3
                      UR(J,I)=0.
                    ENDDO
                    DO  J=1,K8(I)
                      DO  K=1,3
                        UR(K,I)=UR(K,I)+ATOMS(K,J,I)
                      ENDDO
                    ENDDO
                    DO  K=1,3
                      UR(K,I)=UR(K,I)/FLOAT(K8(I))
                    ENDDO
                    K8(I)=0
                  ENDDO
                ENDIF
C                            Die werte URVAL werden fuer ZVGOML gesp.
                DO  NC=1,3
                  URVAL(NC,1)=UR(NC,1)
                  URVAL(NC,2)=UR(NC,2)
                ENDDO
                TEMP2=0.
                DO  I=1,3
                  J=ID2(I)
                  K=ID2(J)
                  TEMP2=TEMP2+(ZTSAV(I)-ZELLE(I,NSE))**2+
     +            (ZTSAV(I+3)-SQRT((DG(1,J,NSE)-DG(1,K,NSE))**2+
     +            (DG(2,J,NSE)-DG(2,K,NSE))**2+
     +            (DG(3,J,NSE)-DG(3,K,NSE))**2))**2
                ENDDO
                TEMP2=SQRT(TEMP2/6.)/(ABS(ZELLE(7,NSE))**0.33333333)
                ISKP(94)=1
                NS=NSA
                ISKP(14)=1
                NTYP=4
                CALL ZVGE05
                IF (NOPT(4) .EQ. 0) THEN
                  TEMP=SQRT(CONST(37)/FLOAT(NCD(1)))
                  WRITE (WRLINE,'(A,F6.4,A,F6.4)')
CYENG1
     +            'Misfit der Atome: ',TEMP,' und der Zelle: ',TEMP2
CYENG2
CYENGY     +            'Misfit of atoms: ',TEMP,' and of the cell: ',TEMP2
                  CALL KPWRTE (NTOUT)
                ENDIF
                IF (ZELLE(7,NSE) .LT. 0.) THEN
                  WRITE (WRLINE,'(A,I2,A)')
CYENG1
     +            'Achtung! NS =',NSE,' ist ein Linkssystem!'
CYENG2
CYENGY     +            'Caution! NS =',NSE,' is a left-handed system!'
                  CALL KPWRTE (NTOUT)
                ENDIF
                WRITE (WRLINE,'(A,2I4)')
CYENG1
     +          'Vergleich erfolgreich.'
CYENG2
CYENGY     +          'Comparison successful.'
                CALL KPWRTE (NTOUT)
                IF (NOPT(2) .EQ. 2) THEN
                  WRITE (WRLINE,'(A)')
CYENG1
     +            'Abbildung der Elemente:'
CYENG2
CYENGY     +            'Mapping of elements:'
                  CALL KPWRTE (NTOUT )
                  DO  I=1,2
                    ISYNR=0
                    DO  J=ISKP(53),NAT(I)
                      K=24
                      IRC=0
                      CALL FCNV (IANR,ISKP(31),2HIR,AT(1,J,I),K,28,IRC)
                      IF (IRC .NE. 0) THEN
                      GO TO 990
                      ENDIF
                      IAIN(IANR)=IAT(5,J,I)
                      ISYNR=MAX(ISYNR,IANR)
                    ENDDO
                    WRITE (WRLINE,'(I1,A,30A4)')
     +              I,': ',(IAIN(J),J=1,ISYNR)
                    CALL KPWRTE (NTOUT )
                  ENDDO
                ENDIF
                IF (NOPT(7) .EQ. NLSG) GO TO 990
C             ENDIF
C                            Generiere einen zellinhalt.
  230         IAIN(1)=1
              IAIN(2)=ISKP(53)
              IAIN(3)=NAT(NSE)
              DO  I=4,6
                AIN(I)=.5
              ENDDO
              NCD(NSE)=0
              NTYP=1
              ISKP(14)=1
              NS=NSE
              CALL ZVAVBR
              IF (IERR .NE. 0) GO TO 990
  240       CONTINUE
          ENDDO  ! JJ=ISKP(53),NAT(NSA)
        ENDDO  ! II=ISKP(53),NAT(NSE)
C
C                            Noch eine permutation?
C
        IF (NOPT(2) .GT. 1) THEN
          J=1
  250     CONTINUE
          CALL PERMUT(NAMERS,IATLST(J),IATLST(J+1),I)
          IF (I .NE. 0) THEN
            DO  K=ISKP(53),NAT(NSE)
              ITEMP=IAT(5,K,NSE)
              CALL CNVTUP (ITEMP,1,4)
              DO  I=1,IATPOI(NSE)
                IF (ITEMP .EQ. IATNAM(I,NSE)) IAT(7,K,NSE)=NAMERS(I)
              ENDDO
            ENDDO
            GO TO 170
          ENDIF
          J=J+1
          IF (J .LT. LPOI) GO TO 250
        ENDIF
        IF (NOPT5 .NE. 0) THEN
          NS=NSE
          IF (ZELLE(7,NS) .GT. 0.) THEN
C
C                            Drehe die basisvektoren um.
            DO  I=1,3
              DO  J=1,3
                S(J,I)=-DG(J,I,NS)
              ENDDO
            ENDDO
            GO TO 160
          ENDIF
        ENDIF
  260   CONTINUE
      ENDDO  ! ITRF=1,ITPOI
      IF (NLSG .GT. 0) GO TO 990
      GO TO 280
C
  270 WRITE (WRLINE,'(A,A,A)')
CYENG1
     + 'ZVCMPC0812 - Keinen Kandidaten fuer ',ACH(I:I),' gefunden.'
CYENG2
CYENGY     + 'ZVCMPC0812 - No candidate found for ',ACH(I:I),'.'
      CALL KPWRTE (NTOUT)
  280 CONTINUE
CYENG1
      WRITE (WRLINE,'(A)') 'ZVCMPC0818 - Vergleich fehlgeschlagen.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'ZVCMPC0818 - Comparison failed.'
      CALL KPWRTE (NTOUT)
      NOPT6=1
C
  990 NCDA(1)=1
      NCDA(2)=1
      ISKP(66)=0
C                            Restore ggf. Zelle.
C
      IF (NOPT6 .NE. 0) THEN
        DO  NS=1,2
          DO  I=1,7
            ZELLE(I,NS)=ZSAV(I,NS)
          ENDDO
          ISKP(14)=1
          NTYP=1
          CALL ZVZ
        ENDDO
      ENDIF
      NS=NSSV
      ISKP(14)=0
  999 RETURN
      END
