C         85      ------------------------------------
                   SUBROUTINE ZVDTAB (N1,N2,D,IFUNKT)
C CY-ENG-         ------------------------------------
C
      IMPLICIT NONE
      INTEGER *4 N1,N2,IFUNKT
      REAL    *4 D
C
C--- Es wird eine tabelle mit abstaenden verwaltet, die bei
C    diversen kommandos als defaults eingesetzt werden.
C    Erweitern: NTRES und ggf. NTDIM hochsetzen und tabellen
C    NTAB und DTAB ergaenzen.
C
C                geschrieben: 190851 APR 1999  (Hundt)
C                  geaendert: 251500 NOV 1999  (Hundt)
C
C                 ------------------------------------
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 NTDIM,NTRES,NRSMDM,NRSMDZ,IAIN(72)
      PARAMETER (NTDIM=30,NTRES=17,NRSMDM=NTDIM-NTRES,NRSMDZ=2*NRSMDM)
      INTEGER *4 I
      INTEGER *2 NTAB(2,NTDIM),NTPOI,NV1,NV2,IELH
      REAL    *4 DTAB(NTDIM),DTOH
      INTEGER *1 MODI(NTDIM)
      EQUIVALENCE (AIN(1),IAIN(1))
      SAVE NTAB,DTAB,NTPOI,DTOH,MODI
C
      DATA NTAB/ 2HC ,2HC ,2HN ,2HC ,2HS ,2HC ,2HS ,2HN ,2HN ,2HN ,
     + 2HF ,2HC ,2HCL,2HC ,2HI ,2HC ,2HO ,2HO ,2HO ,2HC ,2HO ,2HN ,
     + 2HS ,2HO ,2HF ,2HF ,2HS ,2HF ,2HSN,2HSN,2HTE,2HTE,2HB ,2HB ,
     + NRSMDZ*2H  /
      DATA DTAB/    1.7   ,   1.7   ,   1.9   ,   1.8   ,   1.8   ,
     +    2.0   ,   2.2   ,   2.3   ,   1.2   ,   1.5   ,   1.5   ,
     +    1.7   ,   1.7   ,   1.7   ,   3.0   ,   3.0   ,   2.0   ,
     + NRSMDM*0./
      DATA NTPOI/NTRES/,IELH/2HH /,DTOH/1.2/,MODI/NTDIM*0/
C
      GO TO (10,20,30,40,50,60),IFUNKT
C
C                            OFMD - Listen
   10 DO  I=1,NTPOI
        WRITE (WRLINE,'(A,2A4,F6.2)')
     +  'Dist ',NTAB(1,I),NTAB(2,I),DTAB(I)
        CALL KPWRTE (NTOUT)
      ENDDO
      WRITE (WRLINE,'(A,F7.2)') 'Default Dist',CONST(31)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(A,F7.2)') 'Dist  H - xx',DTOH
      CALL KPWRTE (NTOUT)
      GO TO 990
C                            Abstand in tabelle suchen.
   20 CALL COPYCH (N1,1,2, NV1,1)
      CALL COPYCH (N2,1,2, NV2,1)
      CALL CNVTUP (NV1,1,2)
      CALL CNVTUP (NV2,1,2)
      DO  I=1,NTPOI
        IF ((NV1 .EQ. NTAB(1,I) .AND. NV2 .EQ. NTAB(2,I)) .OR.
     +      (NV1 .EQ. NTAB(2,I) .AND. NV2 .EQ. NTAB(1,I))) THEN
            D=DTAB(I)
            GO TO 999
        ENDIF
      ENDDO
      IF (NV1 .EQ. IELH .OR. NV2 .EQ. IELH) THEN
        D=DTOH
      ELSE
        D=CONST(31)
      ENDIF
      GO TO  999
C                            FMDP - FM-Distanzpaar
   30 AIN(3)=CONST(31)
      CALL FLES (AIN,ISKP(31),4HAAFE,13HAt1,At2,dmx?$)
      IF (ISKP(32) .LT. 1) THEN
        IERR=85 0062 16
        GO TO 999
      ENDIF
      CALL COPYCH (IAIN(1),1,2, NV1,1)
      CALL COPYCH (IAIN(2),1,2, NV2,1)
      CALL CNVTUP (NV1,1,2)
      CALL CNVTUP (NV2,1,2)
C                            Teste, ob dieses Paar in der Tabelle
C                            bereits vorkommt.  Wenn ja, ueberschreibe.
      DO  I=1,NTPOI
        IF ((NV1 .EQ. NTAB(1,I) .AND. NV2 .EQ. NTAB(2,I)) .OR.
     +      (NV1 .EQ. NTAB(2,I) .AND. NV2 .EQ. NTAB(1,I))) THEN
            DTAB(I)=AIN(3)
            MODI(I)=1
            GO TO 999
        ENDIF
      ENDDO
C                            Nicht gefunden.  Nimm auf, falls noch
C                            moeglich.
C
      IF (NTPOI .GE. NTDIM) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVDTAB0079 - Tabelle fuer Atompaare voll.'
CYENG2
CYENGY     +  'ZVDTAB0079 - Too many pairs of atoms.'
        IERR=-1
      ELSE
        NTPOI=NTPOI+1
        NTAB(1,NTPOI)=NV1
        NTAB(2,NTPOI)=NV2
        DTAB(NTPOI)=AIN(3)
        MODI(NTPOI)=1
      ENDIF
      GO TO 999
C                            FMDR - Reset auf tabelle
   40 NTPOI=NTRES
      GO TO 990
C                            FMDD - Default distance
   50 AIN(1)=CONST(31)
      AIN(2)=DTOH
      CALL FLES (AIN,ISKP(31),3H2FE,19Hd(default),d(H-)? $)
      CONST(31)=AIN(1)
      DTOH=AIN(2)
      GO TO 999
C                            Modifizierte Werte ausgeben auf NTBILF
   60 DO  I=1,NTPOI
        IF (MODI(I) .NE. 0) THEN
          WRITE (WRLINE,'(A,2A4,F6.2)')
     +    'FMDP ',NTAB(1,I),NTAB(2,I),DTAB(I)
          CALL KPWRTE (NTBILF)
        ENDIF
      ENDDO
      IF (CONST(31) .NE. 2.7 .OR. DTOH .NE. 1.2) THEN
        WRITE (WRLINE,'(A,2F7.2)') 'FMDD',CONST(31),DTOH
        CALL KPWRTE (NTBILF)
      ENDIF
      GO TO 999
C
  990 CALL FLES (AIN,ISKP(31),1HE,2H?$)
  999 RETURN
      END
