C           65         -------------------
                        SUBROUTINE ZVEAEH
C   CY-VAX-ENG-UNX-    -------------------
C
C   Dieses Unterprogramm handhabt eine die Eingabe-Ausgabe-Ein-
C   heiten.
C
C   NTYP  Kommando
C    -6         GET, aber ohne filesave
C    -5         Besorge Argumente (FILENAME)
C    -4         Zeige letzten filenamen (OFN)
C    -3         Wie EAE xx  (xx = 13..19) (GET)
C    -2         Zeige offene Einheiten an
C    -1         Close auf alle offenen Einheiten
C     0   EAE   Definition der Eingabe-Ausgabe-Einheiten
C     n         Diese Nummer oeffnen
C     n+100     Diese Nummer (n) schliessen
C     n+200     Diese Nummer (n) als offen eintragen
C
C                geschrieben: 061134 SEP 1989  (Hundt)
C                geaendert:   301655 JAN 2002  (Hundt)
C
C                          -------------------
      IMPLICIT  NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER*4 KARTE
      COMMON /KPFLIN/ KARTE(21)
C
      INTEGER*4 IOUNIT(10),IOPOI,I,J,NRET,FILNAM(20),IDFLG,FGETCMD
      INTEGER*4 FRAGE(7),IAIN(72),PRNNAM(2),IOSAV,BLANK,ISVFLG
      INTEGER*4 INSTCK(8),INPOI,NTYPN,K,ISKP45,KDMACC,NTINSV,KDSEMI
      LOGICAL*4 EXIST
      CHARACTER*80 CHFLNM,FLNMSV
      CHARACTER*12 CHFLDF
      CHARACTER*28 CFRAGE
      CHARACTER*288 CHAIN
C
      SAVE IOUNIT,IOPOI,FLNMSV,INSTCK,INPOI,ISKP45
C
      EQUIVALENCE (FILNAM,CHFLNM),(AIN(1),IAIN(1))
      EQUIVALENCE (FRAGE(1),CFRAGE),(AIN(1),CHAIN)
C
      DATA IOPOI/2/,IOUNIT/5,6,8*0/,INSTCK/5,7*0/,INPOI/1/
CYENG1
      DATA FRAGE/4HName,4H fue,4Hr Nr,4H.   ,4Hxxxx,4H?$  ,4H    /
CYENG2
CYENGY      DATA FRAGE/4HName,4H for,4H uni,4Ht   ,4Hxxxx,4H?$  ,4H    /
      DATA CHFLDF/'FOR000.DAT'/,PRNNAM/4HPRN ,4HPRN:/,BLANK/4H    /
      DATA FLNMSV/'DUMMY.DMY'/,KDMACC/4HMACC/,KDSEMI/4H   ;/
C
      ISVFLG=0
      IOSAV=NTIN
      NTINSV=NTIN
      IF (NTYP .EQ. NTBILF) ISVFLG=-1
      IF (NTYP) 10,60,90
   10 NTYPN=-NTYP
      GO TO (40,20,315,325,326,315),NTYPN
C            -1 -2  -3  -4  -5  -6
C
C                            Zeige offene files (OOPN)
C
   20 WRITE (WRLINE,30) (IOUNIT(I),I=1,IOPOI)
      CALL KPWRTE (NTDISP)
CYENG1
   30 FORMAT ('Offene Files:',10I4)
CYENG2
CYENGY   30 FORMAT ('Files open:',10I4)
      GO TO 340
C                            Schliesse alle Einheiten
C
   40 IF (IOPOI .LE. 2) GO TO 999
      J=0
      DO  I=3,IOPOI
        IF (IOUNIT(I) .EQ. NTDTEI) THEN
          J=NTDTEI
        ELSE
          CLOSE (IOUNIT(I))
        ENDIF
      ENDDO
      IOPOI=2
      INPOI=1
      IF (J .GT. 0) THEN
        IOPOI=IOPOI+1
        IOUNIT(IOPOI)=NTDTEI
      ENDIF
      GO TO 999
C                            Eingabe- Ausgabeeinheiten (EAE)
C
   60 CALL FLES (NTIN,ISKP(31),3H9JR,
     + 57HNTIN,NTOUT,NTPCH,NTSCR,NTXR1,NTXR2,NTBILF,NTDTEI,NTDISP?$)
C
   70 IF (IOSAV .NE. NTIN) THEN
C
C                            NTIN hat sich veraendert.
        IDFLG=1
        NRET=1
        J=NTIN
        IF (NTIN .EQ. 5) THEN
          INPOI=1
C                            Restore macro-pointer
          IF (ISKP45 .NE. 0) THEN
            ISKP(45)=ISKP45
            KARTE(20)=KDMACC
            IF (KARTE(21) .GT. 76) THEN
              KARTE(21)=76
            ELSE
              KARTE(19)=KDSEMI
            ENDIF
          ENDIF
        ELSE
          IF (NTINSV .EQ. 5) THEN
C
C                            Save macro-pointer and suspend macro-
C                            execution
            ISKP45=ISKP(45)
            ISKP(45)=0
            KARTE(20)=ISKP(24)
          ENDIF
        ENDIF
        GO TO 120
      ENDIF
C
   80 J=NTOUT
      GO TO 110
C
   90 J=NTYP
      IF (J .LT. 100) GO TO 110
      IF (J .LT. 200) GO TO 100
C
C                       Nur Unit als offen eintragen
C
      IF (IOPOI .GE. 10) GO TO 999
      IOPOI=IOPOI+1
      IOUNIT(IOPOI)=J-200
      GO TO 999
C
  100 J=J-100
      NRET=-1
      GO TO 120
C
  110 NRET=0
      IDFLG=0
      IF (J .EQ. NTXR1) IDFLG=1
C
C                              Teste, ob Nummer offen
C
  120 IF (J .LE. 0 .OR. J .GE. 100) THEN
        WRITE (WRLINE,140) J
        CALL KPWRTE (NTDISP)
CYENG1
  140   FORMAT ('ZVEAEH0146 - Unit-Nr.',I5,' nicht erlaubt.')
CYENG2
CYENGY  140   FORMAT ('ZVEAEH0146 - Unit-No.',I5,' not allowed.')
        IERR=-1
        GO TO 999
      ENDIF
C
      DO  I=1,IOPOI
        IF (J .EQ. IOUNIT(I)) THEN
          IF (NRET .GT. 0) THEN
            INPOI=INPOI+1
            INSTCK(INPOI)=J
          ENDIF
          GO TO 280
        ENDIF
      ENDDO
      IF (NRET .LT. 0) THEN
        IERR=-1
        GO TO 999
      ENDIF
      IF (ISKP(14)) 150,170,160
  150   CHFLNM=FLNMSV
        GO TO 165
C
  160   DO  I=1,3
          FILNAM(I)=IAIN(I)
        ENDDO
        DO  I=4,20
          FILNAM(I)=BLANK
        ENDDO
  165   ISKP(14)=0
        GO TO 181
C
  170 FRAGE(5)=FRAGE(7)
      I=16
      CALL KPNTOS (J,FRAGE,I,0)
      CHFLNM=CHFLDF
      I=5
      IF (J .GE. 10) I=4
      CALL KPNTOS (J,FILNAM,I,0)
CYVAX1
      CALL FLES (FILNAM,ISKP(31),4H20AR,CFRAGE)
CYVAX2
CYVAXY      CALL FLES (FILNAM,ISKP(31),4H20AR,FRAGE)
  181 CONTINUE
      IF (CHFLNM .EQ. '.') THEN
        IF (ISKP(75) .NE. 0) THEN
          ISKP(75)=0
          WRITE (WRLINE,'(A)')
CYENG1
     +    'ZVEAEH0196 - Name ''.'' hier nicht erlaubt.'
CYENG2
CYENGY     +    'ZVEAEH0196 - Name ''.'' not allowed here.'
          CALL KPWRTE (NTDISP)
          IERR=-1
          GO TO 999
        ELSE
          CHFLNM=FLNMSV
        ENDIF
      ENDIF
      ISKP(75)=0
CYDOSY      CALL CNVTUP (FILNAM,1,80)
C
C                            Fange Sonderbedingung fuer Laserplot ab
C
      IF (J .NE. 20) GO TO 220
      I=0
      ISKP(55)=0
      IF (FILNAM(1) .EQ. PRNNAM(1)) I=-1
      IF (FILNAM(1) .EQ. PRNNAM(2)) I=-1
C
C                            File nr. 20 wird von ZPRN verwaltet.
      CALL ZPRN (FILNAM,I)
      IF (I .NE. 0) GO TO 999
C                            Setze Flag, falls .PCX oder .IMG file
C
CYDOS1
      CALL CNVTUP (FILNAM,1,80)
CYDOS2
      DO  I=1,37
        IF (CHFLNM(I:I+3) .EQ. '.IMG') THEN
          ISKP(55)=2
          GO TO 999
        ENDIF
        IF (CHFLNM(I:I+3) .EQ. '.PCX') THEN
          ISKP(55)=1
          GO TO 999
        ENDIF
      ENDDO
      GO TO 999
C
  220 IF (IOPOI .GE. 10) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +    'ZVEAEH0240 - Tabelle fuer offene Files ist voll.'
CYENG2
CYENGY     +    'ZVEAEH0240 - Table for open files full.'
        CALL KPWRTE (NTDISP)
        GO TO 280
      ENDIF
C
      IOPOI=IOPOI+1
      IOUNIT(IOPOI)=J
C     IF (J .EQ. NTSCR) GO TO 270
C
C                            Wenn es sich um eine Inputdatei
C                            handelt, teste zuerst deren Existenz.
C
      IF (IDFLG .EQ. 0) GO TO 260
      IF (NRET .EQ. 1) THEN
        INPOI=INPOI+1
        INSTCK(INPOI)=J
      ENDIF
C     WRITE (WRLINE,'(A,8I4)') 'Stack:',(INSTCK(I),I=1,INPOI)
C     CALL KPWRTE (NTDISP)
  225 INQUIRE (FILE=CHFLNM,EXIST=EXIST)
      IF (EXIST) GO TO 260
C                            Teste, ob eine Extension vorhanden ist.
      DO  I=2,79
        IF (CHFLNM(I:I) .EQ. '.') GO TO 240
      ENDDO
C                            Versuche es mit der Endung .KPL
      DO  I=80,1,-1
        IF (CHFLNM(I:I) .NE. ' ') GO TO 230
      ENDDO
      GO TO 240
  230 IF (I .GT. 77) GO TO 240
      CHFLNM(I+1:I+4)='.kpl'
      GO TO 225
  240 IOPOI=IOPOI-1
      INPOI=INPOI-1
      WRITE (WRLINE,'(A,A)')
CYENG1
     + ' KPEAEH0279 - File nicht gefunden: ',CHFLNM
CYENG2
CYENGY     + ' KPEAEH0279 - File not found: ',CHFLNM
      CALL KPWRTE (NTDISP)
C
C                            Restore Nummern
      NTIN=IOSAV
      IAIN(1)=0
      IERR=-1
      GO TO 999
C
CYVAX1
  260 CONTINUE
      OPEN (J,FILE=CHFLNM,STATUS='UNKNOWN',FORM='FORMATTED')
      IF (ISVFLG .NE. 0) FLNMSV=CHFLNM
CYVAX2
CYVAXY  260 OPEN (J,FILE=CHFLNM,STATUS='UNKNOWN',FORM='FORMATTED',
CYVAXY     + CARRIAGECONTROL='LIST')
C     GO TO 280
C
C 270 OPEN (J,FILE=CHFLNM,STATUS='UNKNOWN',FORM='UNFORMATTED')
  280 IF (NRET) 300,281,80
  281 IAIN(1)=0
      GO TO 999
C
  290 IOUNIT(I)=IOUNIT(I+1)
      I=I+1
  300 IF (I .LT. IOPOI) GO TO 290
      IOPOI=IOPOI-1
      CLOSE (J)
C                            Teste, ob sie im stack vorkommt.
      IAIN(1)=0
      K=INPOI
      DO  I=1,K
        IF (INSTCK(I) .EQ. J) THEN
          IF (I .EQ. INPOI) THEN
            INPOI=INPOI-1
            IAIN(1)=INSTCK(INPOI)
C
C                            Restore macro-pointer
C
            IF (IAIN(1) .EQ. 5 .AND. ISKP45 .NE. 0) THEN
              ISKP(45)=ISKP45
              KARTE(20)=KDMACC
              IF (KARTE(21) .GT. 76) THEN
                KARTE(21)=76
              ELSE
                KARTE(19)=KDSEMI
              ENDIF
            ENDIF
C     WRITE (WRLINE,'(A,8I4)') 'Stack:',(INSTCK(J),J=1,INPOI)
C     CALL KPWRTE (NTDISP)
          ELSE
            WRITE (WRLINE,'(A)')
CYENG1
     +      'ZVEAEH0334 - Nicht erlaubte Position im Stack.'
CYENG2
CYENGY     +      'ZVEAEH0334 - Illegal position in stack.'
            CALL KPWRTE (NTDISP)
            IERR=-1
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
      GO TO 999
C                       Kommando GET
C                       Suche freie Unit-Nummer.
C
  315 IF (NTYPN .EQ. 3) ISVFLG=1
      DO  I=13,19
        DO  J=1,IOPOI
          IF (IOUNIT(J) .EQ. I) GO TO 330
        ENDDO
C                       Gefunden, wenn hier.
        NTIN=I
        IOSAV=0
        GO TO 70
  330   CONTINUE
      ENDDO
      IERR=65 0330 16
      GO TO 340
C                            Zeige filenamen
  325 CONTINUE
      WRLINE=FLNMSV
      CALL KPWRTE (NTDISP)
      GO TO 340
C                            Besorge Argument
  326 CONTINUE
C
CYDOSY      I=FGETCMD(CHAIN)
CYDOSY      DO  I=3,82
CYDOS1
      CALL GETARG (1,CHAIN)
      DO  I=1,80
CYDOS2
        IF(CHAIN(I:I) .NE. ' ') GO TO 327
      ENDDO
      IAIN(1)=0
      GO TO 999
CYDOSY  327 DO  I=3,82
CYDOSY        FLNMSV(I-2:I-2)=CHAIN(I:I)
CYDOS1
  327 DO  I=1,80
      FLNMSV(I:I)=CHAIN(I:I)
CYDOS2
      ENDDO
      ISKP(14)=-1
      ISVFLG=1
      GO TO 315
C
  340 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
  999 RETURN
      END
