CKPEFIT   40             -------------------
                          SUBROUTINE ZVEFIT
C CY-ENG-                -------------------
C
C      Das Programm soll eine Ebene in eine Punktmenge fitten.
C
C            Kommando  NTYP  Bedeutung
C            EFTP        1   Ebenenfit ueber Parameter
C            EFTC        2   Ebenenfit ueber Codes
C            EFTS        3   Ebenenfit ueber Symbole
C            EFTG        4   Ebenenfit ueber Gruppe v. Codes
C            -           5   Wie 4, ohne FLES-Call
C            -           6   Wie 2, ohne FLES-Call
C
C                        Geschrieben:  Hundt
C                  Geaendert: 270939 OCT 2011  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 I,IAIN(72),IBIS,IBLANK,IG,IGRPOI,IK,IPCNT,ISYMBL
      INTEGER *4 IVON,J,K,NANZ,NTYPS,NTYPSS
      REAL    *4 A(3,3),D,GEW,R(3,3),SUM(10),SYMBL,T1,U,V(3)
C
      EQUIVALENCE (AIN(1),IAIN(1),IVON),(AIN(2),IBIS),(AIN(3),SUM(1))
      EQUIVALENCE (AIN(13),A(1,1)),(AIN(22),R(1,1)),(AIN(31),V(1))
      EQUIVALENCE (SYMBL,ISYMBL)
C
      DATA IBLANK/4H    /
C
      NTYPS=NTYP
      NTYPSS=NTYP
C                            Hole Eingabe
C
      IF (ISKP(14) .NE. 0) GO TO 30
      GO TO (20,20,40,10,60,20), NTYPS
C             1  2  3  4  5  6
   10 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      GO TO 70
C
   20 IVON=ISKP(53)
      IBIS=NAT(NS)
      IF (NTYPSS .EQ. 6) THEN
        NTYPS=2
        GO TO 30
      ENDIF
CYENG1
      CALL FLES (AIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H2IE,9Hfrom,to?$)
   30 IF (IVON .GT. 0 .AND. IBIS .LE. NAT(NS) .AND. IBIS .GE. IVON)
     + GO TO 70
      IERR=40 0050 16
      GO TO 999
C                            EFTS - Ebenenfit nach Symbol(en)
   40 DO  I=51,57,3
      IAIN(I)=IBLANK
      IAIN(I+1)=ISKP(53)
      IAIN(I+2)=NAT(NS)
      ENDDO
      CALL FLES (AIN(51),ISKP(31),10HA2IA2IA2IE,
     1 26Hs1,v1,b1, s2,v2,b2, ... ?$)
C
C                            Ende der eingegebenen Symbole
      NANZ=0
      DO  I=51,57,3
        CALL CNVTUP (IAIN(I),1,4)
        IF (IAIN(I) .EQ. IBLANK) GO TO 50
        NANZ=I
      ENDDO
   50 IF (NANZ .GT. 0) GO TO 70
      IERR=40 0069 16
      GO TO 999
C                            Berechne Summen
   60 NTYPS=4
   70 NC=1
      NTRY=2
      DO  I=1,10
        SUM(I)=0.
      ENDDO
      IPCNT=0
      IGRPOI=0
      GO TO (90,110,110,80,110), NTYPS
C
   80 IGRPOI=IGRPOI+1
      ICDS(1)=IGRPOI
      NTYP=7
      CALL ZVGC01 (ICDS(1))
      NTRY=26
      IF (ICDS(1)) 150,180,150
C
   90 IANR=IVON-1
      GO TO 160
  100 IANR=IANR+1
      X(1,1)=AT(1,IANR,NS)
      X(2,1)=AT(2,IANR,NS)
      X(3,1)=AT(3,IANR,NS)
      GO TO 150
C
  110 IC=NCDA(NS)-1
      GO TO 170
  120 IC=IC+1
      NTRY=32
      CALL ZVDEK
      IF (NTYPS .LE. 2) GO TO 130
      SYMBL=AT(7,IANR,NS)
      DO  I=51,NANZ,3
        IF (ISYMBL .EQ. IAIN(I) .AND. IANR .GE. IAIN(I+1) .AND.
     +  IANR .LE. IAIN(I+2)) GO TO 140
      ENDDO
      GO TO 170
C
  130 IF (IANR .LT. IVON) GO TO 170
      IF (IANR .GT. IBIS) GO TO 170
  140 NTRY=10
  150 IPCNT=IPCNT+1
      CALL ZVDEK
      IF (NTYPSS .NE. 6) THEN
        GEW=AT(4,IANR,NS)
      ELSE
        GEW=1.
      ENDIF
      SUM(1)=SUM(1)+X1(1)*GEW
      SUM(2)=SUM(2)+X1(2)*GEW
      SUM(3)=SUM(3)+X1(3)*GEW
      SUM(4)=SUM(4)+X1(1)*X1(1)*GEW
      SUM(5)=SUM(5)+X1(1)*X1(2)*GEW
      SUM(6)=SUM(6)+X1(1)*X1(3)*GEW
      SUM(7)=SUM(7)+X1(2)*X1(2)*GEW
      SUM(8)=SUM(8)+X1(2)*X1(3)*GEW
      SUM(9)=SUM(9)+X1(3)*X1(3)*GEW
      SUM(10)=SUM(10)+GEW
      GO TO (160,170,170,80,170), NTYPS
  160 IF (IANR-IBIS) 100,180,180
  170 IF (IC .LT. NCD(NS)) GO TO 120
C
C                            Teste, ob wenigstens 3 Punkte
C
  180 IF (IPCNT .LT. 3) THEN
        IERR=40 0134 16
        GO TO 999
      ENDIF
C                            Definiere Matrix
C
      A(1,1)=SUM(1)*SUM(1)/SUM(10)-SUM(4)
      A(1,2)=SUM(1)*SUM(2)/SUM(10)-SUM(5)
      A(1,3)=SUM(1)*SUM(3)/SUM(10)-SUM(6)
      A(2,2)=SUM(2)*SUM(2)/SUM(10)-SUM(7)
      A(2,3)=SUM(2)*SUM(3)/SUM(10)-SUM(8)
      A(3,3)=SUM(3)*SUM(3)/SUM(10)-SUM(9)
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)
C                            Berechne Eigenwerte und -Vektoren
      CALL ZVEIGN (A,R,3)
      IF (NTYPSS .EQ. 6) THEN
        X1(1)=A(1,1)
        X1(2)=A(2,2)
        X1(3)=A(3,3)
        GO TO 999
      ENDIF
C                            Finde kleinsten und groeszten Eigenvektor
      IK=1
      IG=1
      DO  I=2,3
        IF (ABS(A(IK,IK)) .GT. ABS(A(I,I))) IK=I
        IF (ABS(A(IG,IG)) .LT. ABS(A(I,I))) IG=I
      ENDDO
C                            Falls entartet
C
      IF (IG .EQ. IK) IG=ID2(IK)
C
C                            Normiere auf 1
      U=0.
      DO  I=1,3
        T1=R(I,IK)
        V(I)=T1
        U=U+T1*T1
      ENDDO
      IF (U .GT. 0.) GO TO 200
  190 IERR=40 0169 06
      GO TO 999
C
  200 U=SQRT(U)
      DO  I=1,3
        V(I)=V(I)/U
      ENDDO
      D=(V(1)*SUM(1)+V(2)*SUM(2)+V(3)*SUM(3))/SUM(10)
C
C                            Ursprungspunkt
      DO  I=1,3
        UR(I,NS)=(RG(1,I,NS)*V(1)+RG(2,I,NS)*V(2)+RG(3,I,NS)*V(3))*D
      ENDDO
C                            X-Vektor
      U=0.
      DO  I=1,3
        T1=R(I,IG)
        U=U+T1*T1
        X1(I)=T1
      ENDDO
      IF (U .LE. 0.) GO TO 190
      U=SQRT(U)
C                            Definition der Basis
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        DREH(3,I)=V(I)
        DREH(2,I)=(X1(J)*V(K)-X1(K)*V(J))/U
      ENDDO
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        DREH(1,I)=DREH(2,J)*V(K)-DREH(2,K)*V(J)
      ENDDO
      NTYP=3
      CALL ZVK
C
  999 RETURN
      END
