CKPGNSX   59              -------------------
                           SUBROUTINE ZVGNSX
C  CY-ENG-                -------------------
C
C  Das Programm schreibt auf die Datei mit der Nummer NTPCH
C  Atomkarten im SHELX-Format.
C
C  NTYP=1  SHELX-Karten aus Codeliste
C  NTYP=2  THEO-File erzeugen
C  NTYP=3  Parameter setzen
C  NTYP=4  SHELX-Karten aus Parameterliste
C  NTYP=5  Atome in der Elementarzelle bestimmen
C  NTYP=6  NRC-Atome ausgeben
C  NTYP=7  Input fuer MISSYM erzeugen
C  NTYP=8  Kompletten SHELXL job erzeugen
C  NTYP=9  Initialisieren
C
C                  geschrieben: 250908 JUN 1987 (Hundt)
C                  geaendert:   231448 MAR 2006 (Hundt)
C
C                         -------------------
C
      IMPLICIT  NONE
C
      INTEGER*4 INBFR(2,6),IAIN(72),INRATS(6),ISVBF(4),IN2BFR(2,6)
      INTEGER*4 IARBFR(16),I,J,K,IPOI,IANRSV,LCOMPS,ICTMP
      INTEGER*4 NTYPS,NANZ,INBFDM,IN4BFR(3),ISFAC,KEYIN,ITEMP,JPOI
      INTEGER*4 NTPCHS,MSFLAG,FILNAM(12),IATNAM(2,18),INPOI
      INTEGER*4 KDCU,KDA1,NTYPSS,IRLINE(30)
      REAL*4    TEMP,PARBFR(16)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      EQUIVALENCE (AIN(1),IAIN(1)),(PARBFR(1),IARBFR(1))
      EQUIVALENCE (TEMP,ITEMP),(WRLINE,IRLINE(1))
C
      SAVE IN2BFR,PARBFR
C
      DATA INBFDM/6/,KDCU/4HCU  /,KDA1/4HA1  /
      DATA FILNAM/4HCDED,4HIT.D,4HAT  ,4HKPAT,4HMS.D,4HAT  ,4HMISS,
     + 4HYM.D,4HAT  ,4HCDFI,4HLE.D,4HAT  /
C
      NTYPS=NTYP
      NTYPSS=NTYP
      IF (NTYPS .EQ. 9) THEN
        IARBFR(1)=KDCU
        IARBFR(2)=KDA1
        DO  I=3,6
          IARBFR(3)=ISKP(24)
        ENDDO
        PARBFR(7)=0.02
        PARBFR(8)=5.
        PARBFR(9)=70.
        PARBFR(10)=0.02
        IARBFR(11)=3
        IARBFR(12)=2
        PARBFR(13)=0.9
        IARBFR(14)=13
        PARBFR(15)=0.07
        PARBFR(16)=0.005
        DO  I=1,6
          IN2BFR(1,I)=0
          IN2BFR(2,I)=1
        ENDDO
        GO TO 999
      ENDIF
C
      INPOI=0
      MSFLAG=0
      ISVBF(1)=NCDA(NS)
      ISVBF(2)=NCD(NS)
      ISVBF(3)=ISKP(15)
      ISVBF(4)=ISKP(14)
      IF (NTYPS .EQ. 7) GO TO 770
   10 DO  I=1,72
        IAIN(I)=0
      ENDDO
      JPOI=2
      IF (NTYPS .EQ. 3) GO TO 840
      IF (NTYPS .LT. 3) GO TO 40
C
C                            Hole Eingabe.
      IN4BFR(1)=ISKP(53)
      IN4BFR(2)=NAT(NS)
      IN4BFR(3)=0
CYENG1
      CALL FLES (IN4BFR,ISKP(31),3H3IE,13Hvon,bis,opt?$)
CYENG2
CYENGY      CALL FLES (IN4BFR,ISKP(31),3H3IE,13Hfrom,to,opt?$)
      IF (IN4BFR(1) .LE. 0) GO TO 30
      IF (IN4BFR(2) .GT. NATDM) GO TO 30
      IF (IN4BFR(1) .LE. IN4BFR(2)) GO TO 150
   30 IERR=59003016
      GO TO 999
C
   40 DO  I=1,INBFDM
        INBFR(1,I)=0
        INBFR(2,I)=I
      ENDDO
C
      IF (NTYPS .EQ. 1) GO TO 70
CYENG1
      CALL FLES (IN2BFR,IAIN(1),13HAJAJAJAJAJAJE,15HSymb.,Anz,...?$)
CYENG2
CYENGY      CALL FLES (IN2BFR,IAIN(1),13HAJAJAJAJAJAJE,15HSymb.,no.,...?$)
      DO  I=1,INBFDM
        INBFR(1,I)=IN2BFR(1,I)
      ENDDO
      GO TO 80
C
CYENG1
   70 CALL FLES (INBFR,IAIN(1),13HAJAJAJAJAJAJE,14HSymb.,Nr,...?$)
CYENG2
CYENGY   70 CALL FLES (INBFR,IAIN(1),13HAJAJAJAJAJAJE,15HSymb.,no.,...?$)
   80 NANZ=0
      DO  I=1,INBFDM
        IF (INBFR(1,I) .EQ. 0) GO TO 110
        NANZ=I
        CALL CNVTUP (INBFR(1,I),1,4)
        INRATS(NANZ)=0
      ENDDO
C
  110 IF (NANZ .LE. 0) THEN
        IERR=59012016
        GO TO 999
      ENDIF
C
      IF (NTYPS .EQ. 1 .AND. NCD(NS) .LT. NCDA(NS)) THEN
        IERR=59014012
        GO TO 999
      ENDIF
C                            Oeffne ggf. NTPCH
C
  150 IF (NTYPS .EQ. 5) GO TO 160
      NTYP=NTPCH
      CALL ZVEAEH
      IF (NTYPS .EQ. 8) GO TO 850
C
C                            Bei THEO Vorspann
C
  160 IF (NTYPS .NE. 2) GO TO 240
      WRITE (WRLINE,170) (TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTPCH)
  170 FORMAT ('TITL ',18A4)
      WRITE (WRLINE,180) (PARBFR(I),I=1,2)
      CALL KPWRTE (NTPCH)
  180 FORMAT ('WAVE ',A2,1X,A4)
      WRITE (WRLINE,190) (ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
  190 FORMAT ('CELL ',3F8.4,3F8.3)
      IF (IARBFR(3) .NE. ISKP(24)) THEN
        WRITE (WRLINE,210) (IARBFR(I),I=3,6)
      ELSE
        WRITE (WRLINE,210) (ISKP(I),I=16,17)
      ENDIF
      CALL KPWRTE (NTPCH)
  210 FORMAT ('SYMM ',4A4)
      DO  J=1,NANZ
        CALL CNVTUP (IN2BFR(1,J),1,4)
      CONTINUE
      ENDDO
      WRITE (WRLINE,220) (IN2BFR(1,J),J=1,NANZ)
      CALL KPWRTE (NTPCH)
  220 FORMAT ('SFAC ',6(A2,1X))
      WRITE (WRLINE,230) (IN2BFR(2,J),J=1,NANZ)
      CALL KPWRTE (NTPCH)
  230 FORMAT ('UNIT ',6I3)
C
  240 IF (NCD(NS) .LT. NCDDM) GO TO 250
      IERR=59024002
      GO TO 999
C
  250 NCDA(NS)=NCD(NS)+1
      ISKP(15)=-1
      ISKP(14)=-3
C
      IF (NTYPS .EQ. 1) GO TO 380
      IF (NTYPS .LT. 4) GO TO 270
C
      ICTMP=IN4BFR(1)
  260 IF (ICTMP .GT. IN4BFR(2)) GO TO 690
      NC=1
      ICDS(1)=ICTMP
      GO TO 410
C                            Durchlaufe Parameterliste.
C                            Zaehle Atome (fuer THEO).
  270 J=ISKP(53)-1
      ICTMP=0
      GO TO 310
C
  280 J=J+1
      AIN(1)=AT(7,J,NS)
C      CALL CNVTUP (IAIN,1,4)
      DO 290 I=1,NANZ
      IF (LCOMPS(AIN,1,2, INBFR(1,I),1)) 290,300,290
  290 CONTINUE
      GO TO 310
  300 ICTMP=ICTMP+1
  310 IF (J .LT. NAT(NS)) GO TO 280
      WRITE (WRLINE,320) ICTMP
      CALL KPWRTE (NTPCH)
  320 FORMAT ('ATOM ',I3)
C
      ICTMP=ISKP(53)
  330 IF (ICTMP .GT. NAT(NS)) GO TO 340
      NC=1
      ICDS(1)=ICTMP
      GO TO 410
C                            Nachspann (THEO).
  340 CONTINUE
C     WRITE (WRLINE,350)
C     CALL KPWRTE (NTPCH)
C    + (PARBFR(I),I=8,10),(IARBFR(I),I=11,12),PARBFR(13)
C 350 FORMAT ('CALC ',3F7.2,2I3,F5.1)
C     WRITE (WRLINE,360) IARBFR(14),(PARBFR(I),I=15,16)
C     CALL KPWRTE (NTPCH)
C 360 FORMAT ('PROF ',I2,2F8.3)
      WRITE (WRLINE,370)
      CALL KPWRTE (NTPCH)
  370 FORMAT ('END')
      GO TO 690
C
  380 WRITE (WRLINE,390)
      CALL KPWRTE (NTPCH)
  390 FORMAT ('FVAR    1.0')
C                            Durchlaufe Codeliste/Parameterliste.
      ICTMP=ISVBF(1)
  400 NC=1
      ICDS(1)=ICD(ICTMP,NS)
  410 NTRY=24
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 690
C
C                            Ist dieser Code gemeint?
      AIN(1)=AT(7,IANR,NS)
      IANRSV=IANR
C      CALL CNVTUP (IAIN,1,4)
      IF (NTYPS .GE. 4) GO TO 430
      DO 420 I=1,NANZ
      IF (LCOMPS(AIN,1,2, INBFR(1,I),1)) 420,430,420
  420 CONTINUE
      GO TO 670
C                            Er ist gemeint.  Bestimme Lagebesetzung.
  430 IZ1=IANR
      IZ2=IANR
C                            Fuehre ATB aus.
      NTYP=1
      X(1,7)=CONST(21)
      X(2,7)=CONST(21)
      X(3,7)=CONST(21)
      NCD(NS)=NCDA(NS)-1
      CALL ZVADD
      IF (IERR) 690,440,690
  440 J=NCD(NS)-NCDA(NS)+1
      IF (NTYPS .NE. 5) GO TO 520
C
C                           Nur die Zahl
      J=NSYM(NS)/J
      TEMP=AT(5,IANRSV,NS)
      IF (MSFLAG .NE. 0) GO TO 460
      IF (IN4BFR(3) .EQ. 0) GO TO 460
      WRITE (WRLINE,450) IANRSV,TEMP,AT(6,IANRSV,NS),
     1                   (AT(K,IANRSV,NS),K=1,3),J
      CALL KPWRTE (NTOUT)
  450 FORMAT ('(',I4,') ',2A4,3F10.6,I4)
  460 CALL CNVTUP (TEMP,1,4)
      IF (JPOI .EQ. 2) GO TO 480
      DO 470 K=3,JPOI,2
      IF (IAIN(K) .EQ. ITEMP) GO TO 490
  470 CONTINUE
      IF (JPOI .GE. 72) GO TO 500
  480 JPOI=JPOI+2
      K=JPOI-1
      IAIN(K)=ITEMP
  490 IAIN(K+1)=IAIN(K+1)+J
      GO TO 670
C
  500 WRITE (WRLINE,510)
      CALL KPWRTE (NTDISP)
CYENG1
  510 FORMAT ('ZVGNSX0438 - Liste fuer Symbole voll.')
CYENG2
CYENGY  510 FORMAT ('ZVGNSX0438 - List for symbols full.')
      GO TO 670
C
  520 TEMP=1./FLOAT(J)
      IF (NTYPS .EQ. 1) GO TO 530
      IF (NTYPS .EQ. 4) GO TO 530
      IF (NTYPS .NE. 6) GO TO 540
  530 TEMP=TEMP+10.
C
C                            Generiere Atomkarte.
  540 IAIN(1)=ISKP(24)
      IAIN(2)=ISKP(24)
      AIN(3)=AT(5,IANRSV,NS)
      AIN(4)=AT(6,IANRSV,NS)
      IF (NTYPS .EQ. 1) ICDS(1)=ICD(ICTMP,NS)
      NC=1
      NTRY=24
      CALL ZVDEK
      NTYP=5
      IF (NTYPS .EQ. 2) THEN
        AIN(5)=0.
      ELSE
        CALL ZVTFHN
      ENDIF
      IF (NTYPS .EQ. 4) GO TO 550
      IF (NTYPS .NE. 6) GO TO 580
  550 ISFAC=1
      DO 570 J=1,8
      IF (LCOMPS(AIN(3),J,1, ISKP(24),1)) 560,570,560
  560 CALL COPYCH (AIN(3),J,1, AIN,ISFAC)
      ISFAC=ISFAC+1
  570 CONTINUE
      ISFAC=1
      GO TO 610
C
  580 CALL COPYCH (AT(5,IANRSV,NS),1,2, AIN,1)
      ISFAC=INBFR(2,I)
      IPOI=1
      IF (LCOMPS(AIN,2,1, ISKP(24),1)) 590,600,590
  590 IPOI=2
  600 INRATS(I)=INRATS(I)+1
      CALL KPNTOS (INRATS(I), AIN,IPOI,0)
      CALL CNVTUP (IAIN,1,8)
  610 IF (NTYPS .NE. 6) GO TO 630
      CALL CNVTUP (AIN,1,8)
      WRITE (WRLINE,620) IAIN(1),IAIN(2),(X(J,1),J=1,3),PARBFR(7)
      CALL KPWRTE (NTPCH)
  620 FORMAT (2A4,2X,4F10.5)
      GO TO 670
C
  630 IF (INPOI .GT. 0) THEN
        AIN(72)=AT(7,IANR,NS)
C        CALL CNVTUP (AIN(72),1,4)
        DO  J=1,INPOI
          IF (IAIN(72) .EQ. IATNAM(1,J)) THEN
            ISFAC=J
            GO TO 635
          ENDIF
        ENDDO
      ENDIF
  635 IF (IAIN(5) .EQ. 0) GO TO 650
      WRITE (WRLINE,'(2A4,I1,4F10.5,'' ='')')
     1 IAIN(1),IAIN(2),ISFAC,(X(J,1),J=1,3),TEMP
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(''    '',6F10.6)') (AIN(J),J=6,11)
      CALL KPWRTE (NTPCH)
      GO TO 670
C
  650 WRITE (WRLINE,660) IAIN(1),IAIN(2),ISFAC,(X(J,1),J=1,3),
     + TEMP,PARBFR(7)
      CALL KPWRTE (NTPCH)
  660 FORMAT (2A4,I1,4F10.5,F10.5)
C
  670 ICTMP=ICTMP+1
      IF (KEYIN(0) .NE. ISKP(20)) GO TO 680
      IERR=-1
      GO TO 690
C
  680 IF (NTYPS .EQ. 2) GO TO 330
      IF (NTYPS .GE. 4) GO TO 260
      IF (ICTMP-ISVBF(2)) 400,400,690
C
C                            Restore Variablen.
  690 NCDA(NS)=ISVBF(1)
      NCD(NS)=ISVBF(2)
      ISKP(15)=ISVBF(3)
      ISKP(14)=ISVBF(4)
C                            Optional END-Karte
      IF (NTYPSS .EQ. 8) THEN
        NTYP=19
        CALL ZVZ
        WRITE (WRLINE,'(A)') 'END'
        CALL KPWRTE (NTPCH)
        NTYP=NTPCH+100
        CALL ZVEAEH
      ENDIF
      IF (MSFLAG .NE. 0 .AND. NTYPS .NE. 5) GO TO 750
C
C                            Gib ggf. Summenformel aus
C
      IF (NTYPS .NE. 5) GO TO 999
      IF (MSFLAG .NE. 0) GO TO 710
CYENG1
      WRITE (WRLINE,'(A)') 'Summenformel:'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') ' Sum formula:'
C
C                            Ermittle das kleinste gemeinschaftliche
C                            vielfache nach dem Euklidischen algor.
      ITEMP=IAIN(4)
      DO  K=6,JPOI,2
        J=ITEMP
        I=IAIN(K)
        IF (I .GE. J) GO TO 705
  700   J=I
        I=ITEMP
        ITEMP=J
  705   I=MOD(I,J)
        IF (I .NE. 0) GO TO 700
      ENDDO
      K=15
      J=3
  706 IF (K .LT. 110) THEN
        CALL COPYCH (IAIN(J),1,4,IRLINE,K)
        I=K
  707   K=K+1
        IF (WRLINE(K:K) .NE. ' ') GO TO 707
        IF (K-I .EQ. 2) CALL CNVTLO (IRLINE,K-1,1)
        I=IAIN(J+1)/ITEMP
        IF (I .GT. 1) THEN
          WRLINE(K:K)='('
          CALL KPNTOS(I,IRLINE,K,0)
          K=K+1
          WRLINE(K:K)=')'
          K=K+1
        ENDIF
        K=K+1
        J=J+2
        IF (J .LE. JPOI) GO TO 706
        WRLINE(K:K+4)='  Z ='
        K=K+5
        CALL KPNTOS (ITEMP,IRLINE,K,0)
      ELSE
        WRLINE(K:K+4)=' etc.'
      ENDIF
      CALL KPWRTE (NTOUT)
      IF (ISKP(58) .LE. 0) GO TO 999
      DO  I=3,JPOI,2
        J=IAIN(I+1)/ITEMP
        WRITE (WRLINE,'(A4,I6,A,I6,A,I3)')
     +  IAIN(I),IAIN(I+1),' =',ITEMP,' *',J
        CALL KPWRTE (NTOUT)
      ENDDO
      GO TO 999
C
  710 DO  I=3,JPOI,2
        WRITE (WRLINE,'(A4)') IAIN(I)
        CALL KPWRTE (NTXR2)
        WRITE (WRLINE,'(I6)') IAIN(I+1)
        CALL KPWRTE (NTXR2)
      ENDDO
      WRITE (WRLINE,'(A)') ' '
      CALL KPWRTE (NTXR2)
      NTYP=NTXR2+100
      CALL ZVEAEH
C                            CDEDIT-file
      DO  I=1,3
        IAIN(I)=FILNAM(I)
      ENDDO
      NTYP=NTXR2
      ISKP(14)=1
      CALL ZVEAEH  ! OPEN CDEDIT.DAT
      I=IN4BFR(2)-IN4BFR(1)+1
      WRITE (WRLINE,'(A)') 'T'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'Y'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'N'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'T'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'KPATMS.DAT'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A,I5)') '1 ',I
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'Y'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'U'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') '1'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'F'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') ' '
      CALL KPWRTE (NTXR2)
      NTYP=NTXR2+100
      CALL ZVEAEH
C                            File mit Atomen
      NTPCHS=NTPCH
      NTPCH=NTXR2
      DO  I=1,3
        IAIN(I)=FILNAM(I+3)
      ENDDO
      NTYP=NTXR2
      ISKP(14)=1
      CALL ZVEAEH  ! OPEN KPATMS.DAT
      NTYPS=6
      GO TO 160
C
  750 NTYP=NTPCH+100
      CALL ZVEAEH
      NTPCH=NTPCHS
C                            File fuer MISSYM
C
      DO  I=1,3
        IAIN(I)=FILNAM(I+6)
      ENDDO
      NTYP=NTXR2
      ISKP(14)=1
      CALL ZVEAEH  ! OPEN MISSYM.DAT
      WRITE (WRLINE,'(A)') 'L'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'Y'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'Y'
      CALL KPWRTE (NTXR2)
      NTYP=NTXR2+100
      CALL ZVEAEH
      ISKP(14)=ISVBF(4)
      IF (NSYM(NS) .EQ. 1) GO TO 999
CYENG1
      WRITE (WRLINE,'(A)') ' W a r n u n g !  Die in der Datei CDFILE.DA
     1T eingetragene Raumgruppe'
CYENG2
CYENGY      WRITE (WRLINE,'(A)')  'W a r n i n g !  The space group P1 written
CYENGY     + to file CDFILE.DAT does'
      CALL KPWRTE (NTDISP)
CYENG1
      WRITE (WRLINE,'(A)') ' P 1 stimmt nicht mit den in KPLOT verwendet
     1en Symmetrien ueberein.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'not agree with symmetries used in KPLOT.'
      CALL KPWRTE (NTDISP)
CYENG1
      WRITE (WRLINE,'(A)') ' Raumgruppe (und Gitterkonstanten) muessen a
     1ngepasst werden!'
CYENG2
CYENGY      WRITE (WRLINE,'(A)')  'Space group (and cell constants) have to be
CYENGY     + corrected!'
      CALL KPWRTE (NTDISP)
      GO TO 999
C                            Input fuer MISSYM
  770 ISVBF(4)=ISKP(14)
      ISKP(14)=1
      DO  I=1,3
        IAIN(I)=FILNAM(I+9)
      ENDDO
      NTYP=NTXR2
      CALL ZVEAEH  ! OPEN CDFILE
      WRITE (WRLINE,'(A)') 'T'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'TEMP'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,790) (TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTXR2)
  790 FORMAT (18A4)
      WRITE (WRLINE,'(A)') 'P 1'
      CALL KPWRTE (NTXR2)
      DO 820 I=1,6
      WRITE (WRLINE,'(F10.6)') ZELLE(I,NS)
      CALL KPWRTE (NTXR2)
  820 CONTINUE
      WRITE (WRLINE,'(A)') '0.2 0.2 0.2'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') '24'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') '40 50'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') 'MO'
      CALL KPWRTE (NTXR2)
      WRITE (WRLINE,'(A)') '1'
      CALL KPWRTE (NTXR2)
      MSFLAG=1
      NTYPS=5
      GO TO 10
C                            Parameter fuer THEO.
C
  840 CALL FLES (IARBFR,ISKP(31),13HAA4A4F2IFI2FE,
     + 35Hw1,w2,Symm,U(iso),Calc(6),Prof(3)?$)
      GO TO 999
C                            SXLJ - SHELXL - job produzieren
C
  850 WRITE (WRLINE,'(A,18A4)') 'TITL ',(TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,F8.5,3F8.4,3F8.3)')
     + 'CELL',CONST(58),(ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
      if (iskp(96) .ne. 0) then
        ntyp=22
        call zvz
        ns=3-ns
        iskp(14)=1
        ntyp=2
        call zvz
        do  i=1,6
          const(i+51)=abs(zelle(i,ns)-zelle(i,3-ns))
        enddo
        ns=3-ns
      endif
      WRITE (WRLINE,'(A,F8.2,3F8.4,3F8.3)') 'ZERR',(CONST(I),I=51,57)
      CALL KPWRTE (NTPCH)
      IF (ISKP(71) .EQ. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVGNSX0471 - WARNUNG! Symmetrien nur kopiert.'
CYENG2
CYENGY     +  'ZVGNSX0471 - WARNING! Symmetries copied only.'
        CALL KPWRTE (NTDISP)
        WRITE (WRLINE,'(A)') 'LATT UNKNOWN'
        CALL KPWRTE (NTPCH)
        ISKP(72)=NSYM(NS)
      ELSE
        IF (ISKP(70) .NE. 0) ISKP(71)=ABS(ISKP(71))
        WRITE (WRLINE,'(A,I3)') 'LATT',ISKP(71)
        CALL KPWRTE (NTPCH)
      ENDIF
      I=NSYM(NS)
      NSYM(NS)=ISKP(72)
      IF (ISKP(70) .GT. 0) NSYM(NS)=ISKP(70)
      ISKP(14)=-1
      CALL ZVSYOU
      NSYM(NS)=I
      ISKP(14)=ISVBF(4)
C                            Generiere einen zellinhalt.
      IAIN(1)=IN4BFR(1)
      IAIN(2)=IN4BFR(2)
      NTYP=3
      CALL ZVZLIN
      IF (IERR .NE. 0) GO TO 999
C
C                            Zaehle die atome in der Zelle
      I=0
      DO  J=1,NCD(NS)
        K=ICD(J,NS)/200000
        AIN(72)=AT(7,K,NS)
C        CALL CNVTUP (AIN(72),1,4)
        DO  K=1,I
          IF (IAIN(72) .EQ. IATNAM(1,K)) THEN
            IATNAM(2,K)=IATNAM(2,K)+1
            GO TO 870
          ENDIF
        ENDDO
        IF (I .LT. 18) THEN
          I=I+1
          IATNAM(1,I)=IAIN(72)
          IATNAM(2,I)=1
        ELSE
CYENG1
          WRITE (WRLINE,'(A)') 'ZVGNSX0496 - Mehr als 18 Atomsorten.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'ZVGNSX0496 - More than 18 atom types.'
          CALL KPWRTE (NTDISP)
          GO TO 999
        ENDIF
  870   CONTINUE
      ENDDO
      WRITE (WRLINE,'(A,18A4)') 'SFAC   ',(IATNAM(1,J),J=1,I)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,18I4)') 'UNIT ',(IATNAM(2,J),J=1,I)
      CALL KPWRTE (NTPCH)
      NTYPS=4
      INPOI=I
      GO TO 150
C
  999 RETURN
      END
