CKPGNZL   53             -------------------
                          SUBROUTINE ZVGNZL
C  CY-ENG-               -------------------
C
C  Dieses Programm erzeugt die Codes fuer eine Zellbegrenzung, ferner
C  das (die) entsprechende(n) VB-Kommando(s) oder ein VD-Kommando.
C
C                geschrieben: 301455 MAR 84 (Hundt)
C                geaendert:   261537 MAR 99 (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),INLCDS(8),IT1(3),IPTR(21),IFLAG1,IFLAG2
      INTEGER *4 I,ITEMP1,ITEMP2,NCDSV,I1,I2,I3,I1FLG,I2FLG,J
      INTEGER *4 ILF1,ILF2
      REAL    *4 ZTOL,TEMP,TEMP2
C
      EQUIVALENCE (AIN(1),IAIN(1))
C
      DATA INLCDS/111001,131001,113001,111201,
     + 133201,113201,131201,133001/
      DATA ZTOL/0.015/
      DATA IPTR/0,1,2,8,3,1,4,7,5,6,4,0,2,7,0,8,5,0,3,6,0/
C
      IAIN(1)=2
      IAIN(2)=2
      IF (ISKP(14) .EQ. 0) THEN
      CALL FLES (AIN,ISKP(31),3H2IE,7Hn1,n2?$)
      ENDIF
C
C                            Erzeuge Codes, wenn moeglich.
      IFLAG1=IAIN(1)
      IAIN(1)=IABS(IAIN(1))
      IFLAG2=IAIN(2)
      IAIN(2)=IABS(IAIN(2))
C                            Loesche ggf. vorhandene Codes
      NTRY=32
      J=0
      DO  IC=1,NCD(NS)
        CALL ZVDEK
        IF (IANR .NE. IAIN(1) .AND. IANR .NE. IAIN(2)) THEN
          J=J+1
          ICD(J,NS)=ICD(IC,NS)
        ENDIF
      ENDDO
      NCD(NS)=J
      K8(NS)=0
      K9(NS)=0
      IF (IFLAG1 .LT. 0) GO TO 65
C
      DO  I=1,2
        IF (IAIN(I) .LE. 0 .OR. IAIN(I) .GT. NAT(NS)) THEN
          IERR=53 0038 04
          GO TO 999
        ENDIF
      ENDDO
C
      IF (NCD(NS)+8 .GT. NCDDM) THEN
         IERR=53 0044 02
         GO TO 999
      ENDIF
C
      ITEMP1=IAIN(1)*200000
      ICD(NCD(NS)+1,NS)=ITEMP1+INLCDS(1)
      ITEMP2=IAIN(2)*200000
      ICD(NCD(NS)+5,NS)=ITEMP2+INLCDS(5)
      DO  I=2,4
        ICD(NCD(NS)+I,NS)=ITEMP2+INLCDS(I)
        ICD(NCD(NS)+I+4,NS)=ITEMP1+INLCDS(I+4)
      ENDDO
      NCDSV=NCD(NS)
      NCD(NS)=NCD(NS)+8
C                            Teste die Art, wie Plotbefehle erzeugt w.
C
   65 IF (IFLAG2 .LT. 0) GO TO 280

C                            I1,I2,I3 Pointer auf Zelle in
C                            aufsteigender Reihenfolge
      I1=1
      IF (ZELLE(2,NS) .LT. ZELLE(1,NS)) I1=2
      IF (ZELLE(3,NS) .LT. ZELLE(I1,NS)) I1=3
      I2=ID2(I1)
      I3=ID2(I2)
      IF (ZELLE(I3,NS) .LT. ZELLE(I2,NS)) THEN
        I2=I3
        I3=ID2(I1)
      ENDIF
C                            Lauf ueber die Codes zur Feststellung
C                            unerwuenchter Bindungen.
      I1FLG=0
      I2FLG=0
      ILF1=0
      NTRY=42
C                            Erhoehe Nr 1
   80 ILF1=ILF1+1
      NC=1
      IC=NCDSV+ILF1
      CALL ZVDEK
      DO  I=1,3
        IT1(I)=IT(I)
        X2(I)=X1(I)
      ENDDO
C                            Nr 2 = Nr 1
      ILF2=ILF1
C                            Erhoehe Nr 2
  100 ILF2=ILF2+1
      NC=2
      IC=NCDSV+ILF2
      CALL ZVDEK
C                            Stelle typ der Bindung fest und berechne
C                            deren Laenge.
      J=0
      TEMP=0.
      DO  I=1,3
        IF (IT1(I) .NE. IT(I)) J=J+1
        TEMP2=X2(I)-X1(I)
        TEMP=TEMP+TEMP2*TEMP2
      ENDDO
      TEMP2=SQRT(TEMP)
C                            Raumdiagonale?
      IF (J .EQ. 3) GO TO 120
C                            Flaechendiagonale?
      IF (J .NE. 2) GO TO 150
C                            Sind beide Atomnummern gleich?
C
      IF (IAIN(1) .NE. IAIN(2)) GO TO 150
C
  120 DO  I=1,3
        IF (ABS(ZELLE(I,NS)-TEMP2) .LT. ZTOL) GO TO 250
      ENDDO
      IF (TEMP2 .LT. ZELLE(I2,NS)) GO TO 140
      IF (TEMP2 .GT. ZELLE(I3,NS)) GO TO 150
      I2FLG=1
      GO TO 150
  140 IF (TEMP2 .LT. ZELLE(I1,NS)) GO TO 150
      I1FLG=1
C                            Ist Nr 2 erhoehbar?
C
  150 IF (ILF2 .LT. 8) GO TO 100
C
C                            Ist Nr 1 erhoehbar?
C
      IF (ILF1 .LT. 4) GO TO 80
C
C                            Durch.  Berechne die Anzahl der
C                            zu erzeugenden VB-Kommandos.
      I=13
      IF (I1FLG .NE. 0) I=I+13
      IF (I2FLG .NE. 0) I=I+13
C
C                            Teste, ob noch so viel Platz da ist.
C
      IF (IPKP(NS)+I .GT. IPKDM) THEN
        IERR=53 0139 11
        NCD(NS)=NCDSV
        GO TO 999
      ENDIF
C                            Erzeuge die VB-Kommandos.
      IAIN(10)=13
      IAIN(11)=2
      IAIN(12)=IAIN(1)
      IAIN(13)=IAIN(1)
      IAIN(14)=IAIN(2)
      IAIN(15)=IAIN(2)
      AIN(16)=ZELLE(I1,NS)-ZTOL
      AIN(17)=ZELLE(I1,NS)+ZTOL
      AIN(18)=.01
      IAIN(19)=11
      IAIN(20)=0
      IAIN(21)=0
      IAIN(22)=0
C
      IF (I1FLG .NE. 0) THEN
        DO  I=10,22
          IPKP(NS)=IPKP(NS)+1
          IPK(IPKP(NS),NS)=IAIN(I)
        ENDDO
        AIN(16)=ZELLE(I2,NS)-ZTOL
      ENDIF
C
      AIN(17)=ZELLE(I2,NS)+ZTOL
      IF (I2FLG .NE. 0) THEN
        DO  I=10,22
          IPKP(NS)=IPKP(NS)+1
          IPK(IPKP(NS),NS)=IAIN(I)
        ENDDO
        AIN(16)=ZELLE(I3,NS)-ZTOL
      ENDIF
C
      AIN(17)=ZELLE(I3,NS)+ZTOL
      DO  I=10,22
        IPKP(NS)=IPKP(NS)+1
        IPK(IPKP(NS),NS)=IAIN(I)
      ENDDO
      GO TO 999
C                            Keine Verbindung moeglich unter diesen
C                            Bedingungen.
  250 IF (IFLAG2 .LT. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVGNZL0260 - Eine Diagonale entspricht einer Gitterkonstanten.'
CYENG2
CYENGY     +'ZVGNZL0260 - One diagonal is equal to one cell constant.'
        CALL KPWRTE (NTDISP)
        NCD(NS)=NCDSV
        GO TO 999
      ENDIF
C                       Erzeuge Alternativplotbefehle
C
  280 IF (IPKP(NS)+28 .GT. IPKDM) THEN
        IERR=53 0196 11
        GO TO 999
      ENDIF
C
      IPK(IPKP(NS)+1,NS)=28
      IPK(IPKP(NS)+2,NS)=12
      AIN(3)=0.01
      IPK(IPKP(NS)+3,NS)=IAIN(3)
      IPK(IPKP(NS)+4,NS)=11
      IPK(IPKP(NS)+5,NS)=0
      IPK(IPKP(NS)+6,NS)=0
      IPK(IPKP(NS)+7,NS)=0
      IPKP(NS)=IPKP(NS)+7
      DO  I=1,21
        J=IPTR(I)
        IF (J .NE. 0) J=IAIN(1)*200000+INLCDS(J)
        IPKP(NS)=IPKP(NS)+1
        IPK(IPKP(NS),NS)=J
      ENDDO
C
  999 RETURN
      END
