C         69             -------------------
                          SUBROUTINE ZVSHKL
C  CY-ENG-               -------------------
C
C                  Geschrieben: 211031 FEB 1983  (Hundt)
C                  Geaendert:   201123 APR 2004  (Hundt)
C
C    Das Programm erzeugt einen Datensatz fuer das Programm SCHAKAL
C    und das Programm SYMMOL.
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IDSYMB(3),IAIN(72),IOPT,I,INKEL,J
      REAL    *4 CDS(7),URSAV(3),BLANK,TEMP,A99
      EQUIVALENCE (CDS(1),ICDS(1)),(AIN(1),IAIN(1))
C
      DATA IDSYMB/1HX,1HY,1HZ/,BLANK/4H    /,A99/4H99  /
C
      IF (NTYP .GT. 1) GO TO 180
      IOPT=0
      CALL FLES (IOPT,ISKP(31),2HIE,19H0/1 Schakal 76/88?$)
      NTYP=NTPCH
      CALL ZVEAEH
C                            Vorspann und Zelle
C
      IF (IOPT .EQ. 0) GO TO 40
      WRITE (WRLINE,10) (TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTPCH)
   10 FORMAT ('TITLE ',18A4)
C
      WRITE (WRLINE,20) (ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
   20 FORMAT ('CELL ',3F8.4,3F9.4)
C
      WRITE (WRLINE,30)
      CALL KPWRTE (NTPCH)
   30 FORMAT ('ASSUM BLANK')
      GO TO 60
C
   40 WRITE (WRLINE,'(A)') 'L 3'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(3F8.4,3F9.4)') (ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
C                            Atom-Karten
   60 IC=NCDA(NS)
      NTRY=40
      NC=1
      GO TO 110
C
   70 CALL ZVDEK
      DO 71 I=1,3
   71 X2(I)=X(I,1)-PTRIKL(I)
      IF (IOPT .EQ. 0) GO TO 80
      TEMP=AT(6,IANR,NS)
      IF (TEMP .EQ. BLANK) TEMP=A99
      WRITE (WRLINE,90) AT(5,IANR,NS),TEMP,X2
      CALL KPWRTE (NTPCH)
      GO TO 100
C
   80 WRITE (WRLINE,90) AT(5,IANR,NS),BLANK,X2
      CALL KPWRTE (NTPCH)
   90 FORMAT ('ATOM   ',A4,A2,3F9.5)
  100 IC=IC+1
  110 IF (IC .LE. NCD(NS)) GO TO 70
      IF (IOPT .EQ. 0) GO TO 130
      WRITE (WRLINE,120)
      CALL KPWRTE (NTPCH)
  120 FORMAT ('END')
      GO TO 999
C                            END- und weitere Karten
  130 TEMP=O9
      WRITE (WRLINE,'(A)') 'END'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'K 0.'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'U 0'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,F6.2)') 'M',TEMP
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'F 0.'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'N 2. 1'
      CALL KPWRTE (NTPCH)
C
C                            Orientierung
      CALL ZVORTN
      DO 160 I=1,3
      TEMP=-CDS(I)
      WRITE (WRLINE,150) IDSYMB(I),TEMP
      CALL KPWRTE (NTPCH)
  150 FORMAT (A1,F8.2)
  160 CONTINUE
C
      INKEL=-3
      AIN(1)=CONST(8)*.5
      AIN(2)=CONST(9)*.5
      AIN(3)=CONST(8)*1.5
      AIN(4)=AIN(2)
  170 WRITE (WRLINE,'(A,I3,A)') 'Y',INKEL,'.'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,2F7.2)') 'G 0.   ',AIN(1),AIN(2)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'Y 6.'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,2F7.2)') 'G 0.   ',AIN(3),AIN(4)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'E'
      CALL KPWRTE (NTPCH)
      IF (INKEL .EQ. -6) GO TO 999
      WRITE (WRLINE,'(A)') 'U 1.'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'A 30.'
      CALL KPWRTE (NTPCH)
      INKEL=-6
      GO TO 170
C                            SYMMOL (SYML)
  180 DO  I=1,3
        URSAV(I)=UR(I,NS)
      ENDDO
C                            Hole eingabe
      IAIN(1)=1
      IAIN(2)=1
      AIN(3)=.25
      AIN(4)=.25
      CALL FLES (AIN,ISKP(31),5H2I2FE,24HINDWGH,INDTOL,DCM,DCME?$)
      IF (NCD(NS) .LT. NCDA(NS)) THEN
        IERR=69 0130 12
        GO TO 999
      ENDIF
C                            Setze den ursprung auf den ungewichteten
C                            schwerpunkt.
      DO  I=1,3
        X(I,2)=0.
      ENDDO
      NC=1
      NTRY=40
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          X(I,2)=X(I,2)+X(I,1)
        ENDDO
      ENDDO
      TEMP=FLOAT(NCD(NS)-NCDA(NS)+1)
      DO  I=1,3
        UR(I,NS)=X(I,2)/TEMP
      ENDDO
C                            Produziere file
      NTYP=NTPCH
      CALL ZVEAEH
      WRITE (WRLINE,'(A,18A4)') '# ',(TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') ' 1 1 1 90 90 90'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(2I4,2F10.5)') (IAIN(I),I=1,2),(AIN(I),I=3,4)
      CALL KPWRTE (NTPCH)
      NTRY=44
      NC=1
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        CALL KPCVNM (AT(5,IANR,NS),1,AIN(11),J)
        WRITE (WRLINE,'(A4,A2,A,3F9.5)')
     +  IAIN(11),IAIN(12),' 1',X2
        CALL KPWRTE (NTPCH)
      ENDDO
C                            Restore UR
      DO  I=1,3
        UR(I,NS)=URSAV(I)
      ENDDO
C
  999 RETURN
      END
