C         22             -------------------
                          SUBROUTINE ZVSYOU
C  CY-ENG-               -------------------
C
C         Das Programm codiert Symmetrien in symbolische Form.
C
C                         Geschrieben: Hundt
C                   Geaendert: 291733 NOV 2006  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
C      INTEGER *4 ITPOI(12),ITTAB(10)
      INTEGER *4 ITPOI(24),ITTAB(22)
      INTEGER *4 IZTAB(4),IAIN(72)
      INTEGER *4 INBFR(3),NTYPSV,I,I0,I1,I2,IAPO,IOPOI,IRC,IXTAB
      INTEGER *4 J,J0,J1,J2,KEYIN,M
      REAL    *4 DRSV(3,3),URSV(3),TEMP,TOL
C
      EQUIVALENCE (AIN(1),IAIN(1))
C
C      DATA ITPOI/1,5,8,11,14,18,21,25,28,31,34,39/
      DATA ITPOI /1,5,9,12,15,19,22,26,29,32,36,41,44,
     1 49,53,56,59,64,67,72,75,78,83,88/
C      DATA ITTAB/4H1/12,4H1/61,4H/41/,4H35/1,4H21/2,4H7/12,4H2/33,
C     1 4H/45/,4H611/,4H12  /
      DATA ITTAB/4H1/24,4H1/12,4H1/81,4H/65/,4H241/,
     1 4H47/2,4H41/3,4H3/85,4H/121,4H1/24,4H1/21,4H3/24,4H7/12,4H5/82,
     2 4H/317,4H/243,4H/419,4H/245,4H/67/,4H811/,4H1223,4H/24 /
      DATA IZTAB/4H0123,4H4567,4H89+-,4H,   /,IXTAB/4HXYZ /
      DATA TOL/0.0083/,IAPO/4H'   /
C
      DO  I=1,3
        DO  J=1,3
          DRSV(I,J)=DREH(I,J)
        ENDDO
        URSV(I)=UR(I,NS)
      ENDDO
      INBFR(1)=1
      INBFR(2)=NSYM(NS)
      INBFR(3)=0
      NTYPSV=NTYP
      IF (NTYPSV .EQ. 2) THEN
        INBFR(1)=IAIN(1)
        INBFR(2)=IAIN(1)
        GO TO 15
      ENDIF
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (INBFR,ISKP(31),3H3IE,13Hvon,bis,opt?$)
CYENG2
CYENGY        CALL FLES (INBFR,ISKP(31),3H3IE,13Hfrom,to,opt?$)
        IF (ISKP(31) .EQ. 0 .AND. NHMSNR(3,NS) .GT. 0) INBFR(1)=0
        IF (ISKP(31) .EQ. 1) INBFR(2)=INBFR(1)
        IF (INBFR(2) .GT. NSYM(NS)) INBFR(2)=NSYM(NS)
        IF (NHMSNR(3,NS) .LE. 0) THEN
CYENG1
          WRITE (WRLINE,'(A)') ' Symmetrien:'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') ' Symmetries:'
        ELSE
          WRITE (WRLINE,10) NHMSNR(3,NS),NHMSNR(1,NS),NHMSNR(2,NS)
CYENG1
   10     FORMAT ('Symmetrien (Rg Nr',I6,2X,2A4,'):')
CYENG2
CYENGY   10     FORMAT (' Symmetries (Spg. No.',I6,2X,2A4,'):')
        ENDIF
        CALL KPWRTE (NTOUT)
      ENDIF
      IF (INBFR(1) .LE. 0) GO TO 999
      IF ((INBFR(2) .GT. NSYM(NS)) .OR. (INBFR(1) .GT. INBFR(2))) THEN
        IF (ISKP(14) .NE. 0) GO TO 999
        IERR=22 0059 16
        GO TO 999
      ENDIF
   15 DO 350 M=INBFR(1),INBFR(2)
C
C                            Init
      IOPOI=0
      DO 20 I=1,10
   20 IAIN(I)=ISKP(24)
C                            Schleife durch Segmente
      DO 250 I0=1,9,4
      I1=0
C      TEMP=SYM(I0,M,NS)*12.
      TEMP=SYM(I0,M,NS)*24.
      I2=TEMP+TOL
      IF (ABS(FLOAT(I2)-TEMP)-TOL) 40,30,30
C
C                            Translation negativ oder >=1
   30 IRC=1
      GO TO 330
   40 IF (I2) 30,80,50
C   50 IF (I2-12) 60,30,30
   50 IF (I2-24) 60,30,30
   60 J1=ITPOI(I2)
      J2=ITPOI(I2+1)-1
      DO 70 I=J1,J2
      IOPOI=IOPOI+1
      CALL COPYCH (ITTAB,I,1, AIN,IOPOI)
   70 CONTINUE
      I1=1
C
C   80 SYM(I0,M,NS)=FLOAT(I2)/12.
   80 SYM(I0,M,NS)=FLOAT(I2)/24.
      DO 210 J0=1,3
      TEMP=SYM(I0+J0,M,NS)
      I2=ABS(TEMP)+TOL
      IF (TEMP) 90,210,100
   90 I2=-I2
  100 IF (ABS(FLOAT(I2)-TEMP)-TOL) 120,110,110
C
C                            Nicht ganzzahlig
  110 IRC=3
      GO TO 330
  120 SYM(I0+J0,M,NS)=I2
      IF (I2) 150,210,130
  130 IF (I1) 140,160,140
  140 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,11,1, AIN,IOPOI)
      GO TO 160
  150 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,12,1, AIN,IOPOI)
      I2=-I2
  160 I1=1
      IF (I2-9) 180,180,170
C                            Koeffizient > 9
  170 IRC=2
      GO TO 330
  180 IF (I2-1) 170,200,190
  190 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,I2+1,1, AIN,IOPOI)
  200 IOPOI=IOPOI+1
      CALL COPYCH (IXTAB,J0,1, AIN,IOPOI)
  210 CONTINUE
      IF (I1) 230,220,230
  220 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,1,1, AIN,IOPOI)
  230 IF (I0-5) 240,240,250
  240 IOPOI=IOPOI+2
      CALL COPYCH (IZTAB,13,2, AIN,IOPOI-1)
  250 CONTINUE
C
      IF (ISKP(14)) 260,300,280
  260 IF (M .NE. 1) THEN
        WRITE (WRLINE,270) (AIN(I),I=1,10)
  270   FORMAT ('SYMM ',10A4)
        CALL KPWRTE (NTPCH)
      ENDIF
      GO TO 320
C
  280 CALL COPYCH (IAPO,1,1, AIN,IOPOI+1)
      WRITE (WRLINE,290) (AIN(I),I=1,10)
      CALL KPWRTE (NTBILF)
  290 FORMAT ('SY ''',10A4)
      GO TO 320
C
  300 IOPOI=(IOPOI+3)/4
      WRITE (WRLINE,310) M,(AIN(I),I=1,10)
  310 FORMAT (I3,')  ',10A4)
      CALL KPWRTE (NTOUT)
      IF (INBFR(3) .NE. 0) THEN
        IAIN(1)=M
        CALL ZVSYAN
      ENDIF
  320 IF (KEYIN(0) .NE. ISKP(20)) GO TO 350
      IERR=-1
      GO TO 999
  330 WRITE (WRLINE,340) M,(SYM(I,M,NS),I=1,12),IRC
      CALL KPWRTE (NTOUT)
CYENG1
  340 FORMAT (I3,')  ',12F5.2,' Fehler',I2)
CYENG2
CYENGY  340 FORMAT (I3,')  ',12F5.2,' Error',I2)
        IAIN(1)=M
        CALL ZVSYAN
  350 CONTINUE
C
  999 DO  I=1,3
        DO  J=1,3
          DREH(I,J)=DRSV(I,J)
        ENDDO
        UR(I,NS)=URSV(I)
      ENDDO
      NTYP=3
      CALL ZVK
      NTYP=NTYPSV
      RETURN
      END
