CKPTSY    44             ------------------
                          SUBROUTINE ZVTSY
C  CY-ENG-               ------------------
C
C            Das Programm testet eine vorgegebene Symmetrie.
C
C                         geschrieben: Hundt
C                 Geaendert: 211226 APR 2000  (Hundt)
C
C                        ------------------
C
C     IMPLICIT NONE

      INTEGER *4 ISTSYM(15),I,J,K,IRPOI,IRDIM,IAIN(72),IGTY(7)
      PARAMETER (IRDIM=24)
      REAL    *4 REFL(3,IRDIM),TOL,TSTSYM(15)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      EQUIVALENCE (TSTSYM(1),ISTSYM(1)),(AIN(1),IAIN(1))
C
      SAVE TSTSYM,IDFLG
C
      DATA TOL/0.001/
      DATA IGTY/1HP,1HI,1HR,1HF,1HA,1HB,1HC/
      DATA TSTSYM/0.,1.,0.,0.,  0.,0.,1.,0.,  0.,0.,0.,1.,  0.,0.,0.1/
      DATA IDFLG/0/
C
      GO TO (60,30,10,290,420), NTYP
C
C                            Hinterlege Ergebnisse aus ID
   10 DO 20 I=1,12
   20 TSTSYM(I)=AIN(I+16)
      IDFLG=1
      GO TO 999
C                            TSYI - Teste Symmetrie nach Idealisierung
C
   30 CALL FLES (TSTSYM(13),ISKP(32),4H2IFE,13Hzl1,zl2,tol?$)
      IF (IDFLG) 70,40,70
   40 WRITE (WRLINE,50)
      CALL KPWRTE (NTDISP)
CYENG1
   50 FORMAT ('ZVTSY050 - Kein ID-Daten vorhanden.')
CYENG2
CYENGY   50 FORMAT ('ZVTSY050 - No ID-data present.')
      GO TO 999
C                            TSY - Teste Symmetrie
C
   60 CALL FLES (TSTSYM,ISKP(31),7H12F2IFE,
     1 32Ht1,s11,s12,...,s33,zl1,zl2,tol?$)
C
   70 NTYP=4
      ISKP5=ISKP(5)
      ISKP(5)=1
      IF (ISTSYM(13)) 80,80,90
   80 ISTSYM(13)=ISKP(53)
   90 IF (ISTSYM(14)) 110,110,100
  100 IF (ISTSYM(14)-NAT(NS)) 120,120,110
  110 ISTSYM(14)=NAT(NS)
  120 IZ1=ISTSYM(13)
      IZ2=ISTSYM(14)
      DQ=TSTSYM(15)
      NCDASV=NCDA(NS)
      NCDSV=NCD(NS)
      NCDA(NS)=NCD(NS)+1
C                            Trikline Box
  140 DO 150 I=1,3
  150 X(I,7)=DQ*RK(I,NS)
      DQ=DQ*DQ
C                            Durchlaufe Codeliste
      IK=NCDASV-1
      GO TO 200
  160 IK=IK+1
      NC=2
      NTRY=40
      IC=IK
      CALL ZVDEK
C                            Wende Symmetrie an
      J=1
      DO 170 I=1,3
      X(I,1)=TSTSYM(J)+X(1,2)*TSTSYM(J+1)+X(2,2)*TSTSYM(J+2)
     1 +X(3,2)*TSTSYM(J+3)
      J=J+4
  170 CONTINUE
      CALL KPCDST (ISKP(80),1,ICD(IC,NS))
      WRITE (WRLINE,180) IK,AT(5,IANR,NS),AT(6,IANR,NS),
     1 (ISKP(I),I=80,82),(X(J,1),J=1,3)
      CALL KPWRTE (NTOUT)
  180 FORMAT ('#',I4,' #',3X,2A4,1X,3A4,3F10.5,'   T-Atom')
C
C                            Kartesische Koordinaten
      NC=1
      NTRY=2
      CALL ZVDEK
      DO 190 I=1,3
  190 X2(I)=X1(I)
      CALL ZVADD
      IF (IERR) 990,200,990
C                            Naechstes Ursprungsatom
C
  200 IF (IK-NCDSV) 160,990,990
C
C                            TR - Teste Reflex.
C                            Es werden alle symmetrieaequivalenten
C                            Reflexe erzeugt und die Flaechenhaeufig-
C                            keit berechnet (ohne Friedelreflexe).
C
  290 CALL FLES (X1,ISKP(31),3H3FE,7Hh,k,l?$)
      IRPOI=0
      IF (NSYM(NS) .GT. 0) GO TO 300
      IERR=44029005
      GO TO 999
C
  300 DO 400 I=1,NSYM(NS)
      DO 310 K=1,3
  310 X2(K)=SYM(K+1,I,NS)*X1(1)+SYM(K+5,I,NS)*X1(2)+SYM(K+9,I,NS)*X1(3)
      IF (IRPOI .LE. 0) GO TO 370
      DO 350 J=1,IRPOI
      DO 320 K=1,3
      IF (ABS(REFL(K,J)-X2(K)) .GT. TOL) GO TO 330
  320 CONTINUE
C                            Reflex schon vorhanden.
      GO TO 400
  330 DO 340 K=1,3
      IF (ABS(REFL(K,J)+X2(K)) .GT. TOL) GO TO 350
  340 CONTINUE
C                            Friedelreflex gefunden.
      GO TO 400
  350 CONTINUE
C
      IF (IRPOI .LT. IRDIM) GO TO 370
      WRITE (WRLINE,360)
      CALL KPWRTE (NTDISP)
CYENG1
  360 FORMAT ('Tabelle voll.')
CYENG2
CYENGY  360 FORMAT ('Table full.')
      GO TO 999
C
  370 IRPOI=IRPOI+1
      DO 380 K=1,3
  380 REFL(K,IRPOI)=X2(K)
      WRITE (WRLINE,390) X2
      CALL KPWRTE (NTOUT)
  390 FORMAT (3F10.2)
  400 CONTINUE
      WRITE (WRLINE,410) IRPOI
      CALL KPWRTE (NTOUT)
CYENG1
  410 FORMAT ('Flaechenhaeufigkeit:',I3)
CYENG2
CYENGY  410 FORMAT ('Multiplicity of reflex:',I3)
      GO TO 999
C                            EAR - Entferne ausgeloeschte Reflexe
C
CYENG1
  420 CALL FLES (IAIN,ISKP(31),3HIAE,10HAtNr,Gty?$)
CYENG2
CYENGY  420 CALL FLES (IAIN,ISKP(31),3HIAE,10HAtNo,Gty?$)
      IF (NCD(NS) .LT. NCDA(NS)) GO TO 999
      CALL CNVTUP (AIN(2),1,4)
      DO 430 J=1,7
      IF (IAIN(2) .EQ. IGTY(J)) GO TO 435
  430 CONTINUE
      IERR=44043016
      GO TO 999
C
  435 NTRY=32
      NC=1
      DO 530 IC=NCDA(NS),NCD(NS)
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      IF (IANR .NE. IAIN(1)) GO TO 530
      DO 440 I=1,3
  440 IT(I)=IT(I)-5
      GO TO (520,450,460,470,490,500,510),J
C              P   I   R   F   A   B   C
      GO TO 999
C                            H+K+L=2N
C
  450 IF (MOD(ABS(IT(1)+IT(2)+IT(3)),2) .EQ. 0) GO TO 530
      GO TO 520
C                            -H+K+L=3N
C
  460 IF (MOD(ABS(-IT(1)+IT(2)+IT(3)),3) .EQ. 0) GO TO 530
      GO TO 520
C                            H,K,L ALLE GRADE ODER ALLE UNGRADE
  470 K=0
      DO 480 I=1,3
  480 K=K+MOD(ABS(IT(I)),2)
      IF ((K .EQ. 0) .OR. (K .EQ. 3)) GO TO 530
      GO TO 520
C                            A, B ODER C
  490 IF (MOD(ABS(      IT(2)+IT(3)),2) .EQ. 0) GO TO 530
      GO TO 520
  500 IF (MOD(ABS(IT(1)      +IT(3)),2) .EQ. 0) GO TO 530
      GO TO 520
  510 IF (MOD(ABS(IT(1)+IT(2)      ),2) .EQ. 0) GO TO 530
C
  520 ICD(IC,NS)=0
  530 CONTINUE
C                            RAEUME CODELISTE AUF
      J=NCDA(NS)-1
      DO 540 IC=NCDA(NS),NCD(NS)
      IF (ICD(IC,NS) .EQ. 0) GO TO 540
      J=J+1
      ICD(J,NS)=ICD(IC,NS)
  540 CONTINUE
      NCD(NS)=J
      K8(NS)=0
      K9(NS)=0
      GO TO 999
C
  990 ISKP(5)=ISKP5
      NCDA(NS)=NCDASV
C
  999 RETURN
      END
