C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                      --------------------------
                        subroutine misyou (iflg)
c                      --------------------------
c
c--- Programm listet symmetrien. Ist iflg ungleich 0, wird das
c    programm beendet.
c
c                 geschrieben: 300850 jan 1998 (Hundt)
c
c                      --------------------------
c
      IMPLICIT NONE
      INTEGER *4 iflg
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 j,k,m,symbuf(10),irc
      REAL    *4 s(12)
c
      do  k=1,nsym
        do  m=1,3
          do  j=1,3
            s((m-1)*4+j+1)=sym(m,j,k)
          enddo
          s((m-1)*4+1)=sym(m,4,k)
        enddo
        call symenc (s,symbuf,irc)
        if (irc .eq. 0) then
          write (WRLINE,'(i3,a,6a4,a)') k,') ',(symbuf(m),m=1,6)
        else
          write (WRLINE,'(i3,a,3(f6.3,3f5.1))')
     1     k,')',(s(m),m=1,12)
        endif
        CALL KPWRTE (lptx  )
      enddo
      if (iflg .eq. 1) then
        write (lptx,'(A)') 'Table for symmetries full.'
        CALL KPWRTE (lptx)
        iskp(14)=3
      endif
      return
      END
