C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                        ----------------------
                          SUBROUTINE MM(X,Y,Z)
C                        ----------------------
C
C     MULTIPLY TWO MATRICES
C     Z(3,3)=X(3,3)*Y(3,3)
C
      IMPLICIT NONE
      REAL *4 X(3,3),Y(3,3),Z(3,3)
C
      INTEGER *4 I,J,K
      DO  I=1,3
        DO  K=1,3
          Z(I,K)=0.0
          DO  J=1,3
            Z(I,K)=Z(I,K)+X(I,J)*Y(J,K)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END
