C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                 -------------------------------
                   SUBROUTINE NORM (U,Y,Z,ITYPE)
C                 -------------------------------
C
C                BEARBEITET: 171100 JAN 90 (HUNDT)
C
C
C     ***** VECTOR PRODUCT  Z=X*Y ***** (U=X)
C     ***** ITYPE .GT.0 FOR CARTESIAN,.LE.0 FOR TRICLINIC *****
C
      IMPLICIT NONE
      INTEGER *4 I,I1,I2,ITYPE
      REAL *4 U(3),Y(3),Z(3),Z1(3),T1
C
      INCLUDE 'KPORC.INC'
      INCLUDE 'ZVCOM.INC'
C
      DO 30 I=1,3
      I1=MOD(I+3,3)+1
      I2=MOD(I+1,3)+1
      T1=U(I1)*Y(I2)-U(I2)*Y(I1)
      IF (ITYPE) 20,20,10
   10 Z(I)=T1
      GO TO 30
   20 Z1(I)=T1
   30 CONTINUE
      IF (ITYPE) 40,40,999
   40 CALL MV (BB(1,1,NS),Z1,Z)
  999 RETURN
      END
