C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                       -----------------------
                         SUBROUTINE PLTXY(XX,Y)
C  CY-ENG-              -----------------------
C
C                  BEARBEITET: 171134 JAN 90 (HUNDT)
C
C     ***** PLOT COORD. AND CLOSEST EDGE AFTER PROJECTION *****
C
      IMPLICIT NONE
      REAL *4 XX(3),Y(2),T1,T2,T4
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
C
      T4=1.
      T1=1.
      IF (VIEW .GT. 0.) THEN
        T4=VIEW-XX(3)
        IF (T4 .LE. 0.) THEN
          Y(1)=-99.
          Y(2)=-99.
          GO TO 50
        ENDIF
        T1=VIEW/T4
      ENDIF
      Y(1)=XX(1)*T1+XO(1)
      Y(2)=XX(2)*T1+XO(2)
      T1=CONST(8)-ABS(Y(1)*2.-CONST(8))
      T2=CONST(9)-ABS(Y(2)*2.-CONST(9))
      EDGE=AMIN1(T1,T2)*.5
      IF (T4 .GE. VIEW*.5) GO TO 999
   50 EDGE=-99.
  999 RETURN
      END
