C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C    -----------------------
      SUBROUTINE TMM(X,Y,Z)
C    -----------------------
C
C     ***** TRANSPOSE(TRANSPOSE(X)*Y)=Z *****
C     ***** X,Y,Z ARE 3X3 MATRICES *****
C
      IMPLICIT NONE
      INTEGER *4 I,K
      REAL    *4 X(3,3),Y(3,3),Z(3,3)
C
      DO  I=1,3
        DO  K=1,3
          Z(K,I)=X(1,I)*Y(1,K)+X(2,I)*Y(2,K)+X(3,I)*Y(3,K)
        ENDDO
      ENDDO
      RETURN
      END
