C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                    ----------------------------
                      SUBROUTINE UNIT(X,Z,ITYPE)
C                    ----------------------------
C
C                  BEARBEITET: 200916 DEC 95 (HUNDT)
C
      IMPLICIT NONE
      INTEGER *4 ITYPE,NS
      REAL    *4 X(3),Z(3)
      INCLUDE 'KPORC.INC'
C
      REAL    *4 Y(3),T1
C
      NS=1
      Y(1)=X(1)
      Y(2)=X(2)
      Y(3)=X(3)
      IF (ITYPE .GT. 0) THEN
        T1=SQRT(Y(1)*Y(1)+Y(2)*Y(2)+Y(3)*Y(3))
      ELSE
        T1=SQRT (Y(1)*(Y(1)*AA(1,1,NS)+Y(2)*(AA(1,2,NS)+AA(2,1,NS))+Y(3)
     + *(AA(1,3,NS)+AA(3,1,NS)))+Y(2)*(Y(2)*AA(2,2,NS)+Y(3)*(AA(2,3,NS)+
     +  AA(3,2,NS)))+Y(3)*Y(3)*AA(3,3,NS))
      ENDIF
      IF(T1 .LE. 0.) THEN
        NG=5
        RETURN
      ENDIF
C
      Z(1)=Y(1)/T1
      Z(2)=Y(2)/T1
      Z(3)=Y(3)/T1
      RETURN
      END
