C               -------------------------------------------
                 SUBROUTINE KPCVNM (ISTR1,ITYP,ISTR2,NCHR)
C               -------------------------------------------
C
C  Das Programm konvertiert den KPLOT-Namen eines Atomes in einen
C  String, z.B.
C                     Na   1        Na       ITYP=0
C                     Na   1        Na1           1
C                     Na   1        Na(1)         2
C
C                 Geschrieben: 090754 NOV 1989  (Hundt)
C
C               -------------------------------------------
C
      IMPLICIT NONE
      INTEGER*1 ISTR1(*),ISTR2(*)
      INTEGER*4 ITYP,NCHR,NBLANK,IBUKLA,IBUKLZ
      INTEGER*4 I,J
C
      DATA NBLANK/32/,IBUKLA/40/,IBUKLZ/41/
C
      IF (ITYP) 10,10,30
   10 J=1
      DO 20 I=1,4
      ISTR2(I)=ISTR1(I)
      ISTR2(I+4)=NBLANK
      IF (ISTR2(I) .NE. NBLANK) J=I
   20 CONTINUE
      GO TO 120
C
   30 DO 40 I=1,8
   40 ISTR2(I)=NBLANK
      J=0
      I=0
   50 I=I+1
      IF (ISTR1(I) .EQ. NBLANK) GO TO 60
      J=J+1
      ISTR2(J)=ISTR1(I)
      IF (I .LT. 4) GO TO 50
   60 IF (ITYP .EQ. 0) GO TO 120
      IF (ITYP .NE. 2) GO TO 90
      DO 70 I=5,8
      IF (ISTR1(I) .NE. NBLANK) GO TO 80
   70 CONTINUE
      GO TO 120
C
   80 J=J+1
      ISTR2(J)=IBUKLA
   90 I=4
  100 I=I+1
      IF (ISTR1(I) .EQ. NBLANK) GO TO 110
      IF (J .GE. 8) GO TO 120
      J=J+1
      ISTR2(J)=ISTR1(I)
      IF (I .LT. 8) GO TO 100
  110 IF (ITYP .NE. 2) GO TO 120
      IF (J .GE. 8) GO TO 120
      J=J+1
      ISTR2(J)=IBUKLZ
C
  120 NCHR=J
      RETURN
      END
