c                         -------------------
                           subroutine mihini
c                         -------------------
c
c--- Initialisation of common mispg
c
c                   written: 071520 may 1997 (Hundt)
c                   changed: 091126 jan 2004 (Hundt)
c
c                         -------------------
c
      IMPLICIT NONE
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 i,j
c
      if (iskp(13) .eq. 0) then
        write (WRLINE,'(17x,a)')
     +   'Space-group Detection Program  Version 1.3.8'
        CALL KPWRTE (lptx)
        write (WRLINE,'(30x,a)') 'R. Hundt 1997'
        CALL KPWRTE (lptx)
        write (WRLINE,'('' '')')
        CALL KPWRTE (lptx)
      endif
c                            pi, 2*pi, pi/180, 180/pi
      CONST(1)=3.141593
      CONST(2)=6.283185
      CONST(3)=1.745329E-2
      CONST(4)=57.29578
c                            Tolerance, within lattice axes
c                            are treated to be equal (A)
      const(5)=0.5
c                            Tolerance, within a point is treated
c                            to ly in a plane (A)
      const(6)=0.5
c                            Tolerance, within angles may differ from
c                            an ideal value (degree)
      const(7)=4.0
c                            Allowed deviation of the numbers of a
c                            rotation-matrix from integer values
c                            and translation values from x/12
      const(8)=0.05
      const(9)=0.03125
c                            const 10-20 not used
c                            -------------------------------------------
      call mirmsy (0)
c                            Number of symmetries before anal
      ISKP(3)=0
c                            Flag, whether misyan produces output
      ISKP(4)=0
c                            Flag, if set, numbers of rotation
c                            matrices will be made integer after ANAL
      ISKP(5)=1
c                            ISKP(6) to ISKP(8): HM-symbol
c                            ISKP(9): Number of space group
c                            ISKP(10): Cubic case
c                            ISKP(11): Use origin as found by MICKSY
c                            ISKP(12): Micksy was run
      do  i=6,12
        iskp(i)=0
      enddo
c                            Steps GET/ANAL/RGS/RTF automatically
c     iskp(13)=0
c                            Error code -F-
      iskp(14)=0
c     iskp(15)=0             Set, if first setting is demanded
c     iskp(16)=0             Set, if IDG is used
c                            Set, if no matching space group was found
      iskp(17)=0
c     iskp(18)=0             Set, if ntbilf is open
      iskp(19)=1 !           Reset, if the line RPSY ... is to be suppressed.
      iskp(20)=0 !           If set, iskp(15) will be also set, if
c                            a monoclinic spacae group is found.
c                            No unused flags.
      do  i=1,3
        if (iskp(1) .eq. 0) then
          zelle(i)=10.
          zelle(i+3)=90.
        endif
        orgsh(i)=0.
        do  j=1,3
          trabij(i,j)=0.
        enddo
        trabij(i,i)=1.
      enddo
      call miz
c
      id2(1)=2
      id2(2)=3
      id2(3)=1
c
      return
      END
