      SUBROUTINE minv (a,n,det,iv,iw)
c
c--- Inversion einer (quadratischen) Matrix
c
      IMPLICIT NONE
      INTEGER *4 n,iv(n),iw(n),NMAX
      REAL    *4 a(n,n),det,TINY
      PARAMETER (NMAX= 4,TINY=1.0E-20)
C
      INTEGER *4 i,j
      REAL    *4 b(NMAX,NMAX)
C
      if (n .gt. NMAX) then
        det=0.
        go to 999
      endif
      do  i=1,n
        do  j=1,n
          b(i,j)=a(i,j)
          a(i,j)=0.
        enddo
        a(i,i)=1.
      enddo
C
      call ludcmp (b,n,NMAX,iv,det)
      if (det .eq. 0.) go to 999
      do i=1,n
        det=det*b(i,i)
      enddo
      if (abs(det) .lt. TINY) then
        det=0.
        go to 999
      endif
      do i=1,n
        call lubksb (b,n,NMAX,iv,a(1,i))
      enddo
  999 return
      END
