c                          ------------------
                            subroutine rgrdz
c                          ------------------
c
c                            Zellreduktion
c
c                geschrieben: 140855 feb 2001  (Hundt)
c
c                          ------------------
c
      IMPLICIT NONE
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 i,j,k,iv(3),i1,i2,i3,m,m1,l
      REAL    *4 sv(3,3),svk(3,3),sl(3),aidn(3,3),tol,v(3),al,vt(3)
      REAL    *4 skp,ain(16)
      DATA aidn/1.,0.,0., 0.,1.,0., 0.,0.,1./,tol/0.001/
c
c                            Bringe zuerst die gitterkonstanten
c                            selber auf den bereich der kuerzesten
c                            vektoren.
      do  i=1,3
        do  j=1,3
          sv(j,i)=aidn(j,i)
          svk(j,i)=dgt(j,i)
        enddo
        sl(i)=zelle(i)
      enddo
c                            Durchsuche die symmetrieliste nach
c                            zentrierungen.
      do  i=2,nsym
        do  j=1,3
          do  k=1,3
            if (abs(sym(k,j,i)-aidn(k,j)) .gt. tol) go to 50
          enddo
        enddo
c                            Gefunden, wenn hier. Teste jetzt, ob
c                            kuerzer als ein bereits vorhandener.
        do  i1=0,1
          vt(1)=sym(1,4,i)-float(i1)
          if (vt(1)-tol .le. -1.) go to 90
          do  i2=0,1
            vt(2)=sym(2,4,i)-float(i2)
            if (vt(2)-tol .le. -1.) go to 80
            do  i3=0,1
              vt(3)=sym(3,4,i)-float(i3)
              if (vt(3)-tol .le. -1.) go to 70
              do  j=1,3
                v(j)=dgt(j,1)*vt(1)+dgt(j,2)*vt(2)+dgt(j,3)*vt(3)
              enddo
              al=v(1)*v(1)+v(2)*v(2)+v(3)*v(3)
              if (al .le. 0.) go to 50
              al=sqrt(al)
c                            Suche zuerst einen parallelen.
              do  j=1,3
                skp=(v(1)*svk(1,j)+v(2)*svk(2,j)
     +          +v(3)*svk(3,j))/(al*sl(j))
                if (abs(skp)+tol .ge. 1.) then
                  if (al .ge. sl(j)) go to 70
                  m=j
                  go to 60
                endif
              enddo
c                            Keinen gefunden. Teste, ob kleiner als
c                            ein vorhandener. Sortiere zuerst.
              do  l=1,3
                iv(l)=l
              enddo
              l=1
   10         j=l
              l=l+1
              k=iv(l)
              go to 30
   20         iv(j+1)=iv(j)
              j=j-1
              if (j .lt. 1) go to 40
   30         if (sl(k) .lt. sl(iv(j))) go to 20
   40         iv(j+1)=k
              if (l .lt. 3) go to 10
c
              do  j=1,3
                if (al .lt. sl(iv(j))) then
                  m=j
                  go to 55
                endif
              enddo
c                            Keinen gefunden.
              go to 70
c                            Teste, ob 1, 2 und der neue nicht in
c                            einer ebene liegen.
   55         m1=3
              do  k=1,3
                ain(k)=sv(k,iv(1))
                ain(k+3)=sv(k,iv(2))
                ain(k+6)=vt(k)
              enddo
              call minv (ain,3,ain(10),ain(11),ain(14))
              if (abs(ain(10)) .lt. tol) then
                if (m .eq. 3) go to 70
                m1=2
              endif
              m=iv(m1)
c                            Ueberschreibe.
   60         do  k=1,3
                sv(k,m)=vt(k)
                svk(k,m)=v(k)
              enddo
              sl(m)=al
   70         continue
            enddo
   80       continue
          enddo
   90     continue
        enddo
   50   continue
      enddo
c                            Teste rechshaendigkeit:
      do  i=1,3
        do  j=1,3
          svk(j,i)=sv(j,i)
        enddo
      enddo
      call minv (svk,3,ain(10),ain(11),ain(14))
      if (ain(10) .lt. 0.) then
        do  i=1,3
          sv(i,1)=-sv(i,1)
        enddo
      endif
      call mitz (sv,i)
      return
      end
