C            -------------------------------
              SUBROUTINE UPLINX (AR,NSTEUS)
C CY-ENG-    -------------------------------
C
C          Interface fuer HP-LASERJET PII
C        geschrieben: 020733 MAY 1991  (Hundt)
C        geaendert:   060958 JAN 2002  (Hundt)
C        PC-Version: 3.3.93 (Hundt/Sievers)
C
C            -------------------------------
C
      IMPLICIT NONE
      INCLUDE 'WRBFR.INC'
C
      CHARACTER*8 YPOS8
C
      INTEGER*4 LENZL,LENSP,LENPLY,MATDIM,IXMAXD,IYMAXD,IFLDIM,ME
      PARAMETER (LENZL=148,LENSP=6400,LENPLY=150,IFLDIM=1024)
      PARAMETER (MATDIM=LENZL*LENSP, IXMAXD=LENZL*32-1, IYMAXD=LENSP-1)
      INTEGER KNEGZ
      PARAMETER (KNEGZ=-2147483647-1,ME=-1)
C
      REAL*4    AR(*),XNEU,YNEU
      REAL*4    XZER,XFAKT,YZER,YFAKT,GENFKT
      REAL*4    POLYGN(2,LENPLY),BFX,BFY,FLAKT,FLMST(IFLDIM),AI
C
      INTEGER*4 NSTEUS,NSTEU,KEYIN,ISW
      INTEGER*4 IQ,IZ,INC,ITAB(36),ITABR(32),ITABL(32),IBITM(40)
      INTEGER*4 IXT,IYT,IXMAX,IYMAX,ITEMP,NRET2,NRET3
      INTEGER*4 NPEN,NPENH,I,J,K,L,IXWRT,IXBIT
      INTEGER*4 IPRSTR,IGRPLY(2,0:LENSP-1),IPOLPO
      INTEGER*4 IYWRT,IYBIT,IFLAKT,IFLPOI(11),IPERIM
      INTEGER*4 IFLMST(IFLDIM),IFLSTA,IFLSTW,IFLWPL,IFLADR,IFLEFP
      INTEGER*4 M,IPRLNE,ILSOLL,IEOL,IPOI,OPOI,JC,ILIST
      INTEGER*4 IXTP,IXTM,IYTT,IFMT,IPLSOL,NTOUT,IFLAG,KOMPR
      INTEGER*4 IAKTLN,EOL,IBTCOU,IVRCNT,I4BYTE
      INTEGER*4 LLINE(0:159),IFILTY,IOSTRT,IBTPOI,LEN,NCOLOR
      INTEGER*4 IXA(2),IXN(2),IDEL(2),IX(2),IPOIL,IPOIK,INCK,INCL
C
CYVAXY
      INTEGER *4 IAND,IOR
      INTEGER*4 MATRIX(0:MATDIM-1)
      INTEGER*2 IHDR(8)
      INTEGER*1 M1TRIX(0:4*MATDIM-1),I1TEMP(4),LQ(24)
      INTEGER*1 YPOS(8),RGEND(5),TCHAR,OLINE(640),I1TCOU(4)
      INTEGER*1 I1RCNT(4),I1BYTE(4),I1HDR(16),IBYTE
C
      SAVE XZER,YZER,XFAKT,YFAKT,BFX,BFY,IXA,NCOLOR
      SAVE NPEN,NPENH,MATRIX,IXMAX,IYMAX,POLYGN,IPOLPO,IFLMST,IFLPOI
      SAVE IFLEFP,IPERIM,ITAB,ITABL,ITABR,IBITM,IFMT,IFLAG,KOMPR,LQ
C     SAVE
C
      EQUIVALENCE (MATRIX(0),M1TRIX(0)),(ITEMP,I1TEMP(1))
      EQUIVALENCE (IFLAKT,FLAKT),(IFLMST(1),FLMST(1)),(AI,I)
      EQUIVALENCE (YPOS(1),YPOS8),(IBTCOU,I1TCOU(1))
      EQUIVALENCE (IVRCNT,I1RCNT(1)),(I4BYTE,I1BYTE(1))
      EQUIVALENCE (OLINE(1),LLINE(0)),(IHDR(1),I1HDR(1))
C
      DATA IXA/0,0/,NPEN/1/,NPENH/0/
      DATA XZER,YZER/0.,0./, XFAKT,YFAKT/236.22,236.22/
      DATA IXMAX/IXMAXD/,IYMAX/IYMAXD/,IPERIM/1/,NCOLOR/0/
      DATA GENFKT/1./,IFMT/1/,NTOUT/6/,IFLAG/1/
C
      DATA LQ/  27,   42,  112,   48,  120,   48,   89,
C             <ESC>    *     p     0     x     0     Y
     1 27, 42,116,51,48,48,82,
C      <ESC>*   t  3  0  0  R
     2 27, 42,98,50,77,
C      <ESC>*  b  2  M
     3 27, 42,114,48,65/
C      <ESC>*   r  0  A
      DATA YPOS/27, 42,112,48,48,48,48,89/
C               <ESC>*   p  0  0  0  0  Y
      DATA RGEND/27, 42,114,66,12/
C                <ESC>*   r  B  FF
      DATA BFX,BFY/236.22,236.22/
      DATA (IFLMST(I),I=1,12)/1,1,0, 1,1,-1,
C                             1      4
     1 1,4,-2004318072,0, 572662306, 0/
C      7                               13
      DATA IFLPOI/1,4,7,13,7*0/,IFLEFP/3/
C
      DATA ITAB/0,0,0,0,128,64,32,16,8,4,2,1,32768,16384,8192,4096,2048,
     1 1024,512,256,8388608,4194304,2097152,1048576,524288,262144,
     2 131072,65536,KNEGZ,1073741824,536870912,268435456,134217728,
     3 67108864,33554432,16777216/
      DATA ITABL/128,192,224,240,248,252,254,255,33023,49407,57599,
     1 61695,63743,64767,65279,65535,8454143,12648447,14745599,15794175,
     2 16318463,16580607,16711679,16777215,-2130706433,-1056964609,
     3 -520093697,-251658241,-117440513,-50331649,-16777217,-1/
      DATA ITABR/-1,-129,-193,-225,-241,-249,-253,-255,-256,-33024,
     1 -49408,-57600,-61696,-63744,-64768,-65280,-65536,-8454144,
     2 -12648448,-14745600,-15794176,-16318464,-16580608,-16711680,
     3 -16777216,2130706432,1056964608,520093696,251658240,117440512,
     4 50331648,16777216/
      DATA IBITM/251658240,117440512,50331648,16777216,128,64,32,16,8,
     1 4,2,1,32768,16384,8192,4096,2048,1024,512,256,8388608,4194304,
     2 2097152,1048576,524288,262144,131072,65536,KNEGZ,1073741824,
     3 536870912,268435456,134217728,67108864,33554432,16777216,
     4 128,192,224,240/
C
      NSTEU=NSTEUS
      IF (NSTEU) 9999,9999,10
   10 IF (NSTEU .GT. 24) GO TO 9999
      GO TO (20,50,50,240,250,20,9999,9999,9999,269,270,9999,260,9999,
C             1  2  3   4   5  6    7    8    9  10  11   12  13   14
     1 1200,320,330,9999,9999,340,1050,1040,1030,1230), NSTEU
C        15  16  17   18   19  20  21    22   23   24
C
C                       Initialisiere (1)
   20 IF (IFLAG .EQ. 0) GO TO 40
      DO 30 I=1,MATDIM
   30 MATRIX(I-1)=0
      IFLAG=0
C        KOMPR=0 ohne, 2 mit Datenkompression
      KOMPR=2
      LQ(18)=KOMPR+48
   40 I=5
      GO TO 280
C++                     Point (3) und Line (2)
C
   50 XNEU=AR(1)
      YNEU=AR(2)
      IFLAG=1
      ASSIGN 180 TO NRET2
      ASSIGN 9999 TO NRET3
C
   60 XNEU=XNEU*XFAKT+XZER
      YNEU=YNEU*YFAKT+YZER
C
C                       IFMT 0: Quer-, 1: Hochformat
C
      IF (IFMT .EQ. 0) THEN
        IXN(1)=YNEU
        IXN(2)=XNEU
      ELSE
        IXN(1)=XNEU
        IXN(2)=IYMAX-IFIX(YNEU)
      ENDIF
C
      IPOIL=1
      IPOIK=2
      IF (NSTEU .EQ. 3) THEN
        IX(1)=IXN(1)
        IX(2)=IXN(2)
        GO TO 150
      ENDIF
C
      IDEL(1)=IABS(IXN(1)-IXA(1))
      IDEL(2)=IABS(IXN(2)-IXA(2))
      IF (IDEL(1)+IDEL(2) .LE. 0) GO TO 120
      IX(1)=IXA(1)
      IX(2)=IXA(2)
      IF (IDEL(1) .LE. IDEL(2)) THEN
        IPOIK=1
        IPOIL=2
      ENDIF
      ISW=(IDEL(IPOIL)+1)/2
      INCK=1
      IF (IXN(IPOIK) .LT. IXA(IPOIK)) INCK=-1
      INCL=1
      IF (IXN(IPOIL) .LT. IXA(IPOIL)) INCL=-1
C
C                            Generiere Pixels
C
  100 IF (IX(IPOIL) .EQ. IXN(IPOIL)) GO TO 110
      IX(IPOIL)=IX(IPOIL)+INCL
      ISW=ISW-IDEL(IPOIK)
      IF (ISW .GT. 0) GO TO 150
      ISW=ISW+IDEL(IPOIL)
      IF (IX(IPOIK) .EQ. IXN(IPOIK)) GO TO 150
  105 IX(IPOIK)=IX(IPOIK)+INCK
      GO TO 150
  110 IF (IX(IPOIK) .NE. IXN(IPOIK)) GO TO 105
      IXA(1)=IXN(1)
      IXA(2)=IXN(2)
  120 GO TO NRET3, (1080,1110,1140,1180,9999)
C
  150 IXT=IX(1)
      IYT=IX(2)
      IF (IXT .LT. NPENH) IXT=NPENH
      IF (IXT .GT. IXMAX) IXT=IXMAX
      IF (IYT .LT. NPENH) IYT=NPENH
      IF (IYT .GT. IYMAX) IYT=IYMAX
      GO TO NRET2, (180,1080)
  180 CONTINUE
CYVAX1
C     IXBIT=(IXT .AND. 31)+5
CYVAX2
CYVAXY
      IXBIT=IAND(IXT,31)+5
      IXWRT=IXT/32
      I=LENZL*IYT+IXWRT
      IF (NCOLOR .EQ. 16) GO TO 181
CYVAX1
C     MATRIX(I)=MATRIX(I) .OR. IBITM(IXBIT)
CYVAX2
CYVAXY
      MATRIX(I)=IOR(MATRIX(I),IBITM(IXBIT))
      GO TO 190
  181 CONTINUE
CYVAX1
C     MATRIX(I)=MATRIX(I) .AND. (.NOT. IBITM(IXBIT))
CYVAX2
CYVAXY
      MATRIX(I)=IAND(MATRIX(I),(Ieor(IBITM(IXBIT),ME)))
C
C                       Teste Ueberhang
C
  190 IF (NPENH .LE. 0) GO TO 100
      J=IXBIT-NPENH
      IF (J .GT. 4) GO TO 200
      IF (NCOLOR .EQ. 16) GO TO 191
CYVAX1
C     MATRIX(I-1)=MATRIX(I-1) .OR. IBITM(J)
CYVAX2
CYVAXY
      MATRIX(I-1)=IOR(MATRIX(I-1),IBITM(J))
      GO TO 210
  191 CONTINUE
CYVAX1
c     MATRIX(I-1)=MATRIX(I-1) .AND. (.NOT. IBITM(J))
CYVAX2
CYVAXY
      MATRIX(I-1)=IAND(MATRIX(I-1),Ieor(IBITM(J),ME))
      GO TO 210
C
  200 J=IXBIT+NPENH
      IF (J .LT. 37) GO TO 210
      IF (NCOLOR .EQ. 16) GO TO 201
CYVAX1
c     MATRIX(I+1)=MATRIX(I+1) .OR. IBITM(J)
CYVAX2
CYVAXY
      MATRIX(I+1)=IOR(MATRIX(I+1),IBITM(J))
      GO TO 210
  201 CONTINUE
CYVAX1
c     MATRIX(I+1)=MATRIX(I+1) .AND. (.NOT. IBITM(J))
CYVAX2
CYVAXY
      MATRIX(I+1)=IAND(MATRIX(I+1),Ieor(IBITM(J),ME))
C
  210 K=I
      DO 220 J=1,NPENH
      K=K+LENZL
      I=I-LENZL
      IF (NCOLOR .EQ. 16) GO TO 211
CYVAX1
c     MATRIX(I)=MATRIX(I) .OR. ITAB(IXBIT)
c     MATRIX(K)=MATRIX(K) .OR. ITAB(IXBIT)
CYVAX2
CYVAXY
      MATRIX(I)=IOR(MATRIX(I),ITAB(IXBIT))
CYVAXY
      MATRIX(K)=IOR(MATRIX(K),ITAB(IXBIT))
      GO TO 220
  211 CONTINUE
CYVAX1
c     MATRIX(I)=MATRIX(I) .AND. (.NOT. ITAB(IXBIT))
c     MATRIX(K)=MATRIX(K) .AND. (.NOT. ITAB(IXBIT))
CYVAX2
CYVAXY
      MATRIX(I)=IAND(MATRIX(I),Ieor(ITAB(IXBIT),ME))
CYVAXY
      MATRIX(K)=IAND(MATRIX(K),Ieor(ITAB(IXBIT),ME))
  220 CONTINUE
      GO TO 100
C
C
C                       Set Origin (4)
  240 XZER=AR(1)*BFX
      YZER=AR(2)*BFY
      GO TO 9999
C                       Move Origin (5)
  250 XZER=XZER+AR(1)*BFX
      YZER=YZER+AR(2)*BFY
      GO TO 9999
C                       Define Factor (13)
  260 YNEU=AR(1)/GENFKT
      XFAKT=XFAKT*YNEU
      YFAKT=YFAKT*YNEU
      GENFKT=AR(1)
      GO TO 9999
C                            NPEN (10)
  269 AI=AR(1)
      NCOLOR=I
      GO TO 9999
C                            STRD (11)
  270 AI=AR(1)
  280 IF (I .EQ. NPEN) GO TO 9999
      IF (I .LE. 0) I=1
      IF (I .GT. 9) I=9
      NPENH=(I-1)/2
      NPEN=2*NPENH+1
C
      DO 310 I=1,32
      IZ=I+NPENH
      IQ=I-NPENH
      IF (IQ .GT. 0) GO TO 290
      IBITM(I+4)=ITABL(IZ)
      GO TO 310
C
  290 IF (IZ .LT. 32) GO TO 300
      IBITM(I+4)=ITABR(IQ)
      GO TO 310
C
  300 CONTINUE
CYVAX1
c     IBITM(I+4)=ITABL(IZ) .AND. ITABR(IQ)
CYVAX2
CYVAXY
      IBITM(I+4)=IAND(ITABL(IZ),ITABR(IQ))
  310 CONTINUE
      IXMAX=32*LENZL-NPENH-1
      IYMAX=LENSP-NPENH-1
      GO TO 9999
C                      (16) Setze Format
  320 AI=AR(1)
      IFMT=I
      GO TO 9999
C                      (17) Report Treibertyp
  330 I=1
      AR(1)=AI
      GO TO 9999
C                      Printe Matrix
  340 CONTINUE
      AI=AR(1)
      IF (I .NE. 0) GO TO 580
      IF (IFLAG .EQ. 0) GO TO 9999
C     WRITE (NTOUT,350) (I,I=1,3)
C 350 FORMAT (' ',3('----+----',I1),'--')
C                      Rastergraphik ein
      CALL ZPRN(LQ,24)
C  360 FORMAT (12Z3)
  360 FORMAT ($,A)
C
      IPRLNE=0
      ILIST=0
      ILSOLL=0
      IPLSOL=0
      GO TO 540
C                       Zeile
C
  370 IPRLNE=IPRLNE+LENZL
      IF (KEYIN(0) .EQ. 27) GO TO 561
      IXT=4*IPRLNE-1
C                            Stelle Zeile zusammen.
      IEOL=0
      IPOI=4*IPRSTR
      OPOI=7
      IF (KOMPR .NE. 0) GO TO 390
C                            Keine Kompression
      JC=OPOI
C                            Ermittle dabei letztes <>0 Byte
  380 JC=JC+1
      OLINE(JC)=M1TRIX(IPOI)
      IF (OLINE(JC) .NE. 0) OPOI=JC
      IPOI=IPOI+1
      IF (IPOI .LT. IXT) GO TO 380
      GO TO 500
C                            Kompression. Ermittle ...
  390 J=IPOI
      GO TO 410
C                            ... verschiedenartige Bytes
  400 J=J+1
      IF (M1TRIX(J-1) .EQ. M1TRIX(J)) GO TO 420
  410 IF (J .LT. IXT) GO TO 400
      IEOL=1
      J=J+2
  420 JC=J-IPOI-1
      IF (JC .LE. 0) GO TO 460
C
C                            und schreibe Bytes auf Puffer,
  430 J=JC
      IF (J .GT. 128) J=128
      OPOI=OPOI+1
      OLINE(OPOI)=J-1
      DO 440 K=1,J
      OPOI=OPOI+1
      OLINE(OPOI)=M1TRIX(IPOI)
      IPOI=IPOI+1
  440 CONTINUE
      JC=JC-J
  450 IF (JC .GT. 0) GO TO 430
      IF (IEOL .NE. 0) GO TO 500
C
C                            ... oder gleichartige Bytes,
  460 J=IPOI
      TCHAR=M1TRIX(J)
C
  470 J=J+1
      IF (TCHAR .NE. M1TRIX(J)) GO TO 480
      IF (J .LT. IXT) GO TO 470
      IEOL=1
      IF (TCHAR .EQ. 0) GO TO 500
      J=J+1
  480 JC=J-IPOI
      IPOI=IPOI+JC
C                            und schreibe Wiederholungssequenz.
  490 J=JC
      IF (J .GT. 128) J=128
      OPOI=OPOI+1
      OLINE(OPOI)=-J+1
      OPOI=OPOI+1
      OLINE(OPOI)=TCHAR
      JC=JC-J
      IF (JC .GT. 0) GO TO 490
      IF (IEOL .EQ. 0) GO TO 390
C
C                            Zeile ist fertig.
  500 IZ=OPOI-7
      IF (IZ .GT. 0) GO TO 510
      ILSOLL=ILSOLL+1
      GO TO 540
C                            Konvertiere Laengenzaehler.
  510 I=1
      IF (IZ .LT. 100) I=I+1
      IF (IZ .LT. 10) I=I+1
      ITEMP=IZ/100
      OLINE(4)=I1TEMP(1)+48
      IZ=IZ-100*ITEMP
      ITEMP=IZ/10
      OLINE(5)=I1TEMP(1)+48
      ITEMP=IZ-10*ITEMP
      OLINE(6)=I1TEMP(1)+48
C     OLINE(7)='W'
      OLINE(7)=87
      OLINE(I)=27
C     OLINE(I+1)='*'
      OLINE(I+1)=42
C     OLINE(I+2)='b'
      OLINE(I+2)=98
      IF (ILSOLL .EQ. ILIST) GO TO 530
C
C                            Generiere Tabulator. Istzeile ist
C                            nicht Sollzeile.
C
      WRITE (YPOS8(4:7),520) ILSOLL
  520 FORMAT (I4)
CCC   WRITE (NTPRT,280) YPOS
      CALL ZPRN(YPOS,8)
      ILIST=ILSOLL
C
  530 CONTINUE
CCC   WRITE (NTPRT,280) (OLINE(M),M=I,OPOI)
      CALL ZPRN(OLINE(I),OPOI-I+1)
      ILIST=ILIST+1
      ILSOLL=ILIST
C
  540 IPRSTR=IPRLNE
      IF (ILSOLL .LT. IPLSOL) GO TO 560
C     WRITE (NTOUT,550)
C 550 FORMAT ($,'*')
      IPLSOL=IPLSOL+100
  560 IF (IPRSTR .LT. MATDIM) GO TO 370
  561 CONTINUE
CCC   WRITE (NTPRT,280) RGEND
      CALL ZPRN (RGEND,5)
C     WRITE (NTOUT,570)
C 570 FORMAT (' ')
CCC   CLOSE (NTPRT)
      GO TO 9999
C
C                       Erzeuge einen .PCX - File
  580 IFILTY=I
C                       Suche Start- und Endzeile, ...
      IQ=LENSP
      IYT=-1
      DO  I=0,LENZL-1
        LLINE(I)=0
      enddo
      DO  I=0,LENSP-1
        M=I*LENZL
        DO  J=0,LENZL-1
          K=MATRIX(M+J)
          IF (K .ne. 0) then
            IQ=MIN0(IQ,I)
            IYT=I
CYVAX1
c           LLINE(J)=(LLINE(J) .OR. K)
CYVAX2
CYVAXY
            LLINE(J)=IOR(LLINE(J),K)
          endif
        enddo
      enddo
      IF (IQ .gt. IYT) then
        WRITE (WRLINE,'(A)') 'Image empty.'
        CALL KPWRTE (NTOUT)
        GO TO 9999
      endif
C
C                       ... Start- und Endbyte
      IZ=4*LENZL
      DO  I=1,4*LENZL
        IF (OLINE(I) .ne. 0) then
          IZ=MIN0(IZ,I)
          IXT=I
	endif
      enddo
      IZ=IZ-1
      IXT=IXT-1
C      WRITE (NTOUT,...) IQ,IYT,IZ,IXT
C  ... FORMAT (' Zeilen Start/Ende',2I6,' Start-/Endbyte',2I10)
      IF (IFILTY .EQ. 2) GO TO 760
C
C                       Erzeuge Header
      DO  I=1,128
        OLINE(I)=0
      enddo
      OLINE(1)=10
      OLINE(2)=5
      OLINE(3)=1
      OLINE(4)=1
      ITEMP=IXT-IZ+1            ! Zahl der Bytes in der Zeile
      IF (MOD(ITEMP,2) .EQ. 0) GO TO 650
      ITEMP=ITEMP+1
      IXT=IXT+1
  650 INC=IZ+4*LENZL-IXT        ! Increment zur naechsten Zeile
      OLINE(67)=I1TEMP(1)       ! Anzahl Bytes pro Zeile pro plane
      OLINE(68)=I1TEMP(2)
      IBTCOU=ITEMP*8-1          ! LETZTES PIXEL IN DER ZEILE
      OLINE(9)=I1TCOU(1)
      OLINE(10)=I1TCOU(2)
      IBTCOU=IYT-IQ             ! Anzahl der Zeilen
      OLINE(11)=I1TCOU(1)
      OLINE(12)=I1TCOU(2)
      OLINE(13)=88           ! AUFLOESUNG 600 DPI
      OLINE(14)=2
      OLINE(15)=88
      OLINE(16)=2
      OLINE(20)=-1           ! FARBEN
      OLINE(21)=-1
      OLINE(22)=-1
      OLINE(66)=1            ! ANZAHL PLANES
      OLINE(69)=1            ! FARBBILD
CCC   WRITE (NTPRT,280) (OLINE(I),I=1,128)
      do  i=1,128
        CALL ZPRN (OLINE(i),1)
      enddo
      I4BYTE=0
C                       Setze Startwerte
      IAKTLN=IQ
C                       Komprimiere Zeile
C
  660 IPOI=IAKTLN*LENZL*4+IZ
      EOL=IPOI+ITEMP-1
      I=IPOI
  670 I1BYTE(1)=M1TRIX(I)
  680 I=I+1
      IF (I .GT. EOL) GO TO 690
      IF (M1TRIX(I) .EQ. I1BYTE(1)) GO TO 680
  690 IBTCOU=I-IPOI
C     I1BYTE(1)=.NOT. I1BYTE(1)
      I4BYTE=255-I4BYTE
  700 IF (IBTCOU .LT. 64) GO TO 710
      CALL ZPRN (-1,1)
      CALL ZPRN (I1BYTE,1)
      IBTCOU=IBTCOU-63
      GO TO 700
C
  710 IF (IBTCOU-1) 750,720,730
  720 IF (I4BYTE .LT. 192) GO TO 740
  730 IBTCOU=IBTCOU+192
      CALL ZPRN (I1TCOU,1)
  740 CALL ZPRN (I1BYTE,1)
C
  750 IPOI=I
      IF (IPOI .LE. EOL) GO TO 670
      IAKTLN=IAKTLN+1
      IF (IAKTLN .LE. IYT) GO TO 660
      CALL ZPRN (0,-2)
      GO TO 9999
C
C                            .IMG - File
  760 CONTINUE
C                            Erzeuge Header
      IHDR(1)=1
      IHDR(2)=8
      IHDR(3)=1
      IHDR(4)=2
      IHDR(5)=42
      IHDR(6)=42
      ITEMP=IXT-IZ+1            ! Zahl der Bytes in der Zeile
      INC=IZ+4*LENZL-IXT        ! Increment zur naechsten Zeile
      IHDR(7)=ITEMP*8           ! Pixels pro Zeile
      IHDR(8)=IYT-IQ+1          ! Anzahl der Zeilen
      DO 770 I=2,16,2
      IBYTE=I1HDR(I)
      I1HDR(I)=I1HDR(I-1)
  770 I1HDR(I-1)=IBYTE
CCC   WRITE (NTPRT,280) IHDR
      CALL ZPRN (IHDR,16)
C
C                       Setze Startwerte
      OLINE(1)=0
      OLINE(2)=0
      OLINE(3)=-1
      IAKTLN=IQ
  780 IOSTRT=5          ! Kein vert. rep. Vorspann
      OPOI=4
C                       Komprimiere Zeile
C
  790 IPOI=IAKTLN*LENZL*4+IZ-1
      EOL=IPOI+ITEMP
C
      IBTPOI=0
  800 IPOI=IPOI+1
C                       Teste, ob solid run moeglich
      IBYTE=M1TRIX(IPOI)
      IF (IBYTE .EQ. 0) GO TO 850
      IF (IBYTE .EQ. -1) GO TO 850
C
C                       Teste, ob pattern run moeglich
C
      IF (IPOI+3 .GT. EOL) GO TO 810
      IF (IBYTE .NE. M1TRIX(IPOI+2)) GO TO 810
      TCHAR=M1TRIX(IPOI+1)
      IF (TCHAR .EQ. M1TRIX(IPOI+3)) GO TO 920
C
C                       Bitstring format
C
  810 IF (IBTPOI .GT. 0) GO TO 830
C
C                       Erzeuge neuen Bitstring
  820 IBTPOI=OPOI+2
      OPOI=OPOI+2
      OLINE(OPOI-1)=-128
      IBTCOU=0
      OLINE(IBTPOI)=0
C                       Teste, ob Byte noch eingefuellt w. kann
C
  830 IF (IBTCOU .GE. 255) GO TO 820
C
C                       Fuelle Byte ein
  840 IBTCOU=IBTCOU+1
      OLINE(IBTPOI)=I1TCOU(1)
      OPOI=OPOI+1
      OLINE(OPOI)=IBYTE
      GO TO 970
C                       Solid format run
  850 TCHAR=IBYTE
      LEN=0
  860 LEN=LEN+1
      IPOI=IPOI+1
      IF (IPOI .GT. EOL) GO TO 870
      IF (M1TRIX(IPOI) .EQ. TCHAR) GO TO 860
      IPOI=IPOI-1
      IF (LEN .GT. 1) GO TO 870
      IF (IBTPOI .LE. 0) GO TO 870
      IF (IBTCOU .LT. 255) GO TO 840
C
C                       Reset ggf. Bitstring
  870 IBTPOI=0
      GO TO 900
  880 LEN=LEN-127
      OPOI=OPOI+1
      IF (TCHAR .EQ. 0) GO TO 890
      OLINE(OPOI)=-1
      GO TO 900
  890 OLINE(OPOI)=127
  900 IF (LEN .GT. 127) GO TO 880
      IF (LEN .LE. 0) GO TO 970
      OPOI=OPOI+1
      IF (TCHAR .NE. 0) GO TO 910
      OLINE(OPOI)=LEN
      GO TO 970
  910 OLINE(OPOI)=LEN-128
      GO TO 970
C                       Pattern run
  920 IBTPOI=0
      LEN=2
      IPOI=IPOI+5
      GO TO 940
  930 IF (IBYTE .NE. M1TRIX(IPOI-1)) GO TO 950
      IF (TCHAR .NE. M1TRIX(IPOI)) GO TO 950
      LEN=LEN+1
      IPOI=IPOI+2
  940 IF (IPOI .LE. EOL) GO TO 930
C
C     ++                  Erzeuge Header und Muster
  950 IPOI=IPOI-2
  960 OLINE(OPOI+1)=0
      IBTCOU=LEN
      IF (IBTCOU .GT. 255) IBTCOU=255
      OLINE(OPOI+2)=I1TCOU(1)
      OLINE(OPOI+3)=IBYTE
      OPOI=OPOI+4
      OLINE(OPOI)=TCHAR
      LEN=LEN-255
      IF (LEN .GT. 0) GO TO 960
C
C                       Naechstes Byte
C
  970 IF (IPOI .LT. EOL) GO TO 800
C
C                       Teste, ob Zeile mit naechster uebereinstimmt
      IVRCNT=1
  980 IAKTLN=IAKTLN+1
      IF (IAKTLN .GT. IYT) GO TO 1000
      M=IAKTLN*LENZL
      DO 990 JC=M,M+LENZL-1
      IF (MATRIX(JC) .NE. MATRIX(JC-LENZL)) GO TO 1000
  990 CONTINUE
C                       Zeilen sind identisch. Zaehle Zeile.
      IVRCNT=IVRCNT+1
      GO TO 980
C                       Gruppe pending?
C
 1000 IF (IVRCNT .LE. 1) GO TO 1020
      IOSTRT=1
 1010 OLINE(4)=I1RCNT(1)
 1020 CONTINUE
CCC   WRITE (NTPRT,280) (OLINE(I),I=IOSTRT,OPOI)
      CALL ZPRN (OLINE(IOSTRT),OPOI-IOSTRT+1)
      IVRCNT=IVRCNT-255
      IF (IVRCNT .GT. 0) GO TO 1010
C
      IF (IAKTLN .LE. IYT) GO TO 780
c      CALL ZPRN (0,-2)
      GO TO 9999
C                       Polygon-Befehle
C                       (23) Point
 1030 IPOLPO=0
C                       (22) Line
C
 1040 IF (IPOLPO .GE. LENPLY) GO TO 9999
      IPOLPO=IPOLPO+1
      POLYGN(1,IPOLPO)=AR(1)
      POLYGN(2,IPOLPO)=AR(2)
      GO TO 9999
C                       (21) Polygon ist fertig
C
 1050 IF (IPOLPO-2) 9999,1170,1060
C
C                       1. Durchgang. Ermittle Grenzen ...
C
 1060 ASSIGN 1080 TO NRET2
      ASSIGN 1110 TO NRET3
      IFLAG=1
      FLAKT=AR(1)
      IFLAKT=IFLAKT+1
      IF ((IFLAKT .LE. 0) .OR. (IFLAKT .GT. IFLEFP)) IFLAKT=1
      J=IXMAX+1
      DO 1070 I=0,LENSP-1
      IGRPLY(1,I)=J
      IGRPLY(2,I)=-1
 1070 CONTINUE
      L=1
      NSTEU=3
      GO TO 1120
C
 1080 IXTP=IXT+NPENH
      IXTM=IXT-NPENH
      IGRPLY(1,IYT)=MIN0(IGRPLY(1,IYT),IXTM)
      IGRPLY(2,IYT)=MAX0(IGRPLY(2,IYT),IXTP)
      IF (NPENH .EQ. 0) GO TO 100
      DO 1100 I=1,NPENH
      IYTT=IYT-I
 1090 IGRPLY(1,IYTT)=MIN0(IGRPLY(1,IYTT),IXTM)
      IGRPLY(2,IYTT)=MAX0(IGRPLY(2,IYTT),IXTP)
      IF (IYTT .GT. IYT) GO TO 1100
      IYTT=IYT+I
      GO TO 1090
 1100 CONTINUE
      GO TO 100
C
 1110 NSTEU=2
      L=L+1
      IF (L .GT. IPOLPO) GO TO 1130
 1120 XNEU=POLYGN(1,L)
      YNEU=POLYGN(2,L)
      GO TO 60
C
 1130 ASSIGN 1140 TO NRET3
      L=1
      GO TO 1120
C                       ... und loesche das Innere des Polygons.
C
 1140 IFLADR=IFLPOI(IFLAKT)
      IFLWPL=IFLMST(IFLADR)
      DO 1160 I=0,LENSP-1
      IXT=IGRPLY(1,I)
      J=IGRPLY(2,I)
      IF (IXT .GT. J) GO TO 1160
CYVAX1
c     IXBIT=(IXT .AND. 31)+1
CYVAX2
CYVAXY
      IXBIT=IAND(IXT,31)+1
      IXWRT=IXT/32
CYVAX1
c     IYBIT=(J .AND. 31)+1
CYVAX2
CYVAXY
      IYBIT=IAND(J,31)+1
      IYWRT=J/32
      K=LENZL*I+IXWRT
C
      IFLSTA=MOD(I,IFLMST(IFLADR+1))*IFLWPL+2+IFLADR
      IFLSTW=MOD(IXWRT,IFLWPL)
      DO 1150 J=IXWRT,IYWRT
      IYT=0
      IF (J .EQ. IXWRT) IYT=ITABL(IXBIT)
CYVAX1
c     IF (J .EQ. IYWRT) IYT=IYT .OR. ITABR(IYBIT)
c     MATRIX(K)=(MATRIX(K) .AND. IYT) .OR.
c    1          ((.NOT. IYT) .AND. IFLMST(IFLSTA+IFLSTW))
CYVAX2
CYVAXY
      IF (J .EQ. IYWRT) IYT=IOR(IYT,ITABR(IYBIT))
CYVAXY
      MATRIX(K)=IOR(IAND(MATRIX(K),IYT),
CYVAXY
     1 IAND(Ieor(IYT,ME),IFLMST(IFLSTA+IFLSTW)))
      K=K+1
      IFLSTW=IFLSTW+1
      IF (IFLSTW .GE. IFLWPL) IFLSTW=0
 1150 CONTINUE
 1160 CONTINUE
C                       Zeichne jetzt das Polygon.
C
 1170 IF (IPERIM .EQ. 0) GO TO 9999
      ASSIGN 180 TO NRET2
      ASSIGN 1180 TO NRET3
      L=1
      NSTEU=3
      GO TO 1190
 1180 L=L+1
      IF (L .GT. IPOLPO) GO TO 9999
      NSTEU=2
 1190 XNEU=POLYGN(1,L)
      YNEU=POLYGN(2,L)
      GO TO 60
C                       Definition von Fuellmustern.
 1200 FLAKT=AR(1)
      AI=AR(2)
      J=IFLAKT*I+2
      IF (IFLEFP .GE. 10) GO TO 9999
      IFLEFP=IFLEFP+1
      L=IFLPOI(IFLEFP)
      IF (L+J-1 .LE. IFLDIM) GO TO 1210
      IFLEFP=IFLEFP-1
      GO TO 9999
C
 1210 DO 1220 K=1,J
      FLMST(L)=AR(K)
      L=L+1
 1220 CONTINUE
      IFLPOI(IFLEFP+1)=L
      AR(1)=0.
      GO TO 9999
C                         (25) 0: Polygon ohne Umrisslinie
 1230 AI=AR(1)
      IPERIM=I
C
 9999 RETURN
      END
