C                       ------------------------
                         FUNCTION VMV (X1,Q,X2)
C                       ------------------------
C
C     TRANSPOSED VECTOR * MATRIX * VECTOR
C     VMV=X1(3)*Q(3,3)*X2(3)    TO  EVALUATE QUADRATIC OR BILINEAR FORM
C
      IMPLICIT NONE
      REAL *4 X1(3),Q(3,3),X2(3),VMV
C
      INTEGER *4 J
      REAL    *4 T1
      T1=0.
      DO  J=1,3
        T1=T1+X1(J)*(X2(1)*Q(J,1)+X2(2)*Q(J,2)+X2(3)*Q(J,3))
      ENDDO
      VMV=T1
      RETURN
      END
