C                   ------------------------------
                     SUBROUTINE XYZ (IQA,XX,ITYPE)
C                   ------------------------------
C
C                  BEARBEITET: 171157 JAN 90 (HUNDT)
C
C
C     ***** ITYPE .GT.0 CART. COORD. FROM ATOM CODE WORD *****
C     ***** XABSF(ITYPE) .LE.2 FOR WORKING SYSTEM *****
C     ***** XABSF(ITYPE) .GT.2 FOR REFERENCE SYSTEM *****
C     ***** ITYPE .LE.0 USES TRICLINIC COORD. XT *****
C
      IMPLICIT NONE
      INTEGER *4 IQA,ITYPE
      REAL    *4 XX(3)
      INCLUDE 'KPORC.INC'
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 I,ITA,J,NG1
      REAL    *4 T1,T2
C
      ITA=IABS(ITYPE)-2
      NG1=NG
      NG=0
      IF (ITYPE .GT. 0) THEN
        CALL ATOM (IQA,XT)
        IF (NG .NE. 0) THEN
          DO  J=1,3
            XX(J)=0.
          ENDDO
          RETURN
        ENDIF
      ENDIF
      T1=0.
      DO  J=1,3
        T2=XT(J)-UR(J,NS)
        V1(J)=T2
        T1=T1+ABS(T2)
      ENDDO
      IF (T1 .LE. .0001) THEN
        NG=NG1
        DO  J=1,3
          XX(J)=0.
        ENDDO
        RETURN
      ENDIF
      IF (ITA .LE. 0) THEN
C
C     ***** RELATIVE TO WORKING SYSTEM *****
C
        DO  I=1,3
          XX(I)=(V1(1)*AAWRK(1,I,NS)+V1(2)*AAWRK(2,I,NS)+
     +    V1(3)*AAWRK(3,I,NS))*O9
        ENDDO
      ELSE
C
C     ***** RELATIVE TO REFERENCE SYSTEM *****
C
        DO  I=1,3
          XX(I)=(V1(1)*AAREV(1,I,NS)+V1(2)*AAREV(2,I,NS)+
     +    V1(3)*AAREV(3,I,NS))*O9
        ENDDO
      ENDIF
C
      RETURN
      END
