C                           ----------------
                             PROGRAM ZV0000
C  CY-RS6-DOS-              ----------------
C
C                 geaendert:  141539 APR 2006  (Hundt)
C
      IMPLICIT NONE
C
C                            Fundamental - COMMON
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
      INCLUDE 'RDBFR.INC'
C
      INTEGER*4 KARTE
      COMMON /KPFLIN/ KARTE(21)
C
      INTEGER *4 I,J
C
CYDOS1
      call main2
CYDOS2
C
      NTOSYS=0
C                            Dimensionen
      NATDM=PARDIM
      NCDDM=ATODIM
      IPKDM=IPKDIM
C
      ID2(1)=2
      ID2(2)=3
      ID2(3)=1
C
      DO  I=1,99
        ISKP(I)=0
      ENDDO
C                            FM Optionszahl
      ISKP(1)=31
C                            Abbruch-Character
      ISKP(20)=27
C                            Zahl der Codes im Kommando FM, bei dem
C                            abgebrochen werden kann
      ISKP(23)=150
C                            CHPL/CHHP
      ISKP(26)=1
C                            NPEN default
      ISKP(41)=15
C                            Nummer des Fuellmusters Default
      ISKP(47)=0
C                            STRD - Zahl der Pixel fuer Strich
      ISKP(49)=3
C                            Assume HF was done
CYDOS1
      ISKP(74)=1
CYDOS2
CYDOSY      ISKP(74)=0
C                            Makros mit abspeichern
      ISKP(86)=1
C
C                            Konstanten
      DO  I=1,100
        CONST(I)=0.
      ENDDO
      CONST(1)=3.141593
      CONST(2)=6.283185
      CONST(3)=1.745329E-2
      CONST(4)=57.29578
      CONST(7)=1.E-4
C                            Zeichenfeld-Abmessungen x,y,r
      CONST(8)=24.0
CYDOS1
      CONST(9)=24.0
CYDOS2
CYDOSY      CONST(9)=19.0
CYRS6Y      CONST(8)=33.6
CYRS6Y      CONST(9)=21.4
      CONST(10)=1.
C                            Definition des Zeichenfeldes UPLINF
      AIN(1)=0.
      AIN(2)=CONST(8)
      AIN(3)=0.
      AIN(4)=CONST(9)
      CALL UPLINF (AIN,14)
C                            Origin
      CONST(11)=CONST(8)*0.5
      CONST(12)=CONST(9)*0.5
C                            Abstand der Augen
      CONST(50)=6.3
C                            Zahl der Formeleinheiten
      CONST(51)=1.
C                            Wellenlnge Mo
      CONST(58)=0.71073
C                            Atomfarben
      DO  I=1,IATFDM
        DO  J=1,17
          IATF(J,I)=0
        ENDDO
        IATF(1,I)=ISKP(41)
        IATF(2,I)=ISKP(49)
        IATF(3,I)=ISKP(41)
        IATF(4,I)=ISKP(47)
        IATF(5,I)=ISKP(41)
        IATF(6,I)=ISKP(49)
        IATF(7,I)=1000
        IATF(9,I)=ISKP(41)
        IATF(10,I)=ISKP(49)
        IATF(11,I)=4
        IF (I .GT. 10) IATF(11,I)=1
        IATF(13,I)=8
      ENDDO
C
      NTIN=5
      NTOUT=6
      NS=0
      do  i=1,3
        grid(i)=100.
      enddo
C
      DO  I=1,5
        CONT(I)=SQRT(1./(2.*(1.+COS(CONST(1)/2.**I))))
      ENDDO
      CALL ZVMAIN
      STOP
      END
