CKPDRMO   60             -------------------
                          SUBROUTINE ZVDRMO
C  CY-ENG-               -------------------
C
C  Das gespeicherten Plotbefehle werden dahingehend ausgewertet, dass
C  eine Liste fuer den Bau eines Kugel- und Stabmodells erzeugt wird.
C
C                 geschrieben: 081030 DEC 1987  (Hundt)
C                 geaendert:   151553 MAY 2002  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,IAT(8,PARDIM,2),IBNDG,IBNDGO,IC1,IC1CD,IC2,IC2CD
      INTEGER *4 ICO,IDRFLG,IDRPOI,IERRFL,INBFR(3),IPKPNT,IPLTBF
      INTEGER *4 ISTACK(3,ATODIM),ISTMAX,ISTPOI,ITEMP,J,K,K1,K2,K3,K4
      INTEGER *4 KEYIN,L,LGLCH,IRLINE(30)
      REAL    *4 AINBFR(3),ARCCOS,DMAX,DRWRK(4,6),EW,STBLNG,TEMP,TEMP2
      REAL    *4 TEMP3,U,VQ(IPKDIM,2),W
C
      EQUIVALENCE (ATOMS(1,1,1),ISTACK(1,1)),(AINBFR(1),INBFR(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      DATA ISTMAX/ATODIM/,LGLCH/4H L: /
C
C  NTYP:  Kommando:
C   1      DRMO      Liste fuer Kugel- und Stabmodell erzeugen
C
C                            Schliesse vorsichtshalber NTSCR
      NTYP=NTSCR+100
      CALL ZVEAEH
      NTYP=NTSCR
      CALL ZVEAEH
C
      AINBFR(1)=2.5
      AINBFR(2)=CONST(34)
      INBFR(3)=0
      CALL FLES (AINBFR,ISKP(31),4H2FIE,
CYENG1
     1 33HFaktor,Resttiefe,Maschine (0/1)?$)
CYENG2
CYENGY     1 36HFactor,dist to midp.,machine (0/1)?$)
      WRITE (WRLINE,10) AINBFR(1),AINBFR(2),INBFR(3)
      CALL KPWRTE (NTSCR)
CYENG1
   10 FORMAT ('Skalenfaktor:',F7.3,' cm/A; Resttiefe:',F5.2,
     1 ' Maschinentyp:',I2)
CYENG2
CYENGY   10 FORMAT ('Scalingfactor:',F7.3,' cm/A; dist. to midpoint:',F5.2,
CYENGY     1 ' type of machine:',I2)
      AINBFR(2)=2.*AINBFR(2)
C
      IERRFL=0
      K8(NS)=0
      K9(NS)=0
      NC=1
      NTRY=42
C                            Starte Lauf.
      IC1=NCD(NS)+1
      ISTPOI=0
      IBNDG=0
      IBNDGO=0
C                            Setze Atom 1 um eins weiter
C
   20 IF (IC1-NCDA(NS)) 1320,1320,30
   30 IC1=IC1-1
      IC1CD=ICD(IC1,NS)
      IZ1=IC1CD/200000
      IF (KEYIN(0) .NE. ISKP(20)) GO TO 40
      IERR=-1
      GO TO 1320
C
C                            Atom2 = Atom1;  Auftrag: Kugel bohren
   40 IC=IC1
      IC2=IC1
      CALL ZVDEK
C                            Kartesische Koordinaten des aktuellen
C                            Atomes, das gebohrt wird.
      DO 50 I=1,3
   50 DRWRK(I,1)=X1(I)
      IDRFLG=0
      IDRPOI=ISTMAX+1
C                            Teste, ob Atom auf der Verbotsliste
C                            steht.
      IF (NPPOI(NS)) 90,90,60
   60 DO 80 I=1,NPPOI(NS),2
      IF (NPLST(I,NS)-IC1CD) 80,70,80
   70 IF (NPLST(I+1,NS)) 80,280,80
   80 CONTINUE
C                            Suche Plotbefehl fuer dieses Atom.
   90 IPKPNT=1
      GO TO 110
C                            Skip zum naechsten Plotbefehl
C
  100 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
      IF (IPKPNT-IPKP(NS)) 110,280,280
C
  110 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF-1) 100,120,100
C
C                            Befehl gefunden.  Teste Range.
C
  120 IF (IZ1-IPK(IPKPNT+2,NS)) 100,140,130
  130 IF (IZ1-IPK(IPKPNT+3,NS)) 140,140,100
C
  140 WRLINE=' '
      CALL KPWRTE (NTSCR)
      WRITE (WRLINE,150) IAT(5,IZ1,NS),IAT(6,IZ1,NS),IC1,(X(I,1),I=1,3)
      CALL KPWRTE (NTSCR)
CYENG1
  150 FORMAT ('Atom ',2A4,'   (',I3,')  einspannen.',3F8.4)
CYENG2
CYENGY  150 FORMAT ('Clamp atom ',2A4,'   (',I3,')  in.',3F8.4)
C
C                            Teste, ob hierzu Bindungen haengen.
C
      IF (ISTPOI) 280,280,160
  160 DO 180 I=1,ISTPOI
      IF (ISTACK(2,I)) 180,170,180
  170 IF (ISTACK(1,I)-IC1) 180,190,180
  180 CONTINUE
C                            Keine gefunden.
      GO TO 280
C                            Arbeite Stack auf.
  190 J=I
  200 IF (J-ISTPOI) 210,270,270
  210 J=J+1
      IF (ISTACK(2,J)) 220,260,220
C
  220 IC=ISTACK(1,J)
      CALL ZVDEK
C                            Speichere nach hinten um.
C
      IF (IDRPOI-3-ISTPOI) 230,230,240
  230 IERR=60023020
      GO TO 1320
C
  240 IDRPOI=IDRPOI-3
      DO 250 K=1,3
      ISTACK(K,IDRPOI)=ISTACK(K,J)
  250 ATOMS(K,IDRPOI+1,NS)=X1(K)-DRWRK(K,1)
      ATOMS(1,IDRPOI+2,NS)=0.
      ATOMS(2,IDRPOI+2,NS)=-1.
      ISTACK(3,IDRPOI+2)=IANR
      ISTACK(1,J)=0
      GO TO 200
C                            Komprimiere Stack.
  260 ISTACK(1,I)=ISTACK(1,J)
      ISTACK(2,I)=ISTACK(2,J)
      ISTACK(3,I)=ISTACK(3,J)
      I=I+1
      J=J+1
      IF (J-ISTPOI) 260,260,270
  270 ISTPOI=I-1
C                            Setze Atom 2 um eins weiter
C
  280 IF (IC2-NCDA(NS)) 740,740,290
C
C                            Auftrag: neuen Stab suchen
  290 IC2=IC2-1
      IC2CD=ICD(IC2,NS)
C                            Teste, ob Atom auf der Verbotsliste
C                            steht.
      IF (NPPOI(NS)) 350,350,300
  300 DO 340 I=1,NPPOI(NS),2
      IF (NPLST(I,NS)-IC1CD) 320,310,320
  310 IF (NPLST(I+1,NS)-IC2CD) 340,280,340
  320 IF (NPLST(I,NS)-IC2CD) 340,330,340
  330 IF (NPLST(I+1,NS)-IC1CD) 340,280,340
  340 CONTINUE
C
  350 IZ2=IC2CD/200000
      IC=IC2
      CALL ZVDEK
      IPKPNT=1
      GO TO 730
C
  360 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF .LT. 2) GO TO 720
      IF (IPLTBF .LT. 5) GO TO 420
      IF (IPLTBF .LT. 12) GO TO 720
      IF (IPLTBF .GT. 14) GO TO 720
C
C                            Verbinde direkt.  Teste, ob Paar
C                            im Befehl vorkommt.
      J=IPK(IPKPNT,NS)
      I=8
  370 IF (IPK(IPKPNT+I,NS) .EQ. IC1CD) GO TO 390
  380 I=I+1
      IF (I .LT. J) GO TO 370
      GO TO 720
C
  390 IF (IPK(IPKPNT+I+1,NS) .EQ. IC2CD) GO TO 400
      IF (IPK(IPKPNT+I-1,NS) .NE. IC2CD) GO TO 380
  400 TEMP=0.
      DO 410 I=1,3
      TEMP2=DRWRK(I,1)-X1(I)
      TEMP=TEMP+TEMP2*TEMP2
  410 CONTINUE
      GO TO 550
C                            Fuehre Plotbefehl aus.  Teste, ob Nummer
C                            in Frage kommt.
C
C                                        1. Atom = ur?
  420 IF (IZ1-IPK(IPKPNT+2,NS)) 460,440,430
  430 IF (IZ1-IPK(IPKPNT+3,NS)) 440,440,460
C                                        2. Atom = zl?
  440 IF (IZ2-IPK(IPKPNT+4,NS)) 460,500,450
  450 IF (IZ2-IPK(IPKPNT+5,NS)) 500,500,460
C                                        1. Atom = zl?
  460 IF (IZ1-IPK(IPKPNT+4,NS)) 720,480,470
  470 IF (IZ1-IPK(IPKPNT+5,NS)) 480,480,720
C                                        2. Atom = ur?
  480 IF (IZ2-IPK(IPKPNT+2,NS)) 720,500,490
  490 IF (IZ2-IPK(IPKPNT+3,NS)) 500,500,720
C
C                            Teste Abstandsintervall.
  500 DMAX=VQ(IPKPNT+7,NS)
      TEMP=0.
      DO 520 I=1,3
      TEMP2=ABS(DRWRK(I,1)-X1(I))
      IF (TEMP2-DMAX) 510,510,720
  510 TEMP=TEMP+TEMP2*TEMP2
  520 CONTINUE
C
      IF (TEMP-DMAX*DMAX) 530,530,720
  530 IF (TEMP-VQ(IPKPNT+6,NS)*VQ(IPKPNT+6,NS)) 720,540,540
  540 CONTINUE
C                            Neuen Stab gefunden.
  550 IF (TEMP) 560,560,580
  560 WRITE (WRLINE,570)
CYENG1
  570 FORMAT ('>>>>>> Atome',20X,
     1 ' haben Abstand 0. Ignoriert. <<<<<<')
CYENG2
CYENGY  570 FORMAT ('>>>>>> Atoms',20X,
CYENGY     1 ' have distance 0. Ignorerd. <<<<<<')
      CALL KPCDST (IRLINE,13,IC1CD)
      CALL KPCDST (IRLINE,23,IC2CD)
      CALL KPWRTE (NTDISP)
      IERRFL=1
      GO TO 720
C
  580 TEMP=SQRT(TEMP)
      IBNDG=IBNDG+1
C
      IF (IDRPOI-3-ISTPOI) 590,590,600
  590 IERR=60058020
      GO TO 1320
C
  600 IDRPOI=IDRPOI-3
      ISTACK(1,IDRPOI)=IC2
      ISTACK(2,IDRPOI)=-IBNDG
      ATOMS(3,IDRPOI,NS)=TEMP
      DO 610 K=1,3
  610 ATOMS(K,IDRPOI+1,NS)=X1(K)-DRWRK(K,1)
      ATOMS(1,IDRPOI+2,NS)=TEMP
      ATOMS(2,IDRPOI+2,NS)=-1.
      ISTACK(3,IDRPOI+2)=IANR
C
C                            Befindet sich das Zielatom bereits
C                            auf dem Stack?
  620 IF (ISTPOI) 670,670,630
  630 DO 650 I=1,ISTPOI
      IF (ISTACK(2,I)) 650,640,650
  640 IF (ISTACK(1,I)-IC2) 650,680,650
  650 CONTINUE
C                            Noch nicht.  Nimm auf.
C
      IF (ISTPOI+3-IDRPOI) 670,670,660
  660 IERR=60065020
      GO TO 1320
C
  670 ISTPOI=ISTPOI+2
      ISTACK(1,ISTPOI-1)=IC2
      ISTACK(2,ISTPOI-1)=0
      ATOMS(3,ISTPOI-1,NS)=0.
      I=ISTPOI
      GO TO 710
C                            Gefunden.  Inserte Bindung.
C
  680 IF (ISTPOI+1-IDRPOI) 690,660,660
  690 ISTPOI=ISTPOI+1
      J=ISTPOI
      I=I+1
  700 ISTACK(1,J)=ISTACK(1,J-1)
      ISTACK(2,J)=ISTACK(2,J-1)
      ISTACK(3,J)=ISTACK(3,J-1)
      J=J-1
      IF (J-I) 710,710,700
  710 ISTACK(1,I)=IC1
      ISTACK(2,I)=-IBNDG
      ATOMS(3,I,NS)=TEMP
      GO TO 280
C                            Skip zum naechsten Plotbefehl.
C
  720 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  730 IF (IPKPNT-IPKP(NS)) 360,280,280
C
C                            Werte Ergebnisse des Durchgangs aus.
C                            Berechne kleinste auftretende Winkel.
C
  740 J=IDRPOI-2
      IF (IDRPOI+6-ISTMAX) 750,900,900
  750 J=J+3
      I=J
  760 I=I+3
      TEMP=(ATOMS(1,J,NS)*ATOMS(1,I,NS)+ATOMS(2,J,NS)*ATOMS(2,I,NS)
     1 +ATOMS(3,J,NS)*ATOMS(3,I,NS))/(ATOMS(3,J-1,NS)*ATOMS(3,I-1,NS))
      IF (TEMP-ATOMS(2,I+1,NS)) 780,780,770
  770 ATOMS(2,I+1,NS)=TEMP
  780 IF (TEMP-ATOMS(2,J+1,NS)) 800,800,790
  790 ATOMS(2,J+1,NS)=TEMP
C
  800 IF (I+3-ISTMAX) 760,810,810
  810 IF (J+6-ISTMAX) 750,820,820
C
C                            Suche das Atom heraus, das den groessten
C                            Winkel zu allen anderen hat und tausche
C                            es mit dem ersten um.
  820 I=IDRPOI+2
  830 J=I
      TEMP=ATOMS(2,J,NS)
  840 I=I+3
      IF (I-ISTMAX) 850,850,860
  850 IF (ATOMS(2,I,NS)-TEMP) 830,840,840
  860 I=IDRPOI+2
      IF (J-I) 870,900,870
  870 DO 890 K=1,3
      DO 880 L=1,3
      ITEMP=ISTACK(L,I)
      ISTACK(L,I)=ISTACK(L,J)
  880 ISTACK(L,J)=ITEMP
      I=I-1
      J=J-1
  890 CONTINUE
C                            Werte Stack aus.
  900 J=IDRPOI-3
  910 J=J+3
      IF (J-ISTMAX) 920,20,20
  920 IF (IDRFLG) 930,930,940
  930 IDRFLG=2
      GO TO 970
C
  940 IF (IDRFLG-3) 950,960,970
  950 IDRFLG=3
      GO TO 970
C
  960 IDRFLG=5
C
  970 DO 980 K=1,3
  980 DRWRK(K,IDRFLG)=ATOMS(K,J+1,NS)
      ICO=ISTACK(1,J)
      ITEMP=ISTACK(2,J)
      IF (ITEMP) 990,1030,1030
  990 IBNDGO=IBNDGO+1
      DO 1000 K=1,ISTPOI
      IF (ISTACK(2,K)-ITEMP) 1000,1010,1000
 1000 CONTINUE
      GO TO 1020
C
 1010 ISTACK(2,K)=IBNDGO
 1020 ITEMP=IBNDGO
C
 1030 DRWRK(4,IDRFLG)=ATOMS(3,J,NS)
      TEMP=ATOMS(1,J+2,NS)
      IANR=ISTACK(3,J+2)
C                            Berechne Bohrwinkel.
C
      IF (IDRFLG-3) 1040,1080,1080
 1040 IF (TEMP) 1070,1070,1050
 1050 STBLNG=TEMP*AINBFR(1)-AINBFR(2)
C
      WRITE (WRLINE,1060) IAT(5,IANR,NS),IAT(6,IANR,NS),ICO,ITEMP,
     1 LGLCH,STBLNG
      CALL KPWRTE (NTSCR)
CYENG1
 1060 FORMAT ('---> ',2A4,' (Nr.',I4,')',25X,'St-Nr.',I4,A3,F6.2)
CYENG2
CYENGY 1060 FORMAT ('---> ',2A4,' (No.',I4,')',25X,'St-No.',I4,A3,F6.2)
      GO TO 910
C
 1070 WRITE (WRLINE,1060) IAT(5,IANR,NS),IAT(6,IANR,NS),ICO,ITEMP
      CALL KPWRTE (NTSCR)
      GO TO 910
C
 1080 TEMP2=0.
      TEMP3=0.
      K4=IDRFLG+1
      DO 1090 K1=1,3
      K2=ID2(K1)
      K3=ID2(K2)
      U=DRWRK(K2,IDRFLG)*DRWRK(K3,2)-DRWRK(K3,IDRFLG)*DRWRK(K2,2)
      DRWRK(K1,K4)=U
      TEMP2=TEMP2+U*U
      TEMP3=TEMP3+DRWRK(K1,IDRFLG)*DRWRK(K1,2)
 1090 CONTINUE
      DRWRK(4,K4)=SQRT(TEMP2)
      EW=0.
      W=TEMP3/(DRWRK(4,2)*DRWRK(4,IDRFLG))
      IF (W+0.999999) 1120,1120,1100
 1100 IF (W-0.999999) 1150,1110,1110
C
C                            Grenzfaelle: W=0
 1110 W=0.
      GO TO 1130
C                            W=180
 1120 W=180.
 1130 IF (IDRFLG-3) 1170,1140,1170
 1140 IDRFLG=2
      GO TO 1170
C
 1150 CONTINUE
      W=ARCCOS(W)
      IF (W) 1160,1170,1170
 1160 W=W+360.
 1170 IF (INBFR(3) .EQ. 1) GO TO 1180
C
C                            Umrechnung fuer Bonn
      W=90.-W
      IF (W .LT. 0.) W=W+360.
 1180 IF (IDRFLG-5) 1270,1190,1270
C
C                            Berechne Erhebungswinkel.
C
 1190 TEMP3=DRWRK(4,4)*DRWRK(4,6)
      IF (TEMP3) 1200,1270,1200
 1200 TEMP2=0.
      DO 1210 K1=1,3
      K2=ID2(K1)
      K3=ID2(K2)
      TEMP2=TEMP2+
     1 (DRWRK(K2,4)*DRWRK(K3,6)-DRWRK(K3,4)*DRWRK(K2,6))*DRWRK(K1,2)
      EW=EW+DRWRK(K1,4)*DRWRK(K1,6)
 1210 CONTINUE
C
      EW=EW/TEMP3
      IF (EW+1.) 1220,1220,1230
 1220 EW=180.
      GO TO 1270
 1230 IF (EW-1.) 1250,1240,1240
 1240 EW=0.
      GO TO 1270
C
 1250 EW=ARCCOS(EW)
      IF (TEMP2) 1270,1270,1260
 1260 EW=360.-EW
C                            Rechne ggf. fuer Maschine Bayreuth um.
C
 1270 IF (INBFR(3) .EQ. 0) GO TO 1280
      IF (EW .EQ. 0.) GO TO 1280
      EW=360.-EW
C
 1280 IF (TEMP) 1310,1310,1290
 1290 STBLNG=TEMP*AINBFR(1)-AINBFR(2)
C
C                            W: Winkel an der Marke an der Bohrnadel
C                            EW: Winkel am senkrechten Rad
C
      WRITE (WRLINE,1300) IAT(5,IANR,NS),IAT(6,IANR,NS),ICO,W,EW,ITEMP,
     1 LGLCH,STBLNG
      CALL KPWRTE (NTSCR)
CYENG1
 1300 FORMAT ('---> ',2A4,' (Nr.',I4,') W:',F6.1,' Erh.-W.:',F6.1,
     1 ' St-Nr.',I4,A3,F6.2)
CYENG2
CYENGY 1300 FORMAT ('---> ',2A4,' (No.',I4,') A:',F6.1,' Coil-A.:',F6.1,
CYENGY     1 ' St-No.',I4,A3,F6.2)
      GO TO 910
C
 1310 WRITE (WRLINE,1300) IAT(5,IANR,NS),IAT(6,IANR,NS),ICO ,W,EW,ITEMP
      CALL KPWRTE (NTSCR)
      GO TO 910
C
 1320 IF (IERRFL) 1330,1350,1330
 1330 WRITE (WRLINE,1340)
      CALL KPWRTE (NTSCR)
CYENG1
 1340 FORMAT ('********** W A R N U N G !  Abstaende mit Laenge 0 ignor
     1iert.')
CYENG2
CYENGY 1340 FORMAT ('********** W A R N I N G !  Zero-distances ignored.')
C
 1350 NTYP=NTSCR+100
      CALL ZVEAEH
      RETURN
      END
