CKPFKTR   29             -------------------
                          SUBROUTINE ZVFKTR
C  CY-ENG-               -------------------
C
C                        Geschrieben:  Hundt
C                 Geaendert: 241703 MAR 2004  (Hundt)
C
C           Kommando  NTYP  Bedeutung
C           BF          1   Bestimme Faktor
C           AF          2   Aendere Faktor
C           ZF          3   Zeichenfeld Definition
C           UR          4   Ursprungspunkt Definition
C           OZB         5   Drucke Zeichenfeldbedingungen
C           HF          6   Halbiere Zeichenfeld
C           DF          7   Verdopple Zeichenfeld
C           XZF         8   Tausche ZF mit gesp. ZF um
C
C                        -------------------
C
      IMPLICIT NONE
C
      REAL*4    ZFSV(3),XMIN,XMAX,YMIN,YMAX,TEMP,TA,T1,T2
      INTEGER*4 I,IZFSV(2),NSSV
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
C
      REAL*4    APK(IPKDIM,2)
      SAVE ZFSV,IZFSV
C
      EQUIVALENCE (IPK(1,1),APK(1,1))
C
      DATA ZFSV/19.90,27.09,1.5/,IZFSV/4,0/
C
      NSSV=NS
      GO TO (10, 140, 240, 280, 290, 190, 200, 220), NTYP
C             1    2    3    4    5    6    7    8
C
C                            Berechne freie Koordinaten.
   10 K8(NS)=0
      NTRY=44
      NC=1
      GO TO 40
   30 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,K9(NS),NS)=X2(I)
      ENDDO
   40 IF (K9(NS) .LT. NCD(NS)) GO TO 30
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 10
      ENDIF
      NS=NSSV
C
C                            BF. Bestimme maximale Punkte.
      XMIN=1.E6
      XMAX=-1.E6
      YMIN=1.E6
      YMAX=-1.E6
   45 IF (NCD(NS) .LE. NCDA(NS)) THEN
        IERR=29006018
        GO TO 999
      ENDIF
C
      DO  I=NCDA(NS),NCD(NS)
        TEMP=HOE/(HOE-ATOMS(3,I,NS))
        TA=ATOMS(1,I,NS)*TEMP
        XMIN=AMIN1(XMIN,TA)
        XMAX=AMAX1(XMAX,TA)
        TA=ATOMS(2,I,NS)*TEMP
        YMIN=AMIN1(YMIN,TA)
        YMAX=AMAX1(YMAX,TA)
      ENDDO
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 45
      ENDIF
      NS=NSSV
C                            Durchsuche jetzt noch die plotbefehle
C                            nach 'BT'.
   48 NC=1
      NTRY=28
      I=1
   50 IF (I .GE. IPKP(NS)) GO TO 70
      IF (IPK(I+1,NS) .NE. 6) GO TO 60
        IF ((IPK(I+2,NS) .EQ. IPK(I+3,NS)) .OR. IPK(I+3,NS) .EQ. 0) THEN
          ICDS(1)=IPK(I+2,NS)
          CALL ZVDEK
          IF (IERR .NE. 0) THEN
            IERR=29 0079 09
            GO TO 999
          ENDIF
          TEMP=HOE/(HOE-X2(3))
C         TA=(X2(1)+APK(I+4))*TEMP+CONST(10)*.2
C         XMIN=AMIN1(XMIN,TA)
C         XMAX=AMAX1(XMAX,TA)
          TA=(X2(2)+APK(I+5,NS))*TEMP+CONST(10)*0.2
          YMIN=AMIN1(YMIN,TA)
          YMAX=AMAX1(YMAX,TA)
        ENDIF
   60   I=I+IPK(I,NS)
        GO TO 50
   70 IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 48
      ENDIF
      NS=NSSV
C
      TA=CONST(8)-2.*CONST(10)
      TEMP=XMAX-XMIN
      IF (TEMP .LE. 0.) TEMP=0.00001
      T1=TA/TEMP
      TA=CONST(9)-2.*CONST(10)
      TEMP=YMAX-YMIN
      IF (TEMP .LE. 0.) TEMP=0.00001
      T2=TA/TEMP
      TEMP=AMIN1(T1,T2)
      O9=TEMP
      SCL=CONST(43)*O9
C                            Ursprungspunkt.
C
      CONST(11)=(-(XMIN+XMAX)*O9+CONST(8))*.5
      CONST(12)=(-(YMIN+YMAX)*O9+CONST(9))*.5
  135 XO(1)=CONST(11)
      XO(2)=CONST(12)
      GO TO 999
C                            AF - Hole Increment.
  140 AIN(1)=1.
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (AIN,ISKP(31),2HFE,8HFaktor?$)
CYENG2
CYENGY        CALL FLES (AIN,ISKP(31),2HFE,8HFactor?$)
      ENDIF
      TEMP=AIN(1)*O9
      IF (TEMP .LE. 0.) THEN
        IERR=29014021
        GO TO 999
      ENDIF
      O9=TEMP
      SCL=CONST(43)*O9
      GO TO 999
C                            Kommandos HF und DF
  190 ISKP(59)=3
      IF (ISKP(74) .EQ. 1) GO TO 999
      ISKP(74)=1
      AIN(1)=.5
      IF (AIN(1)*CONST(8) .GT. 2.*CONST(10)) GO TO 210
      GO TO 272
C
  200 ISKP(59)=4
      IF (ISKP(74) .EQ. 0) GO TO 999
      ISKP(74)=0
      AIN(1)=2.
  210 I=8
      IF (ISKP(13) .NE. 0) I=9
      CONST(I)=CONST(I)*AIN(1)
      O9=O9*AIN(1)
      SCL=CONST(43)*O9
      CONST(11)=CONST(11)*AIN(1)
      XO(1)=CONST(11)
      GO TO 270
C                            Kommando XZF.
  220 DO  I=1,3
        TEMP=CONST(I+7)
        CONST(I+7)=ZFSV(I)
        ZFSV(I)=TEMP
      ENDDO
      I=ISKP(59)
      ISKP(59)=IZFSV(1)
      IZFSV(1)=I
      I=ISKP(74)
      ISKP(74)=IZFSV(2)
      IZFSV(2)=I
      GO TO 270
C                            Kommando ZF.
C
  240 DO  I=1,3
        ZFSV(I)=CONST(I+7)
      ENDDO
      IZFSV(1)=ISKP(59)
      IZFSV(2)=ISKP(74)
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (CONST(8),ISKP(31),3H3FE,10Hx,y,Rand?$)
CYENG2
CYENGY        CALL FLES (CONST(8),ISKP(31),3H3FE,12Hx,y,border?$)
        DO  I=8,9
          IF (CONST(I) .LE. 2.*CONST(10)) GO TO 263
        ENDDO
      ENDIF
  270 CALL UPLINF (CONST(8),27)
      IF (NTYP-6) 999,310,310
C                            Restore Zeichenfeldparameter
  263 DO  I=1,3
        CONST(I+7)=ZFSV(I)
      ENDDO
C
  272 CALL FLES(AIN,AIN,1HK,2H?$)
      WRITE (WRLINE,274)
      CALL KPWRTE (NTDISP)
CYENG1
  274 FORMAT ('ZVFKTR0272 - X oder Y des Zeichenfeldes wird zu klein.')
CYENG2
CYENGY  274 FORMAT ('ZVFKTR0141 - X or Y of the drawing area becomes too smal
CYENGY     +l.')
      IERR=-1
      GO TO 999
C                            UR
C
  280 CALL FLES (CONST(11),ISKP(31),3H2FE,5Hx,y?$)
      GO TO 135
C                            OZB
  290 TEMP=HOE*O9
      WRITE (WRLINE,'(A,F7.2,A,F7.2,A,F6.2,A)')
CYENG1
     1 ' Zeichenfeld:',CONST(8),' cm mal',CONST(9),' cm mit',
     2 CONST(10),' cm Rand'
CYENG2
CYENGY     1 'Drawing area:',CONST(8),' cm by',CONST(9),' cm;',
CYENGY     2 CONST(10),' cm border'
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,'(A,F6.2,A,F6.2,A,F7.3,A)')
CYENG1
     1 ' Ursprung:',CONST(11),',',CONST(12),'; Skalenfaktor:',
     2 O9,' cm/A'
CYENG2
CYENGY     1 'Origin:',CONST(11),',',CONST(12),'; Scaling factor:',
CYENGY     2 O9,' cm/A'
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,'(A,E10.3,A,F6.2,A)')
CYENG1
     1 ' Betrachterabstand:',TEMP,' cm; Schrifthoehe:',CONST(15),' A'
CYENG2
CYENGY     1 'Viewing distance:',TEMP,' cm; size of chars:',CONST(15),' A'
      CALL KPWRTE (NTDISP)
C
  310 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (AIN,ISKP(31),1HE,2H?$)
      ENDIF
C
  999 NS=NSSV
      RETURN
      END
