C         25             -------------------
                          SUBROUTINE ZVGE03
C  CY-ENG-               -------------------
C
C   Kommando  NTYP  Bedeutung
C   PVA         1   Punkt durch Vektor und Abstand
C   VPV         2   Verschiebe Punkt um Vektorbetrag
C   VP          3   Verschiebe Punkt
C   AMC         4   Addiere mehrere Codes
C   WA          5   Welches Atom?
C   WV          6   Welche Verschiebung?
C   ACAL        7   Addiere Codes als Atome in Parameterliste
C   VNRM        8   Vektor normieren
C   AV          9   Addiere Verschiebung
C   WTB        10   Welche trikline Box?
C   WARP       11   Welcher Punkt relativ zum freien Punkt?
C   FDG        12   Faktor direkt auf Gruppe anwenden.
C   FRG        13   Faktor reziprok auf Gruppe anwenden.
C   QDG        14   Quotient direkt auf Gruppe
C   BAM        15   Beschrifte Atome mit Maus
C   BTM        16   Beschrifte mit Text mit Maus
C   VGV        17   Verschiebe Gruppe um Vektorbetrag
C   VG         18   Verschiebe Gruppe
C   GREL       19   Verschiebe Gruppe relativ
C   BVLM       20   Beschrifte Vektor mit Laenge
C   -          21   Hinterlegt Defaults fuer VG und VGV
C
C                         Geschrieben: Hundt
C                   Geaendert: 251041 NOV 2012  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *1 I1AIN(288)
      INTEGER *4 I,J,K,L,M,II,NRET,ITYP,IMCL,INRCD,NWRT,NSSV
      INTEGER *4 IAIN(72),IVGBFR(6),MSFRM(5),IBVL(2),KDR,IPKPB,NTYPS
      REAL    *4 DELMRK(8),CDS(7),AMSFRM(5),VQ(IPKDIM,2),BLANK,ANG
      REAL    *4 VGBFR(6),GRELBF(7),XQ,YP,TEMP,TEMP2,TEMP3,TOL
C
      EQUIVALENCE (AIN(1),IAIN(1),I1AIN(1))
      EQUIVALENCE (AIN(1),IAIN(1)),(CDS(1),ICDS(1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (VGBFR(1),IVGBFR(1)),(AMSFRM(1),MSFRM(1))
C
      SAVE VGBFR,GRELBF,IBVL
C
      DATA KDR/4HR   /,MSFRM/0,1,2,3,4/,IBVL/0,2/
      DATA DELMRK/-.3,.3, .3,-.3, -.3,-.3, .3,.3/
      DATA GRELBF/0.,0.,0.,0.,0.,1.,4HR   /,BLANK/4H    /
C
      NSSV=NS
      ANG=0.
      IPKPB=0
      NTYPS=NTYP
      GO TO (10,200,180,510,600,600,450,1000,990,1090,1260,1290,1290,
C             1   2   3   4   5   6   7    8   9   10   11   12   13
     +      1290,591,940,150,160,381,932,20), NTYPS
C             14  15  16  17  18  19  20 21
C
C                            Kommando PVA.
   10 CDS(4)=CONST(5)
CYENG1
      CALL FLES (CDS,ISKP(31),4H3CFE,20Hcpkt,p1,p2,Abstand?$)
CYENG2
CYENGY      CALL FLES (CDS,ISKP(31),4H3CFE,17Hcpnt,p1,p2,dist?$)
C
C                            Berechne freie Koordinaten der Codes.
      NTRY=28
      DO  NC=1,3
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        DO  J=1,3
          X(J,NC)=X2(J)
        ENDDO
      ENDDO
C                            Berechne Laenge der Vektoren.
      DO  I=5,9
        AIN(I)=0.
      ENDDO
      DO  I=1,3
        AIN(10)=X(I,1)-X(I,2)
        AIN(5)=AIN(5)+AIN(10)*AIN(10)
        AIN(10)=X(I,1)-X(I,3)
        AIN(6)=AIN(6)+AIN(10)*AIN(10)
        AIN(10)=X(I,3)-X(I,2)
        AIN(7)=AIN(7)+AIN(10)*AIN(10)
        X1(I)=AIN(10)
      ENDDO
      IF (AIN(7) .LE. 0.) THEN
C
C                            Nullvektor.
        IERR=25 0094 06
        GO TO 9999
      ENDIF
C
      AIN(9)=CDS(4)*CDS(4)
      AIN(8)=SQRT(AIN(7))
      AIN(10)=(AIN(7)+AIN(5)-AIN(6))/(2.*AIN(8))
      AIN(11)=AIN(9)-AIN(5)+AIN(10)*AIN(10)
      IF (AIN(11) .LT. 0.) THEN
C
C                            Es existiert kein Schnittpunkt.
        IERR=25 0105 15
        GO TO 9999
      ENDIF
C
      AIN(11)=(AIN(10)+SQRT(AIN(11)))/AIN(8)
C
C                            Berechne neue Koordinaten.
      DO  I=1,3
        PFREI(I)=X(I,2)+AIN(11)*X1(I)
      ENDDO
      GO TO 370
C                            Hinterlege defaults (VG und VGV)
   20 IVGBFR(1)=IAIN(2)
      IVGBFR(2)=NAT(NS)
      GO TO 9999
C                            Kommandos VGV und VG
  150 VGBFR(5)=1.
      GO TO 170
  160 VGBFR(5)=CONST(5)
C
  170 VGBFR(6)=CONST(38)
CYENG1
      CALL FLES (VGBFR,ISKP(31),5H4CFAE,26Hvon,bis,p1,p2,Betrag,opt?$)
CYENG2
CYENGY      CALL FLES (VGBFR,ISKP(31),5H4CFAE,26Hfrom,to,p1,p2,amount,opt?$)
      CALL CNVTUP (VGBFR,21,4)
      ICDS(1)=IVGBFR(3)
      ICDS(2)=IVGBFR(4)
      CDS(3)=VGBFR(5)
      GO TO 230
C                            Kommando VP
C
  180 IF (ISKP(14) .NE. 0) GO TO 230
      CDS(3)=CONST(5)
      GO TO 220
C                            Kommandos VPV und VP.
C
  200 IF (ISKP(14) .NE. 0) GO TO 230
      CDS(3)=1.
CYENG1
  220 CALL FLES (CDS,ISKP(31),4H2CFE,14Hp1,p2,Betrag?$)
CYENG2
CYENGY  220 CALL FLES (CDS,ISKP(31),4H2CFE,14Hp1,p2,amaunt?$)
  230 NTRY=28
      DO  NC=1,2
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        DO  I=1,3
          X(I,NC+3)=X2(I)
        ENDDO
      ENDDO
C                            Vektor und Laenge.
      AIN(7)=0.
      DO  I=1,3
        AIN(10)=X(I,5)-X(I,4)
        X1(I)=X(I,2)-X(I,1)
        AIN(7)=AIN(7)+AIN(10)*AIN(10)
        X(I,3)=AIN(10)
      ENDDO
      IF (AIN(7) .LE. 0.) THEN
        AIN(11)=0.
        GO TO 340
      ENDIF
C
      IF (NTYPS-3) 320,330,310
  310 IF (NTYPS-18) 320,330,9999
C
C                            Kommando VPV / VGV
  320 AIN(11)=CDS(3)
      GO TO 340
C                            Kommando VP / VG
  330 AIN(11)=CDS(3)/SQRT(AIN(7))
  340 IF (NTYPS-17) 350,390,390
  350 DO  I=1,3
        PFREI(I)=PFREI(I)+X(I,3)*AIN(11)
      ENDDO
C
  370 DO  I=1,3
        PTRIKL(I)=TRAINV(I,1,NS)*PFREI(1)+TRAINV(I,2,NS)*PFREI(2)
     1  +TRAINV(I,3,NS)*PFREI(3)+UR(I,NS)
      ENDDO
      GO TO 9999
C                            Kommando GREL
C
  381 GRELBF(7)=CONST(38)
CYENG1
      CALL FLES (GRELBF,ISKP(31),6H2I4FAE,21Hvon,bis,x,y,z,f,opt?$)
CYENG2
CYENGY      CALL FLES (GRELBF,ISKP(31),6H2I4FAE,21Hfrom,to,x,y,z,f,opt?$)
      CALL CNVTUP (GRELBF(7),1,4)
      VGBFR(1)=GRELBF(1)
      VGBFR(2)=GRELBF(2)
      VGBFR(6)=GRELBF(7)
      IF (IVGBFR(1) .LE. 0) GO TO 383
      IF (IVGBFR(2) .GT. NAT(NS)) GO TO 383
      IF (IVGBFR(1) .LE. IVGBFR(2)) GO TO 384
  383 IERR=25 0202 16
      GO TO 9999
C
  384 DO  I=1,3
        X1(I)=TRAINV(I,1,NS)*GRELBF(3)+TRAINV(I,2,NS)*GRELBF(4)+
     +        TRAINV(I,3,NS)*GRELBF(5)
      ENDDO
      AIN(11)=GRELBF(6)
C
  390 J=IVGBFR(1)-1
      IF (J) 410,400,400
  400 K=NAT(NS)-J
      IF (IVGBFR(6) .EQ. KDR) K=0
      IF (IVGBFR(2)+K-NATDM) 420,420,410
  410 IERR=25 0216 16
      GO TO 9999
C
  420 J=J+1
      DO  I=1,3
        AT(I,J+K,NS)=AT(I,J,NS)+X1(I)*AIN(11)
        AT(I+3,J+K,NS)=AT(I+3,J,NS)
        DO  II=1,3
          TFVKT(II,I,J+K,NS)=TFVKT(II,I,J,NS)
        ENDDO
      ENDDO
      AT(7,J+K,NS)=AT(5,J,NS)
      CALL CNVTUP (AT(7,J+K,NS),1,4)
      ICLRP(J+K,NS)=ICLRP(J,NS)
      IPFLG(J+K,NS)=IPFLG(J,NS)
      IF (J-IVGBFR(2)) 420,440,440
  440 IF (IVGBFR(6) .NE. KDR) NAT(NS)=J+K
      GO TO 9999
C                            Kommando ACAL - Addiere Codes
C                            in Parameterliste
C
  450 IF (ISKP(14) .NE. 0) GO TO 490
      IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),3H2IE,30Hvon,bis (Pos. in Codeliste)? $)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H2IE,30Hfrom,to (pos. in code list)? $)
      IF (IAIN(1)) 480,480,460
  460 IF (IAIN(2)-NCD(NS)) 470,470,480
  470 IF (IAIN(1)-IAIN(2)) 490,490,480
  480 IERR=25 0245 16
      GO TO 9999
C
  490 NRET=1
      NC=1
      NTRY=40
      IC=IAIN(1)-1
  500 IC=IC+1
      IF (IC-IAIN(2)) 550,550,9999
C
C                            Kommando AMC - Addiere mult. Codes
C
C                            Loesche Eingabebereich.
  510 DO  I=1,72
        IAIN(I)=0
      ENDDO
C                            Hole Codes.
C
      CALL FLES (AIN,ISKP(31),4H72CE,11Hc1,c2,...?$)
C
C                            Setze Entries.
      NC=1
      NTRY=24
      NRET=0
C                            Durchlaufe Eingabe
      I=0
  530 I=I+1
C                            Teste auf Ende.
C
      IF (I-ISKP(31)) 535,535,9999
  535 IF (IAIN(I)) 540,536,540
  536 IAIN(I)=I
      NTYP=7
      CALL ZVGC01 (IAIN(I))
  540 CDS(1)=AIN(I)
C                            Berechne trikline Koordinaten.
  550 CALL ZVDEK
      IF (IERR) 9999,560,9999
  560 IF (NAT(NS)-NATDM) 580,570,570
C
C                            Atomliste ist voll.
  570 IERR=25 0286 02
      GO TO 9999
C                            Addiere.
  580 NAT(NS)=NAT(NS)+1
      AT(1,NAT(NS),NS)=X(1,1)
      AT(2,NAT(NS),NS)=X(2,1)
      AT(3,NAT(NS),NS)=X(3,1)
      AT(4,NAT(NS),NS)=AT(4,IANR,NS)
      AT(5,NAT(NS),NS)=AT(5,IANR,NS)
      AT(6,NAT(NS),NS)=AT(6,IANR,NS)
      AT(7,NAT(NS),NS)=AT(5,IANR,NS)
      CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
      ICLRP(NAT(NS),NS)=ICLRP(IANR,NS)
      IPFLG(NAT(NS),NS)=IPFLG(IANR,NS)
      IF (IPFLG(NAT(NS),NS) .NE. 0) THEN
        DO  M=1,3
          K=1
          DO  L=1,3
            S(L,M)=SYM(K+1,ISYNR,NS)*TFVKT(1,M,IANR,NS)+
     +      SYM(K+2,ISYNR,NS)*TFVKT(2,M,IANR,NS)+
     +      SYM(K+3,ISYNR,NS)*TFVKT(3,M,IANR,NS)
            K=K+4
          ENDDO
        ENDDO
        DO  M=1,3
          DO  L=1,3
            TFVKT(L,M,NAT(NS),NS)=S(L,M)
          ENDDO
        ENDDO
      ENDIF
      IF (NRET) 9999,590,500
  590 IF (I-72) 530,9999,9999
C
  585 WRITE (WRLINE,'(A)')
CYENG1
     +'ZVGE030322 - PLT darf nicht 2 sein.'
CYENG2
CYENGY     +'ZVGE030322 - PLT may not be 2.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 9999
C                            BAM - Beschrifte Atom mit Maus
C                            Generiere Header, wenn moeglich.
C
  591 IF (ISKP(7) .GT. 1) GO TO 585
      IF (IPKP(NS)+8 .LE. IPKDM) GO TO 592
      IERR=25 0321 11
      GO TO 1450
C
  592 IPKPB=IPKP(NS)+1
      IPK(IPKP(NS)+1,NS)=5
      IPK(IPKP(NS)+2,NS)=5
      IPK(IPKP(NS)+3,NS)=ISKP(41)
      IPK(IPKP(NS)+4,NS)=ISKP(49)
      IPKP(NS)=IPKP(NS)+5
C
C                            Hole die Koordinaten des graph. Cursors
  600 CONTINUE
C       CALL FLES (AIN(3),ISKP(31),3H2FE,5Hx,y?$)
C       AIN(5)=ISKP(31)
      CALL UPLINF (AIN,8)
      ITYP=IAIN(4)
C
C                            V oder v: Verschiebung
C
      IF (ITYP .EQ.118) ITYP=86
      IF (ITYP .EQ. 86) GO TO 800
C
C                            rechte Maustaste: Abbruch
C
      IF (ITYP .NE. 33) GO TO 620
      WRITE (WRLINE,610)
      CALL KPWRTE (NTDISP)
  610 FORMAT (' ')
      GO TO 1450
C                            Durchsuche Code-Liste
C
  620 IF (NTYPS-5) 9999,650,630
  630 IF (NTYPS-15) 9999,650,640
  640 IF (NTYPS-16) 650,650,645
  645 IF (NTYPS-20) 650,650,9999
  650 XQ=(AIN(1)-CONST(11))/O9
      YP=(AIN(2)-CONST(12))/O9
      J=IAIN(4)
  660 IMCL=NCD(NS)
      IF (NCDA(NS)-NCD(NS)) 690,690,670
  670 IERR=25 0361 12
      GO TO 9999
C
  690 TEMP=HOE/(HOE-ATOMS(3,IMCL,NS))
      IANR=ICD(IMCL,NS)/200000
      TOL=AT(4,IANR,NS)*TEMP*FKGL
      TEMP2=ABS(ATOMS(1,IMCL,NS)*TEMP-XQ)
      IF (TEMP2 .GT. TOL) GO TO 700
      TEMP3=ABS(ATOMS(2,IMCL,NS)*TEMP-YP)
      IF (TEMP3 .GT. TOL) GO TO 700
      IF (TEMP2*TEMP2+TEMP3*TEMP3 .LE. TOL*TOL) GO TO 720
  700 IMCL=IMCL-1
      IF (IMCL .GE. NCDA(NS)) GO TO 690
      IF (ISKP(7) .GT. 1) THEN
        NS=3-NS
        IF (NS .NE. NSSV) GO TO 660
      ENDIF
CYENG1
      WRITE (WRLINE,'(A)') ' >>>>>>>>>>>>>>>>>>>>>> Kein Atom in der Nae
     1he. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') ' >>>>>>>>>>>>>>>>>>>>>> No atom in vicinity.
CYENGY     1 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
      CALL KPWRTE (NTDISP)
      GO TO 600
C
  720 IAIN(1)=IMCL
      IAIN(2)=IMCL
      ISKP(14)=2
      ISKP(32)=0
      NTYP=4
      CALL ZVO
C                            Bringe Koordinaten aufs Punktregister
      DO 730 I=1,3
      PTRIKL(I)=X(I,1)
  730 PFREI(I)=X2(I)
      NC=1
      NTRY=1
      CALL ZVDEK
      CONST(27)=CDS(1)
      CONST(28)=CDS(1)
      ISKP(14)=0
      IF (NTYPS .EQ. 15) GO TO 820
      IF (NTYPS .EQ. 16) GO TO 950
      IF (NTYPS .EQ. 20) GO TO 950
C
C                            Linke Maustaste: Wdh.
C
  740 IF (J .EQ. 32) THEN
        NS=NSSV
        GO TO 600
      ENDIF
C
C                            N oder n: neuer Name
      IF (J .EQ. 110) J=78
      IF (J .EQ. 78) GO TO 791
C
C                            D oder d: delete
C
      IF (J .EQ. 68) GO TO 750
      IF (J .NE.100) GO TO 600
C
  750 NCD(NS)=NCD(NS)-1
      I=IAIN(1)
      IF (I .GT. NCD(NS)) GO TO 780
      DO 770 J=I,NCD(NS)
      ICD(J,NS)=ICD(J+1,NS)
      DO 760 K=1,3
      ATOMS(K,J,NS)=ATOMS(K,J+1,NS)
  760 CONTINUE
  770 CONTINUE
C                            Markiere Punkt
  780 TEMP=HOE/(HOE-PFREI(3))
      I=3
      CALL UPLINF (ISKP(41),10)
      CALL UPLINF (ISKP(49),11)
      DO 790 J=1,7,2
      AIN(1)=(PFREI(1)+DELMRK(J))*TEMP*O9+CONST(11)
      AIN(2)=(PFREI(2)+DELMRK(J+1))*TEMP*O9+CONST(12)
      CALL UPLINF (AIN,I)
      I=5-I
  790 CONTINUE
      CALL UPLINF (T,0)
      GO TO 600
C                            Frage Namen ab
C
CYENG1
  791 CALL FLES (AT(5,IANR,NS),ISKP(31),3HAAE,17HName, Untersch.?$)
CYENG2
CYENGY  791 CALL FLES (AT(5,IANR,NS),ISKP(31),3HAAE,11HName,ext.?$)
      IF (ISKP(31)+ISKP(32) .EQ. 1) AT(6,IANR,NS)=BLANK
      AT(7,IANR,NS)=AT(5,IANR,NS)
      CALL CNVTUP (AT(7,IANR,NS),1,4)
      GO TO 600
C                            Kommando WV - Welche Verschiebung
  800 TEMP=HOE/(HOE-PFREI(3))
      CONST(29)=(AIN(1)-CONST(11))/(O9*TEMP)-PFREI(1)
      CONST(30)=(AIN(2)-CONST(12))/(O9*TEMP)-PFREI(2)
      IF (NTYPS .EQ. 15) GO TO 930
      IF (NTYPS .EQ. 16) GO TO 960
      WRITE (WRLINE,810) CONST(29),CONST(30)
CYENG1
  810 FORMAT ('Verschiebung:',2F7.2)
CYENG2
CYENGY  810 FORMAT ('Shift:',2F7.2)
      CALL KPWRTE (NTDISP)
      GO TO 1450
C
  820 CALL KPCVNM (AT(5,IANR,NS),CONST(36),AIN(11),IAIN(9))
  830 CALL UPLINF (AMSFRM(2),25)
      CALL UPLINF (AIN,8)
  840 AIN(8)=CONST(15)*O9*TEMP
      AIN(5)=AIN(1)
      AIN(6)=AIN(2)
      CALL UPLINF (AMSFRM(4),26)
      CALL UPLINF (ISKP(41),10)
      CALL UPLINF (ISKP(49),11)
      CALL SYMBQL (AIN(5),AIN(6),AIN(8),AIN(11),1,ANG,IAIN(9))
      CALL UPLINF (T,0)
  850 CALL UPLINF (AMSFRM(2),25)
      CALL UPLINF (AIN,8)
C                            A oder a: Abbruch
      J=IAIN(4)
      IF (J .EQ. 97) GO TO 860
      IF (J .EQ. 65) GO TO 860
C
C                            G oder K: Schrift groesser/kleiner
      TEMP2=1.05
      IF (J .EQ. 107) J=75
      IF (J .EQ. 103) J=71
      IF (J .EQ. 71) GO TO 852
      IF (J .NE. 75) GO TO 853
  851 TEMP2=0.95
  852 CONST(15)=CONST(15)*TEMP2
      J=32
C
  853 IF (J .EQ. 32) GO TO 860
      IF (J .NE. 33) GO TO 850
      CALL UPLINF (AMSFRM(2),26)
  860 CALL SYMBQL (AIN(5),AIN(6),AIN(8),AIN(11),1,ANG,IAIN(9))
      CALL UPLINF (T,0)
      CALL UPLINF (AMSFRM(2),26)
      CALL UPLINF (AMSFRM(1),25)
      IF (J .EQ. 32) GO TO 840
      IF (J .NE. 33) GO TO 600
      AIN(1)=AIN(5)
      AIN(2)=AIN(6)
      GO TO 800
C                            Baue BA Befehl auf
C
  930 IF (IPKP(NS)+3 .LE. IPKDM) GO TO 931
      IERR=25 0503 11
      GO TO 1450
C
  931 VQ(IPKP(NS)+1,NS)=CONST(27)
      VQ(IPKP(NS)+2,NS)=CONST(29)
      VQ(IPKP(NS)+3,NS)=CONST(30)
      IPK(IPKPB,NS)=IPK(IPKPB,NS)+3
      VQ(IPKPB+4,NS)=CONST(15)
      IPKP(NS)=IPKP(NS)+3
      GO TO 600
C                            BVLM - Beschrifte Vektor mit Laenge
C
  932 IF (ISKP(7) .GT. 1) GO TO 585
      CALL FLES (IBVL,ISKP(31),3H2IE,
CYENG1
     + 29H0/1: A/pm, Nachkommastellen?$)
CYENG2
CYENGY     + 40H0/1: A/pm, digits following dec. point?$)
      DO  I=11,26
        AIN(I)=BLANK
      ENDDO
C
C                            Besorge die cursor-koordinaten
      INRCD=5
      GO TO 600
C                            BTM - Beschrifte mit Text mit Maus
C
  940 IF (ISKP(7) .GT. 1) GO TO 585
      CALL FLES (AIN(11),ISKP(33),4H16AE,6HText?$)
      NWRT=ISKP(33)
      INRCD=5
      GO TO 600
  950 INRCD=INRCD+1
      ICDS(INRCD)=ICDS(1)
      DO  I=1,3
        X(I,INRCD)=ATOMS(I,IMCL,NS)
      ENDDO
      IF (INRCD .LT. 7) GO TO 600
      CONST(27)=CDS(6)
C                            Berechne bei BVL die laenge des vektors
      IF (NTYPS .EQ. 20) THEN
        TEMP=0.
        DO  I=1,3
          TEMP=TEMP+(X(I,7)-X(I,6))**2
        ENDDO
        IF (TEMP .GT. 0.) TEMP=SQRT(TEMP)
C
C                            Wandle das ergebnis in text.
C
        IF (IBVL(1) .NE. 0) TEMP=TEMP*100.
        I=TEMP*10.**IBVL(2)+0.5
        J=0
        CALL KPNTOS (I,AIN(11),J,IBVL(2))
        NWRT=J/4+1
        NTYPS=16
      ENDIF
C                       Projiziere Koordinaten ...
      DO  I=1,3
        PFREI(I)=(X(I,6)+X(I,7))*0.5
      ENDDO
      TEMP=HOE/(HOE-PFREI(3))
      DO  J=6,7
        AIN(9)=HOE/(HOE-X(3,J))
        X(1,J)=X(1,J)*AIN(9)*O9+CONST(11)
        X(2,J)=X(2,J)*AIN(9)*O9+CONST(12)
      ENDDO
C                       ... und ermittle Drehwinkel.
      X2(1)=X(1,7)-X(1,6)
      X2(2)=X(2,7)-X(2,6)
      IF (X2(1) .NE. 0.) GO TO 957
      IF (X2(2)) 954,956,955
  954 ANG=-90.
      GO TO 956
  955 ANG=90.
      GO TO 956
  957 ANG=CONST(4)*ATAN(X2(2)/X2(1))
      IF (X2(1) .LT. 0.) ANG=ANG+180.
  956 IAIN(9)=NWRT*4
      GO TO 830
C                            Baue BT Befehl auf
  960 AIN(1)=COS(ANG*CONST(3))
      AIN(2)=SIN(ANG*CONST(3))
      AIN(3)=AIN(1)*CONST(29)+AIN(2)*CONST(30)
      AIN(4)=-AIN(2)*CONST(29)+AIN(1)*CONST(30)
      AIN(1)=CONST(27)
      AIN(2)=CONST(28)
      AIN(5)=CONST(15)
      DO  I=1,NWRT
        AIN(I+5)=AIN(I+10)
      ENDDO
      IAIN(22)=ISKP(41)
      IAIN(23)=ISKP(49)
      NTYP=6
      ISKP(14)=1
      ISKP(33)=NWRT
      ISKP(34)=0
      CALL ZVLPK
      ISKP(14)=0
      GO TO 9999
C                            AV - Addiere Verschiebung
C
  990 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      PFREI(1)=PFREI(1)+CONST(29)
      PFREI(2)=PFREI(2)+CONST(30)
      GO TO 370
C                            VNORM - Normiere Vektor auf eins
C
 1000 CALL FLES (CDS,ISKP(31),3H2CE,7Hc1,c2?$)
      IF (ISKP(31)-2) 1010,1020,1020
 1010 IERR=25 0627 16
      GO TO 9999
C
 1020 NTRY=24
      DO 1030 NC=1,2
      CALL ZVDEK
      IF (IERR) 9999,1030,9999
 1030 CONTINUE
      DO 1040 I=1,3
 1040 X(I,3)=X(I,2)-X(I,1)
      DO 1080 I=1,3
      IF (X(I,3)) 1050,1080,1050
 1050 DO 1060 J=1,3
 1060 X(J,1)=X(J,3)/X(I,3)
      WRITE (WRLINE,1070) I,(X(J,1),J=1,3)
 1070 FORMAT ('(',I1,') ',3F10.5)
      CALL KPWRTE (NTOUT)
 1080 CONTINUE
      GO TO 9999
C                            WTB - Welche trikline Box?
 1090 IAIN(1)=1
      IAIN(2)=NAT(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H2IE,9Hfrom,to?$)
      IF (NCDA(NS)-NCD(NS)) 1110,1110,1100
 1100 IERR=25 0654 12
      GO TO 9999
C
 1110 IF (IAIN(1)-IAIN(2)) 1120,1120,1140
 1120 IF (IAIN(1)) 1140,1140,1130
 1130 IF (IAIN(2)-NATDM) 1150,1150,1140
 1140 IERR=25 0660 16
      GO TO 9999
C
 1150 DO 1160 I=1,3
      X(I,1)=100.
 1160 X(I,2)=-100.
      NC=3
      IAIN(1)=IAIN(1)*200000
      IAIN(2)=IAIN(2)*200000+199999
      NTRY=40
C                            Durchsuche Codeliste.
      DO 1200 IC=NCDA(NS),NCD(NS)
      J=ICD(IC,NS)
      IF (J-IAIN(1)) 1200,1170,1170
 1170 IF (J-IAIN(2)) 1180,1180,1200
 1180 CALL ZVDEK
      DO 1190 J=1,3
      X(J,1)=AMIN1(X(J,1),X(J,3))
      X(J,2)=AMAX1(X(J,2),X(J,3))
 1190 CONTINUE
 1200 CONTINUE
      IF (X(1,1)-X(1,2)) 1230,1230,1210
 1210 IERR=25 0682 16
      GO TO 9999
C
 1230 DO 1240 J=1,3
      X1(J)=(X(J,1)+X(J,2))*.5
      X2(J)=(X(J,2)-X(J,1))*.5
 1240 CONTINUE
C
      WRITE (WRLINE,1250) X1,X2
CYENG1
 1250 FORMAT ('Ursprung:',3F10.5,' Halbmesser:',3F6.2)
CYENG2
CYENGY 1250 FORMAT ('Origin:',3F10.5,' half size:',3F6.2)
      CALL KPWRTE (NTOUT)
      GO TO 9999
C                            WARP - Welches Atom relativ zum
C                            freien Punkt?
 1260 DO 1270 I=1,3
 1270 AIN(I)=0.
      CALL FLES (AIN,ISKP(31),3H3FE,7Hx,y,z?$)
      DO 1280 I=1,3
 1280 AIN(I)=AIN(I)+PFREI(I)
      TEMP=HOE/(HOE-AIN(3))
      XQ=AIN(1)*TEMP
      YP=AIN(2)*TEMP
      GO TO 660
C                            FDG und FRG - Faktor auf Gruppe
C                            anwenden.
 1290 IF (ISKP(14) .EQ. 0) THEN
      AIN(4)=CONST(5)
      AIN(5)=CONST(38)
CYENG1
      CALL FLES (AIN,ISKP(31),5H3CFAE,30Hvon,bis,czentr <,fakt <opt>>?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),5H3CFAE,30Hfrom,to,ccentr <,fact <opt>>?$)
      ENDIF
      CALL CNVTUP (AIN(5),1,4)
C
      IF (IAIN(1)) 1340,1340,1300
 1300 IF (IAIN(2)-NATDM) 1310,1310,1340
 1310 IZ2=NAT(NS)+1
      IF (IAIN(5) .EQ. KDR) IZ2=IAIN(1)
 1320 IF (IZ2) 1340,1340,1330
 1330 IF (IZ2+IAIN(2)-IAIN(1)-NATDM) 1350,1340,1340
 1340 IERR=25 0724 16
      GO TO 9999
C                            Updte ggf. NAT
C
 1350 IF (IAIN(5) .NE. KDR) THEN
        NAT(NS)=IZ2+IAIN(2)-IAIN(1)
      ENDIF
      IF (NTYPS .EQ. 14) THEN
        IF (CONST(5) .EQ. 0.) GO TO 1340
        AIN(4)=AIN(4)/CONST(5)
      ENDIF
C                            Berechne trikline Koordinaten des
C                            Zentralatomes.
      CDS(1)=AIN(3)
      NC=1
      NTRY=24
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9999
C
      IF (NTYPS .EQ. 13) THEN
        IF (AIN(4) .EQ. 0.) THEN
          IERR=25 0745 16
          GO TO 9999
        ELSE
          AIN(4)=1./AIN(4)
        ENDIF
      ENDIF
C
      IZ1=IAIN(1)-1
      GO TO 1440
 1420 IZ1=IZ1+1
      DO  I=1,3
        AT(I,IZ2,NS)=(AT(I,IZ1,NS)-X(I,1))*AIN(4)+X(I,1)
        AT(I+3,IZ2,NS)=AT(I+3,IZ1,NS)
        DO  M=1,3
          TFVKT(M,I,IZ2,NS)=TFVKT(M,I,IZ1,NS)
        ENDDO
      ENDDO
      ICLRP(IZ2,NS)=ICLRP(IZ1,NS)
      IPFLG(IZ2,NS)=IPFLG(IZ1,NS)
      IZ2=IZ2+1
 1440 IF (IZ1-IAIN(2)) 1420,9999,9999
C
 1450 CALL FLES (AIN,ISKP(31),1HE,2H?$)
C
C                       Teste, ob BAM anhaengig und wenigstens
C                       ein Atom geladen, wenn ja
C
      IF (IPKPB .EQ. 0) GO TO 9999
      IF (IPK(IPKPB,NS) .LE. 5) IPKP(NS)=IPKPB-1
 9999 NS=NSSV
      RETURN
      END
