C         80              -------------------
                           SUBROUTINE ZVGE06
C                         -------------------
C
C                    ntyp 1  CCL   Compare cluster
C
C                     geschrieben: 151039 NOV 2011
C                     geaendert:   231212 APR 2017
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 IRLINE(30),IAIN(72)
      INTEGER *4 INBUF(10),I,NSV,NSH,IA,IB,ID,J,KDR
      REAL    *4 PROD(2),FAKT,AINBUF(10),X3(3),CWMIN,TW
C      REAL    *4 ARCCOS
      EQUIVALENCE (WRLINE,IRLINE(1)),(INBUF(1),AINBUF(1))
      EQUIVALENCE (AIN(1),IAIN(1))
      SAVE INBUF
      DATA AINBUF(4)/0.25/,AINBUF(5)/4.0/,AINBUF(6)/0./
      DATA INBUF(9)/0/,INBUF(10)/1/,KDR/4HR   /
      DATA CWMIN/0.94/ ! cos 20 Grad
C
      NSV=NS
      NSH=3-NS
      INBUF(7)=ISKP(53)
      INBUF(8)=NAT(NSH)
      CALL FLES (INBUF(4),ISKP(31),5H3F4IE,
CYENG1
     1 28Htold,tolw,f,z1,z2,opt,nlsg?$)
CYENG2
CYENGY     1 28Htold,tolw,f,z1,z2,opt,nsol?$)
      IF (INBUF(7) .LE. 0 .OR. INBUF(8) .GT. NAT(NSH)) THEN
        IERR=80003616
        GO TO 999
      ENDIF
      IF (AINBUF(6) .EQ. 0. .AND. NAT(1) .NE. NAT(2)) THEN
        WRITE (WRLINE,'(A)') 
CYENG1
     1  'ZVGE060042 - Die Parameterlisten muessen gleich lang sein.'
CYENG2
CYENGY     1  'ZVGE060042 - The parameter lists should not be different.'
        IERR=-1
        CALL KPWRTE (NTOUT)
        GO TO 999
      ENDIF
C                     Fuelle codeliste.
      NS=NSV
      IF (AINBUF(6) .GE. 0.) THEN
        NCD(NS)=0
        DO  I=INBUF(7),INBUF(8)
          NCD(NS)=NCD(NS)+1
          ICD(NCD(NS),NS)=I*200000+111001
        ENDDO
C                  Berechne freie koordinaten.
        K9(NS)=0
      ENDIF
      K8(NS)=0
      NTRY=44
      NC=1
      GO TO 40
C
   20 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,IC,NS)=X2(I)
      ENDDO
   40 IF (K9(NS) .LT. NCD(NS)) GO TO 20
C
C             Berechne kreuzprodukte und suche maximales.
C
      DO  I=1,3
        INBUF(I)=0
      ENDDO
      PROD(2)=0.
      DO  IA=1,NCD(NS)-2
        DO  IB=IA+1,NCD(NS)-1
          DO  I=1,3
            X1(I)=ATOMS(I,IB,NS)-ATOMS(I,IA,NS)
          ENDDO
          T(1)=sqrt(x1(1)*x1(1)+x1(2)*x1(2)+x1(3)*x1(3))
          DO  ID=IB+1,NCD(NS)
            DO  I=1,3
              X2(I)=ATOMS(I,ID,NS)-ATOMS(I,IA,NS)
            ENDDO
            T(2)=SQRT(X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3))
C
C                    Test auf winkellimit
C
            TW=((X1(1)*X2(1)+X1(2)*X2(2)+X1(3)*X2(3))/(T(1)*T(2)))
            IF (ABS(TW) .GT. CWMIN) GO TO 44
            DO  I=1,3
              X3(I)=ATOMS(I,ID,NS)-ATOMS(I,IB,NS)
            ENDDO
            T(3)=SQRT(X3(1)*X3(1)+X3(2)*X3(2)+X3(3)*X3(3))
            TW=-((X1(1)*X3(1)+X1(2)*X3(2)+X1(3)*X3(3))/(T(1)*T(3)))
            IF (ABS(TW) .GT. CWMIN) GO TO 42
C
            TW=((X2(1)*X3(1)+X2(2)*X3(2)+X2(3)*X3(3))/(T(2)*T(3)))
            IF (ABS(TW) .GT. CWMIN) GO TO 42
C
            PROD(1)=ABS(X1(2)*X2(3)-X1(3)*X2(2))+
     1              ABS(X1(3)*X2(1)-X1(1)*X2(3))+
     2              ABS(X1(1)*X2(2)-X1(2)*X2(1))
            IF (PROD(1) .GT. PROD(2)) THEN
              PROD(2)=PROD(1)
              INBUF(1)=ICD(IA,NS)
              INBUF(2)=ICD(IB,NS)
              INBUF(3)=ICD(ID,NS)
            ENDIF
   42       CONTINUE
          ENDDO
   44     CONTINUE
        ENDDO
      ENDDO
      IF (PROD(2) .EQ. 0.) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Kein geeignetes Handle gefunden.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'No suitable handle found.'
        CALL KPWRTE(NTOUT)
        GO TO 999
      ENDIF
C               Faktor automatisch ermitteln?
C
      IF (AINBUF(6) .EQ. 0.) THEN
C
C           Flle codeliste der hintergrundstruktur ...
C
        NS=NSH
        NCD(NS)=0
        DO  I=INBUF(7),INBUF(8)
          NCD(NS)=NCD(NS)+1
          ICD(NCD(NS),NS)=I*200000+111001
        ENDDO
C               ... und berechne freie koordinaten.
        K8(NS)=0
        K9(NS)=0
        NTRY=44
        NC=1
        GO TO 60
C
   50   K9(NS)=K9(NS)+1
        IC=K9(NS)
        CALL ZVDEK
        DO  I=1,3
          ATOMS(I,IC,NS)=X2(I)
        ENDDO
   60   IF (K9(NS) .LT. NCD(NS)) GO TO 50
C
        ISKP(76)=0
        DO  NS=1,2
          NTYP=6
          CALL ZVEFIT
C                      Ignoriere entartete Eigenwerte.
          DO  I=1,3
            IF (ABS(X1(I)) .LT. 0.01) X1(I)=1.
          ENDDO
          PROD(NS)=ABS(X1(1)*X1(2)*X1(3))
        ENDDO
        IF (PROD(1) .GT. PROD(2)) THEN
          NS=1
        ELSE
          NS=2
        ENDIF
        FAKT=(PROD(NS)/PROD(3-NS))**0.166666666
        NS=3-NS
      ELSE
        FAKT=ABS(AINBUF(6))
        NS=NSV
      ENDIF
C      WRITE (WRLINE,'(A,F10.5)') 'FAKT:',FAKT
C      CALL KPWRTE (NTOUT)
C                            Aendere die Gitterkonstanten
C
      IF (ABS(FAKT-1.) .GT. 1.E-5) THEN
        DO  I=1,3
          ZELLE(I,NS)=ZELLE(I,NS)*FAKT
        ENDDO
        ISKP(14)=1
        NTYP=1
        CALL ZVZ
c                             Alternativ FDG
C        IAIN(1)=INBUF(7)
C        IAIN(2)=INBUF(8)
C        IAIN(3)=1
C        AIN(4)=FAKT
C        IAIN(5)=KDR
C        NTYP=12
C        ISKP(14)=1
C        CALL ZVGE03
      ENDIF
C
      DO  I=1,10
        IAIN(I)=INBUF(I)
      ENDDO
C                             Output line passed to UFRA
C
C        WRITE (WRLINE,'(30X,3F6.2,4I5)')
C     +   (AIN(I),I=4,6),(IAIN(I),I=7,10)
C        J=1
C        DO  I=1,3
C          CALL KPCDST (IRLINE,J,IAIN(I))
C          J=J+10
C        ENDDO
C        CALL KPWRTE (NTDISP)
C                             Execute UFRA
      ISKP(31)=3
      ISKP(14)=1
      NTYP=2
      CALL ZVGE05
C
  999 CONTINUE
      NS=NSV
      RETURN
      END
