CZVGTY    08             ------------------
                          SUBROUTINE ZVGTY
C  CY-ENG-               ------------------
C
C   Das Programm erzeugt je nach Gittertyp aus den vorhandenen
C   Symmetrien weitere Symmetrien.
C
C                         Geschrieben: Hundt
C                  Geaendert: 211703 JAN 2002  (Hundt)
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,IEND,J,J1,K,K1,KA,KDA,KDB,KDBLNK,KDC
      INTEGER *4 KDF,KDI,KDL,KDP,KDQ,KDR,KDS,KDZ,KTYP,L,L1,LA,M
      INTEGER *4 MA,NSYMS
      REAL    *4 TEMP
C
      EQUIVALENCE (AIN(1),IAIN(1))
C
      DATA KDP,KDF,KDA,KDB,KDC,KDI,KDR,KDZ/1HP,1HF,1HA,1HB,1HC,1HI,
     1 1HR,1HZ/,KDQ/1HQ/,KDL/1HL/,KDS/1HS/,KDBLNK/4H    /
C
      IERR=0
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (KTYP,ISKP(31),2HAE,5HTyp?$)
CYENG2
CYENGY        CALL FLES (KTYP,ISKP(31),2HAE,6HType?$)
        NHMSNR(1,NS)=KDBLNK
        NHMSNR(2,NS)=KDBLNK
        NHMSNR(3,NS)=0
        IF (NSYM(NS) .LE. 0) THEN
          IERR=8 0027 05
          GO TO 999
        ENDIF
      ELSE
        KTYP=IAIN(1)
      ENDIF
C
   30 NSYMS=NSYM(NS)
      CALL CNVTUP (KTYP,1,1)
      IF (KTYP .EQ. KDP) THEN
        ISKP(71)=-1
        ISKP(72)=NSYMS
        GO TO 999
      ENDIF
C
      IEND=NSYM(NS)
      NTYP=0
      IF (KTYP .EQ. KDA) THEN
        J=5
        K=9
        ISKP(71)=-5
        GO TO 140
      ENDIF
      IF (KTYP .EQ. KDB) THEN
        J=1
        K=9
        ISKP(71)=-6
        GO TO 140
      ENDIF
      IF (KTYP .EQ. KDC) THEN
        J=1
        K=5
        ISKP(71)=-7
        GO TO 140
      ENDIF
      IF (KTYP .EQ. KDF) THEN
        ISKP(71)=-4
        NTYP=1
        J=5
        K=9
        GO TO 135
      ELSE
        GO TO 220
      ENDIF
  120 NTYP=2
      J=1
      K=9
      GO TO 140
  130 NTYP=0
      J=1
      K=5
C
  135 ISKP(72)=NSYMS
  140 DO 210 I=1,IEND
      IF (NSYM(NS)-NSYMDM) 150,420,420
  150 NSYM(NS)=NSYM(NS)+1
      DO 160 M=1,12
  160 SYM(M,NSYM(NS),NS)=SYM(M,I,NS)
      TEMP=SYM(J,I,NS)+.5
      IF (TEMP-1.) 180,170,170
  170 TEMP=TEMP-1.
  180 SYM(J,NSYM(NS),NS)=TEMP
      TEMP=SYM(K,I,NS)+.5
      IF (TEMP-1.) 200,190,190
  190 TEMP=TEMP-1.
  200 SYM(K,NSYM(NS),NS)=TEMP
  210 CONTINUE
      IF (NTYP-1) 999,120,130
C
  220 IF (KTYP-KDI) 290,230,290
  230 ISKP(71)=-2
      ISKP(72)=NSYMS
      DO 280 I=1,IEND
      IF (NSYM(NS)-NSYMDM) 240,420,420
  240 NSYM(NS)=NSYM(NS)+1
      DO 250 M=1,12
  250 SYM(M,NSYM(NS),NS)=SYM(M,I,NS)
      DO 270 J=1,9,4
      TEMP=SYM(J,NSYM(NS),NS)+.5
      IF (TEMP-1.) 270,260,260
  260 TEMP=TEMP-1.
  270 SYM(J,NSYM(NS),NS)=TEMP
  280 CONTINUE
      GO TO 999
C
  290 IF (KTYP-KDR) 340,300,340
  300 DO 330 J=2,3
      DO 330 I=1,IEND
      IF (NSYM(NS)-NSYMDM) 310,420,420
  310 NSYM(NS)=NSYM(NS)+1
      K=ID2(J)
      L=ID2(K)
      J1=(J-1)*4
      K1=(K-1)*4
      L1=(L-1)*4
      DO 320 M=1,4
      SYM(M,NSYM(NS),NS)=SYM(J1+M,I,NS)
      SYM(M+4,NSYM(NS),NS)=SYM(K1+M,I,NS)
  320 SYM(M+8,NSYM(NS),NS)=SYM(L1+M,I,NS)
  330 CONTINUE
      GO TO 999
C
  340 IF (KTYP .NE. KDZ) GO TO 430
      ISKP(70)=NSYM(NS)
      DO  I=1,IEND
        IF (NSYM(NS) .GE. NSYMDM) GO TO 420
        NSYM(NS)=NSYM(NS)+1
        DO  M=1,12
          SYM(M,NSYM(NS),NS)=-SYM(M,I,NS)
        ENDDO
        DO  J=1,9,4
          IF (SYM(J,NSYM(NS),NS) .LT. 0.)
     +    SYM(J,NSYM(NS),NS)=SYM(J,NSYM(NS),NS)+1.
        ENDDO
      ENDDO
      GO TO 999
C
  420 IERR=8 0117 03
      NSYM(NS)=NSYMS
      WRITE (WRLINE,421) KTYP
      CALL KPWRTE (NTDISP)
CYENG1
  421 FORMAT ('ZVGTY0421 - Gittertyp ',A1,' nicht ausfuehrbar.')
CYENG2
CYENGY  421 FORMAT ('ZVGTY0421 - Lattice type ',A1,' not executable.')
      GO TO 999
C                            GTY Q  (1/3,2/3,2/3; 2/3,1/3,1/3)+
C
  430 IF (KTYP .EQ. KDQ) THEN
        ISKP(71)=-3
        ISKP(72)=NSYMS
        AIN(9)=.6666667
        GO TO 470
      ENDIF
      IF (KTYP .NE. KDS) GO TO 550
      AIN(9)=.3333333
  470 AIN(1)=.3333333
      AIN(5)=.6666667
      IEND=NSYM(NS)
      DO 540 J=1,2
      DO 530 I=1,IEND
      IF (NSYM(NS)-NSYMDM) 480,420,420
  480 NSYM(NS)=NSYM(NS)+1
      DO 490 M=1,12
  490 SYM(M,NSYM(NS),NS)=SYM(M,I,NS)
      DO 520 L=1,9,4
      TEMP=SYM(L,NSYM(NS),NS)+AIN(L)
      IF (TEMP-1.) 510,500,500
  500 TEMP=TEMP-1.
  510 SYM(L,NSYM(NS),NS)=TEMP
  520 CONTINUE
  530 CONTINUE
      AIN(5)=1.-AIN(5)
      AIN(1)=1.-AIN(1)
      AIN(9)=1.-AIN(9)
  540 CONTINUE
      GO TO 999
C                            Gittertyp L - Wende die zuletzt einge-
C                            gebene Symmetrie auf alle bisherigen an.
C
  550 IF (KTYP .NE. KDL) THEN
        IERR=8 0179 14
        GO TO 999
      ENDIF
      IEND=NSYM(NS)-1
      I=NSYM(NS)
      IF (IEND .LE. 1) THEN
        IERR=8 0197 16
        GO TO 999
      ENDIF
  570 DO 680 J=2,IEND
      IF (NSYM(NS)-NSYMDM) 580,420,420
  580 NSYM(NS)=NSYM(NS)+1
      DO  K=1,12
        SYM(K,NSYM(NS),NS)=0.
      ENDDO
      LA=-3
      DO 670 L=1,3
      LA=LA+4
      MA=-4
      DO  M=1,3
        MA=MA+4
        TEMP=SYM(LA+M,I,NS)
        DO  K=1,4
          KA=LA+K-1
          SYM(KA,NSYM(NS),NS)=SYM(KA,NSYM(NS),NS)+TEMP*SYM(MA+K,J,NS)
        ENDDO
      ENDDO
C                            Normiere
C
      TEMP=SYM(LA,NSYM(NS),NS)+SYM(LA,I,NS)
      GO TO 630
  620 TEMP=TEMP-1.
  630 IF (TEMP-.95) 650,650,620
  640 TEMP=TEMP+1.
  650 IF (TEMP+.08) 640,640,660
  660 SYM(LA,NSYM(NS),NS)=TEMP
  670 CONTINUE
  680 CONTINUE
C
  999 RETURN
      END
