CZVK      11             ----------------
                          SUBROUTINE ZVK
C  CY-ENG-               ----------------
C
C                       geschrieben: Hundt
C                geaendert: 241642 MAR 2004 (Hundt)
C
C                        ----------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 NSKDIM
      PARAMETER (NSKDIM=1)
      INTEGER *4 IAIN(72),KONST(40),INBFR(3),ICBFR(2)
      INTEGER *4 I,IACHSE,IVON,IZL,J,K,KDR,L,M,N1,N2,NRET,NTYPS,NZC
      REAL    *4 SAVK(3,4),SAVTRA(3,3),SAVUR(3),CDS(7),AKML(12)
      REAL    *4 SK(3,10),ARCCOS,TEMP,TEMP2
C
      SAVE SAVK,SAVTRA,SAVUR,INBFR,AKML,SK
C
      EQUIVALENCE (AIN(1),IAIN(1),IACHSE),(CONST(1),KONST(1))
      EQUIVALENCE (ICDS(1),CDS(1))
C
      DATA SAVK/1.,3*0.,1.,3*0.,1.,3*0./
      DATA SAVTRA/1.,3*0.,1.,3*0.,1./,SAVUR/3*0./
      DATA INBFR/0,0,0/,KDR/1HR/,AKML/6*0.,6*1./
C
C                            Freie Koordinaten sind nicht berechnet
      K9(1)=0
      K9(2)=0
C
C        1:  K          6:  KUP   11:  IMAT              16:  NKML
C        2:  DK         7:  XK    12:  (K AUS BASISV.)   17:  KOC
C        3:  (TR-MATR)  8:  WK    13:  DKSV              18:  DKOS
C        4:  SK         9:  KEE   14:  KML               19:  (SK)
C        5:  RK        10:  KTG   15:  DKML              20:  (RK)
C                                                        21:  KS
C
C
C
      NTYPS=NTYP
      GO TO (10,460,400,540,570,600,620,650,670,
C            1  2   3   4   5   6   7   8   9
     1 710,840,910,930,990,1000,1010,1040,460,1050,1060,1070),NTYPS
C      10  11  12  13  14    15   16   17  18   19   20   21
C
C                            Lies Codes.
   10 ASSIGN 120 TO NRET
      IF (ISKP(14) .NE. 0) GO TO 90
      ICDS(2)=0
      ICDS(4)=0
      CALL FLES (ICDS,ISKP(31),3H5CE,27Hcur <,cx1,cx2 <,cy1,cy2>>?$)
      I=ISKP(31)
      IF (I .NE. 1 .AND. I .NE. 3 .AND. I .NE. 5) THEN
        IERR=11005216
        GO TO 9999
      ENDIF
C                            Tausche ggf. 0 durch Gruppencode
      DO  J=1,I
        IF (ICDS(J) .EQ. 0) THEN
          NTYP=7
          ICDS(J)=J
          CALL ZVGC01 (ICDS(J))
        ENDIF
      ENDDO
C                            Setze Ursprung.
   90 NTRY=24
      NC=1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9999
      DO  I=1,3
        UR(I,NS)=X(I,NC)
      ENDDO
      GO TO NRET, (120,690)
C                            Wenn 2. Code =0 nur Ursprung setzen.
C
  120 IF (ICDS(2) .EQ. 0) GO TO 9999
C
C                            Berechne Koordinaten der anderen Codes.
      NZC=5
      IF (ICDS(4) .EQ. 0) NZC=3
      DO  NC=2,NZC
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
      ENDDO
C                            Berechne hierzu die Vektoren ...
  170 DO  I=1,3
        X(I,1)=X(I,3)-X(I,2)
      ENDDO
      IF (NZC .EQ. 5) THEN
        DO  I=1,3
          X(I,2)=X(I,5)-X(I,4)
        ENDDO
      ENDIF
C                            ...in kartesischen Koordinaten.
      NTRY=2
      NC=1
      CALL ZVDEK
C                            Erster Vektor ist Basisvektor x.
      DO  I=1,3
        DREH(1,I)=X1(I)
        X2(I)=0.
      ENDDO
C                            Wenn 2. Vektor nicht angegeben, nehme
C                            einen willkuerlichen.
      IF (NZC .EQ. 3) THEN
        I=1
        IF (ABS(X1(2)) .LT. ABS(X1(1))) I=2
        IF (ABS(X1(3)) .LT. ABS(X1(I))) I=3
        X2(I)=1.
        DO  I=1,3
          X1(I)=X2(I)
        ENDDO
        GO TO 300
      ENDIF
C                            Hole 2. Vektor.
      NC=2
      CALL ZVDEK
C                            Berechne Kreuzprodukt v1 X v2 und
C                            speichere Ergebnis als 3. Basisvektor.
  300 DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        DREH(3,I)=DREH(1,J)*X1(K)-DREH(1,K)*X1(J)
C
C                            Loesche Vektor x2
        X2(I)=0.
      ENDDO
C                            Berechne 2. Basisvektor als Kreuzprodukt
C                            aus drittem und erstem Vektor.
  320 DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        DREH(2,I)=DREH(3,J)*DREH(1,K)-DREH(3,K)*DREH(1,J)
C
C                            Summiere fuer die Normierung.
        DO  J=1,3
          X2(J)=DREH(J,I)*DREH(J,I)+X2(J)
        ENDDO
      ENDDO
C                            Normiere die Vektoren auf die Laenge 1.
  350 DO  I=1,3
        TEMP=SQRT(X2(I))
        IF (TEMP .LE. 0.) THEN
          IERR=11 0350 06
          GO TO 9999
        ENDIF
C
        DO  J=1,3
          DREH(I,J)=DREH(I,J)/TEMP
        ENDDO
      ENDDO
C                            Berechne die Transformationsmatrix
C                            sowie ihre Inverse.
  400 DO  I=1,3
        DO  J=1,3
          DO  K=1,2
            TRA(I,J,K)=DREH(I,1)*DG(1,J,K)+DREH(I,2)*DG(2,J,K)+
     +      DREH(I,3)*DG(3,J,K)
            TRAINV(J,I,K)=DREH(I,1)*RG(1,J,K)+DREH(I,2)*RG(2,J,K)
     1               +DREH(I,3)*RG(3,J,K)
            AAWRK(J,I,K)=TRA(I,J,K)
            IF (NTYPS .NE. 18) THEN
              AAREV(J,I,K)=TRA(I,J,K)
              REFV(J,I,K)=TRAINV(J,I,K)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      IF (ISKP(58) .GE. 2) THEN
        WRITE (WRLINE,421)
        CALL KPWRTE (NTOUT)
CYENG1
  421   FORMAT ('Ursprung',15X,'Transformationsmatrix')
CYENG2
CYENGY  421 FORMAT (' Origin  ',15X,'Transformation matrix')
        DO  I=1,3
          WRITE (WRLINE,'(F12.6,5X,3F12.6)')UR(I,NS),(TRA(I,J,NS),J=1,3)
          CALL KPWRTE (NTOUT)
        ENDDO
        WRITE (WRLINE,'(24X,A)') 'Inverse:'
        CALL KPWRTE (NTOUT)
        DO  I=1,3
          WRITE (WRLINE,'(18X,3F12.6)') (TRAINV(I,J,NS),J=1,3)
          CALL KPWRTE (NTOUT)
        ENDDO
      ENDIF
C                            Drehe bei 'KEE' das Koordinatensystem
C                            so, dass die x-Koordinate des Nullpunktes
C                            im freien Koordinatensystem positiv ist.
      IF (NTYPS-9) 9980,430,9999
  430 IF (TRA(1,1,NS)*UR(1,NS)+TRA(1,2,NS)*UR(2,NS)+
     +  TRA(1,3,NS)*UR(3,NS) .LE. 0) GO TO 9999
      DO  I=1,3
        DREH(1,I)=-DREH(1,I)
        DREH(2,I)=-DREH(2,I)
      ENDDO
      NTYPS=1
      GO TO 400
C
C                            'DK' - Drehe Koordinatensystem.
C
  460 CONTINUE
      IF (ISKP(14) .EQ. 0) THEN
        IACHSE=0
        AIN(2)=CONST(6)
CYENG1
        CALL FLES (AIN,ISKP(31),3HIFE,21HAchse,Winkel (Grad)?$)
CYENG2
CYENGY        CALL FLES (AIN,ISKP(31),3HIFE,18HAxis,angle (deg)?$)
        IF (IACHSE .LE. 0 .OR. IACHSE .GT. 3) THEN
C
C                              Achsennummer illegal.
          IERR=11 0480 07
          GO TO 9999
        ENDIF
      ENDIF
      ICBFR(1)=0
C
  500 J=ID2(IACHSE)
      K=ID2(J)
      DO  L=1,3
        DO  M=1,3
          TRA(L,M,1)=0.
        ENDDO
      ENDDO
      TRA(IACHSE,IACHSE,1)=1.
      TEMP=COS(AIN(2)*CONST(3))
      TRA(J,J,1)=TEMP
      TRA(K,K,1)=TEMP
      TEMP=SIN(AIN(2)*CONST(3))
      TRA(K,J,1)=TEMP
      TRA(J,K,1)=-TEMP
      DO  I=1,3
        DO  J=1,3
          S(I,J)=TRA(I,1,1)*DREH(1,J)+TRA(I,2,1)*DREH(2,J)+
     +    TRA(I,3,1)*DREH(3,J)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  M=1,3
          DREH(I,M)=S(I,M)
        ENDDO
      ENDDO
      IF (ICBFR(1) .NE. 0) THEN
        IAIN(1)=ICBFR(1)
        IAIN(2)=ICBFR(2)
        NTYP=1
        ISKP(31)=2
        ISKP(14)=1
C                            LGC
        CALL ZVGC01 (I)
        ISKP(14)=0
      ENDIF
      GO TO 400
C                            'SK' - Save Koordinatensystem.
  540 DO  I=1,3
        DO  J=1,3
          SAVTRA(I,J)=TRA(I,J,NS)
          SAVK(I,J)=DREH(I,J)
        ENDDO
        SAVUR(I)=UR(I,NS)
        SAVK(I,4)=UR(I,NS)
      ENDDO
      GO TO 9980
C
C                            'RK' - Restore Koordinatensystem.
  570 DO  I=1,3
        DO  J=1,3
          DREH(I,J)=SAVK(I,J)
        ENDDO
        UR(I,NS)=SAVK(I,4)
      ENDDO
      GO TO 400
C                            'KUP' - Lade den Ursprungspunkt des
C                            Koordinatensystems vom Punktregister.
  600 DO  I=1,3
        UR(I,NS)=PTRIKL(I)
        PFREI(I)=0.
      ENDDO
      K9(NS)=0
      GO TO 9980
C                            'XK' - Exchange Koordinatensystem.
  620 DO  I=1,3
        DO  J=1,3
          TEMP=SAVK(I,J)
          SAVK(I,J)=DREH(I,J)
          DREH(I,J)=TEMP
        ENDDO
        TEMP=SAVK(I,4)
        SAVK(I,4)=UR(I,NS)
        UR(I,NS)=TEMP
      ENDDO
      GO TO 400
C                            'WK' - Wende Koordinatensystem.
  650 DO  I=1,3
        TEMP=DREH(1,I)
        DREH(1,I)=DREH(2,I)
        DREH(2,I)=DREH(3,I)
        DREH(3,I)=TEMP
        CONTINUE
      ENDDO
      GO TO 400
C                            'KEE' - Definition des Koordinatensystems
C                            durch zwei Ebenen.
C
  670 ASSIGN 690 TO NRET
      CALL FLES (ICDS,ISKP(31),4HC2IE,11Hcur,e1,e2?$)
      IF (ISKP(31)-3) 680,90,90
  680 IERR=11 0670 16
      GO TO 9999
C                            Basisvektoren: x=n1 X n2, z= n1
  690 N1=ICDS(2)
      N2=ICDS(3)
C
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        DREH(1,I)=AT(J,N1,NS)*AT(K,N2,NS)-AT(K,N1,NS)*AT(J,N2,NS)
        DREH(3,I)=AT(I,N1,NS)
        X2(I)=0.
      ENDDO
      GO TO 320
C                            'KTG' - Koordinaten-
C                            transformierte Gruppe.
  710 IF (ISKP(14)) 720,730,720
  720 INBFR(1)=IAIN(1)
      INBFR(2)=IAIN(2)
      INBFR(3)=IAIN(3)
      GO TO 740
C
  730 INBFR(3)=KONST(38)
CYENG1
      CALL FLES (INBFR,ISKP(31),4H2IAE,13Hvon,bis(,R)?$)
CYENG2
CYENGY      CALL FLES (INBFR,ISKP(31),4H2IAE,13Hfrom,to(,R)?$)
  740 CALL CNVTUP (INBFR(3),1,4)
      IF (INBFR(1)) 770,770,750
  750 IF (INBFR(2)-NATDM) 760,760,770
  760 IF (INBFR(1)-INBFR(2)) 780,780,770
  770 IERR=11 0760 16
      GO TO 9999
C
  780 IZL=NAT(NS)
      IF (INBFR(3) .EQ. KDR) IZL=INBFR(1)-1
      IVON=INBFR(1)
C
  790 IZL=IZL+1
      DO  I=1,3
        X1(I)=AT(I,IVON,NS)-SAVUR(I)
      ENDDO
      DO  I=1,3
        X2(I)=SAVTRA(I,1)*X1(1)+SAVTRA(I,2)*X1(2)+SAVTRA(I,3)*X1(3)
      ENDDO
      DO  I=1,3
        AT(I,IZL,NS)=TRAINV(I,1,NS)*X2(1)+TRAINV(I,2,NS)*X2(2)+
     +  TRAINV(I,3,NS)*X2(3)+UR(I,NS)
        AT(I+3,IZL,NS)=AT(I+3,IVON,NS)
      ENDDO
      ICLRP(IZL,NS)=ICLRP(IVON,NS)
      IPFLG(IZL,NS)=IPFLG(IVON,NS)
      IF (IPFLG(IZL,NS) .NE. 0) THEN
        CALL MM (SAVTRA,TFVKT(1,1,IVON,NS),S)
        CALL MM (TRAINV(1,1,NS),S,TFVKT(1,1,IZL,NS))
      ENDIF
C
      IVON=IVON+1
      IF (IVON-INBFR(2)) 790,790,830
C
  830 IF (INBFR(3) .NE. KDR) NAT(NS)=IZL
      GO TO 9999
C
  840 CALL FLES (X,ISKP(31),3H9FE,17Hm11,m12,...,m33?$)
C
C                            Teste Determinante.
      TEMP=0.
      DO 850 I=1,3
      J=ID2(I)
      K=ID2(J)
      TEMP=TEMP+X(1,I)*X(2,J)*X(3,K)-X(3,I)*X(2,J)*X(1,K)
  850 CONTINUE
      IF (ABS(TEMP-1.)-.0001) 880,880,860
  860 WRITE (WRLINE,870) TEMP
      CALL KPWRTE (NTDISP)
CYENG1
  870 FORMAT ('ZVK0356 - Determinante:',E12.6,' nicht 1.')
CYENG2
CYENGY  870 FORMAT ('ZVK0356 - Determinant:',E12.6,' not 1.')
      GO TO 9999
C
  880 DO 900 I=1,3
      DO 890 J=1,3
      DREH(I,J)=X(I,J)
  890 CONTINUE
  900 CONTINUE
      GO TO 400
C                            Berechne Koordinatensystem, wenn
C                            auf X die Basisvektoren vorgegeben sind.
  910 DO 920 I=1,3
  920 UR(I,NS)=X(I,1)
      NZC=5
      GO TO 170
C                            DKSV - Setze Vektor senkrecht
  930 T(1)=0.
      ICDS(2)=0
      DO  I=1,3
        T(2)=ABS(TRA(2,I,NS)/ZELLE(I,NS))
        IF (T(2) .GT. T(1)) THEN
          T(1)=T(2)
          ICDS(2)=I
        ENDIF
      ENDDO
      ICDS(3)=311001+2*10**(5-ICDS(2))
      ICDS(2)=311001
      ICDS(4)=1
      IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (ICDS(2),ISKP(31),3H3CE,15Hc0,c1,opt[1]? $)
      ENDIF
      NTRY=28
      DO  NC=2,3
        IF (ICDS(NC) .EQ. 0) THEN
          NTYP=7
          ICDS(NC)=NC-1
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
C
C                            Save freie Koordinaten
        ICBFR(NC-1)=ICDS(NC)
        TEMP=HOE/(HOE-X2(3))
        X(1,NC)=X2(1)*TEMP*O9+CONST(11)
        X(2,NC)=X2(2)*TEMP*O9+CONST(12)
      ENDDO
      X1(1)=X(1,3)-X(1,2)
      X1(2)=X(2,3)-X(2,2)
      X1(3)=X1(1)*X1(1)+X1(2)*X1(2)
      IF (X1(3) .LE. 0.) THEN
        IERR=11 0970 16
        GO TO 9999
      ENDIF
      AIN(2)=ARCCOS(X1(2)/SQRT(X1(3)))
      IF (X(1,3) .LT. X(1,2)) AIN(2)=-AIN(2)
      IAIN(1)=3
      IF (ICDS(4) .EQ. 0) ICBFR(1)=0
      GO TO 500
C                            KML - Koordinatensystem durch mill. Ind.
  990 IF (ISKP(14) .EQ. 0) THEN
        DO  I=1,6
          ICDS(I)=0
        ENDDO
        CALL FLES (ICDS,ISKP(31),5H3F3CE,19Hh,k,l,cur,cx1,cx2?$)
      ENDIF
      ISKP(14)=0
      TEMP2=0.
      DO  I=1,3
        TEMP=RG(I,1,NS)*CDS(1)+RG(I,2,NS)*CDS(2)+RG(I,3,NS)*CDS(3)
        X(1,I)=0.
        X(3,I)=TEMP
        TEMP2=TEMP2+TEMP*TEMP
      ENDDO
C                            x-Achse angegeben?
C
      IF (ISKP(32) .GE. 3) THEN
        NTRY=26
        DO  NC=5,6
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 9999
          DO  I=1,3
            X(I,NC)=X1(I)
          ENDDO
        ENDDO
        DO  I=1,3
          X(1,I)=X(I,6)-X(I,5)
        ENDDO
      ELSE
C                            Achse nicht angegeben.
        I=1
        DO  J=2,3
          IF (ABS(X(3,J)) .LT. ABS(X(3,I))) I=J
        ENDDO
        X(1,I)=1.
      ENDIF
C                            Kreuzprodukte
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        X(2,I)=X(3,J)*X(1,K)-X(3,K)*X(1,J)
      ENDDO
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        X(1,I)=X(2,J)*X(3,K)-X(2,K)*X(3,J)
      ENDDO
C                            Ursprung angegeben?
C
      IF (ICDS(4) .NE. 0) THEN
        NTRY=24
        NC=4
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        DO  I=1,3
          UR(I,NS)=X(I,4)
        ENDDO
      ENDIF
C                            Kopiere auf DREH und summiere Quadrate.
      DO  I=1,3
        X2(I)=0.
        DO  J=1,3
          TEMP=X(I,J)
          DREH(I,J)=TEMP
          X2(I)=X2(I)+TEMP*TEMP
        ENDDO
      ENDDO
      GO TO 350
C                            DKML - Definition fuer KML
C
CYENG1
 1000 CALL FLES (AKML,ISKP(31),4H12FE,25Hh,k,l - akt,min,max,inc?$)
CYENG2
CYENGY 1000 CALL FLES (AKML,ISKP(31),4H12FE,25Hh,k,l - act,min,max,inc?$)
      IF (ISKP(31) .EQ. 0) THEN
        WRITE (WRLINE,'(12F5.1)') AKML
        CALL KPWRTE (NTDISP)
      ENDIF
      GO TO 9999
C                            NKML - Next KML
C
 1010 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      I=3
 1020 IF (AKML(I) .GT. 0) THEN
        AKML(I)=-AKML(I)
        IF (AKML(I) .GE. AKML(I+3)) GO TO 1030
        GO TO 1020
      ELSE
        AKML(I)=-AKML(I)+AKML(I+9)
        IF (AKML(I) .LE. AKML(I+6)) GO TO 1030
        IF (-AKML(I) .GE. AKML(I+3)) GO TO 1020
        AKML(I)=0.
        I=I-1
        IF (I .GT. 0) GO TO 1020
CYENG1
        WRITE (WRLINE,'(A)') 'NKML fertig.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'NKML done.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 9999
      ENDIF
C
 1030 DO  I=1,3
        ICDS(I+3)=0
        CDS(I)=AKML(I)
      ENDDO
      ISKP(14)=1
      ISKP(32)=0
      GO TO 990
C                            'KOC' - Koordintensystem ueber Code
 1040 ICDS(2)=0
      CALL FLES (ICDS(2),ISKP(31),2HCE,6Hcode?$)
      IF (NCD(NS) .LT. NCDA(NS)) THEN
        IERR=11 0465 12
        GO TO 9999
      ENDIF
      IF (ICDS(2) .EQ. 0) THEN
        ICDS(2)=1
        NTYP=7
        CALL ZVGC01 (ICDS(2))
      ENDIF
C                            Berechne dessen freie Koordinaten.
      NC=2
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9999
      DO  I=1,3
        X(I,2)=X2(I)
      ENDDO
C                            Suche Punkt mit groesztem z.
      K8(NS)=0
      NTRY=44
      NC=1
      TEMP=-10000.
C
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        IF (X2(3) .GT. TEMP) TEMP=X2(3)
      ENDDO
C                            Konstruiere Punkt.
      DO  I=1,3
        UR(I,NS)=TRAINV(I,1,NS)*X(1,2)+TRAINV(I,2,NS)*X(2,2)+
     +  TRAINV(I,3,NS)*TEMP+UR(I,NS)
      ENDDO
      GO TO 9999
C                            (SK fuer interne zwecke)
 1050 ISKP(73)=ISKP(73)+1
      IF (ISKP(73) .LE. NSKDIM) THEN
        DO  I=1,3
          DO  J=1,3
            SK(J,I)=TRA(J,I,NS)
            SK(J,I+3)=TRAINV(J,I,NS)
            SK(J,I+6)=DREH(J,I)
          ENDDO
          SK(I,10)=UR(I,NS)
        ENDDO
      ELSE
        WRITE (WRLINE,'(A)') 'ZVK0574 - Stack overflow.'
        CALL KPWRTE (NTDISP)
      ENDIF
      GO TO 9999
C                            (RK fuer interne zwecke)
 1060 IF (ISKP(73) .GT. 0) THEN
        IF (ISKP(73) .LE. NSKDIM) THEN
          DO  I=1,3
            DO  J=1,3
              TRA(J,I,NS)=SK(J,I)
              TRAINV(J,I,NS)=SK(J,I+3)
              DREH(J,I)=SK(J,I+6)
            ENDDO
            UR(I,NS)=SK(I,10)
          ENDDO
        ELSE
          WRITE (WRLINE,'(A)') 'ZVK0590 - Stackpointer out of range.'
          CALL KPWRTE (NTDISP)
        ENDIF
        ISKP(73)=ISKP(73)-1
      ELSE
      WRITE (WRLINE,'(A)') 'ZVK0595 - Stack empty.'
      CALL KPWRTE (NTDISP)
      ENDIF
      GO TO 9999
C                            KS - Standard-Koordinatensystem
 1070 ASSIGN 120 TO NRET
      DO  I=1,5
        ICDS(I)=2
      ENDDO
      ICDS(3)=531001
      ICDS(5)=513001
      IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (AIN,ISKP(31),1HE,2H?$)
      ENDIF
      GO TO 90
C
 9980 IF (NTYPS .LT. 4) GO TO 9999
      IF (ISKP(14) .NE. 0) GO TO 9999
      CALL FLES (AIN,ISKP(31),1HE,2H?$)
C
 9999 RETURN
      END
