CZVORTN   14             -------------------
                          SUBROUTINE ZVORTN
C  CY-ENG-               -------------------
C
C   Das Programm berechnet und druckt die Orientierung
C
C                         Geschrieben: Hundt
C                   Geaendert: 121430 MAR 2004  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,J,K
      REAL    *4 HA(3),HB(3),ARCCOS,B1,B2,B3,B4
C
      EQUIVALENCE (S(1,1),HA(1)),(S(1,2),HB(1)),(ICDS(1),B1)
      EQUIVALENCE (ICDS(2),B2),(ICDS(3),B3),(ICDS(4),B4)
C
      HA(1)=0.
      HA(2)=DREH(3,3)
      HA(3)=-DREH(3,2)
      B1=HA(2)*HA(2)+HA(3)*HA(3)
      IF (B1 .LE. 0.) THEN
        HA(2)=1.
      ELSE
        B1=SQRT(B1)
        DO  I=1,3
          HA(I)=HA(I)/B1
        ENDDO
        B1=ARCCOS(HA(2))
        IF (HA(3) .GT. 0.) B1=-B1
      ENDIF
      HB(1)=0.
      HB(2)=-HA(3)
      HB(3)=HA(2)
      B3=0.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        B3=B3+HB(I)*DREH(3,I)
        T(I)=HB(J)*DREH(3,K)-HB(K)*DREH(3,J)
        IF (T(I) .NE. 0.) B4=HA(I)/T(I)
      ENDDO
      B2=ARCCOS(B3)
      IF (B4 .GE. 0.) B2=-B2
      B3=0.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        B3=B3+HA(I)*DREH(2,I)
        T(I)=HA(J)*DREH(2,K)-HA(K)*DREH(2,J)
        IF (T(I) .NE. 0.) B4=DREH(3,I)/T(I)
      ENDDO
      B3=ARCCOS(B3)
      IF (B4 .GE. 0.) B3=-B3
      IF (NTYP .EQ. 1) THEN
        WRITE (WRLINE,'(A,F8.2,A,F8.2,A,F8.2,A,3F8.5)')
CYENG1
     +  'Drehung  1',B1,' 2',B2,' 3',B3,' Urspr:',(UR(I,NS),I=1,3)
CYENG2
CYENGY     +  'Rotation  1',B1,' 2',B2,' 3',B3,' Origin:',(UR(I,NS),I=1,3)
        CALL KPWRTE (NTOUT)
      ENDIF
C
      RETURN
      END
