C         94              -------------------
                           SUBROUTINE ZVSFTX
C                         -------------------
C
C          Das programm sucht ein fragment in einer struktur.
C
C                    geschrieben: 190934 JAN 2004
C
C                         -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
C  inbfr
C  1-2 Nrn der zielgruppe
C  3   ref-atom zielgruppe
C  4-5 Nrn der finiten gruppe, die passen muessen
C  6   ref-atom der finiten gruppe
C  7-8 ggf zusaetzlich nummern der finiten gruppe
C  9   Aktionszahl: <0 suche alle loesungen; =0 finde nur ueberhaupt
C      eine; >0 diese loesung behalten.
C
C  flags / iflags
C  1  Toleranzfaktor fuer handle
C  2  Suchradius start fuer affine abbildung
C  3  Suchradius max
C  4  Suchradius inc
C  5  End-rms muss unter diesem wert liegen
C  6  Maximale zyklenzahl
C
      INTEGER *4 INBFR(12),MERK,IFLAGS(6),IAT(6,PARDIM,2),NAME
      INTEGER *4 I,J,K,L,II,JJ,KEYIN
      INTEGER *4 KDALL,ITFVKT(9,PARDIM,2),NZFIN,IAIN(72),ISYMB(2)
      INTEGER *4 ICYCLE,ILSG
C
      REAL    *4 FLAGS(6),TP,TEMP2,G1(4),G2(3)
      REAL    *4 E(4,4),EE(4,3),C,RTEMP,HL(5)
C
      SAVE INBFR,IFLAGS
C
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (TFVKT(1,1,1,1),ITFVKT(1,1,1))
      EQUIVALENCE (IFLAGS(1),FLAGS(1)),(AIN(1),IAIN(1))
C
      DATA FLAGS(1)/0.05/,FLAGS(2)/0.4/,FLAGS(3)/4./FLAGS(4)/0.2/
      DATA FLAGS(5)/0.5/,IFLAGS(6)/5/
      DATA INBFR/0,0,4HALL ,0,0,4HALL ,0,0,0, 0,0, 0/
      DATA KDALL/4HALL /
C
      IF (NTYP .EQ. 2) THEN
        CALL FLES (IFLAGS,ISKP(31),4H5FIE,
     +  30Htolh,rs,rmax,rinc,lim-rms,nz?$)
        IF (ISKP(31) .LE. 0) THEN
          WRITE (WRLINE,'(5F6.3,I3)') (FLAGS(I),I=1,5),IFLAGS(6)
          CALL KPWRTE (NTOUT)
        ENDIF
        GO TO 999
      ENDIF
C
      CALL FLES (INBFR,ISKP(31),9H2IA2IA6IE,
     + 46Hz1,z2,refz, n1,n2,refn, h1,h2,h3, k1,k2, opt?$)
C
      IF (INBFR(1) .LE. 0 .OR. INBFR(2) .GT. NAT(NS) .OR.
     + INBFR(1) .GT. INBFR(2)) GO TO 140
      IF (INBFR(4) .LE. 0 .OR. INBFR(5) .GT. NAT(NS) .OR.
     + INBFR(4) .GT. INBFR(5)) GO TO 140
      CALL CNVTUP (INBFR(3),1,4)
      CALL CNVTUP (INBFR(6),1,4)
      NZFIN=INBFR(5)-INBFR(4)+1
      ILSG=0
C                            Schreibe die originalkoordinaten ab.
C
      DO  I=INBFR(4),INBFR(5)
        DO  J=1,3
          TFVKT(J,1,I,NS)=AT(J,I,NS)
        ENDDO
        ITFVKT(7,I,NS)=IAT(5,I,NS)
        CALL CNVTUP (ITFVKT(7,I,NS),1,4)
      ENDDO
      IF (INBFR(10) .NE. 0) THEN
        DO  I=INBFR(10),INBFR(11)
          DO  J=1,3
            TFVKT(J,1,I,NS)=AT(J,I,NS)
          ENDDO
        ENDDO
      ENDIF
C                            Beschaffe ggf. codes des handles ...
      NTRY=26
      DO  NC=1,3
        IF (INBFR(NC+6) .EQ. 0) THEN
          J=NC
          NTYP=7
          CALL ZVGC01 (J)
          IF (MOD(J,200000) .NE. 111001) GO TO 140
          INBFR(NC+6)=J/200000
        ENDIF
        ICDS(NC)=INBFR(NC+6)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          X(I,NC)=X1(I)
        ENDDO
      ENDDO
C                            ... und berechne laengen.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        HL(I)=SQRT((X(1,J)-X(1,K))**2+(X(2,J)-X(2,K))**2+
     +  (X(3,J)-X(3,K))**2)
      ENDDO
      HL(4)=HL(1)*(1.-FLAGS(1))
      HL(5)=HL(1)*(1.+FLAGS(1))
C
C                            Durchlaufe zielmenge
C
      DO  II=INBFR(1),INBFR(2)
C
C                            Ist dieses atom moeglicher kandidat?
C
        IF (INBFR(3) .NE. KDALL) THEN
          NAME=IAT(5,II,NS)
          CALL CNVTUP (NAME,1,4)
          IF (NAME .NE. INBFR(3)) GO TO 130
        ENDIF
        K8(NS)=0
        K9(NS)=0
        NCD(NS)=1
        ICD(1,NS)=II*200000+111001
C
C                            Erzeuge umgebungen via AKS
        ICDS(1)=II
        IZ1=INBFR(1)
        IZ2=INBFR(2)
        DQ=HL(3)*(1.+FLAGS(1))
        CONST(20)=(HL(3)*(1.-FLAGS(1)))**2
        NTYP=3
        ISKP(14)=1
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 990
        IF (NCD(NS) .LE. 1) GO TO 130
        NCDA(NS)=NCD(NS)+1
        DQ=HL(2)*(1.+FLAGS(1))
        CONST(20)=(HL(2)*(1.-FLAGS(1)))**2
        NTYP=3
        ISKP(14)=1
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 990
        IF (NCD(NS) .LT. NCDA(NS)) GO TO 130
C
C                            Baue hieraus ein 'DTG' zusammen.
        IAIN(1)=INBFR(4)
        IAIN(2)=INBFR(5)
C
        IAIN(3)=INBFR(7)
        IAIN(4)=INBFR(8)
        IAIN(5)=INBFR(9)
C                            Entferne von der codeliste die atome,
C                            die nicht zu den handelatomen passen.
C
        IF (INBFR(3) .NE. KDALL .AND. INBFR(6) .NE. KDALL) THEN
          J=1
          ISYMB(1)=IAT(5,INBFR(8),NS)
          DO  IC=2,NCD(NS)
            IF (IC .EQ. NCDA(NS)) ISYMB(1)=IAT(5,INBFR(9),NS)
            ISYMB(2)=IAT(5,ICD(IC,NS)/200000,NS)
            CALL CNVTUP (ISYMB,1,8)
            IF (ISYMB(1) .EQ. INBFR(6)) THEN
              IF (ISYMB(2) .EQ. INBFR(3)) GO TO 10
            ELSE
              IF (ISYMB(2) .NE. INBFR(3)) GO TO 10
            ENDIF
            ICD(IC,NS)=0
   10       CONTINUE
          ENDDO
          J=1
          K=NCDA(NS)
          DO  IC=2,NCD(NS)
            IF (ICD(IC,NS) .NE. 0) THEN
              J=J+1
              ICD(J,NS)=ICD(IC,NS)
            ELSE
              IF (IC .LT. K) NCDA(NS)=NCDA(NS)-1
            ENDIF
          ENDDO
          NCD(NS)=J
        ENDIF
C                            Teste handle auf brauchbarkeit
C
        IF (NCDA(NS) .LT. 3 .OR. NCD(NS)-NCDA(NS) .LT. 0) GO TO 130
        DO  I=1,NCD(NS)
          IAIN(I+5)=ICD(I,NS)
        ENDDO
        IAIN(7)=-IAIN(7)
        IAIN(5+NCDA(NS))=-IAIN(5+NCDA(NS))
        NCDA(NS)=1
        IF (ISKP(58) .GT. 0) THEN
          WRITE (WRLINE,'(A)') 'DTG:'
          CALL KPWRTE (NTDISP)
          DO  I=1,5
          WRITE (WRLINE,'(2I10)') I,IAIN(I)
          CALL KPWRTE (NTDISP)
          ENDDO
          DO  I=6,NCD(NS)+5
          WRITE (WRLINE,'(2I10)') I
          CALL KPCDST (WRLINE,11,IAIN(I))
          CALL KPWRTE (NTDISP)
          ENDDO
        ENDIF
        ISKP(93)=0
        NTYP=10
        ISKP(31)=NCD(NS)+5
C                            Fuehre transformation aus
        CALL ZVGC02
        IF (ISKP(93) .EQ. 2) GO TO 130
        IF (IERR .NE. 0) GO TO 990
C
C                            Teste auch den 2-3-abstand des handels.
   20   NTRY=26
        DO  NC=4,6,2
          ICDS(NC)=IAIN(NC)
          CALL ZVDEK
          IF (NC .EQ. 4) THEN
            DO  I=1,3
              X2(I)=X1(I)
            ENDDO
          ELSE
            TP=SQRT((X2(1)-X1(1))**2+(X2(1)-X1(1))**2+(X2(1)-X1(1))**2)
            IF (TP .GE. HL(4) .AND. TP .LE. HL(5)) GO TO 120
          ENDIF
        ENDDO
C                            Punkte sind o.k. Bilde jetzt affin ab.
        TEMP2=1.E6
        ICYCLE=0
   30   CONTINUE
C                            Initialisiere ...
        DO  J=1,4
          DO  K=1,4
            E(K,J)=0.
          ENDDO
          DO  I=1,3
            EE(J,I)=0.
          ENDDO
        ENDDO
C                            ... und loesche bereich fuer codes.
C
        DO  I=INBFR(4),INBFR(5)
          ITFVKT(8,I,NS)=0
        ENDDO
C                            Durchlaufe die liste.
        RTEMP=FLAGS(2)
   40   MERK=0
        DO  I=INBFR(4),INBFR(5)
          IF (ITFVKT(8,I,NS) .EQ. 0) THEN
            ICDS(1)=I
            ISYMB(1)=ITFVKT(7,I,NS)
            IZ1=INBFR(1)
            IZ2=INBFR(2)
            DQ=RTEMP
            CONST(20)=0.
            NCD(NS)=0
            K8(NS)=0
            K9(NS)=0
            NTYP=3
            ISKP(14)=1
C                            AKS
            CALL ZVAVBR
            IF (IERR .NE. 0) GO TO 90
C
C                            Etwas gefunden?
C
            IF (NCD(NS) .GT. 0) THEN
              DO  IC=1,NCD(NS)
                IF (INBFR(3) .NE. KDALL) THEN
                  ISYMB(2)=IAT(5,ICD(IC,NS)/200000,NS)
                  CALL CNVTUP (ISYMB,5,4)
                  IF (ISYMB(2) .EQ. INBFR(3)) THEN
                    IF (INBFR(6) .NE. KDALL) THEN
                      IF (ISYMB(1) .NE. INBFR(6)) GO TO 50
                    ENDIF
                  ELSE
                    IF (INBFR(6) .NE. KDALL) THEN
                      IF (ISYMB(1) .EQ. INBFR(6)) GO TO 50
                    ENDIF
                  ENDIF
                ENDIF
                DO  J=INBFR(4),INBFR(5)
                  IF (ITFVKT(8,J,NS) .EQ. ICD(IC,NS)) GO TO 50
                ENDDO
                ITFVKT(8,I,NS)=ICD(IC,NS)
                MERK=MERK+1
                GO TO 60
   50           CONTINUE
              ENDDO
            ENDIF
          ELSE
            MERK=MERK+1
          ENDIF
   60     CONTINUE
        ENDDO
   70   IF (MERK .LT. NZFIN) THEN
          RTEMP=RTEMP+FLAGS(4)
          IF (RTEMP .LT. FLAGS(3)) GO TO 40
C
C                            Die liste ist unvollstaendig. Abbruch.
          GO TO 100
        ENDIF
C                            Durchlaufe jetzt die liste.
        JJ=INBFR(4)
   80     ICDS(1)=JJ
          ICDS(2)=ITFVKT(8,JJ,NS)
          IF (ICDS(2) .GT. 0) THEN
            NTRY=24
            DO  NC=1,2
              CALL ZVDEK
              IF (IERR .NE. 0) GO TO 90
            ENDDO
            DO  I=1,3
              G1(I)=X(I,1)
              G2(I)=X(I,2)
            ENDDO
            G1(4)=1.
            DO  J=1,4
              DO  K=1,4
                E(K,J)=E(K,J)+G1(K)*G1(J)
              ENDDO
              DO  K=1,3
                EE(J,K)=EE(J,K)+G1(J)*G2(K)
              ENDDO
            ENDDO
          ENDIF
        JJ=JJ+1
        IF (JJ .LE. INBFR(5)) GO TO 80
   90   K8(NS)=0
        K9(NS)=0
        IF (IERR .NE. 0) GO TO 999
C
        CALL LUDCMP (E,4,4,X(1,3),X(2,4))
        IF (ABS(X(2,4)) .LT. 1.E-6) THEN
C
C                            Determinante ist null, d.h. die punkte
C                            sind (noch) ungeeignet.
        MERK=0
        GO TO 110
      ENDIF
      DO  I=1,3
        CALL LUBKSB (E,4,4,X(1,3),EE(1,I))
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Affine Abbildung:'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Affine mapping:'
        CALL KPWRTE (NTDISP)
        DO  J=1,3
          WRITE (WRLINE,'(4F12.4)') (EE(I,J),I=1,4)
          CALL KPWRTE (NTDISP)
        ENDDO
      ENDIF
C                            Fuehre abbildung aus.
C
      DO  JJ=INBFR(4),INBFR(5)
        DO  I=1,3
          T(I)=EE(1,I)*AT(1,JJ,NS)+EE(2,I)*AT(2,JJ,NS)+
     +    EE(3,I)*AT(3,JJ,NS)+EE(4,I)
        ENDDO
        DO  I=1,3
          AT(I,JJ,NS)=T(I)
        ENDDO
      ENDDO
      IF (INBFR(10) .NE. 0) THEN
        DO  JJ=INBFR(10),INBFR(11)
          DO  I=1,3
            T(I)=EE(1,I)*AT(1,JJ,NS)+EE(2,I)*AT(2,JJ,NS)+
     +      EE(3,I)*AT(3,JJ,NS)+EE(4,I)
          ENDDO
          DO  I=1,3
            AT(I,JJ,NS)=T(I)
          ENDDO
        ENDDO
      ENDIF
C                            Berechne noch den RMS-wert.
      L=0
      C=0.
      DO  JJ=INBFR(4),INBFR(5)
        I=ITFVKT(8,JJ,NS)
        IF (I .GT. 0) THEN
          L=L+1
          ICDS(1)=JJ
          ICDS(2)=I
          NTRY=26
          DO  NC=1,2
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 999
            IF (NC .EQ. 1) THEN
              DO  I=1,3
                X2(I)=X1(I)
                TFVKT(I,2,JJ,NS)=X1(I)
              ENDDO
            ENDIF
          ENDDO
          C=C+(X1(1)-X2(1))**2+(X1(2)-X2(2))**2+(X1(3)-X2(3))**2
        ENDIF
      ENDDO
C                            RMS-Wert
      C=SQRT(C/FLOAT(L))
      ICYCLE=ICYCLE+1
      IF (ICYCLE .GE. IFLAGS(6)) GO TO 100
C
C                            Verbesserung erzielt?
C
      IF (C .LT. TEMP2) THEN
        TEMP2=C
        GO TO 30
      ENDIF
  100 IF (C .LT. FLAGS(5)) THEN
        ILSG=ILSG+1
        WRITE (WRLINE,'(A,I3,A,F10.5)')
CYENG1
     +  'Loesung',ilsg,'. RMS-Wert:',c
CYENG2
CYENGY     +  'Solution',ilsg,'. RMS value:',c
        CALL KPWRTE (NTDISP)
        IF (INBFR(12) .GT. 0) THEN
          IF (INBFR(12) .EQ. ILSG) GO TO 990
        ENDIF
      ENDIF
C                            Restore original koordinaten
  110 TEMP2=1.E6
      ICYCLE=0
       DO  I=INBFR(4),INBFR(5)
          DO  J=1,3
            AT(J,I,NS)=TFVKT(J,1,I,NS)
          ENDDO
        ENDDO
        IF (INBFR(10) .NE. 0) THEN
          DO  I=INBFR(10),INBFR(11)
            DO  J=1,3
              AT(J,I,NS)=TFVKT(J,1,I,NS)
            ENDDO
          ENDDO
        ENDIF
        IF (ILSG .GT. 0 .AND. INBFR(12) .EQ. 0) GO TO 990
C
C                            Naechste moeglichkeit
C
  120   IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 990
        ENDIF
        ISKP(93)=0
        NTYP=11
        CALL ZVGC02
        IF (ISKP(93) .GE. 1) GO TO 130
        IF (IERR .NE. 0) GO TO 990
        GO TO 20
C                            next ii
  130   CONTINUE
      ENDDO
      GO TO 990
C
  140 IERR=94 0465 16
      GO TO 999
C
  990 K8(NS)=0
      K9(NS)=0
      NCD(NS)=0
  999 RETURN
      END
