CZVSXL    73             ------------------
                          SUBROUTINE ZVSXL
C  CY-VAX-ENG-           ------------------
C
C              Programm zum Lesen von SHELXL-Karten
C
C              Geschrieben: 261542 JUN 1992  (Hundt)
C              Geaendert:   071104 FEB 2000  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INCLUDE 'KPORC.INC'
C
      INTEGER*4 NZDMMY,IFVMAX
      PARAMETER (NZDMMY=72,IFVMAX=24)
      INTEGER*4 KDDMMY(NZDMMY),IAIN(72),ILATTT(8),KDLETR
      INTEGER*4 KDBLNK,KDTITL,KDCELL,KDSYMM,KDFVAR,KDEND,KDLATT,NZATMS
      INTEGER*4 IFVARP,NLINE,NTYPS,ILATT,LPOI,I,J,K,IRC,KDOWRT,LCOMPS
      INTEGER*4 ITFERR,KDH,IRD,KDZERR
      REAL*4    FVAR(IFVMAX),TEMP,TEMP2
CYVAX1
      INTEGER*1 I1AIN(288)
CYVAX2
CYVAXY      LOGICAL*1 I1AIN(288)
C
      EQUIVALENCE (AIN(1),IAIN(1),I1AIN(1))
C
      DATA KDBLNK/4H    /,KDTITL/4HTITL/,KDCELL/4HCELL/,KDSYMM/4HSYMM/
      DATA KDFVAR/4HFVAR/,KDEND /4HEND /,KDLATT/4HLATT/,KDLETR/4HAZaz/
      DATA KDH/4HH   /,KDZERR/4HZERR/
C
      DATA KDDMMY/4HACTA,4HAFIX,4HAFLS,4HANIS,4HATOM,4HBASF,4HBIND,
     1 4HBLOC,4HBOND,4HCHIV,4HCONF,4HCONN,4HDAMP,4HDELU,4HDFIX,4HDISP,
     2 4HEADP,4HEQIV,4HEXTI,4HEXYZ,4HFEND,4HFLAT,4HFMAP,4HFRAG,4HFREE,
     3 4HGRID,4HHFIX,4HHKLF,4HISOR,4HL.S.,4HLAUE,4HLIST,4HMERG,4HMOLE,
     4 4HMORE,4HMPLA,4HOMIT,4HPART,4HPLAN,4HREM ,4HRESI,4HRTAB,4HSADI,
     5 4HSAME,4HSFAC,4HSHEL,4HSIMU,4HSIZE,4HSPEC,4HSUMP,4HTEMP,4HTIME,
     6 4HTWIN,4HUNIT,4HVFIL,4HVOID,4HWGHT,4HZERR,4HABSC,4HFACE,
     7 4H$H  ,4HBUMP,4HCGLS,4HDEFS,4HEMPI,4HHOPE,4HLAMI,4HMOVE,4HSKIP,
     8 4HSLIM,4HSWAT,4HWPDB/
C
      DATA IRC/0/
      DATA ILATT/1/,ILATTT/4HP   ,4HI   ,4HQ   ,4HF   ,4HA   ,
     1 4HB   ,4HC   ,4HZ   /
C                            Initialisiere
      NZATMS=0
      IFVARP=0
      NLINE=0
      NTYPS=NTYP
      NSYM(NS)=1
      ITFERR=0
      IF (NAT(NS) .EQ. 0) NAT(NS)=ISKP(53)-1
C
C                            Raumgruppen-Symbol und Nummer
      NHMSNR(1,NS)=KDBLNK
      NHMSNR(2,NS)=KDBLNK
      NHMSNR(3,NS)=0
C                            Oeffne File
      NTYP=NTXR1
      CALL ZVEAEH
      IF (IERR .NE. 0) GO TO 480
      ISKP(14)=1
C
C                            Lies naechste Zeile
C
   10 CALL KPRDLN (NTXR1,IRD)
      IF (IRD .NE. 0) GO TO 430
      READ (RDLINE,20) (AIN(I),I=1,20)
   20 FORMAT (20A4)
      CALL CNVTUP (AIN,1,4)
      NLINE=NLINE+1
C                            Interpr. Zeile
      KDOWRT=IAIN(1)
      IF (KDOWRT .EQ. KDBLNK) GO TO 10
      IF (KDOWRT .EQ. KDTITL) GO TO 290
      IF (KDOWRT .EQ. KDCELL) GO TO 310
      IF (KDOWRT .EQ. KDZERR) GO TO 421
      IF (KDOWRT .EQ. KDLATT) GO TO 370
      IF (KDOWRT .EQ. KDSYMM) GO TO 360
      IF (KDOWRT .EQ. KDEND ) GO TO 430
      IF (KDOWRT .EQ. KDFVAR) GO TO 380
C
      DO 30 I=1,NZDMMY
      IF (KDOWRT .EQ. KDDMMY(I)) GO TO 10
   30 CONTINUE
C                            Nicht gefunden; versuche als Atom-
C                            Karte zu interpretieren
   40 DO 41 I=26,31
   41 AIN(I)=0.
   43 LPOI=4
      CALL FCNV (IAIN(21),ISKP(31),5HI10FE,AIN,LPOI,80,IRC)
      IF (IRC .NE. -4) GO TO 50
      CALL KPRDLN (NTXR1,IRD)
      IF (IRD .NE. 0) GO TO 430
      READ (RDLINE,20) (AIN(I),I=1,20)
      NLINE=NLINE+1
      IAIN(1)=KDOWRT
      GO TO 43
C
   50 IF (IRC .EQ. 0) GO TO 80
   60 WRITE (WRLINE,'('' ZVSXL070 - '',20A4)') (AIN(I),I=1,20)
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,70) IRC,NLINE
      CALL KPWRTE (NTDISP)
CYENG1
   70 FORMAT (14X,'Keine SHELX-Karte. (RC:',I4,' Zeile:',I5,')')
CYENG2
CYENGY   70 FORMAT (14X,'No SHELX instruction. (RC:',I4,' Line:',I5,')')
      GO TO 10
C
   80 J=ISKP(32)
      IF (J .LT. 3) GO TO 60
      NZATMS=NZATMS+1
C
   90 IF (NAT(NS)-NATDM) 110,100,100
  100 IERR=73 0113 02
      CALL ZVERR
      GO TO 10
C                            Ersetze Parameter, die fix sind oder
C                            auf FVAR verweisen.
  110 DO 160 I=1,J
      TEMP2=AIN(I+21)
      TEMP=ABS(TEMP2)
      IF (TEMP .LT. 5.) GO TO 160
      IF (TEMP .GE. 15.) GO TO 120
      TEMP=TEMP-10.
      GO TO 156
C
  120 K=(TEMP+5.)/10.
      IF (K .LE. IFVARP) GO TO 140
      WRITE (WRLINE,130) TEMP2,NLINE
      CALL KPWRTE (NTDISP)
CYENG1
  130 FORMAT ('ZVSXL130 - Illegaler FVAR-Verweis:',
     1 F12.6,' Zeile:',I4)
CYENG2
CYENGY  130 FORMAT (' ZVSXL130 - Illegal FVAR indirection:',
CYENGY     1 F12.6,' Zeile:',I4)
      GO TO 160
C
  140 TEMP=TEMP-FLOAT(K*10)
      IF (TEMP2) 154,156,152
  152 TEMP=FVAR(K)*TEMP
      GO TO 156
C
  154 TEMP=(1.-FVAR(K))*TEMP
  156 AIN(I+21)=TEMP
  160 CONTINUE
      NAT(NS)=NAT(NS)+1
      DO 170 I=1,3
      AT(I,NAT(NS),NS)=AIN(I+21)
  170 CONTINUE
C                            Zerpfluecke Symbol
      IAIN(21)=KDBLNK
      IAIN(22)=KDBLNK
      I1AIN(81)=I1AIN(1)
      I=2
      IF (LCOMPS(AIN,2,1, KDLETR,1)) 190,210,180
  180 IF (LCOMPS(AIN,2,1, KDLETR,2)) 210,210,190
  190 IF (LCOMPS(AIN,2,1, KDLETR,3)) 220,210,200
  200 IF (LCOMPS(AIN,2,1, KDLETR,4)) 210,210,220
  210 I1AIN(82)=I1AIN(2)
      I=3
  220 DO 230 K=85,87
      I1AIN(K)=I1AIN(I)
      I=I+1
      IF (I .GT. 4) GO TO 240
  230 CONTINUE
  240 AT(4,NAT(NS),NS)=0.3
      AT(5,NAT(NS),NS)=AIN(21)
      AT(6,NAT(NS),NS)=AIN(22)
      CALL CNVTUP (AIN(21),1,4)
      AT(7,NAT(NS),NS)=AIN(21)
      IF (J .LT. 5) GO TO 10
C                            Anisotrope Temperaturfaktoren,
C                            wenn nicht H
C
      IF (IAIN(21) .EQ. KDH) GO TO 10
      DO  I=1,2
        AIN(I)=AIN(I+20)
      ENDDO
      DO  I=1,3
        AIN(I+2)=AIN(I+25)
      ENDDO
      AIN(6)=AIN(31)
      AIN(7)=AIN(30)
      AIN(8)=AIN(29)
      AIN(9)=8.
      DO  I=4,8
        IF (AIN(I) .NE. 0.) GO TO 286
      ENDDO
      AIN(9)=6.
  286 ISKP(14)=-1
      CALL ZVTFH2
      IF (NG .EQ. 0) THEN
        DO  J=1,3
          DO  K=1,3
            TFVKT(J,K,NAT(NS),NS)=PA(J,K)*EV(K)
          ENDDO
        ENDDO
        IPFLG(NAT(NS),NS)=AIN(9)+.1
      ELSE
        WRITE (WRLINE,'(A,I3)') 'ZVTFH2 NG',NG
        CALL KPWRTE (NTDISP)
      ENDIF
      GO TO 10
C                            Titel
  290 DO 300 I=1,18
  300 TITEL(I,NS)=IAIN(I+1)
      GO TO 10
C                            Zelle
  310 LPOI=4
      CALL FCNV (IAIN(21),ISKP(31),3H7FE,AIN,LPOI,80,IRC)
      IF (IRC) 320,340,320
  320 WRITE (WRLINE,'('' KPSXL330 - '',20A4)') (AIN(I),I=1,20)
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,330) IRC,NLINE
      CALL KPWRTE (NTDISP)
CYENG1
  330 FORMAT (14X,'Konversionsfehler',I3,' Zeile',I5)
CYENG2
CYENGY  330 FORMAT (14X,'Conversion error',I3,' line',I5)
      GO TO 10
C
  340 DO  I=1,6
        ZELLE(I,NS)=AIN(I+21)
      ENDDO
      CONST(58)=AIN(21)
      NTYP=1
      CALL ZVZ
      GO TO 10
C                            SYMM-Karte
  360 IAIN(1)=KDBLNK
      ISKP(31)=18
      CALL ZVSYDC
      ISKP(72)=NSYM(NS)
      IAIN(1)=KDSYMM
      GO TO 10
C                            LATT-Karte
  370 LPOI=4
      CALL FCNV (ILATT,ISKP(31),2HIE,AIN,LPOI,80,IRC)
      ISKP(71)=ILATT
      IF (IRC) 320,10,320
C                            FVAR-Karte
  380 LPOI=4
      CALL FCNV (IAIN(21),ISKP(31),4H24FE,AIN,LPOI,80,IRC)
      IF (IRC .NE. -4) GO TO 390
      CALL KPRDLN (NTXR1,IRD)
      IF (IRD .NE. 0) GO TO 430
      READ (RDLINE,20) (AIN(I),I=1,20)
      NLINE=NLINE+1
      GO TO 380
C
  390 IF (IRC .NE. 0) GO TO 320
      J=ISKP(31)
      DO 400 I=1,J
      IF (IFVARP .GE. IFVMAX) GO TO 410
      IFVARP=IFVARP+1
      FVAR(IFVARP)=AIN(I+20)
  400 CONTINUE
      GO TO 10
C
  410 WRITE (WRLINE,420) IFVMAX
      CALL KPWRTE (NTDISP)
CYENG1
  420 FORMAT ('ZVSXL420 - Speicher fuer freie Variabeln voll (',
     1 I3,')')
CYENG2
CYENGY  420 FORMAT ('ZVSXL420 - Table for free variables full (',I3,')')
      GO TO 10
C                            ZERR
  421 LPOI=4
      CALL FCNV (CONST(51),ISKP(31),3H7FE,AIN,LPOI,80,IRC)
      IF (IRC) 320,422,320
  422 IF (ISKP(96) .NE. 0) THEN
        K=NS
        NS=3-NS
        J=52
        DO  I=1,6
          ZELLE(I,NS)=ZELLE(I,K)+CONST(J)
          J=J+1
        ENDDO
        NS=K
      ENDIF
      NTYP=1
      CALL ZVZ
      GO TO 10
C                            END oder EOF
C                            Erzeuge Symmetrien nach Gittertyp
  430 DO 440 I=1,20
  440 IAIN(I)=KDBLNK
      IF (ILATT) 460,480,450
  450 IAIN(1)=ILATTT(8)
      ISKP(14)=1
      CALL ZVGTY
  460 ILATT=IABS(ILATT)
      IF (ILATT-7) 470,470,480
  470 IAIN(1)=ILATTT(ILATT)
      ISKP(14)=1
      CALL ZVGTY
C
  480 ISKP(14)=0
      WRITE (WRLINE,490) NZATMS
      CALL KPWRTE (NTDISP)
CYENG1
  490 FORMAT (I5,' Atome gelesen.')
CYENG2
CYENGY  490 FORMAT (I5,' atoms read.')
      IF (ITFERR) 500,999,500
  500 WRITE (WRLINE,510)
      CALL KPWRTE (NTDISP)
CYENG1
  510 FORMAT ('ZVSXL510 - Nicht alle anisotropen Auslenkungsparameter ge
     1speichert.')
CYENG2
CYENGY  510 FORMAT ('ZVSXL510 - Not all anisotropic parameters stored.')
  999 RETURN
      END
