CKPZK     57             -----------------
                          SUBROUTINE ZVZK
C  CY-ENG-               -----------------
C
C       Zeichnet ein Koordinatensystem an die Stelle des Punktes
C       auf dem Punktregister.
C
C                Geschrieben: 190918 FEB 87 (Hundt)
C                Geaendert:   071603 MAY 2002 (Hundt)
C
C                        -----------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 I,II,ITYP,M,MX,MY,NRET
      REAL    *4 AINBFR(3),TMPFKT
C
      SAVE AINBFR
C
      DATA AINBFR/1.5,1.5,10./
C
C                            Eingabe
C
CYENG1
      CALL FLES (AINBFR,ISKP(31),3H3FE,16Hx,y,Schritte/A?$)
CYENG2
CYENGY      CALL FLES (AINBFR,ISKP(31),3H3FE,13Hx,y,steps/A?$)
C
C                            Berechne Zahl der Schritte
C
      MX=AINBFR(1)*AINBFR(3)
      MY=AINBFR(2)*AINBFR(3)
      TMPFKT=HOE/(HOE-PFREI(3))*O9
      CALL UPLINF (ISKP(41),10)
      CALL UPLINF (ISKP(49),11)
C
C                            Zeichne Koordinatensystem
      AIN(3)=-AINBFR(1)
      AIN(4)=0.
      AIN(5)=AINBFR(1)
      AIN(6)=0.
      ASSIGN 10 TO NRET
      GO TO 140
C
   10 AIN(4)=-AINBFR(2)
      AIN(3)=0.
      AIN(6)=AINBFR(2)
      AIN(5)=0.
      ASSIGN 20 TO NRET
      GO TO 140
C                            Trage Skalierung ein.
   20 I=-MX
      ASSIGN 70 TO NRET
   30 AIN(3)=FLOAT(I)/AINBFR(3)
      AIN(4)=0.
      AIN(5)=AIN(3)
      AIN(6)=0.1
      M=ABS(AIN(3)*10.)+.5
      M=MOD(M,10)
      IF (M) 50,40,50
   40 AIN(6)=.4
      GO TO 140
   50 IF (M-5) 140,60,140
   60 AIN(6)=.2
      GO TO 140
C
   70 I=I+1
      IF (I-MX) 30,30,80
C                            dto. fuer y
   80 I=-MY
      AIN(3)=0.
      ASSIGN 130 TO NRET
C
   90 AIN(4)=FLOAT(I)/AINBFR(3)
      AIN(5)=0.1
      AIN(6)=AIN(4)
      M=ABS(AIN(4)*10.)+.5
      M=MOD(M,10)
      IF (M) 110,100,110
  100 AIN(5)=.4
      GO TO 140
  110 IF (M-5) 140,120,140
  120 AIN(5)=.2
      GO TO 140
C
  130 I=I+1
      IF (I-MY) 90,90,180
C
C                            Internes UP zum Plotten eines Strichs
C                            von AIN(3),AIN(4) nach AIN(5),AIN(6)
  140 II=3
      ITYP=3
  150 AIN(1)=(PFREI(1)+AIN(II))*TMPFKT+CONST(11)
      AIN(2)=(PFREI(2)+AIN(II+1))*TMPFKT+CONST(12)
      CALL UPLINF (AIN,ITYP)
      IF (ITYP-3) 160,170,160
  160 GO TO NRET, (10,20,70,130)
  170 ITYP=2
      II=5
      GO TO 150
C                            Leere Puffer.
  180 CALL UPLINF (AIN,0)
      RETURN
      END
